This is release 0.9 of the Fortran interface 
to the GNU Scientific Library. It is based on version 1.10 of GSL, 
but should also work with later releases apart from missing API
mappings.

Changes since 0.8.1:
~~~~~~~~~~~~~~~~~~~~
* added examples for error handling
* added support for double precision complex vectors and matrices
* added linear algebra and eigensystem APIs
* added fourier transform API
* Note: testing of added APIs is not yet complete
* moved testing stuff to tests subdirectory

Changes since 0.8:
~~~~~~~~~~~~~~~~~~
* bug fixes
* improved 32 vs. 64 bit handling (--bits switch for configure)
* OS X on Intel support

Fixes since first beta and new features:
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
* added string constants describing version and GSL base
* added new features from GSL 1.9 and 1.10 as far as deemed
  necessary for FGSL coverage.

Fixes since second alpha and new features:
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
* augmented error treatment
* additional compilers added to configure script
* more fgsl_sizeof specifics
* extended (but not finished) manual
* testing much extended and many bugs/missing symbols fixed:
  - special functions
  - permutations and combinations
  - integration
  - permutations and combinations
  - sorting
  - random numbers (partially)
  - histograms (partially)

Fixes since first alpha and new features:
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
* statistics functions not exported, fixed
* changed permutation/combination data access to return
  a fortran pointer to enable referencing original data
* added further examples, nearly all from C are now mirrored
* added fgsl_sizeof generic, often needed for API calls with
  C polymorphic arguments
* the build process has been improved

*********************************************************************************

While this release supports a large subset of 
GSL functionality, there are a number of things missing still:

* for the most part, no generics yet for varying types and kinds
* no support for linear algebra and FFT since these are covered
  by LAPACK, BLAS and FFTW, respectively
* 1d and 2d vector/matrix API is not explicitly supported, but mapping
  routines to Fortran arrays and pointers are available
* no support yet for non-interoperable function and polymorphic
  arguments. This will be done once the compilers are ready.
* the test suite is still incomplete
* the build process needs further refinement

Nothing is *guaranteed* to work at this point. Depending
on feedback and other considerations, the API for additional 
calls implemented within FGSL may change without notice up to 
the final production release.


License:
~~~~~~~~

FGSL is released under Version 2 or later of the GPL.

Installation procedure:
~~~~~~~~~~~~~~~~~~~~~~~

(A) prerequisites:

 1. An installation of GSL libraries and include files 
 2. The ANSI C compiler used to build the GSL installation
 3. A Fortran 95 compiler which additionally implements the
    following Fortran 2003 features:
    - the IMPORT statement
    - Interoperability with C (more specifically, the C processor
      mentioned in 2. above). The intrinsic ISO_C_BINDING
      module and all of its functionality except C_F_PROCPOINTER
      is needed. The configure script checks the needed subset
      of interoperable intrinsic types.


Note that to date, the following compilers have been verified to 
correctly build the library and run the test programs:

    - g95 0.92 (on 64 bit systems, please use a version
      from after August 14, 2008, earlier releases have problems
      with C interoperable functions returning structures).
    - NAG 5.1 build 344 or higher (32 bit). Please perform 
export GSL_IEEE_MODE="mask-invalid,mask-underflow,mask-denormalized" 
      before running the test program, or build with the option
      -ieee=full (this was not checked with the 0.9 release).

In particular, the following compilers fail to build and/or run FGSL:

    - IBM xlf 10.1.0.5 and lower fails to build the library due to 
      non-implemented character length to array mapping.
      10.1.0.6 builds the library, but fails to build any application
      using the module due to spurious label duplication errors.
    - NAG 5.1 on 64 bit. There is no support for a c_size_t shape array
      constructor for c_f_pointer. This may actually not be required by 
      the standard. 
    - Sun Studio 12 (May 07) has no c_null_funptr and other problems.
      Sun Studio Express (July 08) cannot initialize type components to
      c_null_ptr.
    - PGI 7.2 has some C interop support, but insufficient to build
      FGSL. 
    - Intel ifort version 10.1 has a problem with C interoperable 
      functions returning structures. This has been reported and
      will be fixed.
    - Pathscale 3.2 has too buggy C interop support to build FGSL.
    - gfortran 4.3.x does not support complex(c_double).
    - IBM 11.1 builds the library and the tests in the tests subdirectory. 
      Some tests fail, apparently due to being miscompiled
      (illegal instruction).

(B) build procedure:

export FFLAGS=<suitable Fortran flags>
./configure [--prefix <inst_path>] [--gsl <gsl_inst_path>] \
            [--f90 <f90_compiler] [--bits <32|64>] 
make
make install


    Testing can be performed by doing
make test
    which should produce a number of lines "OK: All tests passed".

(C) usage:

With F90 denoting the Fortran compiler and GSL_INST_PATH the GSL installation
path, and assuming GSL_INST_PATH was also chosen as installation prefix for
FGSL:

$F90 -o myprog.exe -I$GSL_INST_PATH/include/$F90 myprog.f90 \
     -L$GSL_INST_PATH/lib -lfgsl_${F90}.a -lgsl -lgslcblas



Reporting Bugs etc.
~~~~~~~~~~~~~~~~~~~

Patches and/or bug reports are very welcome and should be directed
to Bader_at_lrz_dot_de

Suggestions for implementations of missing bits will be worked
on by me as time allows. 

Releases:

  * 0.5: End of March, 2007 (revision 1636)
  * 0.6: End of April, 2007 (revision 1680)
  * 0.7: End of July, 2007 (revision 1809)
  * 0.8: Early October, 2007 (revision 1940)
  * 0.8.1: Early April, 2008 (revision 2282) 
  * 0.9: End of August, 2008 (revision 2578)
  * 1.0: ???
  

program error_3
  use fgsl
  use, intrinsic :: ieee_exceptions
  implicit none
  real(fgsl_double) :: x, y
  integer :: i
  type(fgsl_error_handler_t) :: default_errh
  logical :: have_invalid
  default_errh = fgsl_set_error_handler_off()
  x = -2.2d0
  do i=1,3
     x = x + 0.1d0
!    If your Fortran processor supports the IEEE stuff, 
!    you can do your own processing of the error condition
!    You need to know whether an FP error, and what kind
!    of FP error can happen.
     call ieee_set_flag(ieee_invalid, .false.)
     y = fgsl_sf_gamma(x)
     call ieee_get_flag(ieee_invalid, have_invalid)
     if (have_invalid) then
        write(*, *) x, 'Not a number'
     else
        write(*, *) x, y
     end if
  end do
end program error_3

program interp
  use fgsl
  implicit none
  integer :: i
  integer(fgsl_int) :: status
  real(fgsl_double) :: xi, yi, x(10), y(10)
  type(fgsl_interp_accel) :: acc
  type(fgsl_spline) :: spline
!
  do i=1, 10
     x(i) = dble(i-1) + 0.5d0*sin(dble(i-1))
     y(i) = dble(i-1) + cos(dble(i)**2)
     write(6, '(2(F10.5,1X))') x(i), y(i)
  end do
  acc = fgsl_interp_accel_alloc()
  write(6, *) 'Values of interpolating spline:'
  spline = fgsl_spline_alloc(fgsl_interp_cspline, 10_fgsl_size_t)
  status = fgsl_spline_init (spline, x, y, 10_fgsl_size_t)
  do i=1, 101
     xi = x(1) + dble(i-1)/100.D0 * (x(10) - x(1))
     yi = fgsl_spline_eval (spline, xi, acc)
     write(6, '(2(F10.5,1X))') xi, yi
  end do
  call fgsl_spline_free(spline)
  call fgsl_interp_accel_free(acc)
end program interp

program dwt
  use fgsl
  integer(fgsl_size_t), parameter :: N=256, NC=20
  integer(fgsl_int) :: i, status
  real(fgsl_double) :: data(N), abscoeff(N)
  integer(fgsl_size_t) :: p(N)
  type(fgsl_wavelet) :: w
  type(fgsl_wavelet_workspace) :: work
!
  w = fgsl_wavelet_alloc(fgsl_wavelet_daubechies, 4_fgsl_size_t)
  work = fgsl_wavelet_workspace_alloc (N)
  open(unit=20, file='dwt.dat', form='FORMATTED', status='OLD')
  do i=1,N
     read(20, fmt=*) data(i)
  end do
  close(unit=20)
  status = fgsl_wavelet_transform_forward(w, data, 1_fgsl_size_t, N, work)
  do i=1,N
     abscoeff(i) = abs(data(i))
  end do
  call fgsl_sort_index(p, abscoeff, 1_fgsl_size_t, N)
  do i=1,N-NC
     data(p(i)+1) = 0.0_fgsl_double
  end do
  status = fgsl_wavelet_transform_inverse(w, data, 1_fgsl_size_t, N, work)
  do i=1,N
     write(6, '(F15.12)') data(i)
  end do
  call fgsl_wavelet_workspace_free(work)
  call fgsl_wavelet_free(w)
end program dwt

module mod_sort
  use fgsl
  use mod_unit
  use, intrinsic :: iso_c_binding
  implicit none
  integer(fgsl_size_t), parameter :: dim = 40
  real(fgsl_double), parameter :: eps10=1.0d-10
  type(c_ptr) :: array_ptr
  real(c_double), dimension(dim), target :: array, t_array
  integer(fgsl_size_t), dimension(dim) :: p_array
  integer(fgsl_long), dimension(dim) :: i_array
contains
  function compare(x, y) bind(c)
    use, intrinsic :: iso_c_binding, only: c_ptr, c_int, c_double
    type(c_ptr), value :: x, y
    integer(c_int) :: compare
!
    real(c_double), pointer :: rx, ry
    call c_f_pointer(x, rx); call c_f_pointer(y, ry)
    compare = 0 ;  if (rx < ry) compare = -1
  end function compare
end module mod_sort
program sort
  use mod_sort
  implicit none
  type(fgsl_error_handler_t) :: std
  integer :: i, status
!
! Test sorting routines
!
  call unit_init(200)
  std = fgsl_set_error_handler_off()
  array = (/(dble(i),i=40,1,-1)/)
  array_ptr = c_loc(array)
  call fgsl_heapsort(array_ptr,dim,fgsl_sizeof(1.0d0),compare)
  call unit_assert_equal_within('fgsl_heapsort',(/(dble(i),i=1,40)/),array,eps10)
  array = (/(dble(i),i=40,1,-1)/)
  status = fgsl_heapsort_index(p_array,array_ptr,dim,fgsl_sizeof(1.0d0),compare)
  call unit_assert_equal('fgsl_heapsort_index_status',fgsl_success,status)
! NOTE: results use zero base!
  call unit_assert_equal('fgsl_heapsort_index',(/(i,i=39,0,-1)/),int(p_array))
  array = (/(dble(i),i=40,1,-1)/)
  call fgsl_sort(array,1_fgsl_size_t,dim)
  call unit_assert_equal_within('fgsl_heapsort',(/(dble(i),i=1,40)/),array,eps10)
  p_array = (/(dble(i),i=40,1,-1)/)
  call fgsl_sort(p_array,1_fgsl_size_t,dim)
  call unit_assert_equal('fgsl_sort',(/(i,i=1,40)/),int(p_array))
  array = (/(dble(i),i=40,1,-1)/)
  call fgsl_sort_index(p_array,array,1_fgsl_size_t,dim)
  call unit_assert_equal('fgsl_sort_index',(/(i,i=39,0,-1)/),int(p_array))
  i_array = (/(i,i=40,1,-1)/)
  call fgsl_sort_index(p_array,i_array,1_fgsl_size_t,dim)
  call unit_assert_equal('fgsl_sort_index',(/(i,i=39,0,-1)/),int(p_array))
  array = (/(dble(i),i=40,1,-1)/)
  status = fgsl_sort_smallest(t_array,dim,array,1_fgsl_size_t,dim)
  call unit_assert_equal('fgsl_sort_smallest:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sort_smallest',&
       (/(dble(i),i=1,40)/),t_array,eps10)
  i_array = (/(i,i=40,1,-1)/)
  status = fgsl_sort_smallest(p_array,dim,i_array,1_fgsl_size_t,dim)
  call unit_assert_equal('fgsl_sort_smallest:status',fgsl_success,status)
  call unit_assert_equal('fgsl_sort_smallest',(/(i,i=1,40)/),int(p_array))
  array = (/(dble(i),i=40,1,-1)/)
  status = fgsl_sort_smallest_index(p_array,dim,array,1_fgsl_size_t,dim)
  call unit_assert_equal('fgsl_sort_smallest_index',(/(i,i=39,0,-1)/),int(p_array))
  i_array = (/(i,i=40,1,-1)/)
  status = fgsl_sort_smallest_index(p_array,dim,i_array,1_fgsl_size_t,dim)
  call unit_assert_equal('fgsl_sort_smallest_index',(/(i,i=39,0,-1)/),int(p_array))
  array = (/(dble(i),i=40,1,-1)/)
  status = fgsl_sort_largest(t_array,dim,array,1_fgsl_size_t,dim)
  call unit_assert_equal('fgsl_sort_largest:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sort_largest',&
       (/(dble(i),i=40,1,-1)/),t_array,eps10)
  i_array = (/(i,i=40,1,-1)/)
  status = fgsl_sort_largest(p_array,dim,i_array,1_fgsl_size_t,dim)
  call unit_assert_equal('fgsl_sort_largest:status',fgsl_success,status)
  call unit_assert_equal('fgsl_sort_largest',(/(i,i=40,1,-1)/),int(p_array))
  array = (/(dble(i),i=40,1,-1)/)
  status = fgsl_sort_largest_index(p_array,dim,array,1_fgsl_size_t,dim)
  call unit_assert_equal('fgsl_sort_largest_index',(/(i,i=0,39)/),int(p_array))
  i_array = (/(i,i=40,1,-1)/)
  status = fgsl_sort_largest_index(p_array,dim,i_array,1_fgsl_size_t,dim)
  call unit_assert_equal('fgsl_sort_largest_index',(/(i,i=0,39)/),int(p_array))
!
! Done
!
  call unit_finalize()  
end program sort

module mod_nlfit
  use fgsl
  use, intrinsic :: iso_c_binding
  implicit none
  type data 
     integer(fgsl_size_t) :: n
     real(fgsl_double), allocatable :: y(:), sigma(:)
  end type data
contains
  function expb_f(x, cdata, f) bind(c)
    type(c_ptr), value :: x, cdata, f
    integer(c_int) :: expb_f
!
    type(fgsl_vector) :: f_x, f_f
    type(data), pointer :: f_data
    integer(fgsl_size_t) :: i
    integer(fgsl_int) :: status
    real(fgsl_double) :: yy
    real(fgsl_double), pointer :: p_x(:), p_f(:)
!
    call fgsl_obj_c_ptr(f_x, x)
    call fgsl_obj_c_ptr(f_f, f)
    status = fgsl_vector_align(p_x, f_x)
    status = fgsl_vector_align(p_f, f_f)
    call c_f_pointer(cdata, f_data)
    do i=1,f_data%n
       yy = p_x(1) * exp(- p_x(2) * dble(i-1) ) + p_x(3)
       p_f(i) = (yy - f_data%y(i))/f_data%sigma(i)
    end do
    expb_f = fgsl_success
  end function expb_f
  function expb_df(x, cdata, j) bind(c)
    type(c_ptr), value :: x, cdata, j
    integer(c_int) :: expb_df
!
    type(fgsl_vector) :: f_x
    type(fgsl_matrix) :: f_j
    type(data), pointer :: f_data
    integer(fgsl_size_t) :: i
    integer(fgsl_int) :: status
    real(fgsl_double) :: yy
    real(fgsl_double), pointer :: p_x(:), p_j(:,:)
!
    call fgsl_obj_c_ptr(f_x, x)
    call fgsl_obj_c_ptr(f_j, j)
    status = fgsl_vector_align(p_x, f_x)
    status = fgsl_matrix_align(p_j, f_j)
    call c_f_pointer(cdata, f_data)
    do i=1,f_data%n
       yy = exp(- p_x(2) * dble(i-1) )
       p_j(1,i) = yy / f_data%sigma(i)
       p_j(2,i) = - dble(i-1) * p_x(1) * yy / f_data%sigma(i)
       p_j(3,i) = 1 / f_data%sigma(i)
    end do
    expb_df = fgsl_success
  end function expb_df
  function expb_fdf(x, cdata, f, j) bind(c)
    type(c_ptr), value :: x, cdata, f, j
    integer(c_int) :: expb_fdf
!
    integer(c_int) :: status
    status = expb_f(x, cdata, f)
    status = expb_df(x, cdata, j)
    expb_fdf = fgsl_success
  end function expb_fdf
end module
program nlfit
  use mod_nlfit
  implicit none
  real(fgsl_double), parameter :: eps = 1.0E-4_fgsl_double
  integer(fgsl_size_t), parameter :: itmax = 30
  integer(fgsl_size_t) :: nmax, nrt
  integer(fgsl_int) :: status
  type(fgsl_multifit_function_fdf) :: nlfit_fdf
  type(fgsl_multifit_fdfsolver) :: nlfit_slv
  type(fgsl_rng) :: rng
  type(fgsl_vector) :: params
  type(fgsl_matrix) :: cov, jac
  type(data), target :: fitdata
  type(c_ptr) :: ptr
  real(fgsl_double), target :: v_params(3), v_cov(3,3)
  real(fgsl_double), pointer :: v_fun(:), v_parptr(:)
  real(fgsl_double) :: chi, c
  integer :: i
!
  nmax = 40
  rng = fgsl_rng_alloc(fgsl_rng_default)
  fitdata%n = nmax
  allocate(fitdata%y(nmax),fitdata%sigma(nmax))
  write(6, fmt='('' No.       Data value       Sigma'')')       
  do i=1, nmax
     fitdata%y(i) = 1.0_fgsl_double + &
          5.0_fgsl_double * exp(-0.1_fgsl_double*dble(i-1)) + &
          fgsl_ran_gaussian(rng, 0.1_fgsl_double)
     fitdata%sigma(i) = 0.1_fgsl_double
     write(6, fmt='(I3,2X,2(F16.8,1X))') i, fitdata%y(i), fitdata%sigma(i)
  end do
  ptr = c_loc(fitdata)
  nrt = 3_fgsl_size_t
  nlfit_fdf = fgsl_multifit_function_fdf_init(expb_f, expb_df, &
       expb_fdf, nmax, nrt, ptr)
  nlfit_slv = fgsl_multifit_fdfsolver_alloc(fgsl_multifit_fdfsolver_lmsder, &
       nmax, nrt)
! initial guess for fit parameters
  v_params(1:3) = (/1.0_fgsl_double, 0.0_fgsl_double, 0.0_fgsl_double/)
  params = fgsl_vector_init(type = 1.0_fgsl_double)
  status = fgsl_vector_align(v_params,nrt,params,nrt, &
       0_fgsl_size_t,1_fgsl_size_t)
! alignment of target function and parameter values only needed once
! storage allocated within the nlfit_slv object
  status = fgsl_vector_align(v_fun, &
       fgsl_multifit_fdfsolver_f(nlfit_slv))
  status = fgsl_vector_align(v_parptr, &
       fgsl_multifit_fdfsolver_position(nlfit_slv))
! storage for cov within Fortran
  cov = fgsl_matrix_init(type = 1.0_fgsl_double)
  status = fgsl_matrix_align(v_cov,nrt,nrt,nrt,cov)
  if (fgsl_well_defined(nlfit_slv)) then
     status = fgsl_multifit_fdfsolver_set(nlfit_slv, nlfit_fdf, params)
     i = 0
     write(6, fmt= &
          '(''Iteration   <--------- Fit Parameter Values --------->   Targ. function'')')
     do
        write(6, fmt='(2X,I3,2X,3(F15.8,1X),2X,1PD12.5)') i, v_parptr(1:nrt), &
             sqrt(dot_product(v_fun,v_fun))
        i = i + 1
        status = fgsl_multifit_fdfsolver_iterate(nlfit_slv)
        if (status /= fgsl_success .or. i > itmax) then
           write(6, *) 'Iteration or Convergence failure'
           exit
        end if
        status = fgsl_multifit_test_delta( &
             fgsl_multifit_fdfsolver_dx(nlfit_slv), &
             fgsl_multifit_fdfsolver_position(nlfit_slv), eps, eps)
        if (status == fgsl_success) then 
           exit
        end if
     end do
     jac = fgsl_multifit_fdfsolver_jac(nlfit_slv)
     status = fgsl_multifit_covar(jac, 0.0_fgsl_double, cov)
     chi = sqrt(dot_product(v_fun,v_fun))
     c = max(1.0d0, chi/sqrt(dble(nmax-nrt)))
!  c only relevant for error estimate if chi*chi/dof exceeds 1
     write(6, '(''Iteration complete. Final Results for '')')
     write(6, '(''  fit function A exp (-lambda x) + b: '')')
     write(6, '(''  A      = '',1PE15.8,'' +/- '',1PE12.5)') v_parptr(1), &
          c * v_cov(1,1)
     write(6, '(''  lambda = '',1PE15.8,'' +/- '',1PE12.5)') v_parptr(2), & 
          c * v_cov(2,2)
     write(6, '(''  b      = '',1PE15.8,'' +/- '',1PE12.5)') v_parptr(3), &
          c * v_cov(3,3)
     write(6, '(''  chisq / degrees_of_freedom: '',1PE10.3)') chi*chi/dble(nmax-nrt)
  end if
  call fgsl_vector_free(params)
  call fgsl_matrix_free(cov)
  call fgsl_multifit_fdfsolver_free(nlfit_slv)
  call fgsl_multifit_function_fdf_free(nlfit_fdf)
  call fgsl_rng_free(rng)
end program nlfit

program interpp
  use fgsl
  implicit none
  integer(fgsl_size_t), parameter :: n = 4
  integer(fgsl_int) :: i, status
  real(fgsl_double) :: xi, yi
  real(fgsl_double) :: x(4) = (/0.0D0, 0.1D0, 0.27D0, 0.3D0 /), &
       y(4) = (/0.15D0, 0.7D0, -0.1D0, 0.15D0 /) 
!      Note: first = last for periodic data
  type(fgsl_interp_accel) :: acc
  type(fgsl_spline) :: spline

  spline =  fgsl_spline_alloc(fgsl_interp_cspline_periodic, n)
  write(6, '(''#m=0,S=5'')')
  do i=1,n
     write(6, '(2(F10.5,1X))') x(i), y(i)
  end do
  write(6, '(''#m=1,S=0'')')
  status = fgsl_spline_init(spline, x, y, n)
  do i=1, 100
     xi = (1.D0 - dble(i-1)/100.D0) * x(1) + dble(i-1)/100.D0 * x(n)
     yi = fgsl_spline_eval(spline, xi, acc)
     write(6, '(2(F10.5,1X))') xi, yi
  end do
  call fgsl_spline_free (spline)
  call fgsl_interp_accel_free (acc)
end program interpp

module mod_siman
  use, intrinsic :: iso_c_binding
  use fgsl
  use mod_unit
  implicit none
contains
  function e1(xp) bind(c)
    type(c_ptr), value :: xp
    real(fgsl_double) :: e1
!
    real(fgsl_double), pointer :: x
    call c_f_pointer(xp, x)
    e1 = exp(-(x-1.0_fgsl_double)**2.0_fgsl_double) * &
         sin(8.0_fgsl_double*x)
  end function e1
  function m1(xp, yp) bind(c)
    type(c_ptr), value :: xp, yp
    real(fgsl_double) :: m1
!
    real(fgsl_double), pointer :: x, y
    call c_f_pointer(xp, x)
    call c_f_pointer(yp, y)
    m1 = abs(x - y)
  end function m1
  subroutine s1(r, xp, step_size) bind(c)
    type(c_ptr), value :: r, xp
    real(fgsl_double), value :: step_size
!
    real(fgsl_double), pointer :: x
    real(fgsl_double) :: u
    type(fgsl_rng) :: gr
    call fgsl_obj_c_ptr(gr, r)
    call c_f_pointer(xp, x)
    u = fgsl_rng_uniform(gr)
    x = x + 2.0_fgsl_double * u * step_size - step_size
  end subroutine s1
end module mod_siman
program siman
  use mod_siman
  implicit none
  real(fgsl_double), parameter :: eps6 = 1.0d-6
  real(fgsl_double), target :: xx
  type(c_ptr) :: ptr
  type(fgsl_rng) :: rng
  type(fgsl_siman_params_t) :: siman_params
!
! Test simulated annealing routines
!
  call unit_init(20)
!
  rng = fgsl_rng_alloc(fgsl_rng_default)
  xx = 15.5_fgsl_double
  ptr = c_loc(xx)
  call fgsl_siman_params_init(siman_params, 200, 10, 10.0_fgsl_double, &
       1.0_fgsl_double, 0.002_fgsl_double, 1.005_fgsl_double, 2.0e-6_fgsl_double) 
!  call fgsl_siman_solve(rng, ptr, e1, s1, m1, pp1, &
  call fgsl_siman_solve(rng, ptr, e1, s1, m1, &
       element_size=8_fgsl_size_t, params=siman_params)
!  write(6, *) xx
  call unit_assert_equal_within('fgsl_siman_solve',&
       1.3633498d0,xx,eps6)
  call fgsl_siman_params_free(siman_params)
  call fgsl_rng_free(rng)
!
! Done
!
  call unit_finalize() 
end program siman

module fgsl
!-------------------------------------------------------------------------------
!  Interface module for use of GSL from Fortran
!  Author: R. Bader, Leibniz Computing Centre, Garching, Germany
!  Notes:
!  (1) Conventions used:
!      * GSL_* must be replaced by FGSL_* for each API call, abstract
!        data type and parameters (with exception of the M_* mathematical 
!        constants)
!      * Some names were changed due to UC/LC aliasing. See the documentation
!        chapter on special functions for details
!      * Type matching: 
!        - real(fgsl_double) is used for double 
!        - real(fgsl_float) is used for float 
!        - integer(fgsl_int) for integer 
!        - integer(fgsl_long) for long integer 
!        - integer(fgsl_size_t) for size_t integer
!        - complex(fgsl_double) for gsl_complex
!        - character(fgsl_char) for characters
!        - no value attributes and mostly no pointers in Fortran calls
!        - unsigned int must be converted to integer(fgsl_long).
!        - char * results are converted to fixed length strings. Use TRIM. 
!  (2) Additional routines
!      * Generic interface fgsl_well_defined for checking status of FGSL
!        objects (which are typically opaque).
!      * See api/array.finc for array alignment routines.
!      * See api/math.finc for function object constructors.
!      * See api/io.finc for I/O related add-ons.
!  (3) Only the manual-documented interface are implemented. The 
!      C include files may contain more stuff which may only be meant 
!      for internal use. Or is not documented yet. Tough.
!  (4) Inlining of GSL routines is of course not possible
!  (5) Macros
!      * are not supported
!      * macro values are replicated as parameters
!      * Inf/Nan need to use IEEE_VALUE (if available)
!-------------------------------------------------------------------------------
  use, intrinsic :: iso_c_binding
  implicit none
  private
!
! Exported entities
!
  public :: fgsl_set_error_handler_off, fgsl_set_error_handler, fgsl_strerror, &
       fgsl_error_handler_init, fgsl_name, fgsl_error
  public :: fgsl_well_defined, fgsl_obj_c_ptr, fgsl_sizeof
  public :: fgsl_open, fgsl_close, fgsl_stdin, fgsl_stdout, fgsl_stderr, fgsl_flush
  public :: assignment(=)
  public :: fgsl_isnan, fgsl_isinf, fgsl_finite, fgsl_log1p, fgsl_expm1, &
       fgsl_hypot, fgsl_acosh, fgsl_asinh, fgsl_atanh, fgsl_ldexp, fgsl_frexp, &
       fgsl_fcmp, fgsl_function_init, fgsl_function_fdf_init, fgsl_function_free, &
       fgsl_function_fdf_free, fgsl_fn_eval, fgsl_fn_fdf_eval_f, fgsl_fn_fdf_eval_df, &
       fgsl_fn_fdf_eval_f_df 
! complex functions
  public :: fgsl_complex_arg, fgsl_complex_logabs, fgsl_complex_log10, &
       fgsl_complex_log_b, fgsl_complex_arcsin, fgsl_complex_arcsin_real, &
       fgsl_complex_arccos, fgsl_complex_arccos_real,  fgsl_complex_arctan, &
       fgsl_complex_arcsec, fgsl_complex_arcsec_real, fgsl_complex_arccsc, &
       fgsl_complex_arccsc_real, fgsl_complex_arccot, fgsl_complex_arcsinh, &
       fgsl_complex_arccosh, fgsl_complex_arccosh_real, fgsl_complex_arctanh, &
       fgsl_complex_arctanh_real, fgsl_complex_arcsech, fgsl_complex_arccsch, &
       fgsl_complex_arccoth
! polynomials
  public :: fgsl_poly_eval, fgsl_poly_dd_init, fgsl_poly_dd_eval, fgsl_poly_dd_taylor, &
       fgsl_poly_solve_quadratic, fgsl_poly_complex_solve_quadratic, &
       fgsl_poly_solve_cubic, fgsl_poly_complex_solve_cubic, &
       fgsl_poly_complex_workspace_alloc, fgsl_poly_complex_workspace_free, &
       fgsl_poly_complex_solve
! special functions
  public :: fgsl_sf_airy_ai, fgsl_sf_airy_ai_e, fgsl_sf_airy_bi, fgsl_sf_airy_bi_e, &
       fgsl_sf_airy_ai_scaled, fgsl_sf_airy_ai_scaled_e, fgsl_sf_airy_bi_scaled, &
       fgsl_sf_airy_bi_scaled_e, fgsl_sf_airy_ai_deriv, fgsl_sf_airy_bi_deriv, &
       fgsl_sf_airy_ai_deriv_scaled, fgsl_sf_airy_bi_deriv_scaled, &
       fgsl_sf_airy_ai_deriv_e, fgsl_sf_airy_bi_deriv_e, &
       fgsl_sf_airy_ai_deriv_scaled_e, fgsl_sf_airy_bi_deriv_scaled_e, &
       fgsl_sf_airy_zero_ai, fgsl_sf_airy_zero_ai_e, &
       fgsl_sf_airy_zero_bi, fgsl_sf_airy_zero_bi_e, &
       fgsl_sf_airy_zero_ai_deriv, fgsl_sf_airy_zero_ai_deriv_e, &
       fgsl_sf_airy_zero_bi_deriv, fgsl_sf_airy_zero_bi_deriv_e
  public :: fgsl_sf_bessel_jc0, fgsl_sf_bessel_jc0_e, & 
       fgsl_sf_bessel_jc1, fgsl_sf_bessel_jc1_e, fgsl_sf_bessel_jcn, &
       fgsl_sf_bessel_jcn_e, fgsl_sf_bessel_jcn_array, &
       fgsl_sf_bessel_yc0, fgsl_sf_bessel_yc0_e, & 
       fgsl_sf_bessel_yc1, fgsl_sf_bessel_yc1_e, fgsl_sf_bessel_ycn, &
       fgsl_sf_bessel_ycn_e, fgsl_sf_bessel_ycn_array, &
       fgsl_sf_bessel_ic0, fgsl_sf_bessel_ic0_e, & 
       fgsl_sf_bessel_ic1, fgsl_sf_bessel_ic1_e, fgsl_sf_bessel_icn, &
       fgsl_sf_bessel_icn_e, fgsl_sf_bessel_icn_array, &
       fgsl_sf_bessel_ic0_scaled, fgsl_sf_bessel_ic0_scaled_e, & 
       fgsl_sf_bessel_ic1_scaled, fgsl_sf_bessel_ic1_scaled_e, fgsl_sf_bessel_icn_scaled, &
       fgsl_sf_bessel_icn_scaled_e, fgsl_sf_bessel_icn_scaled_array, &
       fgsl_sf_bessel_kc0, fgsl_sf_bessel_kc0_e, & 
       fgsl_sf_bessel_kc1, fgsl_sf_bessel_kc1_e, fgsl_sf_bessel_kcn, &
       fgsl_sf_bessel_kcn_e, fgsl_sf_bessel_kcn_array, &
       fgsl_sf_bessel_kc0_scaled, fgsl_sf_bessel_kc0_scaled_e, & 
       fgsl_sf_bessel_kc1_scaled, fgsl_sf_bessel_kc1_scaled_e, fgsl_sf_bessel_kcn_scaled, &
       fgsl_sf_bessel_kcn_scaled_e, fgsl_sf_bessel_kcn_scaled_array
  public :: fgsl_sf_bessel_js0, fgsl_sf_bessel_js0_e, fgsl_sf_bessel_js1, fgsl_sf_bessel_js1_e, &
       fgsl_sf_bessel_js2, fgsl_sf_bessel_js2_e, fgsl_sf_bessel_jsl, fgsl_sf_bessel_jsl_e, &
       fgsl_sf_bessel_jsl_array, fgsl_sf_bessel_jsl_steed_array, &
       fgsl_sf_bessel_ys0, fgsl_sf_bessel_ys0_e, fgsl_sf_bessel_ys1, fgsl_sf_bessel_ys1_e, &
       fgsl_sf_bessel_ys2, fgsl_sf_bessel_ys2_e, fgsl_sf_bessel_ysl, fgsl_sf_bessel_ysl_e, &
       fgsl_sf_bessel_ysl_array, fgsl_sf_bessel_is0_scaled, fgsl_sf_bessel_is0_scaled_e, &
       fgsl_sf_bessel_is1_scaled, fgsl_sf_bessel_is1_scaled_e, &
       fgsl_sf_bessel_is2_scaled, fgsl_sf_bessel_is2_scaled_e, fgsl_sf_bessel_isl_scaled, &
       fgsl_sf_bessel_isl_scaled_e, fgsl_sf_bessel_isl_scaled_array, &
       fgsl_sf_bessel_ks0_scaled, fgsl_sf_bessel_ks0_scaled_e, &
       fgsl_sf_bessel_ks1_scaled, fgsl_sf_bessel_ks1_scaled_e, &
       fgsl_sf_bessel_ks2_scaled, fgsl_sf_bessel_ks2_scaled_e, fgsl_sf_bessel_ksl_scaled, &
       fgsl_sf_bessel_ksl_scaled_e, fgsl_sf_bessel_ksl_scaled_array
  public :: fgsl_sf_bessel_jnu, fgsl_sf_bessel_jnu_e, fgsl_sf_bessel_sequence_jnu_e, &
       fgsl_sf_bessel_ynu, fgsl_sf_bessel_ynu_e, fgsl_sf_bessel_inu, fgsl_sf_bessel_inu_e, &
       fgsl_sf_bessel_inu_scaled, fgsl_sf_bessel_inu_scaled_e, &
       fgsl_sf_bessel_knu, fgsl_sf_bessel_knu_e, &
       fgsl_sf_bessel_lnknu, fgsl_sf_bessel_lnknu_e, &
       fgsl_sf_bessel_knu_scaled, fgsl_sf_bessel_knu_scaled_e, &
       fgsl_sf_bessel_zero_jc0, fgsl_sf_bessel_zero_jc0_e, &
       fgsl_sf_bessel_zero_jc1, fgsl_sf_bessel_zero_jc1_e, &
       fgsl_sf_bessel_zero_jnu, fgsl_sf_bessel_zero_jnu_e
  public :: fgsl_sf_clausen, fgsl_sf_clausen_e, fgsl_sf_hydrogenicr_1, &
       fgsl_sf_hydrogenicr_1_e, fgsl_sf_hydrogenicr, fgsl_sf_hydrogenicr_e, &
       fgsl_sf_coulomb_wave_fg_e, fgsl_sf_coulomb_wave_f_array, fgsl_sf_coulomb_wave_fg_array, &
       fgsl_sf_coulomb_wave_fgp_array, fgsl_sf_coulomb_wave_sphf_array, &
       fgsl_sf_coulomb_cl_e, fgsl_sf_coulomb_cl_array
  public :: fgsl_sf_coupling_3j, fgsl_sf_coupling_3j_e, fgsl_sf_coupling_6j, &
       fgsl_sf_coupling_6j_e, fgsl_sf_coupling_9j, fgsl_sf_coupling_9j_e, &
       fgsl_sf_dawson, fgsl_sf_dawson_e, fgsl_sf_debye_1, fgsl_sf_debye_1_e, &
       fgsl_sf_debye_2, fgsl_sf_debye_2_e, fgsl_sf_debye_3, fgsl_sf_debye_3_e, &
       fgsl_sf_debye_4, fgsl_sf_debye_4_e, fgsl_sf_debye_5, fgsl_sf_debye_5_e, &
       fgsl_sf_debye_6, fgsl_sf_debye_6_e, fgsl_sf_dilog, fgsl_sf_dilog_e, &
       fgsl_sf_complex_dilog_e, fgsl_sf_multiply_e, fgsl_sf_multiply_err_e
  public :: fgsl_sf_ellint_kcomp, fgsl_sf_ellint_kcomp_e, fgsl_sf_ellint_ecomp, &
       fgsl_sf_ellint_ecomp_e, fgsl_sf_ellint_f, fgsl_sf_ellint_f_e, &
       fgsl_sf_ellint_e, fgsl_sf_ellint_e_e, fgsl_sf_ellint_p, fgsl_sf_ellint_p_e, & 
       fgsl_sf_ellint_d, fgsl_sf_ellint_d_e, fgsl_sf_ellint_rc, fgsl_sf_ellint_rc_e, &
       fgsl_sf_ellint_rd, fgsl_sf_ellint_rd_e, fgsl_sf_ellint_rf, fgsl_sf_ellint_rf_e, &
       fgsl_sf_ellint_rj, fgsl_sf_ellint_rj_e, fgsl_sf_elljac_e
  public :: fgsl_sf_erf, fgsl_sf_erf_e, fgsl_sf_erfc, fgsl_sf_erfc_e, fgsl_sf_log_erfc, &
       fgsl_sf_log_erfc_e, fgsl_sf_erf_z, fgsl_sf_erf_z_e, fgsl_sf_erf_q, fgsl_sf_erf_q_e, &
       fgsl_sf_hazard, fgsl_sf_hazard_e, fgsl_sf_exp, fgsl_sf_exp_e, fgsl_sf_exp_e10_e, &
       fgsl_sf_exp_mult, fgsl_sf_exp_mult_e, fgsl_sf_exp_mult_e10_e, fgsl_sf_expm1, &
       fgsl_sf_expm1_e, fgsl_sf_exprel, fgsl_sf_exprel_e, fgsl_sf_exprel_2, fgsl_sf_exprel_2_e, &
       fgsl_sf_exprel_n, fgsl_sf_exprel_n_e, fgsl_sf_exp_err_e, fgsl_sf_exp_err_e10_e, &
       fgsl_sf_exp_mult_err_e, fgsl_sf_exp_mult_err_e10_e
  public :: fgsl_sf_expint_e1, fgsl_sf_expint_e1_e, fgsl_sf_expint_e2, fgsl_sf_expint_e2_e, &
       fgsl_sf_expint_ei, fgsl_sf_expint_ei_e, fgsl_sf_shi, fgsl_sf_shi_e, fgsl_sf_chi, &
       fgsl_sf_chi_e, fgsl_sf_expint_3, fgsl_sf_expint_3_e, fgsl_sf_si, fgsl_sf_si_e, &
       fgsl_sf_ci, fgsl_sf_ci_e, fgsl_sf_atanint, fgsl_sf_atanint_e
  public :: fgsl_sf_fermi_dirac_m1, fgsl_sf_fermi_dirac_m1_e, fgsl_sf_fermi_dirac_0, &
       fgsl_sf_fermi_dirac_0_e, fgsl_sf_fermi_dirac_1, fgsl_sf_fermi_dirac_1_e, &
       fgsl_sf_fermi_dirac_2, fgsl_sf_fermi_dirac_2_e, fgsl_sf_fermi_dirac_int, &
       fgsl_sf_fermi_dirac_int_e, fgsl_sf_fermi_dirac_mhalf, fgsl_sf_fermi_dirac_mhalf_e, &
       fgsl_sf_fermi_dirac_half, fgsl_sf_fermi_dirac_half_e, fgsl_sf_fermi_dirac_3half, &
       fgsl_sf_fermi_dirac_3half_e, fgsl_sf_fermi_dirac_inc_0, &
       fgsl_sf_fermi_dirac_inc_0_e
  public :: fgsl_sf_gamma, fgsl_sf_gamma_e, fgsl_sf_lngamma, fgsl_sf_lngamma_e, &
       fgsl_sf_lngamma_sgn_e, fgsl_sf_gammastar, fgsl_sf_gammastar_e, fgsl_sf_gammainv, &
       fgsl_sf_gammainv_e, fgsl_sf_lngamma_complex_e, fgsl_sf_fact, fgsl_sf_fact_e, &
       fgsl_sf_doublefact, fgsl_sf_doublefact_e, fgsl_sf_lnfact, fgsl_sf_lnfact_e, &
       fgsl_sf_lndoublefact, fgsl_sf_lndoublefact_e, fgsl_sf_choose, fgsl_sf_choose_e, &
       fgsl_sf_lnchoose, fgsl_sf_lnchoose_e, fgsl_sf_taylorcoeff, fgsl_sf_taylorcoeff_e, &
       fgsl_sf_poch, fgsl_sf_poch_e, fgsl_sf_lnpoch, fgsl_sf_lnpoch_e, &
       fgsl_sf_lnpoch_sgn_e, fgsl_sf_pochrel, fgsl_sf_pochrel_e, &
       fgsl_sf_gamma_inc, fgsl_sf_gamma_inc_e, &
       fgsl_sf_gamma_inc_q, fgsl_sf_gamma_inc_q_e, fgsl_sf_gamma_inc_p, &
       fgsl_sf_gamma_inc_p_e, fgsl_sf_beta, fgsl_sf_beta_e, fgsl_sf_lnbeta, &
       fgsl_sf_lnbeta_e, fgsl_sf_beta_inc, fgsl_sf_beta_inc_e
  public :: fgsl_sf_gegenpoly_1, fgsl_sf_gegenpoly_1_e, fgsl_sf_gegenpoly_2, &
       fgsl_sf_gegenpoly_2_e, fgsl_sf_gegenpoly_3, fgsl_sf_gegenpoly_3_e, &
       fgsl_sf_gegenpoly_n, fgsl_sf_gegenpoly_n_e, fgsl_sf_gegenpoly_array, &
       fgsl_sf_hyperg_0f1, fgsl_sf_hyperg_0f1_e, fgsl_sf_hyperg_1f1_int, &
       fgsl_sf_hyperg_1f1_int_e, fgsl_sf_hyperg_1f1, fgsl_sf_hyperg_1f1_e, &
       fgsl_sf_hyperg_u_int, fgsl_sf_hyperg_u_int_e, fgsl_sf_hyperg_u_int_e10_e, &
       fgsl_sf_hyperg_u, fgsl_sf_hyperg_u_e, fgsl_sf_hyperg_u_e10_e, &
       fgsl_sf_hyperg_2f1, fgsl_sf_hyperg_2f1_e, fgsl_sf_hyperg_2f1_conj, &
       fgsl_sf_hyperg_2f1_conj_e, fgsl_sf_hyperg_2f1_renorm, fgsl_sf_hyperg_2f1_renorm_e, &
       fgsl_sf_hyperg_2f1_conj_renorm, fgsl_sf_hyperg_2f1_conj_renorm_e, &
       fgsl_sf_hyperg_2f0, fgsl_sf_hyperg_2f0_e
  public :: fgsl_sf_laguerre_1, fgsl_sf_laguerre_1_e, fgsl_sf_laguerre_2, &
       fgsl_sf_laguerre_2_e, fgsl_sf_laguerre_3, fgsl_sf_laguerre_3_e, &
       fgsl_sf_laguerre_n, fgsl_sf_laguerre_n_e
  public :: fgsl_sf_lambert_w0, fgsl_sf_lambert_w0_e, fgsl_sf_lambert_wm1, &
       fgsl_sf_lambert_wm1_e, fgsl_sf_legendre_p1, fgsl_sf_legendre_p1_e, &
       fgsl_sf_legendre_p2, fgsl_sf_legendre_p2_e, fgsl_sf_legendre_p3, &
       fgsl_sf_legendre_p3_e, fgsl_sf_legendre_pl, fgsl_sf_legendre_pl_e, &
       fgsl_sf_legendre_pl_array, fgsl_sf_legendre_pl_deriv_array, &
       fgsl_sf_legendre_q0, fgsl_sf_legendre_q0_e, &
       fgsl_sf_legendre_q1, fgsl_sf_legendre_q1_e, fgsl_sf_legendre_ql, &
       fgsl_sf_legendre_ql_e, fgsl_sf_legendre_plm, fgsl_sf_legendre_plm_e, &
       fgsl_sf_legendre_plm_array, fgsl_sf_legendre_plm_deriv_array, &
       fgsl_sf_legendre_sphplm, fgsl_sf_legendre_sphplm_e, &
       fgsl_sf_legendre_sphplm_array, fgsl_sf_legendre_sphplm_deriv_array, &
       fgsl_sf_legendre_array_size
  public :: fgsl_sf_conicalp_half, fgsl_sf_conicalp_half_e, fgsl_sf_conicalp_mhalf, &
       fgsl_sf_conicalp_mhalf_e, fgsl_sf_conicalp_0, fgsl_sf_conicalp_0_e, &
       fgsl_sf_conicalp_1, fgsl_sf_conicalp_1_e, fgsl_sf_conicalp_sph_reg, &
       fgsl_sf_conicalp_sph_reg_e, fgsl_sf_conicalp_cyl_reg, fgsl_sf_conicalp_cyl_reg_e, &
       fgsl_sf_legendre_h3d_0, fgsl_sf_legendre_h3d_0_e, fgsl_sf_legendre_h3d_1, &
       fgsl_sf_legendre_h3d_1_e, fgsl_sf_legendre_h3d, fgsl_sf_legendre_h3d_e, &
       fgsl_sf_legendre_h3d_array
  public :: fgsl_sf_log, fgsl_sf_log_e, fgsl_sf_log_abs, fgsl_sf_log_abs_e, &
       fgsl_sf_complex_log_e, fgsl_sf_log_1plusx, fgsl_sf_log_1plusx_e, &
       fgsl_sf_log_1plusx_mx, fgsl_sf_log_1plusx_mx_e, fgsl_sf_psi_int, &
       fgsl_sf_psi_1_int, fgsl_sf_psi_1_int_e, fgsl_sf_psi_1, fgsl_sf_psi_1_e,&
       fgsl_sf_psi_n, fgsl_sf_psi_n_e,&
       fgsl_sf_psi_int_e, fgsl_sf_psi, fgsl_sf_psi_e, fgsl_sf_psi_1piy, &
       fgsl_sf_psi_1piy_e, fgsl_sf_synchrotron_1, fgsl_sf_synchrotron_1_e, &
       fgsl_sf_synchrotron_2, fgsl_sf_synchrotron_2_e, fgsl_sf_transport_2, &
       fgsl_sf_transport_2_e, fgsl_sf_transport_3, fgsl_sf_transport_3_e, &
       fgsl_sf_transport_4, fgsl_sf_transport_4_e, fgsl_sf_transport_5, &
       fgsl_sf_transport_5_e, fgsl_sf_hypot, fgsl_sf_hypot_e, fgsl_sf_sinc, &
       fgsl_sf_sinc_e, fgsl_sf_complex_sin_e, fgsl_sf_complex_cos_e, &
       fgsl_sf_complex_logsin_e, fgsl_sf_lnsinh, fgsl_sf_lnsinh_e, &
       fgsl_sf_lncosh, fgsl_sf_lncosh_e, fgsl_sf_polar_to_rect, &
       fgsl_sf_rect_to_polar, fgsl_sf_angle_restrict_symm, fgsl_sf_angle_restrict_symm_e, &
       fgsl_sf_angle_restrict_pos, fgsl_sf_angle_restrict_pos_e, fgsl_sf_sin_err_e, &
       fgsl_sf_cos_err_e, fgsl_sf_zeta_int, fgsl_sf_zeta_int_e, &
       fgsl_sf_eta_int, fgsl_sf_eta_int_e, fgsl_sf_zeta, &
       fgsl_sf_zeta_e, fgsl_sf_zetam1_int, fgsl_sf_zetam1_int_e, fgsl_sf_zetam1, &
       fgsl_sf_zetam1_e, fgsl_sf_hzeta, fgsl_sf_hzeta_e, fgsl_sf_eta, fgsl_sf_eta_e
! array processing
  public :: fgsl_vector_init, fgsl_vector_align, fgsl_vector_free
  public :: fgsl_matrix_init, fgsl_matrix_align, fgsl_matrix_free
! interpolation
  public :: fgsl_interp_alloc, fgsl_interp_init, &
       fgsl_interp_free, fgsl_interp_eval, fgsl_interp_eval_e, &
       fgsl_interp_eval_deriv, fgsl_interp_eval_deriv_e, &
       fgsl_interp_eval_deriv2, fgsl_interp_eval_deriv2_e, &
       fgsl_interp_eval_integ, fgsl_interp_eval_integ_e, &
       fgsl_interp_min_size,fgsl_interp_name
  public :: fgsl_spline_alloc, fgsl_spline_init, fgsl_spline_free, & 
       fgsl_spline_name, fgsl_spline_min_size, fgsl_spline_eval, &
       fgsl_spline_eval_e, fgsl_spline_eval_deriv, fgsl_spline_eval_deriv_e, &
       fgsl_spline_eval_deriv2, fgsl_spline_eval_deriv2_e, &
       fgsl_spline_eval_integ, fgsl_spline_eval_integ_e
  public :: fgsl_interp_accel_alloc, fgsl_interp_accel_free, &
       fgsl_interp_accel_find, fgsl_interp_bsearch
! permutations and combinations
  public :: fgsl_permutation_alloc, fgsl_permutation_calloc, fgsl_permutation_init, &
       fgsl_permutation_free, fgsl_permutation_memcpy, fgsl_permutation_get, &
       fgsl_permutation_swap, fgsl_permutation_size, fgsl_permutation_data, &
       fgsl_permutation_valid, fgsl_permutation_reverse, fgsl_permutation_inverse, &
       fgsl_permutation_next, fgsl_permutation_prev, &
       fgsl_permute, fgsl_permute_inverse, fgsl_permute_vector, &
       fgsl_permute_vector_inverse, fgsl_permutation_mul, &
       fgsl_permutation_linear_to_canonical, fgsl_permutation_canonical_to_linear, &
       fgsl_permutation_inversions, fgsl_permutation_linear_cycles, &
       fgsl_permutation_canonical_cycles, fgsl_permutation_fwrite, &
       fgsl_permutation_fread, fgsl_permutation_fprintf, &
       fgsl_permutation_fscanf, fgsl_combination_alloc, &
       fgsl_combination_calloc, fgsl_combination_init_first, fgsl_combination_init_last, &
       fgsl_combination_free, fgsl_combination_memcpy, fgsl_combination_get, &
       fgsl_combination_n, fgsl_combination_k, fgsl_combination_data, &
       fgsl_combination_valid, fgsl_combination_next, &
       fgsl_combination_prev, fgsl_combination_fwrite, fgsl_combination_fread, &
       fgsl_combination_fprintf, fgsl_combination_fscanf
! sorting
  public :: fgsl_heapsort, fgsl_heapsort_index, fgsl_sort, fgsl_sort_index, &
       fgsl_sort_smallest, fgsl_sort_smallest_index, &
       fgsl_sort_largest, fgsl_sort_largest_index
! numerical integration
  public :: fgsl_integration_qng, fgsl_integration_workspace_alloc, &
       fgsl_integration_workspace_free, &
       fgsl_integration_qag, fgsl_integration_qagi, fgsl_integration_qags, &
       fgsl_integration_qagp, fgsl_integration_qagiu, fgsl_integration_qagil, &
       fgsl_integration_qawc, fgsl_integration_qaws_table_alloc, &
       fgsl_integration_qaws_table_set, fgsl_integration_qaws_table_free, &
       fgsl_integration_qaws, &
       fgsl_integration_qawo_table_alloc, fgsl_integration_qawo_table_set, &
       fgsl_integration_qawo_table_set_length, fgsl_integration_qawo, &
       fgsl_integration_qawo_table_free, fgsl_integration_qawf
! random numbers, quasi-random numbers, distribution functions
  public :: fgsl_rng_alloc, fgsl_rng_set, fgsl_rng_free, fgsl_rng_get, fgsl_rng_uniform, &
       fgsl_rng_uniform_pos, fgsl_rng_uniform_int, fgsl_rng_name, fgsl_rng_max, &
       fgsl_rng_min, fgsl_rng_env_setup, fgsl_rng_memcpy, fgsl_rng_clone, &
       fgsl_rng_fwrite, fgsl_rng_fread, fgsl_qrng_alloc, &
       fgsl_qrng_free, fgsl_qrng_init, fgsl_qrng_get, fgsl_qrng_name, fgsl_qrng_memcpy, &
       fgsl_qrng_clone
  public :: fgsl_ran_gaussian, fgsl_ran_gaussian_pdf, fgsl_ran_gaussian_ziggurat, &
       fgsl_ran_gaussian_ratio_method, fgsl_ran_ugaussian, fgsl_ran_ugaussian_pdf, &
       fgsl_ran_ugaussian_ratio_method, fgsl_cdf_gaussian_p, fgsl_cdf_gaussian_q, &
       fgsl_cdf_gaussian_pinv, fgsl_cdf_gaussian_qinv, fgsl_cdf_ugaussian_p, &
       fgsl_cdf_ugaussian_q, fgsl_cdf_ugaussian_pinv, fgsl_cdf_ugaussian_qinv, &
       fgsl_ran_gaussian_tail, fgsl_ran_gaussian_tail_pdf, fgsl_ran_ugaussian_tail, &
       fgsl_ran_ugaussian_tail_pdf, fgsl_ran_bivariate_gaussian, fgsl_ran_exponential, &
       fgsl_ran_exponential_pdf, fgsl_cdf_exponential_p, fgsl_cdf_exponential_q, &
       fgsl_cdf_exponential_pinv, fgsl_cdf_exponential_qinv, fgsl_ran_laplace, &
       fgsl_ran_laplace_pdf, fgsl_cdf_laplace_p, fgsl_cdf_laplace_q, &
       fgsl_cdf_laplace_pinv, fgsl_cdf_laplace_qinv, fgsl_ran_exppow, &
       fgsl_ran_exppow_pdf, fgsl_cdf_exppow_p, fgsl_cdf_exppow_q, fgsl_ran_cauchy, &
       fgsl_ran_cauchy_pdf, fgsl_cdf_cauchy_p, fgsl_cdf_cauchy_q, fgsl_cdf_cauchy_pinv, &
       fgsl_cdf_cauchy_qinv, fgsl_ran_rayleigh, fgsl_ran_rayleigh_pdf, &
       fgsl_cdf_rayleigh_p, fgsl_cdf_rayleigh_q, fgsl_cdf_rayleigh_pinv, &
       fgsl_cdf_rayleigh_qinv, fgsl_ran_rayleigh_tail, fgsl_ran_rayleigh_tail_pdf, &
       fgsl_ran_landau, fgsl_ran_landau_pdf, fgsl_ran_levy, fgsl_ran_levy_skew
  public :: fgsl_ran_gamma, fgsl_ran_gamma_mt, fgsl_ran_gamma_pdf, fgsl_cdf_gamma_p, &
       fgsl_cdf_gamma_q, fgsl_cdf_gamma_pinv, fgsl_cdf_gamma_qinv, fgsl_ran_flat, &
       fgsl_ran_flat_pdf, fgsl_cdf_flat_p, fgsl_cdf_flat_q, fgsl_cdf_flat_pinv, &
       fgsl_cdf_flat_qinv, fgsl_ran_lognormal, fgsl_ran_lognormal_pdf, &
       fgsl_cdf_lognormal_p, fgsl_cdf_lognormal_q, fgsl_cdf_lognormal_pinv, &
       fgsl_cdf_lognormal_qinv, fgsl_ran_chisq, fgsl_ran_chisq_pdf, fgsl_cdf_chisq_p, &
       fgsl_cdf_chisq_q, fgsl_cdf_chisq_pinv, fgsl_cdf_chisq_qinv, fgsl_ran_fdist, &
       fgsl_ran_fdist_pdf, fgsl_cdf_fdist_p, fgsl_cdf_fdist_q, fgsl_cdf_fdist_pinv, &
       fgsl_cdf_fdist_qinv, fgsl_ran_tdist, fgsl_ran_tdist_pdf, fgsl_cdf_tdist_p, &
       fgsl_cdf_tdist_q, fgsl_cdf_tdist_pinv, fgsl_cdf_tdist_qinv, fgsl_ran_beta, &
       fgsl_ran_beta_pdf, fgsl_cdf_beta_p, fgsl_cdf_beta_q, fgsl_cdf_beta_pinv, &
       fgsl_cdf_beta_qinv, fgsl_ran_logistic, fgsl_ran_logistic_pdf, fgsl_cdf_logistic_p, &
       fgsl_cdf_logistic_q, fgsl_cdf_logistic_pinv, fgsl_cdf_logistic_qinv, &
       fgsl_ran_pareto, fgsl_ran_pareto_pdf, fgsl_cdf_pareto_p, fgsl_cdf_pareto_q, &
       fgsl_cdf_pareto_pinv, fgsl_cdf_pareto_qinv, fgsl_ran_dir_2d, &
       fgsl_ran_dir_2d_trig_method, fgsl_ran_dir_3d, fgsl_ran_dir_nd, &
       fgsl_ran_weibull, fgsl_ran_weibull_pdf, fgsl_cdf_weibull_p, fgsl_cdf_weibull_q, &
       fgsl_cdf_weibull_pinv, fgsl_cdf_weibull_qinv, fgsl_ran_gumbel1, &
       fgsl_ran_gumbel1_pdf, fgsl_cdf_gumbel1_p, fgsl_cdf_gumbel1_q, &
       fgsl_cdf_gumbel1_pinv, fgsl_cdf_gumbel1_qinv, fgsl_ran_gumbel2, &
       fgsl_ran_gumbel2_pdf, fgsl_cdf_gumbel2_p, fgsl_cdf_gumbel2_q, &
       fgsl_cdf_gumbel2_pinv, fgsl_cdf_gumbel2_qinv, fgsl_ran_dirichlet, &
       fgsl_ran_dirichlet_pdf, fgsl_ran_dirichlet_lnpdf, fgsl_ran_discrete_preproc, &
       fgsl_ran_discrete, fgsl_ran_discrete_pdf, fgsl_ran_poisson, fgsl_ran_poisson_pdf, &
       fgsl_cdf_poisson_p, fgsl_cdf_poisson_q, fgsl_ran_bernoulli, &
       fgsl_ran_bernoulli_pdf, fgsl_ran_binomial, fgsl_ran_binomial_pdf, &
       fgsl_cdf_binomial_p, fgsl_cdf_binomial_q, fgsl_ran_multinomial, &
       fgsl_ran_multinomial_pdf, fgsl_ran_multinomial_lnpdf, fgsl_ran_negative_binomial, &
       fgsl_ran_negative_binomial_pdf, fgsl_cdf_negative_binomial_p, &
       fgsl_cdf_negative_binomial_q, fgsl_ran_pascal, fgsl_ran_pascal_pdf, &
       fgsl_cdf_pascal_p, fgsl_cdf_pascal_q, fgsl_ran_geometric, fgsl_ran_geometric_pdf, &
       fgsl_cdf_geometric_p, fgsl_cdf_geometric_q, fgsl_ran_hypergeometric, &
       fgsl_ran_hypergeometric_pdf, fgsl_cdf_hypergeometric_p, fgsl_cdf_hypergeometric_q, &
       fgsl_ran_logarithmic, fgsl_ran_logarithmic_pdf, &
       fgsl_ran_shuffle, fgsl_ran_choose, fgsl_ran_sample
! simulated annealing
  public :: fgsl_siman_params_init, fgsl_siman_params_free, fgsl_siman_solve
! ordinary differential equations
  public :: fgsl_odeiv_system_init, fgsl_odeiv_system_free, &
       fgsl_odeiv_step_alloc, fgsl_odeiv_step_status, fgsl_odeiv_system_status, &
       fgsl_odeiv_step_reset, fgsl_odeiv_step_free, fgsl_odeiv_step_name, &
       fgsl_odeiv_step_order, fgsl_odeiv_step_apply, fgsl_odeiv_control_standard_new, &
       fgsl_odeiv_control_y_new, fgsl_odeiv_control_yp_new, &
       fgsl_odeiv_control_scaled_new, fgsl_odeiv_control_init, &
       fgsl_odeiv_control_free, fgsl_odeiv_control_hadjust, &
       fgsl_odeiv_control_name, fgsl_odeiv_evolve_alloc, fgsl_odeiv_evolve_apply, &
       fgsl_odeiv_evolve_reset, fgsl_odeiv_evolve_free
! Monte Carlo
  public :: fgsl_monte_function_init, fgsl_monte_function_free, &
       fgsl_monte_plain_alloc, fgsl_monte_plain_init, &
       fgsl_monte_plain_integrate, fgsl_monte_plain_free, &
       fgsl_monte_miser_alloc, fgsl_monte_miser_init, &
       fgsl_monte_miser_integrate, fgsl_monte_miser_free, &
       fgsl_monte_vegas_alloc, fgsl_monte_vegas_init, &
       fgsl_monte_vegas_integrate, fgsl_monte_vegas_free, &
       fgsl_monte_miser_setparams, fgsl_monte_miser_getparams, &
       fgsl_monte_vegas_setparams, fgsl_monte_vegas_getparams
! Histograms
  public :: fgsl_histogram_alloc, fgsl_histogram_set_ranges, &
       fgsl_histogram_set_ranges_uniform, fgsl_histogram_free, &
       fgsl_histogram_memcpy, fgsl_histogram_clone, fgsl_histogram_increment, &
       fgsl_histogram_accumulate, fgsl_histogram_get, fgsl_histogram_get_range, &
       fgsl_histogram_max, fgsl_histogram_min, fgsl_histogram_bins, &
       fgsl_histogram_reset, fgsl_histogram_find, fgsl_histogram_max_val, &
       fgsl_histogram_min_val, fgsl_histogram_max_bin, &
       fgsl_histogram_min_bin, fgsl_histogram_mean, &
       fgsl_histogram_sigma, fgsl_histogram_sum, fgsl_histogram_equal_bins_p, &
       fgsl_histogram_add, fgsl_histogram_sub, fgsl_histogram_mul, &
       fgsl_histogram_div, fgsl_histogram_scale, fgsl_histogram_shift, &
       fgsl_histogram_fwrite, fgsl_histogram_fread, fgsl_histogram_fprintf, &
       fgsl_histogram_fscanf, fgsl_histogram_pdf_alloc, fgsl_histogram_pdf_init, &
       fgsl_histogram_pdf_free, fgsl_histogram_pdf_sample, &
       fgsl_histogram2d_alloc, fgsl_histogram2d_set_ranges, &
       fgsl_histogram2d_set_ranges_uniform, fgsl_histogram2d_free, &
       fgsl_histogram2d_memcpy, fgsl_histogram2d_clone, fgsl_histogram2d_increment, &
       fgsl_histogram2d_accumulate, fgsl_histogram2d_get, fgsl_histogram2d_get_xrange, &
       fgsl_histogram2d_get_yrange, fgsl_histogram2d_xmax, &
       fgsl_histogram2d_xmin, fgsl_histogram2d_ymax, &
       fgsl_histogram2d_ymin, fgsl_histogram2d_nx, fgsl_histogram2d_ny, &
       fgsl_histogram2d_reset, fgsl_histogram2d_find, fgsl_histogram2d_max_val, &
       fgsl_histogram2d_min_val, fgsl_histogram2d_max_bin, &
       fgsl_histogram2d_min_bin, fgsl_histogram2d_xmean, fgsl_histogram2d_ymean, &
       fgsl_histogram2d_xsigma, fgsl_histogram2d_ysigma, fgsl_histogram2d_cov, &
       fgsl_histogram2d_sum, fgsl_histogram2d_equal_bins_p, &
       fgsl_histogram2d_add, fgsl_histogram2d_sub, fgsl_histogram2d_mul, &
       fgsl_histogram2d_div, fgsl_histogram2d_scale, fgsl_histogram2d_shift, &
       fgsl_histogram2d_fwrite, fgsl_histogram2d_fread, fgsl_histogram2d_fprintf, &
       fgsl_histogram2d_fscanf, fgsl_histogram2d_pdf_alloc, fgsl_histogram2d_pdf_init, &
       fgsl_histogram2d_pdf_free, fgsl_histogram2d_pdf_sample
! Ntuples
  public :: fgsl_ntuple_create, fgsl_ntuple_open, fgsl_ntuple_write, &
       fgsl_ntuple_bookdata, fgsl_ntuple_read, fgsl_ntuple_close, &
       fgsl_ntuple_select_fn_init, fgsl_ntuple_value_fn_init, &
       fgsl_ntuple_select_fn_free, fgsl_ntuple_value_fn_free, &
       fgsl_ntuple_project
! Numerical derivatives
  public :: fgsl_deriv_central, fgsl_deriv_forward, fgsl_deriv_backward
! Chebyshev approximations
  public :: fgsl_cheb_alloc, fgsl_cheb_free, fgsl_cheb_init, fgsl_cheb_eval, &
       fgsl_cheb_eval_err, fgsl_cheb_eval_n, fgsl_cheb_eval_n_err, fgsl_cheb_calc_deriv, &
       fgsl_cheb_calc_integ
! Series acceleration
  public :: fgsl_sum_levin_u_alloc, fgsl_sum_levin_u_free, fgsl_sum_levin_u_accel, &
       fgsl_sum_levin_utrunc_alloc, fgsl_sum_levin_utrunc_free, fgsl_sum_levin_utrunc_accel
! Wavelet transforms
  public :: fgsl_wavelet_alloc, fgsl_wavelet_name, fgsl_wavelet_free, &
       fgsl_wavelet_workspace_alloc, fgsl_wavelet_workspace_free, fgsl_wavelet_transform, &
       fgsl_wavelet_transform_forward, fgsl_wavelet_transform_inverse, &
       fgsl_wavelet2d_transform, fgsl_wavelet2d_transform_forward, &
       fgsl_wavelet2d_transform_inverse, fgsl_wavelet2d_nstransform, &
       fgsl_wavelet2d_nstransform_forward, fgsl_wavelet2d_nstransform_inverse
! Hankel Transform
  public :: fgsl_dht_alloc, fgsl_dht_init, fgsl_dht_new, fgsl_dht_free, &
       fgsl_dht_apply, fgsl_dht_x_sample, fgsl_dht_k_sample
! One-dimensional root finding
  public :: fgsl_root_fsolver_alloc, fgsl_root_fdfsolver_alloc, fgsl_root_fsolver_set, &
       fgsl_root_fdfsolver_set, fgsl_root_fsolver_free, fgsl_root_fdfsolver_free, &
       fgsl_root_fsolver_name, fgsl_root_fdfsolver_name, fgsl_root_fsolver_iterate, &
       fgsl_root_fdfsolver_iterate, fgsl_root_fsolver_x_lower, fgsl_root_fsolver_x_upper, &
       fgsl_root_test_interval, fgsl_root_test_delta, fgsl_root_test_residual, &
       fgsl_root_fsolver_root, fgsl_root_fdfsolver_root
! One-dimensional minimization
  public :: fgsl_min_fminimizer_alloc, fgsl_min_fminimizer_free, fgsl_min_fminimizer_set, &
       fgsl_min_fminimizer_set_with_values, fgsl_min_fminimizer_iterate, fgsl_min_fminimizer_name, &
       fgsl_min_fminimizer_x_minimum, fgsl_min_fminimizer_x_lower, fgsl_min_fminimizer_x_upper, &
       fgsl_min_fminimizer_f_minimum, fgsl_min_fminimizer_f_lower, fgsl_min_fminimizer_f_upper, &
       fgsl_min_test_interval
! Multi-root
  public :: fgsl_multiroot_function_init, fgsl_multiroot_function_free, &
       fgsl_multiroot_fsolver_alloc, fgsl_multiroot_fsolver_free, fgsl_multiroot_fsolver_name, &
       fgsl_multiroot_fsolver_iterate, fgsl_multiroot_fsolver_root, fgsl_multiroot_fsolver_f, &
       fgsl_multiroot_fsolver_dx, fgsl_multiroot_test_delta, fgsl_multiroot_test_residual, &
       fgsl_multiroot_fsolver_set, fgsl_multiroot_fdfsolver_alloc, fgsl_multiroot_fdfsolver_free, &
       fgsl_multiroot_fdfsolver_name, fgsl_multiroot_function_fdf_init, fgsl_multiroot_function_fdf_free, &
       fgsl_multiroot_fdfsolver_iterate, fgsl_multiroot_fdfsolver_root, fgsl_multiroot_fdfsolver_f, &
       fgsl_multiroot_fdfsolver_dx, fgsl_multiroot_fdfsolver_set
! Multi-minimization
  public :: fgsl_multimin_function_init, fgsl_multimin_function_fdf_init, &
       fgsl_multimin_function_free, fgsl_multimin_function_fdf_free, fgsl_multimin_fminimizer_alloc, &
       fgsl_multimin_fdfminimizer_alloc, fgsl_multimin_fminimizer_free, fgsl_multimin_fdfminimizer_free, &
       fgsl_multimin_fminimizer_set, fgsl_multimin_fdfminimizer_set, fgsl_multimin_fminimizer_name, &
       fgsl_multimin_fdfminimizer_name, fgsl_multimin_fminimizer_iterate, &
       fgsl_multimin_fdfminimizer_iterate, &
       fgsl_multimin_fminimizer_minimum, fgsl_multimin_fdfminimizer_minimum, &
       fgsl_multimin_fdfminimizer_gradient, fgsl_multimin_fminimizer_size, &
       fgsl_multimin_fdfminimizer_restart, fgsl_multimin_fminimizer_x, &
       fgsl_multimin_test_size, fgsl_multimin_fdfminimizer_x, fgsl_multimin_test_gradient
! Linear and nonlinear fitting
  public :: fgsl_fit_linear, fgsl_fit_wlinear, fgsl_fit_linear_est, fgsl_fit_mul, &
       fgsl_fit_wmul, fgsl_fit_mul_est, fgsl_multifit_linear_alloc, fgsl_multifit_linear_free, &
       fgsl_multifit_linear, fgsl_multifit_linear_svd, fgsl_multifit_wlinear, &
       fgsl_multifit_wlinear_svd, fgsl_multifit_linear_est
  public :: fgsl_multifit_function_init, fgsl_multifit_function_fdf_init, &
       fgsl_multifit_function_free, fgsl_multifit_function_fdf_free, fgsl_multifit_fsolver_alloc, &
       fgsl_multifit_fdfsolver_alloc, fgsl_multifit_fsolver_free, fgsl_multifit_fdfsolver_free, &
       fgsl_multifit_fsolver_set, fgsl_multifit_fdfsolver_set, fgsl_multifit_fsolver_name, &
       fgsl_multifit_fdfsolver_name, fgsl_multifit_fsolver_iterate, fgsl_multifit_fdfsolver_iterate, &
       fgsl_multifit_fsolver_position, fgsl_multifit_fdfsolver_position, &
       fgsl_multifit_fdfsolver_dx, fgsl_multifit_fdfsolver_f, fgsl_multifit_fdfsolver_jac, &
       fgsl_multifit_test_delta, fgsl_multifit_test_gradient, fgsl_multifit_gradient, &
       fgsl_multifit_covar
! statistics
  public :: fgsl_stats_mean, fgsl_stats_variance, fgsl_stats_variance_m, &
       fgsl_stats_sd, fgsl_stats_sd_m, fgsl_stats_variance_with_fixed_mean, &
       fgsl_stats_sd_with_fixed_mean, fgsl_stats_absdev, fgsl_stats_absdev_m, &
       fgsl_stats_skew, fgsl_stats_skew_m_sd, fgsl_stats_kurtosis, &
       fgsl_stats_kurtosis_m_sd, fgsl_stats_lag1_autocorrelation, &
       fgsl_stats_covariance, fgsl_stats_covariance_m, fgsl_stats_wmean, &
       fgsl_stats_wvariance, fgsl_stats_wvariance_m, fgsl_stats_wsd, &
       fgsl_stats_wvariance_with_fixed_mean, fgsl_stats_wsd_with_fixed_mean, &
       fgsl_stats_wabsdev, fgsl_stats_wabsdev_m, fgsl_stats_wskew, &
       fgsl_stats_wskew_m_sd, fgsl_stats_wkurtosis, fgsl_stats_max, &
       fgsl_stats_min, fgsl_stats_minmax, fgsl_stats_max_index, &
       fgsl_stats_min_index, fgsl_stats_minmax_index, fgsl_stats_median_from_sorted_data, &
       fgsl_stats_quantile_from_sorted_data
! IEEE
  public :: fgsl_ieee_fprintf, fgsl_ieee_printf, fgsl_ieee_env_setup
!
!
! Kind and length parameters are default integer
!
  integer, parameter, public :: fgsl_double = c_double
!  integer, parameter, public :: fgsl_extended = selected_real_kind(18)
  integer, parameter, public :: fgsl_extended = selected_real_kind(13)
! FIXME - c_long_double unsupported, selected_real_kind(30) unsupported in g95
  integer, parameter, public :: fgsl_float = c_float
  integer, parameter, public :: fgsl_int = c_int
  integer, parameter, public :: fgsl_long = c_long
  integer, parameter, public :: fgsl_size_t = c_size_t
  integer, parameter, public :: fgsl_char = c_char
  integer, parameter, public :: fgsl_strmax = 128
  integer, parameter :: fgsl_pathmax = 2048
!
! Version strings
!
  character(kind=fgsl_char, len=3), public, parameter :: fgsl_version='0.7'
  character(kind=fgsl_char, len=3), public, parameter :: fgsl_gslbase='1.8'
!
! Error codes
!
  integer(fgsl_int), parameter, public :: fgsl_success = 0
  integer(fgsl_int), parameter, public :: fgsl_failure = -1
  integer(fgsl_int), parameter, public :: fgsl_continue = -2 ! iteration has not converged
  integer(fgsl_int), parameter, public :: fgsl_edom = 1      ! input domain error, e.g. sqrt(-1)
  integer(fgsl_int), parameter, public :: fgsl_erange = 2    ! output range error, e.g. exp(1e100)
  integer(fgsl_int), parameter, public :: fgsl_efault = 3    ! invalid pointer
  integer(fgsl_int), parameter, public :: fgsl_einval = 4    ! invalid argument supplied by user 
  integer(fgsl_int), parameter, public :: fgsl_efactor = 6   ! generic failure
  integer(fgsl_int), parameter, public :: fgsl_esanity = 7   ! sanity check failed - shouldn't happen
  integer(fgsl_int), parameter, public :: fgsl_enomem = 8    ! malloc failed
  integer(fgsl_int), parameter, public :: fgsl_ebadfunc = 9  ! problem with user-supplied function
  integer(fgsl_int), parameter, public :: fgsl_erunaway = 10 ! iterative process is out of control 
  integer(fgsl_int), parameter, public :: fgsl_emaxiter = 11 ! exceeded max number of iterations
  integer(fgsl_int), parameter, public :: fgsl_ezerodiv = 12 ! tried to divide by zero
  integer(fgsl_int), parameter, public :: fgsl_ebadtol = 13  ! user specified an invalid tolerance
  integer(fgsl_int), parameter, public :: fgsl_etol = 14     ! failed to reach the specified tolerance
  integer(fgsl_int), parameter, public :: fgsl_eundrflw = 15 ! underflow 
  integer(fgsl_int), parameter, public :: fgsl_eovrflw = 16  ! overflow
  integer(fgsl_int), parameter, public :: fgsl_eloss = 17    ! loss of accuracy 
  integer(fgsl_int), parameter, public :: fgsl_eround = 18   ! failed because of roundoff error
  integer(fgsl_int), parameter, public :: fgsl_ebadlen = 19  ! matrix, vector lengths are not conformant
  integer(fgsl_int), parameter, public :: fgsl_enotsqr = 20  ! matrix not square
  integer(fgsl_int), parameter, public :: fgsl_esing = 21    ! apparent singularity detected 
  integer(fgsl_int), parameter, public :: fgsl_ediverge = 22 ! integral or series is divergent 
  integer(fgsl_int), parameter, public :: fgsl_eunsup = 23   ! no hw support for requested feature 
  integer(fgsl_int), parameter, public :: fgsl_eunimpl = 24  ! requested feature not (yet) implemented 
  integer(fgsl_int), parameter, public :: fgsl_ecache = 25   ! cache limit exceeded
  integer(fgsl_int), parameter, public :: fgsl_etable = 26   ! table limit exceeded 
  integer(fgsl_int), parameter, public :: fgsl_enoprog = 27  ! iteration: no progress towards solution
  integer(fgsl_int), parameter, public :: fgsl_enoprogj = 28 ! jacobian evals not improving the solution
  integer(fgsl_int), parameter, public :: fgsl_etolf = 29    ! can't reach specified tolerance in F 
  integer(fgsl_int), parameter, public :: fgsl_etolx = 30    ! can't reach specified tolerance in X
  integer(fgsl_int), parameter, public :: fgsl_etolg = 31    ! can't reach specified tolerance in gradient
  integer(fgsl_int), parameter, public :: fgsl_eof = 32      ! end of file 
!
! mathematical constants from gsl_math.h
!
  real(fgsl_extended), parameter, public :: m_e = 2.71828182845904523536028747135_fgsl_extended
  real(fgsl_extended), parameter, public :: m_log2e = 1.44269504088896340735992468100_fgsl_extended
  real(fgsl_extended), parameter, public :: m_log10e = 0.43429448190325182765112891892_fgsl_extended
  real(fgsl_extended), parameter, public :: m_sqrt2 = 1.41421356237309504880168872421_fgsl_extended
  real(fgsl_extended), parameter, public :: m_sqrt1_2 = 0.70710678118654752440084436210_fgsl_extended
  real(fgsl_extended), parameter, public :: m_sqrt3 = 1.73205080756887729352744634151_fgsl_extended
  real(fgsl_extended), parameter, public :: m_pi = 3.14159265358979323846264338328_fgsl_extended
  real(fgsl_extended), parameter, public :: m_pi_2 = 1.57079632679489661923132169164_fgsl_extended
  real(fgsl_extended), parameter, public :: m_pi_4 = 0.78539816339744830966156608458_fgsl_extended
  real(fgsl_extended), parameter, public :: m_sqrtpi = 1.77245385090551602729816748334_fgsl_extended
  real(fgsl_extended), parameter, public :: m_2_sqrtpi = 1.12837916709551257389615890312_fgsl_extended
  real(fgsl_extended), parameter, public :: m_1_pi = 0.31830988618379067153776752675_fgsl_extended
  real(fgsl_extended), parameter, public :: m_2_pi = 0.63661977236758134307553505349_fgsl_extended
  real(fgsl_extended), parameter, public :: m_ln10 = 2.30258509299404568401799145468_fgsl_extended
  real(fgsl_extended), parameter, public :: m_ln2 = 0.69314718055994530941723212146_fgsl_extended
  real(fgsl_extended), parameter, public :: m_lnpi = 1.14472988584940017414342735135_fgsl_extended
  real(fgsl_extended), parameter, public :: m_euler = 0.57721566490153286060651209008_fgsl_extended
! the following provokes warnings from g95 ... may need to change if refused by other compilers 
!  real(fgsl_double), parameter, public :: fgsl_posinf = 1.0_fgsl_double / 0.0_fgsl_double
!  real(fgsl_double), parameter, public :: fgsl_neginf = -1.0_fgsl_double / 0.0_fgsl_double
!  real(fgsl_double), parameter, public :: fgsl_nan = 0.0_fgsl_double / 0.0_fgsl_double
! probably should throw this out - use IEEE_VALUE intrinsic if these are needed.
!
! Numerical constants
!
  real(fgsl_double), parameter, public :: fgsl_const_num_fine_structure = 7.297352533E-3_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_num_avogadro = 6.02214199E23_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_num_yotta = 1e24_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_num_zetta = 1e21_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_num_exa = 1e18_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_num_peta = 1e15_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_num_tera = 1e12_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_num_giga = 1e9_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_num_mega = 1e6_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_num_kilo = 1e3_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_num_milli = 1e-3_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_num_micro = 1e-6_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_num_nano = 1e-9_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_num_pico = 1e-12_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_num_femto = 1e-15_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_num_atto = 1e-18_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_num_zepto = 1e-21_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_num_yocto = 1e-24_fgsl_double
!
! MKSA physical units
!
  real(fgsl_double), parameter, public :: fgsl_const_mksa_speed_of_light = 2.99792458e8_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_gravitational_constant = 6.673e-11_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_plancks_constant_h = 6.62606876e-34_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_plancks_constant_hbar = 1.05457159642e-34_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_astronomical_unit = 1.49597870691e11_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_light_year = 9.46053620707e15_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_parsec = 3.08567758135e16_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_grav_accel = 9.80665e0_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_electron_volt = 1.602176462e-19_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_mass_electron = 9.10938188e-31_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_mass_muon = 1.88353109e-28_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_mass_proton = 1.67262158e-27_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_mass_neutron = 1.67492716e-27_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_rydberg = 2.17987190389e-18_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_boltzmann = 1.3806503e-23_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_bohr_magneton = 9.27400899e-24_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_nuclear_magneton = 5.05078317e-27_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_electron_magnetic_moment = 9.28476362e-24_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_proton_magnetic_moment = 1.410606633e-26_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_molar_gas = 8.314472e0_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_standard_gas_volume = 2.2710981e-2_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_minute = 6e1_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_hour = 3.6e3_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_day = 8.64e4_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_week = 6.048e5_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_inch = 2.54e-2_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_foot = 3.048e-1_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_yard = 9.144e-1_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_mile = 1.609344e3_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_nautical_mile = 1.852e3_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_fathom = 1.8288e0_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_mil = 2.54e-5_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_point = 3.52777777778e-4_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_texpoint = 3.51459803515e-4_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_micron = 1e-6_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_angstrom = 1e-10_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_hectare = 1e4_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_acre = 4.04685642241e3_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_barn = 1e-28_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_liter = 1e-3_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_us_gallon = 3.78541178402e-3_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_quart = 9.46352946004e-4_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_pint = 4.73176473002e-4_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_cup = 2.36588236501e-4_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_fluid_ounce = 2.95735295626e-5_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_tablespoon = 1.47867647813e-5_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_teaspoon = 4.92892159375e-6_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_canadian_gallon = 4.54609e-3_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_uk_gallon = 4.546092e-3_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_miles_per_hour = 4.4704e-1_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_kilometers_per_hour = 2.77777777778e-1_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_knot = 5.14444444444e-1_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_pound_mass = 4.5359237e-1_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_ounce_mass = 2.8349523125e-2_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_ton = 9.0718474e2_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_metric_ton = 1e3_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_uk_ton = 1.0160469088e3_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_troy_ounce = 3.1103475e-2_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_carat = 2e-4_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_unified_atomic_mass = 1.66053873e-27_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_gram_force = 9.80665e-3_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_pound_force = 4.44822161526e0_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_kilopound_force = 4.44822161526e3_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_poundal = 1.38255e-1_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_calorie = 4.1868e0_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_btu = 1.05505585262e3_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_therm = 1.05506e8_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_horsepower = 7.457e2_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_bar = 1e5_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_std_atmosphere = 1.01325e5_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_torr = 1.33322368421e2_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_meter_of_mercury = 1.33322368421e5_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_inch_of_mercury = 3.38638815789e3_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_inch_of_water = 2.490889e2_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_psi = 6.89475729317e3_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_poise = 1e-1_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_stokes = 1e-4_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_faraday = 9.6485341472e4_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_electron_charge = 1.602176462e-19_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_gauss = 1e-4_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_stilb = 1e4_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_lumen = 1e0_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_lux = 1e0_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_phot = 1e4_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_footcandle = 1.076e1_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_lambert = 1e4_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_footlambert = 1.07639104e1_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_curie = 3.7e10_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_roentgen = 2.58e-4_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_rad = 1e-2_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_solar_mass = 1.98892e30_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_bohr_radius = 5.291772083e-11_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_newton = 1e0_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_dyne = 1e-5_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_joule = 1e0_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_erg = 1e-7_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_stefan_boltzmann_constant = 5.67039934436e-8_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_thomson_cross_section = 6.65245853542e-29_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_vacuum_permittivity = 8.854187817e-12_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_vacuum_permeability = 1.25663706144e-6_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_mksa_debye = 3.33564095198e-30_fgsl_double
!
! CGSM physical constants
!
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_speed_of_light = 2.99792458e10_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_gravitational_constant = 6.673e-8_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_plancks_constant_h = 6.62606876e-27_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_plancks_constant_hbar = 1.05457159642e-27_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_astronomical_unit = 1.49597870691e13_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_light_year = 9.46053620707e17_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_parsec = 3.08567758135e18_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_grav_accel = 9.80665e2_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_electron_volt = 1.602176462e-12_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_mass_electron = 9.10938188e-28_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_mass_muon = 1.88353109e-25_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_mass_proton = 1.67262158e-24_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_mass_neutron = 1.67492716e-24_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_rydberg = 2.17987190389e-11_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_boltzmann = 1.3806503e-16_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_bohr_magneton = 9.27400899e-21_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_nuclear_magneton = 5.05078317e-24_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_electron_magnetic_moment = 9.28476362e-21_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_proton_magnetic_moment = 1.410606633e-23_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_molar_gas = 8.314472e7_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_standard_gas_volume = 2.2710981e4_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_minute = 6e1_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_hour = 3.6e3_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_day = 8.64e4_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_week = 6.048e5_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_inch = 2.54e0_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_foot = 3.048e1_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_yard = 9.144e1_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_mile = 1.609344e5_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_nautical_mile = 1.852e5_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_fathom = 1.8288e2_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_mil = 2.54e-3_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_point = 3.52777777778e-2_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_texpoint = 3.51459803515e-2_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_micron = 1e-4_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_angstrom = 1e-8_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_hectare = 1e8_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_acre = 4.04685642241e7_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_barn = 1e-24_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_liter = 1e3_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_us_gallon = 3.78541178402e3_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_quart = 9.46352946004e2_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_pint = 4.73176473002e2_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_cup = 2.36588236501e2_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_fluid_ounce = 2.95735295626e1_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_tablespoon = 1.47867647813e1_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_teaspoon = 4.92892159375e0_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_canadian_gallon = 4.54609e3_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_uk_gallon = 4.546092e3_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_miles_per_hour = 4.4704e1_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_kilometers_per_hour = 2.77777777778e1_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_knot = 5.14444444444e1_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_pound_mass = 4.5359237e2_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_ounce_mass = 2.8349523125e1_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_ton = 9.0718474e5_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_metric_ton = 1e6_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_uk_ton = 1.0160469088e6_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_troy_ounce = 3.1103475e1_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_carat = 2e-1_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_unified_atomic_mass = 1.66053873e-24_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_gram_force = 9.80665e2_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_pound_force = 4.44822161526e5_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_kilopound_force = 4.44822161526e8_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_poundal = 1.38255e4_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_calorie = 4.1868e7_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_btu = 1.05505585262e10_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_therm = 1.05506e15_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_horsepower = 7.457e9_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_bar = 1e6_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_std_atmosphere = 1.01325e6_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_torr = 1.33322368421e3_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_meter_of_mercury = 1.33322368421e6_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_inch_of_mercury = 3.38638815789e4_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_inch_of_water = 2.490889e3_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_psi = 6.89475729317e4_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_poise = 1e0_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_stokes = 1e0_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_faraday = 9.6485341472e3_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_electron_charge = 1.602176462e-20_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_gauss = 1e0_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_stilb = 1e0_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_lumen = 1e0_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_lux = 1e-4_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_phot = 1e0_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_footcandle = 1.076e-3_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_lambert = 1e0_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_footlambert = 1.07639104e-3_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_curie = 3.7e10_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_roentgen = 2.58e-8_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_rad = 1e2_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_solar_mass = 1.98892e33_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_bohr_radius = 5.291772083e-9_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_newton = 1e5_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_dyne = 1e0_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_joule = 1e7_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_erg = 1e0_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_stefan_boltzmann_constant = 5.67039934436e-5_fgsl_double
  real(fgsl_double), parameter, public :: fgsl_const_cgsm_thomson_cross_section = 6.65245853542e-25_fgsl_double
!
! Types : Error treatment
!
  type, public :: fgsl_error_handler_t
     private
     type(c_funptr) :: gsl_error_handler_t = c_null_funptr
  end type fgsl_error_handler_t
!
! Types: I/O Add-ons
!
  type, public :: fgsl_file
     private
     type(c_ptr) :: gsl_file = c_null_ptr
  end type fgsl_file
!
! Types: Mathematical Functions
!
  type, public :: fgsl_function
     private
     type(c_ptr) :: gsl_function = c_null_ptr
  end type fgsl_function
  type, public :: fgsl_function_fdf
     private
     type(c_ptr) :: gsl_function_fdf = c_null_ptr
  end type fgsl_function_fdf
!
! Types: Polynomial
!
! FIXME ifort refuses = overload if not public
  type, public, bind(c) :: gsl_complex
     real(c_double) :: dat(2)
  end type
  type, public :: fgsl_poly_complex_workspace
     private
     type(c_ptr) :: gsl_poly_complex_workspace
  end type fgsl_poly_complex_workspace
!
! Types: Special Functions
!
  type, public :: fgsl_sf_result
     real(fgsl_double) :: val, err
  end type fgsl_sf_result
! FIXME ifort refuses = overload if not public
  type, public, bind(c) :: gsl_sf_result
     real(c_double) :: val, err
  end type
  type, public :: fgsl_sf_result_e10
     real(fgsl_double) :: val, err
     integer(fgsl_int) :: e10
  end type fgsl_sf_result_e10
! FIXME ifort refuses = overload if not public
  type, public, bind(c) :: gsl_sf_result_e10
     real(c_double) :: val, err
     integer(c_int) :: e10
  end type 
  type, public :: fgsl_mode_t
     private
     integer(c_int) :: gsl_mode = 0
  end type fgsl_mode_t
  type(fgsl_mode_t), parameter, public :: &
       fgsl_prec_double = fgsl_mode_t(0), &
       fgsl_prec_single = fgsl_mode_t(1), &
       fgsl_prec_approx = fgsl_mode_t(2)
!
! Types : Array support
!
  type, public :: fgsl_vector
     private
     type(c_ptr) :: gsl_vector = c_null_ptr
  end type fgsl_vector
  type, public :: fgsl_matrix
     private
     type(c_ptr) :: gsl_matrix = c_null_ptr
  end type fgsl_matrix
!
! Types : Interpolation
!
!  integer, parameter :: interp_maxnum = 6
  type, public :: fgsl_interp_type
     private
     integer(fgsl_int) :: which = 0
  end type fgsl_interp_type
  type(fgsl_interp_type), parameter, public :: &
       fgsl_interp_linear = fgsl_interp_type(1), &
       fgsl_interp_polynomial = fgsl_interp_type(2), &
       fgsl_interp_cspline = fgsl_interp_type(3), &
       fgsl_interp_cspline_periodic = fgsl_interp_type(4), &
       fgsl_interp_akima = fgsl_interp_type(5), &
       fgsl_interp_akima_periodic = fgsl_interp_type(6)
  type, public :: fgsl_interp
     private
     type(c_ptr) :: gsl_interp = c_null_ptr
  end type fgsl_interp
  type, public :: fgsl_interp_accel
     private
     type(c_ptr) :: gsl_interp_accel = c_null_ptr
  end type fgsl_interp_accel
  type, public :: fgsl_spline
     private
     type(c_ptr) :: gsl_spline = c_null_ptr
  end type fgsl_spline
!
! Types: Permutations and Combinations
!
  type, public :: fgsl_permutation
     private
     type(c_ptr) :: gsl_permutation = c_null_ptr
  end type fgsl_permutation
  type, public :: fgsl_combination
     private
     type(c_ptr) :: gsl_combination = c_null_ptr
  end type fgsl_combination
!
! Types: Numerical Integration
!
  type, public :: fgsl_integration_workspace
     private
     type(c_ptr) :: gsl_integration_workspace = c_null_ptr
     logical :: status = .false.
  end type fgsl_integration_workspace
  integer(fgsl_int), parameter, public :: fgsl_integ_gauss15 = 1
  integer(fgsl_int), parameter, public :: fgsl_integ_gauss21 = 2
  integer(fgsl_int), parameter, public :: fgsl_integ_gauss31 = 3
  integer(fgsl_int), parameter, public :: fgsl_integ_gauss41 = 4
  integer(fgsl_int), parameter, public :: fgsl_integ_gauss51 = 5
  integer(fgsl_int), parameter, public :: fgsl_integ_gauss61 = 6
  type, public :: fgsl_integration_qaws_table
     private
     type(c_ptr) :: gsl_integration_qaws_table
     logical :: status = .false.
  end type fgsl_integration_qaws_table
  type, public :: fgsl_integration_qawo_table
     private
     type(c_ptr) :: gsl_integration_qawo_table
     logical :: status = .false.
  end type fgsl_integration_qawo_table
  integer(fgsl_int), parameter, public :: fgsl_integ_cosine = 0
  integer(fgsl_int), parameter, public :: fgsl_integ_sine = 1
!
! Types: Random and Quasi-random numbers
!
  type, public :: fgsl_rng
     private
     type(c_ptr) :: gsl_rng
  end type fgsl_rng
  type, public :: fgsl_rng_type
     private
     type(c_ptr) :: gsl_rng_type
     integer :: type = 0
  end type fgsl_rng_type
! Note: we need a dynamic component here, since 
! fgsl_rng_default needs to change at run time.
! fgsl_rng_default will be set by fgsl_rng_env_setup, 
! and the static objects will be all set at the
! first call of fgsl_rng_alloc
  integer, parameter :: rngmax = 61
! check new g95  type(fgsl_rng_type) :: fgsl_rng_allgen(rngmax) = (/(fgsl_rng_type(c_null_ptr, i)), i=1, rngmax/)
! cannot have protected attribute since modified by fgsl_rng_alloc
  type(fgsl_rng_type), public :: &
       fgsl_rng_default = fgsl_rng_type(c_null_ptr, -1), &
       fgsl_rng_borosh13 = fgsl_rng_type(c_null_ptr, 1), &
       fgsl_rng_coveyou = fgsl_rng_type(c_null_ptr, 2), &
       fgsl_rng_cmrg = fgsl_rng_type(c_null_ptr, 3), &
       fgsl_rng_fishman18 = fgsl_rng_type(c_null_ptr, 4), &
       fgsl_rng_fishman20 = fgsl_rng_type(c_null_ptr, 5), &
       fgsl_rng_fishman2x = fgsl_rng_type(c_null_ptr, 6), &
       fgsl_rng_gfsr4 = fgsl_rng_type(c_null_ptr, 7), &
       fgsl_rng_knuthran = fgsl_rng_type(c_null_ptr, 8), &
       fgsl_rng_knuthran2 = fgsl_rng_type(c_null_ptr, 9), &
       fgsl_rng_lecuyer21 = fgsl_rng_type(c_null_ptr, 10), &
       fgsl_rng_minstd = fgsl_rng_type(c_null_ptr, 11), &
       fgsl_rng_mrg = fgsl_rng_type(c_null_ptr, 12), &
       fgsl_rng_mt19937 = fgsl_rng_type(c_null_ptr, 13), &
       fgsl_rng_mt19937_1999 = fgsl_rng_type(c_null_ptr, 14), &
       fgsl_rng_mt19937_1998 = fgsl_rng_type(c_null_ptr, 15), &
       fgsl_rng_r250 = fgsl_rng_type(c_null_ptr, 16), &
       fgsl_rng_ran0 = fgsl_rng_type(c_null_ptr, 17), &
       fgsl_rng_ran1 = fgsl_rng_type(c_null_ptr, 18), &
       fgsl_rng_ran2 = fgsl_rng_type(c_null_ptr, 19), &
       fgsl_rng_ran3 = fgsl_rng_type(c_null_ptr, 20), &
       fgsl_rng_rand = fgsl_rng_type(c_null_ptr, 21), &
       fgsl_rng_rand48 = fgsl_rng_type(c_null_ptr, 22), &
       fgsl_rng_random128_bsd = fgsl_rng_type(c_null_ptr, 23), &
       fgsl_rng_random128_glibc2 = fgsl_rng_type(c_null_ptr, 24), &
       fgsl_rng_random128_libc5 = fgsl_rng_type(c_null_ptr, 25), &
       fgsl_rng_random256_bsd = fgsl_rng_type(c_null_ptr, 26), &
       fgsl_rng_random256_glibc2 = fgsl_rng_type(c_null_ptr, 27), &
       fgsl_rng_random256_libc5 = fgsl_rng_type(c_null_ptr, 28), &
       fgsl_rng_random32_bsd = fgsl_rng_type(c_null_ptr, 29), &
       fgsl_rng_random32_glibc2 = fgsl_rng_type(c_null_ptr, 30), &
       fgsl_rng_random32_libc5 = fgsl_rng_type(c_null_ptr, 31), &
       fgsl_rng_random64_bsd = fgsl_rng_type(c_null_ptr, 32), &
       fgsl_rng_random64_glibc2 = fgsl_rng_type(c_null_ptr, 33), &
       fgsl_rng_random64_libc5 = fgsl_rng_type(c_null_ptr, 34), &
       fgsl_rng_random8_bsd = fgsl_rng_type(c_null_ptr, 35)
  type(fgsl_rng_type), public ::  &
       fgsl_rng_random8_glibc2 = fgsl_rng_type(c_null_ptr, 36), &
       fgsl_rng_random8_libc5 = fgsl_rng_type(c_null_ptr, 37), &
       fgsl_rng_random_bsd = fgsl_rng_type(c_null_ptr, 38), &
       fgsl_rng_random_glibc2 = fgsl_rng_type(c_null_ptr, 39), &
       fgsl_rng_random_libc5 = fgsl_rng_type(c_null_ptr, 40), &
       fgsl_rng_randu = fgsl_rng_type(c_null_ptr, 41), &
       fgsl_rng_ranf = fgsl_rng_type(c_null_ptr, 42), &
       fgsl_rng_ranlux = fgsl_rng_type(c_null_ptr, 43), &
       fgsl_rng_ranlux389 = fgsl_rng_type(c_null_ptr, 44), &
       fgsl_rng_ranlxd1 = fgsl_rng_type(c_null_ptr, 45), &
       fgsl_rng_ranlxd2 = fgsl_rng_type(c_null_ptr, 46), &
       fgsl_rng_ranlxs0 = fgsl_rng_type(c_null_ptr, 47), &
       fgsl_rng_ranlxs1 = fgsl_rng_type(c_null_ptr, 48), &
       fgsl_rng_ranlxs2 = fgsl_rng_type(c_null_ptr, 49), &
       fgsl_rng_ranmar = fgsl_rng_type(c_null_ptr, 50), &
       fgsl_rng_slatec = fgsl_rng_type(c_null_ptr, 51), &
       fgsl_rng_taus = fgsl_rng_type(c_null_ptr, 52), &
       fgsl_rng_taus2 = fgsl_rng_type(c_null_ptr, 53), &
       fgsl_rng_taus113 = fgsl_rng_type(c_null_ptr, 54), &
       fgsl_rng_transputer = fgsl_rng_type(c_null_ptr, 55), &
       fgsl_rng_tt800 = fgsl_rng_type(c_null_ptr, 56), &
       fgsl_rng_uni = fgsl_rng_type(c_null_ptr, 57), &
       fgsl_rng_uni32 = fgsl_rng_type(c_null_ptr, 58), &
       fgsl_rng_vax = fgsl_rng_type(c_null_ptr, 59), &
       fgsl_rng_waterman14 = fgsl_rng_type(c_null_ptr, 60), &
       fgsl_rng_zuf = fgsl_rng_type(c_null_ptr, 61)
  integer(fgsl_long), public, bind(c, name='gsl_rng_default_seed') :: fgsl_rng_default_seed
  type, public :: fgsl_qrng
     private
     type(c_ptr) :: gsl_qrng
  end type fgsl_qrng
  type, public :: fgsl_qrng_type
     private
     integer :: type = 0
  end type fgsl_qrng_type
  type(fgsl_qrng_type), parameter, public :: &
       fgsl_qrng_niederreiter_2 = fgsl_qrng_type(1), &
       fgsl_qrng_sobol = fgsl_qrng_type(2)
  type, public :: fgsl_ran_discrete_t
     private
     type(c_ptr) :: gsl_ran_discrete_t
  end type fgsl_ran_discrete_t
!
! Types: Histograms
!
  type, public :: fgsl_histogram
     private
     type(c_ptr) :: gsl_histogram = c_null_ptr
  end type fgsl_histogram
  type, public :: fgsl_histogram_pdf
     private
     type(c_ptr) :: gsl_histogram_pdf = c_null_ptr
  end type fgsl_histogram_pdf
  type, public :: fgsl_histogram2d
     private
     type(c_ptr) :: gsl_histogram2d = c_null_ptr
  end type fgsl_histogram2d
  type, public :: fgsl_histogram2d_pdf
     private
     type(c_ptr) :: gsl_histogram2d_pdf = c_null_ptr
  end type fgsl_histogram2d_pdf
!
! Types: Ntuples
!
  type, public :: fgsl_ntuple
     private
     type(c_ptr) :: gsl_ntuple = c_null_ptr
  end type fgsl_ntuple
  type, public :: fgsl_ntuple_select_fn
     private
     type(c_ptr) :: gsl_ntuple_select_fn = c_null_ptr
  end type fgsl_ntuple_select_fn
  type, public :: fgsl_ntuple_value_fn
     private
     type(c_ptr) :: gsl_ntuple_value_fn = c_null_ptr
  end type fgsl_ntuple_value_fn
      
!
! Types: Monte Carlo integration
!
  type, public :: fgsl_monte_function
     private
     type(c_ptr) :: gsl_monte_function = c_null_ptr
  end type fgsl_monte_function
  type, public :: fgsl_monte_plain_state
     private
     type(c_ptr) :: gsl_monte_plain_state = c_null_ptr
  end type fgsl_monte_plain_state
  type, public :: fgsl_monte_miser_state
     private
     type(c_ptr) :: gsl_monte_miser_state = c_null_ptr
  end type fgsl_monte_miser_state
  type, public :: fgsl_monte_vegas_state
     private
     type(c_ptr) :: gsl_monte_vegas_state = c_null_ptr
  end type fgsl_monte_vegas_state
!
! Types: Simulated Annealing
!
  type, bind(c) :: gsl_siman_params_t 
     integer(c_int) :: n_tries, iters_fixed_t
     real(c_double) :: step_size, k, t_initial, mu_t, t_min
  end type gsl_siman_params_t
  type, public :: fgsl_siman_params_t
     private
     type(gsl_siman_params_t), pointer :: gsl_siman_params_t => null()
  end type fgsl_siman_params_t
!
! Types: Ordinary Differential Equations
!
  type, public :: fgsl_odeiv_system
     private
     type(c_ptr) :: gsl_odeiv_system = c_null_ptr
  end type fgsl_odeiv_system
  type, public :: fgsl_odeiv_step_type
     private
     integer(c_int) :: which = 0
  end type fgsl_odeiv_step_type
  type(fgsl_odeiv_step_type), parameter, public :: &
       fgsl_odeiv_step_rk2 = fgsl_odeiv_step_type(1), &
       fgsl_odeiv_step_rk4 = fgsl_odeiv_step_type(2), &
       fgsl_odeiv_step_rkf45 = fgsl_odeiv_step_type(3), &
       fgsl_odeiv_step_rkck = fgsl_odeiv_step_type(4), &
       fgsl_odeiv_step_rk8pd = fgsl_odeiv_step_type(5), &
       fgsl_odeiv_step_rk2imp = fgsl_odeiv_step_type(6), &
       fgsl_odeiv_step_rk2simp = fgsl_odeiv_step_type(7), &
       fgsl_odeiv_step_rk4imp = fgsl_odeiv_step_type(8), &
       fgsl_odeiv_step_bsimp = fgsl_odeiv_step_type(9), &
       fgsl_odeiv_step_gear1 = fgsl_odeiv_step_type(10), &
       fgsl_odeiv_step_gear2 = fgsl_odeiv_step_type(11)
  type, public :: fgsl_odeiv_step
     type(c_ptr) :: gsl_odeiv_step = c_null_ptr
  end type fgsl_odeiv_step
  type, public :: fgsl_odeiv_control
     type(c_ptr) :: gsl_odeiv_control = c_null_ptr
  end type fgsl_odeiv_control
  integer(fgsl_int), parameter, public :: fgsl_odeiv_hadj_inc = 1
  integer(fgsl_int), parameter, public :: fgsl_odeiv_hadj_nil = 0
  integer(fgsl_int), parameter, public :: fgsl_odeiv_hadj_dec = -1
  type, public :: fgsl_odeiv_evolve
     type(c_ptr) :: gsl_odeiv_evolve
  end type fgsl_odeiv_evolve
!
! Types: Chebyshev approximation
!
  type, public :: fgsl_cheb_series
     private
     type(c_ptr) :: gsl_cheb_series = c_null_ptr
  end type fgsl_cheb_series
!
! Types: Series acceleration
!
  type, public :: fgsl_sum_levin_u_workspace
     private
     type(c_ptr) :: gsl_sum_levin_u_workspace = c_null_ptr
  end type fgsl_sum_levin_u_workspace
  type, public :: fgsl_sum_levin_utrunc_workspace
     private
     type(c_ptr) :: gsl_sum_levin_utrunc_workspace = c_null_ptr
  end type fgsl_sum_levin_utrunc_workspace
!
! Types: Wavelet transforms
!
  type, public :: fgsl_wavelet
     private
     type(c_ptr) :: gsl_wavelet = c_null_ptr
  end type fgsl_wavelet
  type, public :: fgsl_wavelet_type
     private
     integer(c_int) :: which = 0
  end type fgsl_wavelet_type
  type(fgsl_wavelet_type), public, parameter :: &
       fgsl_wavelet_daubechies = fgsl_wavelet_type(1), &
       fgsl_wavelet_daubechies_centered = fgsl_wavelet_type(2), &
       fgsl_wavelet_haar = fgsl_wavelet_type(3), &
       fgsl_wavelet_haar_centered = fgsl_wavelet_type(4), &
       fgsl_wavelet_bspline = fgsl_wavelet_type(5), &
       fgsl_wavelet_bspline_centered = fgsl_wavelet_type(6)
  type, public :: fgsl_wavelet_workspace
     private
     type(c_ptr) :: gsl_wavelet_workspace
  end type fgsl_wavelet_workspace
!
! Types: Hankel transforms
!
  type, public :: fgsl_dht
     private
     type(c_ptr) :: gsl_dht = c_null_ptr
  end type fgsl_dht
!
! Types: Root finding
!
  type, public :: fgsl_root_fsolver_type
     private
     integer(c_int) :: which = 0
  end type fgsl_root_fsolver_type
  type(fgsl_root_fsolver_type), public, parameter :: &
       fgsl_root_fsolver_bisection = fgsl_root_fsolver_type(1), &
       fgsl_root_fsolver_brent = fgsl_root_fsolver_type(2), &
       fgsl_root_fsolver_falsepos = fgsl_root_fsolver_type(3)
  type, public :: fgsl_root_fdfsolver_type
     private
     integer(c_int) :: which = 0
  end type fgsl_root_fdfsolver_type
  type(fgsl_root_fdfsolver_type), public, parameter :: &
       fgsl_root_fdfsolver_newton = fgsl_root_fdfsolver_type(1), &
       fgsl_root_fdfsolver_secant = fgsl_root_fdfsolver_type(2), &
       fgsl_root_fdfsolver_steffenson = fgsl_root_fdfsolver_type(3)
  type, public :: fgsl_root_fsolver
     private
     type(c_ptr) :: gsl_root_fsolver = c_null_ptr
  end type fgsl_root_fsolver
  type, public :: fgsl_root_fdfsolver
     private
     type(c_ptr) :: gsl_root_fdfsolver = c_null_ptr
  end type fgsl_root_fdfsolver
!
! Types: Minimization
!
  type, public :: fgsl_min_fminimizer_type
     private
     integer(c_int) :: which = 0
  end type fgsl_min_fminimizer_type
  type(fgsl_min_fminimizer_type), public, parameter :: &
       fgsl_min_fminimizer_goldensection = fgsl_min_fminimizer_type(1), &
       fgsl_min_fminimizer_brent = fgsl_min_fminimizer_type(2)
  type, public :: fgsl_min_fminimizer
     private
     type(c_ptr) :: gsl_min_fminimizer = c_null_ptr
  end type fgsl_min_fminimizer
!
! Types: Multi-Root
!
  type, public :: fgsl_multiroot_function
     private
     type(c_ptr) :: gsl_multiroot_function = c_null_ptr
  end type fgsl_multiroot_function
  type, public :: fgsl_multiroot_function_fdf
     private
     type(c_ptr) :: gsl_multiroot_function_fdf = c_null_ptr
  end type fgsl_multiroot_function_fdf
  type, public :: fgsl_multiroot_fsolver
     private
     type(c_ptr) :: gsl_multiroot_fsolver = c_null_ptr
  end type fgsl_multiroot_fsolver
  type, public :: fgsl_multiroot_fsolver_type
     private
     integer(c_int) :: which = 0
  end type fgsl_multiroot_fsolver_type
  type(fgsl_multiroot_fsolver_type), public, parameter :: &
       fgsl_multiroot_fsolver_dnewton = fgsl_multiroot_fsolver_type(1), &
       fgsl_multiroot_fsolver_broyden = fgsl_multiroot_fsolver_type(2), &
       fgsl_multiroot_fsolver_hybrid = fgsl_multiroot_fsolver_type(3), &
       fgsl_multiroot_fsolver_hybrids = fgsl_multiroot_fsolver_type(4) 
  type, public :: fgsl_multiroot_fdfsolver
     private
     type(c_ptr) :: gsl_multiroot_fdfsolver = c_null_ptr
  end type fgsl_multiroot_fdfsolver
  type, public :: fgsl_multiroot_fdfsolver_type
     private
     integer(c_int) :: which = 0
  end type fgsl_multiroot_fdfsolver_type
  type(fgsl_multiroot_fdfsolver_type), public, parameter :: &
       fgsl_multiroot_fdfsolver_newton = fgsl_multiroot_fdfsolver_type(1), &
       fgsl_multiroot_fdfsolver_gnewton = fgsl_multiroot_fdfsolver_type(2), &
       fgsl_multiroot_fdfsolver_hybridj = fgsl_multiroot_fdfsolver_type(3), &
       fgsl_multiroot_fdfsolver_hybridsj = fgsl_multiroot_fdfsolver_type(4) 
!
! Types: Multi-Min
!
  type, public :: fgsl_multimin_function
     private
     type(c_ptr) :: gsl_multimin_function = c_null_ptr
  end type fgsl_multimin_function
  type, public :: fgsl_multimin_function_fdf
     private
     type(c_ptr) :: gsl_multimin_function_fdf = c_null_ptr
  end type fgsl_multimin_function_fdf
  type, public :: fgsl_multimin_fminimizer
     private
     type(c_ptr) :: gsl_multimin_fminimizer = c_null_ptr
  end type fgsl_multimin_fminimizer
  type, public :: fgsl_multimin_fminimizer_type
     private
     integer(c_int) :: which = 0
  end type fgsl_multimin_fminimizer_type
  type(fgsl_multimin_fminimizer_type), public, parameter :: &
       fgsl_multimin_fminimizer_nmsimplex = fgsl_multimin_fminimizer_type(1)
  type, public :: fgsl_multimin_fdfminimizer
     private
     type(c_ptr) :: gsl_multimin_fdfminimizer = c_null_ptr
  end type fgsl_multimin_fdfminimizer
  type, public :: fgsl_multimin_fdfminimizer_type
     private
     integer(c_int) :: which = 0
  end type fgsl_multimin_fdfminimizer_type
  type(fgsl_multimin_fdfminimizer_type), public, parameter :: &
       fgsl_multimin_fdfminimizer_steepest_descent = fgsl_multimin_fdfminimizer_type(1), &
       fgsl_multimin_fdfminimizer_conjugate_pr = fgsl_multimin_fdfminimizer_type(2), &
       fgsl_multimin_fdfminimizer_conjugate_fr = fgsl_multimin_fdfminimizer_type(3), &
       fgsl_multimin_fdfminimizer_vector_bfgs = fgsl_multimin_fdfminimizer_type(4)
!
! Types: Fitting
!
  type, public :: fgsl_multifit_linear_workspace
     private
     type(c_ptr) :: gsl_multifit_linear_workspace = c_null_ptr
  end type fgsl_multifit_linear_workspace
  type, public :: fgsl_multifit_function
     private
     type(c_ptr) :: gsl_multifit_function = c_null_ptr
  end type fgsl_multifit_function
  type, public :: fgsl_multifit_function_fdf
     private
     type(c_ptr) :: gsl_multifit_function_fdf = c_null_ptr
  end type fgsl_multifit_function_fdf
  type, public :: fgsl_multifit_fsolver
     private
     type(c_ptr) :: gsl_multifit_fsolver = c_null_ptr
  end type fgsl_multifit_fsolver
  type, public :: fgsl_multifit_fsolver_type
     private
     integer(c_int) :: which = 0
  end type fgsl_multifit_fsolver_type
  type, public :: fgsl_multifit_fdfsolver
     private
     type(c_ptr) :: gsl_multifit_fdfsolver = c_null_ptr
  end type fgsl_multifit_fdfsolver
  type, public :: fgsl_multifit_fdfsolver_type
     private
     integer(c_int) :: which = 0
  end type fgsl_multifit_fdfsolver_type
  type(fgsl_multifit_fdfsolver_type), public, parameter :: &
       fgsl_multifit_fdfsolver_lmder = fgsl_multifit_fdfsolver_type(1), &
       fgsl_multifit_fdfsolver_lmsder = fgsl_multifit_fdfsolver_type(2)
  
!
! required C interfaces
! FGSL names occurring here are auxiliary routines
! needed to transfer static C information to the Fortran subsystem
  interface
     include "interface/error.finc"
     include "interface/misc.finc"
     include "interface/io.finc"
     include "interface/math.finc"
     include "interface/complex.finc"
     include "interface/poly.finc"
     include "interface/specfunc.finc"
     include "interface/array.finc"
     include "interface/interp.finc"
     include "interface/permutation.finc"
     include "interface/sort.finc"
     include "interface/integration.finc"
     include "interface/rng.finc"
     include "interface/statistics.finc"
     include "interface/histogram.finc"
     include "interface/ntuple.finc"
     include "interface/montecarlo.finc"
     include "interface/siman.finc"
     include "interface/ode.finc"
     include "interface/deriv.finc"
     include "interface/chebyshev.finc"
     include "interface/sum_levin.finc"
     include "interface/wavelet.finc"
     include "interface/dht.finc"
     include "interface/roots.finc"
     include "interface/min.finc"
     include "interface/multiroots.finc"
     include "interface/multimin.finc"
     include "interface/fit.finc"
     include "interface/multifit.finc"
     include "interface/ieee.finc"
  end interface
  include "interface/generics.finc"
contains
  include "api/error.finc"
  include "api/misc.finc"
  include "api/io.finc"
  include "api/math.finc"
  include "api/complex.finc"
  include "api/poly.finc"
  include "api/specfunc.finc"
  include "api/array.finc"
  include "api/interp.finc"
  include "api/permutation.finc"
  include "api/sort.finc"
  include "api/integration.finc"
  include "api/rng.finc"
  include "api/statistics.finc"
  include "api/histogram.finc"
  include "api/ntuple.finc"
  include "api/montecarlo.finc"
  include "api/siman.finc"
  include "api/ode.finc"
  include "api/deriv.finc"
  include "api/chebyshev.finc"
  include "api/sum_levin.finc"
  include "api/wavelet.finc"
  include "api/dht.finc"
  include "api/roots.finc"
  include "api/min.finc"
  include "api/multiroots.finc"
  include "api/multimin.finc"
  include "api/fit.finc"
  include "api/multifit.finc"
  include "api/ieee.finc"
end module fgsl

program test_fgslerr
!------------------------------------------------------------------------------
! Testing the Fortran error interface to GSL
!------------------------------------------------------------------------------
  use fgsl
  use tmod
  implicit none
!
  integer(fgsl_int), parameter :: num_tests=10
  integer(fgsl_size_t), parameter :: nmax=10
  type(fgsl_error_handler_t) :: std, off, mine
  type(fgsl_interp) :: interp
  integer :: i, nok
  integer(fgsl_int) :: status
  integer(fgsl_size_t) :: index
  character(kind=fgsl_char, len=fgsl_strmax) :: message
  real(fgsl_double), dimension(10) :: xa, ya
  logical :: test_ok, ok(num_tests)
  type(fgsl_vector) :: vec
  type(fgsl_matrix) :: mat
  type(fgsl_wavelet) :: w
  type(fgsl_permutation) :: p
  type(fgsl_combination) :: c
!  write object sizes
  open(20, file='typesizes.out',form='formatted',status='unknown')
  write(20,'(''All sizes in units of C sizeof (Bytes)'')') 
  write(20,'(''Size of fgsl_char   : '',I4)') fgsl_sizeof(fgsl_char_'a')
  write(20,'(''Size of fgsl_int    : '',I4)') fgsl_sizeof(1_fgsl_int)
  write(20,'(''Size of fgsl_long   : '',I4)') fgsl_sizeof(1_fgsl_long)
  write(20,'(''Size of fgsl_size_t : '',I4)') fgsl_sizeof(1_fgsl_size_t)
  write(20,'(''Size of fgsl_float  : '',I4)') fgsl_sizeof(1.0_fgsl_float)
  write(20,'(''Size of fgsl_double : '',I4)') fgsl_sizeof(1.0_fgsl_double)
  write(20,'(''Size of DT fgsl_vector          : '',I4)') fgsl_sizeof(vec)
  write(20,'(''Size of DT fgsl_matrix          : '',I4)') fgsl_sizeof(mat)
  write(20,'(''Size of DT fgsl_permutation     : '',I4)') fgsl_sizeof(p)
  write(20,'(''Size of DT fgsl_combination     : '',I4)') fgsl_sizeof(c)
  write(20,'(''Size of DT fgsl_wavelet         : '',I4)') fgsl_sizeof(w)
  write(20,'(''Size of DT fgsl_interp          : '',I4)') fgsl_sizeof(interp)
  close(20)
!
  ok = .true.
  test_ok = .true.
  nok = 1
! use an interpolation object to test
  do i=1,nmax
     xa(i) = dble(i-1)
     ya(i) = dble(i-1)**3.0_fgsl_double
  end do
!
  std = fgsl_set_error_handler_off()
!
  interp = fgsl_interp_alloc(fgsl_interp_cspline,1_fgsl_size_t)
  if (fgsl_well_defined(interp)) test_ok = .false.
  call testres_toggle('interp_alloc',test_ok,ok,nok)

  interp = fgsl_interp_alloc(fgsl_interp_cspline,nmax)
  status = fgsl_interp_init(interp,xa,ya,1_fgsl_size_t)
  if (status == fgsl_success) then
     test_ok = .false.
  else
     message = fgsl_strerror(status)
!     write(6, *) 'Error message is: ',trim(message)
     if (trim(message) /= 'invalid argument supplied by user') test_ok=.false.
  end if
  call testres_toggle('interp_init',test_ok,ok,nok)
  status = fgsl_interp_init(interp,xa,ya,nmax)
  if (status /= fgsl_success) test_ok = .false.
  call testres_toggle('interp_init_success',test_ok,ok,nok)
!
! own error handler
!
  mine = fgsl_error_handler_init(mine_sr)
  off = fgsl_set_error_handler(mine)
  status = fgsl_interp_init(interp,xa,ya,1_fgsl_size_t)
!  write(6, *) trim(test_message)
  if (trim(test_message) /= 'invalid argument supplied by user') &
       test_ok=.false.
  call testres_toggle('my_error_handler',test_ok,ok,nok)
! need to build with preprocessing for next line
!  call fgsl_error("my_own_call",__FILE__,__LINE__,2)
  call fgsl_error("my_own_call","test_fgslerr.f90",80,2)
  write(6, *) trim(test_message)
  if (trim(test_message) /= 'output range error') &
       test_ok=.false.
  call testres_toggle('my_own_call',test_ok,ok,nok)
!
!
!
  if (all(ok)) then
     write(6, *) 'OK: All tests passed - now check GSL-internal abort ...'
  else
     write(6, *) 'FAIL: Some or all tests failed'
     stop
  end if
!
! Copy back standard handler 
!
  call fgsl_interp_free(interp)
  off = fgsl_set_error_handler(std)
  interp = fgsl_interp_alloc(fgsl_interp_cspline,1_fgsl_size_t)
  
  write(6, *) 'FAIL: Final triggering failed.'

end program test_fgslerr

module mod_multiroots
  use, intrinsic :: iso_c_binding
  use fgsl
  use mod_unit
  implicit none
contains
  function rosenbrock_f(x, params, f) bind(c)
    type(c_ptr), value :: x, params, f
    integer(c_int) :: rosenbrock_f
!
    type(fgsl_vector) :: fx, ff
    real(fgsl_double), pointer :: par(:), xv(:), yv(:)
    integer(fgsl_int) :: status
    call fgsl_obj_c_ptr(fx, x)
    call fgsl_obj_c_ptr(ff, f)
    call c_f_pointer(params, par, (/ 2 /))
    status = fgsl_vector_align(xv, fx)
    status = fgsl_vector_align(yv, ff)
    yv(1) = par(1) * (1.0_fgsl_double - xv(1))
    yv(2) = par(2) * (xv(2) - xv(1)*xv(1))
    rosenbrock_f = fgsl_success
  end function rosenbrock_f
  function rosenbrock_df(x, params, df) bind(c)
    type(c_ptr), value :: x, params, df
    integer(c_int) :: rosenbrock_df
!
    type(fgsl_vector) :: fx
    type(fgsl_matrix) :: dff
    real(fgsl_double), pointer :: par(:), xv(:), yv(:,:)
    integer(fgsl_int) :: status
    call fgsl_obj_c_ptr(fx, x)
    call fgsl_obj_c_ptr(dff, df)
    call c_f_pointer(params, par, (/ 2 /))
    status = fgsl_vector_align(xv, fx)
    status = fgsl_matrix_align(yv, dff)
    yv(1:2,1:2) = reshape( source = (/ -par(1), 0.0_fgsl_double , &
         -2.0_fgsl_double*par(2)*xv(1), par(2)  /), &
         shape = (/ 2, 2 /))
    rosenbrock_df = fgsl_success
  end function rosenbrock_df
  function rosenbrock_fdf(x, params, f, df) bind(c)
    type(c_ptr), value :: x, params, f, df
    integer(c_int) :: rosenbrock_fdf
!
    integer(c_int) :: status
    status = rosenbrock_f(x, params, f)
    status = rosenbrock_df(x, params, df)
    rosenbrock_fdf = fgsl_success
  end function rosenbrock_fdf
end module mod_multiroots
program multiroots
  use mod_multiroots
  implicit none
  real(fgsl_double), parameter :: eps5 = 1.0d-5
  integer(fgsl_int), parameter :: itmax_root = 50
  real(fgsl_double), target :: fpar(2), xv(2)
  real(fgsl_double) :: ri, ra, xlo, xhi
  type(c_ptr) :: ptr
  type(fgsl_function) :: stdfunc
  type(fgsl_function_fdf) :: stdfunc_fdf
  type(fgsl_multiroot_fsolver) :: mroot_fslv
  type(fgsl_multiroot_fdfsolver) :: mroot_fdfslv
  type(fgsl_multiroot_function) :: mroot_f
  type(fgsl_multiroot_function_fdf) :: mroot_fdf
  type(fgsl_vector) :: xvec, fvec
  integer(fgsl_int) :: status, i
  integer(fgsl_size_t) :: nrt
  character(kind=fgsl_char,len=fgsl_strmax) :: name
  real(fgsl_double), pointer :: fptr(:), xptr(:)
!
! Test multiroot finding routines
!
  call unit_init(20)
! fsolver
  nrt = 2
  mroot_fslv = fgsl_multiroot_fsolver_alloc(fgsl_multiroot_fsolver_hybrids,nrt)
  name = fgsl_multiroot_fsolver_name(mroot_fslv)
  call unit_assert_equal('fgsl_multiroot_fsolver_name','hybrids',trim(name))
! initialize function object
  fpar(1:2) = (/1.0_fgsl_double, 10.0_fgsl_double/)
  ptr = c_loc(fpar)
  mroot_f = fgsl_multiroot_function_init(rosenbrock_f,nrt,ptr)
  xv(1:2) = (/-10.0_fgsl_double, -5.0_fgsl_double/)
  xvec = fgsl_vector_init(1.0_fgsl_double)
  status = fgsl_vector_align(xv,nrt,xvec,nrt,0_fgsl_size_t,1_fgsl_size_t)
  status = fgsl_multiroot_fsolver_set(mroot_fslv, mroot_f, xvec)
  call unit_assert_equal('fgsl_multiroot_fsolver_set:status', &
       fgsl_success,status)
  fvec = fgsl_multiroot_fsolver_f(mroot_fslv)
  status = fgsl_vector_align(fptr, fvec)
  call fgsl_vector_free(xvec)
  xvec = fgsl_multiroot_fsolver_root(mroot_fslv)
  status = fgsl_vector_align(xptr, xvec)
  call unit_assert_true('fgsl_multiroot_fsolver_alloc', &
       fgsl_well_defined(mroot_fslv), .true.)
  i = 0
  do
     i = i + 1
     status = fgsl_multiroot_fsolver_iterate(mroot_fslv);
     if (status /= fgsl_success .or. i > itmax_root) then
        exit
     end if
     status = fgsl_multiroot_test_residual(fvec, 1.0d-7)
     if (status == fgsl_success) then 
!       write(6, '(1x,i2,1x,2(1f12.5),1x,2(1f12.5))') i, xptr(1:2), fptr(1:2)
        exit
     end if
  end do
  call unit_assert_equal('fgsl_multiroot_fsolver_iterate:status', &
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_multiroot_fsolver',(/1.0d0, 1.0d0/), &
       xptr,eps5)
  call fgsl_multiroot_fsolver_free(mroot_fslv)
  call fgsl_multiroot_function_free(mroot_f)
! fdfsolver
  nrt = 2
  mroot_fdfslv = fgsl_multiroot_fdfsolver_alloc( &
       fgsl_multiroot_fdfsolver_gnewton,nrt)
  name = fgsl_multiroot_fdfsolver_name(mroot_fdfslv)
  call unit_assert_equal('fgsl_multiroot_fdfsolver_name','gnewton',trim(name))
! initialize function object
  fpar(1:2) = (/1.0_fgsl_double, 10.0_fgsl_double/)
  ptr = c_loc(fpar)
  mroot_fdf = fgsl_multiroot_function_fdf_init(rosenbrock_f,rosenbrock_df, &
       rosenbrock_fdf,nrt,ptr)
!
  xv(1:2) = (/-10.0_fgsl_double, -5.0_fgsl_double/)
  xvec = fgsl_vector_init(1.0_fgsl_double)
  status = fgsl_vector_align(xv,nrt,xvec,nrt,0_fgsl_size_t,1_fgsl_size_t)
  status = fgsl_multiroot_fdfsolver_set(mroot_fdfslv, mroot_fdf, xvec)
  call unit_assert_equal('fgsl_multiroot_fdfsolver_set:status', &
       fgsl_success,status)
  fvec = fgsl_multiroot_fdfsolver_f(mroot_fdfslv)
  status = fgsl_vector_align(fptr, fvec)
  call fgsl_vector_free(xvec)
  xvec = fgsl_multiroot_fdfsolver_root(mroot_fdfslv)
  status = fgsl_vector_align(xptr, xvec)
  call unit_assert_true('fgsl_multiroot_fdfsolver_alloc', &
       fgsl_well_defined(mroot_fdfslv), .true.)
  i = 0
  do
     i = i + 1
     status = fgsl_multiroot_fdfsolver_iterate(mroot_fdfslv);
     if (status /= fgsl_success .or. i > itmax_root) then
        exit
     end if
     status = fgsl_multiroot_test_residual(fvec, 1.0E-7_fgsl_double)
     if (status == fgsl_success) then 
!       write(6, '(1x,i2,1x,2(1f12.5),1x,2(1f12.5))') i, xptr(1:2), fptr(1:2)
        exit
     end if
  end do
  call unit_assert_equal('fgsl_multiroot_fdfsolver_iterate:status', &
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_multiroot_fdfsolver',(/1.0d0, 1.0d0/), &
       xptr,eps5)

  call fgsl_multiroot_fdfsolver_free(mroot_fdfslv)
  call fgsl_multiroot_function_fdf_free(mroot_fdf)


!
! Done
!
  call unit_finalize() 
end program multiroots

module mod_nlfit
  use, intrinsic :: iso_c_binding
  use fgsl
  use mod_unit
  implicit none
  type data 
     integer(fgsl_size_t) :: n
     real(fgsl_double), allocatable :: y(:), sigma(:)
  end type data
contains
  function expb_f(x, cdata, f) bind(c)
    type(c_ptr), value :: x, cdata, f
    integer(c_int) :: expb_f
!
    type(fgsl_vector) :: f_x, f_f
    type(data), pointer :: f_data
    integer(fgsl_size_t) :: i
    integer(fgsl_int) :: status
    real(fgsl_double) :: yy
    real(fgsl_double), pointer :: p_x(:), p_f(:)
!
    call fgsl_obj_c_ptr(f_x, x)
    call fgsl_obj_c_ptr(f_f, f)
    status = fgsl_vector_align(p_x, f_x)
    status = fgsl_vector_align(p_f, f_f)
    call c_f_pointer(cdata, f_data)
    do i=1,f_data%n
       yy = p_x(1) * exp(- p_x(2) * dble(i-1) ) + p_x(3)
       p_f(i) = (yy - f_data%y(i))/f_data%sigma(i)
    end do
    expb_f = fgsl_success
  end function expb_f
  function expb_df(x, cdata, j) bind(c)
    type(c_ptr), value :: x, cdata, j
    integer(c_int) :: expb_df
!
    type(fgsl_vector) :: f_x
    type(fgsl_matrix) :: f_j
    type(data), pointer :: f_data
    integer(fgsl_size_t) :: i
    integer(fgsl_int) :: status
    real(fgsl_double) :: yy
    real(fgsl_double), pointer :: p_x(:), p_j(:,:)
!
    call fgsl_obj_c_ptr(f_x, x)
    call fgsl_obj_c_ptr(f_j, j)
    status = fgsl_vector_align(p_x, f_x)
    status = fgsl_matrix_align(p_j, f_j)
    call c_f_pointer(cdata, f_data)
    do i=1,f_data%n
       yy = exp(- p_x(2) * dble(i-1) )
       p_j(1,i) = yy / f_data%sigma(i)
       p_j(2,i) = - dble(i-1) * p_x(1) * yy / f_data%sigma(i)
       p_j(3,i) = 1 / f_data%sigma(i)
    end do
    expb_df = fgsl_success
  end function expb_df
  function expb_fdf(x, cdata, f, j) bind(c)
    type(c_ptr), value :: x, cdata, f, j
    integer(c_int) :: expb_fdf
!
    integer(c_int) :: status
    status = expb_f(x, cdata, f)
    status = expb_df(x, cdata, j)
    expb_fdf = fgsl_success
  end function expb_fdf
end module mod_nlfit
program nlfit
  use mod_nlfit
  implicit none
  integer(fgsl_size_t), parameter :: nmax = 10
  integer(fgsl_int), parameter :: itmax_root = 50
  real(fgsl_double), parameter :: eps6 = 1.0d-6
  integer(fgsl_size_t) :: nrt
  integer(fgsl_int) :: i, status
  real(fgsl_double) :: xv(3)
  type(c_ptr) :: ptr
  type(fgsl_rng) :: rng
!  type(fgsl_nlfit_params_t) :: nlfit_params
  type(fgsl_multifit_function_fdf) :: nlfit_fdf
  type(fgsl_multifit_fdfsolver) :: nlfit_slv
  type(fgsl_vector) :: xvec
  type(data), target :: fitdata
!
! Test simulated annealing routines
!
  call unit_init(20)
!
  rng = fgsl_rng_alloc(fgsl_rng_default)
  fitdata%n = nmax
  allocate(fitdata%y(nmax),fitdata%sigma(nmax))
  do i=1, nmax
     fitdata%y(i) = 1.0_fgsl_double + 5.0_fgsl_double * exp(-0.1_fgsl_double*dble(i-1)) + &
          fgsl_ran_gaussian(rng, 0.1_fgsl_double)
     fitdata%sigma(i) = 0.1_fgsl_double
  end do
  ptr = c_loc(fitdata)
  nrt = 3_fgsl_size_t
  nlfit_fdf = fgsl_multifit_function_fdf_init(expb_f, expb_df, expb_fdf, nmax, nrt, ptr)
  nlfit_slv = fgsl_multifit_fdfsolver_alloc(fgsl_multifit_fdfsolver_lmsder, nmax, nrt)
  xv(1:3) = (/1.0_fgsl_double, 0.0_fgsl_double, 0.0_fgsl_double/)
  xvec = fgsl_vector_init(1.0_fgsl_double)
  status = fgsl_vector_align(xv,nrt,xvec,nrt,0_fgsl_size_t,1_fgsl_size_t)
  call unit_assert_true('fgsl_multifit_fdfsolver_alloc', &
       fgsl_well_defined(nlfit_slv), .true.)

  status = fgsl_multifit_fdfsolver_set(nlfit_slv, nlfit_fdf, xvec)
  call unit_assert_equal('fgsl_multifit_fdfsolver_set:status', &
       fgsl_success,status)
  i = 0
  do
     i = i + 1
     status = fgsl_multifit_fdfsolver_iterate(nlfit_slv)
     if (status /= fgsl_success .or. i > itmax_root) then
        exit
     end if
     status = fgsl_multifit_test_delta(fgsl_multifit_fdfsolver_dx(nlfit_slv), &
          fgsl_multifit_fdfsolver_position(nlfit_slv), eps6, eps6)
     if (status == fgsl_success) then 
        exit
     end if
  end do
  call unit_assert_equal('fgsl_multifit_fdfsolver_iterate:status', &
       fgsl_success,status)
! FIXME: result check
  call fgsl_vector_free(xvec)
  call fgsl_multifit_fdfsolver_free(nlfit_slv)
  call fgsl_multifit_function_fdf_free(nlfit_fdf)
  deallocate(fitdata%y,fitdata%sigma)
  call fgsl_rng_free(rng)
!
! Done
!
  call unit_finalize() 
end program nlfit

program histogram
  use fgsl
  use mod_unit
  implicit none
  integer(fgsl_size_t), parameter :: ntmax = 8_fgsl_size_t
  integer(fgsl_size_t) :: ibins, ival
  integer(fgsl_int) :: status, i
  real(fgsl_double), parameter :: eps10 = 1.0d-10
  real(fgsl_double) :: table(3,ntmax), a, b
  type(fgsl_histogram) :: h, h_clone, h_copy
  type(fgsl_file) :: hfile
!
! Test histogram routines
!
  call unit_init(200)
!
  h = fgsl_histogram_alloc(ntmax)
  call unit_assert_true('fgsl_histogram_alloc',fgsl_well_defined(h),.true.)
  status = fgsl_histogram_set_ranges_uniform(h, &
       0.0_fgsl_double, 4.0_fgsl_double)
  call unit_assert_equal('fgsl_histogram_set_ranges_uniform:status', &
       fgsl_success,status)
  status = fgsl_histogram_increment(h, 0.2d0)
  call unit_assert_equal('fgsl_histogram_increment:status',fgsl_success,status)
  status = fgsl_histogram_increment(h, 0.2d0)
  status = fgsl_histogram_increment(h, 0.2d0)
  status = fgsl_histogram_accumulate(h, 2.2d0,2.0d0)
  status = fgsl_histogram_increment(h, 3.2d0)
  status = fgsl_histogram_accumulate(h, 3.2d0, 3.0d0)
  status = fgsl_histogram_increment(h, 3.6d0)
  hfile = fgsl_open('histogram.dat','w')
  status = fgsl_histogram_fprintf(hfile,h,'%16.8f ','%16.8f ')
  status = fgsl_close(hfile)
  open(20, file='histogram.dat',form='FORMATTED',status='OLD')
  do i=1, ntmax
     read(20, fmt=*) table(:,i)
  end do
  call unit_assert_equal_within('fgsl_histogram_fprintf',&
       (/0.0d0,0.5d0,1.0d0,1.5d0,2.0d0,2.5d0,3.0d0,3.5d0/), &
       table(1,:),eps10)
  call unit_assert_equal_within('fgsl_histogram_fprintf',&
       (/0.5d0,1.0d0,1.5d0,2.0d0,2.5d0,3.0d0,3.5d0,4.0d0/), &
       table(2,:),eps10)
  call unit_assert_equal_within('fgsl_histogram_fprintf',&
       (/3.0d0,0.0d0,0.0d0,0.0d0,2.0d0,0.0d0,4.0d0,1.0d0/), &
       table(3,:),eps10)
! NOTE: zero based
  status = fgsl_histogram_get_range(h, 2_fgsl_size_t, a, b) 
  call unit_assert_equal('fgsl_histogram_get_range:status', &
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_histogram_get_range:lower',&
       1.0d0,a,eps10)
  call unit_assert_equal_within('fgsl_histogram_get_range:upper',&
       1.5d0,b,eps10)
  a = fgsl_histogram_max(h)
  call unit_assert_equal_within('fgsl_histogram_max',&
       4.0d0,a,eps10)
  a = fgsl_histogram_min(h)
  call unit_assert_equal_within('fgsl_histogram_min',&
       0.0d0,a,eps10)
  ibins = fgsl_histogram_bins(h)
  call unit_assert_equal('fgsl_histogram_bins',&
       int(ntmax),int(ibins))
  status = fgsl_histogram_find(h, 2.3d0, ival)
  call unit_assert_equal('fgsl_histogram_find',&
       4,int(ival))
  a = fgsl_histogram_max_val(h)
  call unit_assert_equal_within('fgsl_histogram_max_val',&
       4.0d0,a,eps10)
  a = fgsl_histogram_min_val(h)
  call unit_assert_equal_within('fgsl_histogram_min_val',&
       0.0d0,a,eps10)
  ibins = fgsl_histogram_max_bin(h)
  call unit_assert_equal('fgsl_histogram_max_bin',&
       6,int(ibins))
  ibins = fgsl_histogram_min_bin(h)
  call unit_assert_equal('fgsl_histogram_min_bin',&
       1,int(ibins))
! NOTE: sum ( x * f(x) ) / sum (f(x)) is taken at mid point
  a = fgsl_histogram_mean(h)
  call unit_assert_equal_within('fgsl_histogram_mean',&
       2.2d0,a,eps10)
  a = fgsl_histogram_sigma(h)
  call unit_assert_equal_within('fgsl_histogram_sigma',&
       1.35d0,a,eps10)
  a = fgsl_histogram_sum(h)
  call unit_assert_equal_within('fgsl_histogram_sum',&
       1.0d1,a,eps10)
  call unit_assert_true('fgsl_well_defined:false', &
       .not. fgsl_well_defined(h_clone),.true.) 
  h_clone = fgsl_histogram_clone(h)
  call unit_assert_true('fgsl_histogram_well_defined:true', &
       fgsl_well_defined(h_clone),.true.)
  a = fgsl_histogram_mean(h_clone)
  call unit_assert_equal_within('fgsl_histogram_clone',&
       2.2d0,a,eps10)
  h_copy = fgsl_histogram_alloc(ntmax)
  call unit_assert_true('fgsl_well_defined:true', &
       fgsl_well_defined(h_clone),.true.) 
  status = fgsl_histogram_memcpy(h_copy, h)
  call unit_assert_equal('fgsl_histogram_memcpy:status',fgsl_success,status)
  a = fgsl_histogram_mean(h_copy)
  call unit_assert_equal_within('fgsl_histogram_memcpy',&
       2.2d0,a,eps10)


  call fgsl_histogram_free(h)
  call fgsl_histogram_free(h_clone)
  call fgsl_histogram_free(h_copy)



!
! Done
!
  call unit_finalize() 
end program histogram

program statistics
  use fgsl
  use mod_unit
  implicit none
  integer(fgsl_size_t), parameter :: nsize = 50
  real(fgsl_double), parameter :: eps10 = 1.0d-10
  real(fgsl_double) :: s_array(nsize), s_arr2(nsize), w(nsize)
  real(fgsl_double) :: s_mean, s_m2, s_var, s_kur, s_sd, s_skew, &
       s_auto, s_cov, s_cor, xc, xv
  integer :: i
  integer(fgsl_size_t) :: mx, mn
!
! Test statistical routines
!
  call unit_init(200)
!
  s_array = (/ (dble(i), i=1, nsize) /)
  s_mean = fgsl_stats_mean(s_array,1_fgsl_size_t,nsize)
  call unit_assert_equal_within('fgsl_stats_mean:1',&
       2.55d1,s_mean,eps10)
  s_mean = fgsl_stats_mean(s_array,2_fgsl_size_t,nsize/2_fgsl_size_t)
  call unit_assert_equal_within('fgsl_stats_mean:2',&
       2.5d1,s_mean,eps10)
  s_var = fgsl_stats_variance(s_array,1_fgsl_size_t,nsize)
  call unit_assert_equal_within('fgsl_stats_variance',&
       2.125d2,s_var,eps10)
  s_var = fgsl_stats_variance_m(s_array,1_fgsl_size_t,nsize,2.55d1)
  call unit_assert_equal_within('fgsl_stats_variance_m',&
       2.125d2,s_var,eps10)
  s_sd = fgsl_stats_sd(s_array,1_fgsl_size_t,nsize)
  call unit_assert_equal_within('fgsl_stats_sd',&
       sqrt(2.125d2),s_sd,eps10)
  s_sd = fgsl_stats_sd_m(s_array,1_fgsl_size_t,nsize,2.55d1)
  call unit_assert_equal_within('fgsl_stats_sd_m',&
       sqrt(2.125d2),s_sd,eps10)
  s_var = fgsl_stats_variance_with_fixed_mean(s_array,1_fgsl_size_t,&
       nsize,2.55d1)
  call unit_assert_equal_within('fgsl_stats_variance_with_fixed_mean',&
       2.0825d2,s_var,eps10)
  s_sd = fgsl_stats_sd_with_fixed_mean(s_array,1_fgsl_size_t,&
       nsize,2.55d1)
  call unit_assert_equal_within('fgsl_stats_sd_with_fixed_mean',&
       sqrt(2.0825d2),s_sd,eps10)
  s_var = fgsl_stats_absdev(s_array,1_fgsl_size_t,nsize)
  call unit_assert_equal_within('fgsl_stats_absdev',&
       1.25d1,s_var,eps10)
  s_var = fgsl_stats_absdev_m(s_array,1_fgsl_size_t,nsize,2.55d1)
  call unit_assert_equal_within('fgsl_stats_absdev',&
       1.25d1,s_var,eps10)
  s_array = (/ (dble(i)**2, i=1, nsize) /)
  s_mean = fgsl_stats_mean(s_array,1_fgsl_size_t,nsize)
  s_sd = fgsl_stats_sd(s_array,1_fgsl_size_t,nsize)
  xc = 0.0d0
  do i=1,nsize
     xc = xc + ((dble(i)**2 - s_mean)/s_sd)**3
  end do
  xc = xc/dble(nsize) 
  s_skew = fgsl_stats_skew(s_array,1_fgsl_size_t,nsize)
  call unit_assert_equal_within('fgsl_stats_skew',&
       xc,s_skew,eps10)
  s_skew = fgsl_stats_skew_m_sd(s_array,1_fgsl_size_t,nsize,s_mean,s_sd)
  call unit_assert_equal_within('fgsl_stats_skew_m_sd',&
       xc,s_skew,eps10)
  xc = 0.0d0
  do i=1,nsize
     xc = xc + ((dble(i)**2 - s_mean)/s_sd)**4
  end do
  xc = xc/dble(nsize) - 3.0d0
  s_kur = fgsl_stats_kurtosis(s_array,1_fgsl_size_t,nsize)
  call unit_assert_equal_within('fgsl_stats_kurtosis',&
       xc,s_kur,eps10)
  s_kur = fgsl_stats_kurtosis_m_sd(s_array,1_fgsl_size_t,nsize,s_mean,s_sd)
  call unit_assert_equal_within('fgsl_stats_kurtosis_m_sd',&
       xc,s_kur,eps10)
  xc = 0.0d0; xv = 0.0d0
  do i=2,nsize
     xc = xc + (dble(i)**2 - s_mean)*(dble(i-1)**2 - s_mean)
     xv = xv + (dble(i)**2 - s_mean)**2
  end do
  xv = xv + (1.0d0-s_mean)**2
  xc = xc / xv
  s_auto = fgsl_stats_lag1_autocorrelation(s_array,1_fgsl_size_t,nsize)
  call unit_assert_equal_within('fgsl_stats_lag1_autocorrelation',&
       xc,s_auto,eps10)
  s_auto = fgsl_stats_lag1_autocorrelation_m(s_array,1_fgsl_size_t, &
       nsize,s_mean)
  call unit_assert_equal_within('fgsl_stats_lag1_autocorrelation_m',&
       xc,s_auto,eps10)
  s_arr2 = (/ (dble(i), i=1, nsize) /)
  s_m2 = fgsl_stats_mean(s_arr2,1_fgsl_size_t,nsize)
  xc = 0.0d0
  do i=1,nsize
     xc = xc + (dble(i)**2 - s_mean) * (dble(i) - s_m2)
  end do
  xc = xc / dble(nsize-1)
  s_cov = fgsl_stats_covariance(s_array,1_fgsl_size_t,s_arr2,1_fgsl_size_t, &
       nsize)
  call unit_assert_equal_within('fgsl_stats_covariance',&
       xc,s_cov,eps10)
  s_cov = fgsl_stats_covariance_m(s_array,1_fgsl_size_t,s_arr2, &
       1_fgsl_size_t, nsize, s_mean, s_m2)
  call unit_assert_equal_within('fgsl_stats_covariance_m',&
       xc,s_cov,eps10)
!
  s_cor = fgsl_stats_correlation(s_array,1_fgsl_size_t,s_arr2, &
       1_fgsl_size_t, nsize)
  call unit_assert_equal_within('fgsl_stats_correlation',&
       0.9694696278887304786d0,s_cor,eps10)
!
  w = (/ (0.43d0, i=1, nsize) /)
  s_mean = fgsl_stats_wmean(w,1_fgsl_size_t,s_arr2,1_fgsl_size_t,nsize)
  call unit_assert_equal_within('fgsl_stats_wmean',&
       2.55d1,s_mean,eps10)
  s_var = fgsl_stats_wvariance(w,1_fgsl_size_t,s_arr2,1_fgsl_size_t,nsize)
  call unit_assert_equal_within('fgsl_stats_wvariance',&
       2.125d2,s_var,eps10)
  s_var = fgsl_stats_wvariance_m(w,1_fgsl_size_t,s_arr2,1_fgsl_size_t,&
       nsize,s_mean)
  call unit_assert_equal_within('fgsl_stats_wvariance_m',&
       2.125d2,s_var,eps10)
  s_sd = fgsl_stats_wsd(w,1_fgsl_size_t,s_arr2,1_fgsl_size_t,nsize)
  call unit_assert_equal_within('fgsl_stats_wsd',&
       sqrt(2.125d2),s_sd,eps10)
  s_sd = fgsl_stats_wsd_m(w,1_fgsl_size_t,s_arr2,1_fgsl_size_t,nsize,s_mean)
  call unit_assert_equal_within('fgsl_stats_wsd_m',&
       sqrt(2.125d2),s_sd,eps10)
  s_var = fgsl_stats_wvariance_with_fixed_mean(w,1_fgsl_size_t,s_arr2, &
       1_fgsl_size_t,nsize,2.55d1)
  call unit_assert_equal_within('fgsl_stats_wvariance_with_fixed_mean',&
       2.0825d2,s_var,eps10)
  s_sd = fgsl_stats_wsd_with_fixed_mean(w,1_fgsl_size_t,s_arr2,1_fgsl_size_t,&
       nsize,2.55d1)
  call unit_assert_equal_within('fgsl_stats_wsd_with_fixed_mean',&
       sqrt(2.0825d2),s_sd,eps10)
  s_var = fgsl_stats_wabsdev(w,1_fgsl_size_t,s_arr2,1_fgsl_size_t,nsize)
  call unit_assert_equal_within('fgsl_stats_wabsdev',&
       1.25d1,s_var,eps10)
  s_var = fgsl_stats_wabsdev_m(w,1_fgsl_size_t,s_arr2,1_fgsl_size_t,&
       nsize,s_mean)
  call unit_assert_equal_within('fgsl_stats_wabsdev_m',&
       1.25d1,s_var,eps10)
  s_mean = fgsl_stats_mean(s_array,1_fgsl_size_t,nsize)
  s_sd = fgsl_stats_sd(s_array,1_fgsl_size_t,nsize)
  xc = 0.0d0
  do i=1,nsize
     xc = xc + ((dble(i)**2 - s_mean)/s_sd)**3
  end do
  xc = xc/dble(nsize) 
  s_skew = fgsl_stats_wskew(w,1_fgsl_size_t,s_array,1_fgsl_size_t,nsize)
  call unit_assert_equal_within('fgsl_stats_wskew',&
       xc,s_skew,eps10)
  s_skew = fgsl_stats_wskew_m_sd(w,1_fgsl_size_t,s_array,1_fgsl_size_t,&
       nsize,s_mean,s_sd)
  call unit_assert_equal_within('fgsl_stats_wskew_m_sd',&
       xc,s_skew,eps10)
    xc = 0.0d0
  do i=1,nsize
     xc = xc + ((dble(i)**2 - s_mean)/s_sd)**4
  end do
  xc = xc/dble(nsize) - 3.0d0
  s_kur = fgsl_stats_wkurtosis(w,1_fgsl_size_t,s_array,1_fgsl_size_t,nsize)
  call unit_assert_equal_within('fgsl_stats_wkurtosis',&
       xc,s_kur,eps10)
  s_kur = fgsl_stats_wkurtosis_m_sd(w,1_fgsl_size_t,s_array,1_fgsl_size_t, &
       nsize,s_mean,s_sd)
  call unit_assert_equal_within('fgsl_stats_wkurtosis_m_sd',&
       xc,s_kur,eps10)
  xc = fgsl_stats_max(s_array,1_fgsl_size_t,nsize)
  call unit_assert_equal_within('fgsl_stats_max',&
       maxval(s_array),xc,eps10)
  xc = fgsl_stats_min(s_array,1_fgsl_size_t,nsize)
  call unit_assert_equal_within('fgsl_stats_min',&
       minval(s_array),xc,eps10)
  call fgsl_stats_minmax(xc, xv, s_array,1_fgsl_size_t,nsize)
  call unit_assert_equal_within('fgsl_stats_minmax',&
       maxval(s_array),xv,eps10)
  call unit_assert_equal_within('fgsl_stats_minmax',&
       minval(s_array),xc,eps10)
! NOTE: zero-based counting
  i = fgsl_stats_max_index(s_array,1_fgsl_size_t,nsize)
  call unit_assert_equal('fgsl_stats_max_index',int(nsize-1),i)
  i = fgsl_stats_min_index(s_array,1_fgsl_size_t,nsize)
  call unit_assert_equal('fgsl_stats_min_index',0,i)
  call fgsl_stats_minmax_index(mn, mx, s_array,1_fgsl_size_t,nsize)
  call unit_assert_equal('fgsl_stats_minmax_index',0,int(mn))
  call unit_assert_equal('fgsl_stats_minmax_index',int(nsize-1),int(mx))
!
  xv = fgsl_stats_median_from_sorted_data(s_array,1_fgsl_size_t,nsize)
  xc = 0.5d0*(s_array(25)+s_array(26))
  call unit_assert_equal_within('fgsl_stats_median_from_sorted_data',&
       xc,xv,eps10)
  xv = fgsl_stats_quantile_from_sorted_data(s_array,1_fgsl_size_t,nsize,0.5d0)
  call unit_assert_equal_within('fgsl_stats_quantile_from_sorted_data',&
       xc,xv,eps10)



!
! Done
!
  call unit_finalize() 
end program statistics

program vector
  use fgsl
  implicit none
  integer(fgsl_size_t), parameter :: ndim = 12
  real(fgsl_double) :: v(ndim)
  real(fgsl_double), pointer :: p_v(:)
  integer(fgsl_int) :: i, status
  type(fgsl_vector) :: vec

  v(1:ndim) = (/ (dble(i)+0.1_fgsl_double, i=1,ndim) /)
  vec = fgsl_vector_init(1.0_fgsl_double)
  status = fgsl_vector_align(v, ndim, vec, 3_fgsl_size_t, 2_fgsl_size_t, &
       3_fgsl_size_t)
  if (status == fgsl_success) then
     status = fgsl_vector_align(p_v, vec)
     write(6, '(''Size of pointer is: '',i3)') size(p_v)
     write(6, '(''Components: '',3F12.5)') p_v(1:size(p_v))
     write(6, '(''Should be : '',3F12.5)') (/3.1D0,6.1D0,9.1D0/)
     v(6) = v(6) + 1.0_fgsl_double
     write(6, '(''Increased 2nd component by one: '',F12.5)') p_v(2)
  else
     write(6, *) 'Failed to properly initialize vector object.'
  end if
  call fgsl_vector_free(vec)
end program vector

module mod_montecarlo
  use fgsl
  use, intrinsic :: iso_c_binding
  implicit none
  real(fgsl_double), parameter :: exact = 1.3932039296856768_fgsl_double
  real(fgsl_double), parameter :: eps6 = 1.0d-6
  integer(fgsl_size_t), parameter :: calls = 500000
contains
  function g(v, n, params) bind(c)
    integer(c_size_t), value :: n
    real(c_double), dimension(*) :: v
    type(c_ptr), value :: params
    real(c_double) :: g
    g = 1.0_c_double/(m_pi**3)/ &
         (1.0_fgsl_double - cos(v(1))*cos(v(2))*cos(v(3)))
  end function g
end module mod_montecarlo
program montecarlo
  use mod_montecarlo
  use mod_unit
  implicit none
  real(fgsl_double) :: chisq, xl(3), xu(3), res, err, y, yy, yyy
  integer(fgsl_int) :: status, stage, mode, verbose
  integer(fgsl_size_t) :: its
  type(fgsl_file) :: file
  type(fgsl_rng) :: r
  type(fgsl_rng_type) :: t
  type(fgsl_monte_plain_state) :: s
  type(fgsl_monte_miser_state) :: m
  type(fgsl_monte_vegas_state) :: v
  type(fgsl_monte_function) :: gfun
  type(c_ptr) :: ptr
!
! Test monte carlo routines
!
  call unit_init(200)
!
  xl = 0.0_fgsl_double ; xu = m_pi
  t = fgsl_rng_env_setup()
  r = fgsl_rng_alloc(t)
  gfun = fgsl_monte_function_init(g, 3_fgsl_size_t, ptr)
  s = fgsl_monte_plain_alloc(3_fgsl_size_t)
  call unit_assert_true('fgsl_monte_plain_alloc',&
       fgsl_well_defined(s),.true.)
  status = fgsl_monte_plain_integrate(gfun, xl, xu, 3_fgsl_size_t, &
       calls, r, s, res, err)
  call unit_assert_equal('fgsl_monte_plain:status',&
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_monte_plain:res',1.412209d0,res,eps6)
  call unit_assert_equal_within('fgsl_monte_plain:err',0.013436d0,err,eps6)
  call fgsl_monte_plain_free(s)
!
  m = fgsl_monte_miser_alloc(3_fgsl_size_t)
  call unit_assert_true('fgsl_monte_miser_alloc',&
       fgsl_well_defined(m),.true.)
  status = fgsl_monte_miser_integrate(gfun, xl, xu, 3_fgsl_size_t, &
       calls, r, m, res, err)
  call unit_assert_equal('fgsl_monte_miser_integrate:status',&
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_monte_plain:res',1.391322d0,res,eps6)
  call unit_assert_equal_within('fgsl_monte_plain:err',0.003461d0,err,eps6)
  call fgsl_monte_miser_free(m)

!
  v = fgsl_monte_vegas_alloc(3_fgsl_size_t)
  call unit_assert_true('fgsl_monte_vegas_alloc',&
       fgsl_well_defined(v),.true.)
  status = fgsl_monte_vegas_integrate(gfun, xl, xu, 3_fgsl_size_t, &
       10000_fgsl_size_t, r, v, res, err)
  do 
     status = fgsl_monte_vegas_integrate(gfun, xl, xu, 3_fgsl_size_t, &
          calls/5_fgsl_size_t, r, v, res, err)
     call fgsl_monte_vegas_getparams(v, y, yy, chisq, yyy, &
       its, stage, mode, verbose, file)
     if (abs(chisq - 1.0_fgsl_double) <= 0.5_fgsl_double) exit 
  end do
  call unit_assert_equal('fgsl_monte_vegas:status',&
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_monte_vegas:res',1.393281d0,res,eps6)
  call unit_assert_equal_within('fgsl_monte_vegas:err',0.000362d0,err,eps6)
  call unit_assert_equal_within('fgsl_monte_vegas_getparams:res',&
       1.393702d0,y,eps6)
  call unit_assert_equal_within('fgsl_monte_vegas_getparams:sigma',&
       0.000630d0,yy,eps6)
  call unit_assert_equal_within('fgsl_monte_vegas_getparams:chisq',&
       1.499468d0,chisq,eps6)
  call unit_assert_equal_within('fgsl_monte_vegas_getparams:alpha',&
       1.5d0,yyy,eps6)
  call unit_assert_equal('fgsl_monte_vegas_getparams:iterations',&
       5,int(its))
  call unit_assert_equal('fgsl_monte_vegas_getparams:stage',&
       1,stage)
  call unit_assert_equal('fgsl_monte_vegas_getparams:mode',&
       fgsl_vegas_mode_stratified,mode)
  call unit_assert_equal('fgsl_monte_vegas_getparams:verbose',&
       -1,verbose)
  call unit_assert_true('fgsl_monte_monte_vegas_getparams',&
       .not. fgsl_well_defined(file),.true.)
  call fgsl_monte_vegas_free(v)
  call fgsl_monte_function_free(gfun)
  call fgsl_rng_free(r)
!
! Done
!
  call unit_finalize()
end program montecarlo

  function fgsl_function_fdf_init(f, df, fdf, params)
    procedure(function) :: f
    procedure(function_df) :: df
    procedure(function_fdf) :: df
    type(c_ptr), intent(in) :: params
    type(fgsl_function_fdf) :: fgsl_function_fdf_init
  end function fgsl_function_fdf_init

module mod_ode
  use, intrinsic :: iso_c_binding
  use fgsl
  use mod_unit
  implicit none
contains
  function func_ode(t, y, dydt, params) bind(c)
    real(c_double), value :: t
    real(c_double), dimension(*), intent(in) :: y
    real(c_double), dimension(*) :: dydt
    type(c_ptr), value :: params
    integer(c_int) :: func_ode
! 
    real(c_double), pointer :: mu
!
!    write(6, *) 'Starting func:'
    call c_f_pointer(params, mu)
!    write(6, *) 'y, mu:', y(1:2), mu
    dydt(1) = y(2)
    dydt(2) = -y(1) - mu*y(2)*(y(1)*y(1) - 1)
    func_ode = fgsl_success
  end function func_ode
  function jac(t, y, dfdy, dfdt, params) bind(c)
    real(c_double), value :: t
    real(c_double), dimension(*), intent(in) :: y
    real(c_double), dimension(*) :: dfdy
    real(c_double), dimension(*) :: dfdt
    type(c_ptr), value :: params
    integer(c_int) :: jac
! 
    real(c_double), pointer :: mu
!
!    write(6, *) 'Calling jac'
    call c_f_pointer(params, mu)
    dfdy(1) = 0.0_c_double
    dfdy(2) = 1.0_c_double
    dfdy(3) = -2.0_c_double*mu*y(1)*y(2) - 1.0_c_double
    dfdy(4) = -mu*(y(1)*y(1) - 1.0_c_double)
    dfdt(1:2) = 0.0_c_double
    jac = fgsl_success
  end function jac
end module mod_ode
program ode
  use mod_ode
  implicit none
  real(fgsl_double), parameter :: eps3 = 1.0d-3
  real(fgsl_double), target :: xx
  real(fgsl_double) :: t, t1, h, y(2)
  character(kind=fgsl_char, len=fgsl_strmax) :: name
  type(c_ptr) :: ptr
  integer(fgsl_int) :: status
  type(fgsl_odeiv_step) :: ode_step
  type(fgsl_odeiv_control) :: ode_ctrl
  type(fgsl_odeiv_evolve) :: ode_evlv
  type(fgsl_odeiv_system) :: ode_system

!
! Test ODE solvers
!
  call unit_init(20)
!
  ode_step = fgsl_odeiv_step_alloc(fgsl_odeiv_step_bsimp,2_fgsl_size_t)
  name = fgsl_odeiv_step_name(ode_step)
!  write(6, *) 'ode_step_alloc of type ',trim(name),' done'
! FIXME: well_defined checks missing
  ode_ctrl = fgsl_odeiv_control_y_new(1.0e-6_fgsl_double, 0.0_fgsl_double)
  ode_evlv = fgsl_odeiv_evolve_alloc(2_fgsl_size_t)
  xx = 10.0_fgsl_double
  ptr = c_loc(xx)
  ode_system = fgsl_odeiv_system_init(func_ode, 2_c_size_t, ptr, jac)
!
  t = 0.0_fgsl_double; t1 = 100.0_fgsl_double
  h = 1.0e-6_fgsl_double; y = (/1.0_c_double, 0.0_c_double /)
  do while (t < t1) 
     status = fgsl_odeiv_evolve_apply(ode_evlv, ode_ctrl, ode_step, ode_system, & 
          t, t1, h, y)
     if (status /= fgsl_success) exit
!     write(6,fmt='(3E15.8,1X)') t, y(1), y(2)
  end do
  call unit_assert_equal('fgsl_odeiv_evolve_apply:status', &
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_odeiv_evolve_apply',&
       (/-1.758888d0, 0.083643595d0/),y,eps3)
  call fgsl_odeiv_evolve_free (ode_evlv)
  call fgsl_odeiv_control_free (ode_ctrl)
  call fgsl_odeiv_step_free (ode_step)
  call fgsl_odeiv_system_free(ode_system)
!
! Done
!
  call unit_finalize() 
end program ode

program permutation
  use mod_unit
  use fgsl
  implicit none
  real(fgsl_double), parameter :: eps10 = 1.0E-10_fgsl_double
  type(fgsl_permutation) :: p1, p2, p3
  type(fgsl_combination) :: c1, c2, c3
  type(fgsl_error_handler_t) :: std
  type(fgsl_vector) :: vec
  type(fgsl_file) :: pfile
  integer(fgsl_int) :: status
  integer(fgsl_size_t) :: index
  integer(fgsl_size_t), pointer, dimension(:) :: p_data
  real(fgsl_double) :: da(8)
  integer(fgsl_long) :: ida(8)
!
! Test permutations and combinations
!
  call unit_init(100)
  std = fgsl_set_error_handler_off()
  call unit_assert_true('fgsl_well_defined',.not. fgsl_well_defined(p1),.false.)
!
! permutations
!
  p1 = fgsl_permutation_alloc(4_fgsl_size_t)
  p2 = fgsl_permutation_alloc(4_fgsl_size_t)
  p3 = fgsl_permutation_alloc(4_fgsl_size_t)
  call unit_assert_true('fgsl_well_defined',fgsl_well_defined(p1),.true.)
  call unit_assert_true('fgsl_well_defined',fgsl_well_defined(p2),.true.)
  call fgsl_permutation_init(p1)
  call fgsl_permutation_init(p2)
  status = fgsl_permutation_swap(p1, 1_fgsl_size_t, 3_fgsl_size_t)
  index = fgsl_permutation_get(p1,1_fgsl_size_t)
  call unit_assert_equal('fgsl_permutation_get:after swap',3,int(index))
  index = fgsl_permutation_get(p1,3_fgsl_size_t)
  call unit_assert_equal('fgsl_permutation_get:after swap',1,int(index))
  status = fgsl_permutation_valid(p1)
  call unit_assert_equal('fgsl_permutation_valid',fgsl_success,status)
  index = fgsl_permutation_size(p1)
  call unit_assert_equal('fgsl_permutation_size',4,int(index))
  p_data => fgsl_permutation_data(p1)
  call unit_assert_true('fgsl_well_defined',associated(p_data),.true.)
  call unit_assert_equal('fgsl_permutation_data',(/0,3,2,1/),int(p_data))
  status = fgsl_permutation_memcpy(p2,p1)
  call unit_assert_equal('fgsl_permutation_memcpy:status',fgsl_success,status)
  p_data => fgsl_permutation_data(p2)
  call unit_assert_equal('fgsl_permutation_memcpy',(/0,3,2,1/),int(p_data))
  status = fgsl_permutation_valid(p2)
  call unit_assert_equal('fgsl_permutation_valid:yes',fgsl_success,status)
  p_data(2) = 0
  status = fgsl_permutation_valid(p2)
  call unit_assert_equal('fgsl_permutation_valid:no',fgsl_failure,status)
  call fgsl_permutation_free(p1)
  p1 = fgsl_permutation_calloc(4_fgsl_size_t)
  p_data => fgsl_permutation_data(p1)
  call unit_assert_equal('fgsl_permutation_data',(/0,1,2,3/),int(p_data))
  call fgsl_permutation_reverse(p1)
  call unit_assert_equal('fgsl_permutation_reverse',(/3,2,1,0/),int(p_data))
  status = fgsl_permutation_inverse(p2,p1)
  p_data => fgsl_permutation_data(p2)
  call unit_assert_equal('fgsl_permutation_inverse',(/3,2,1,0/),int(p_data))
  call fgsl_permutation_reverse(p2)
  status = fgsl_permutation_next(p2)
  call unit_assert_equal('fgsl_permutation_next:status',fgsl_success,status)
  status = fgsl_permutation_prev(p2)
  call unit_assert_equal('fgsl_permutation_prev:status',fgsl_success,status)
  call unit_assert_equal('fgsl_permutation_next/prev',(/0,1,2,3/),int(p_data))
!
  da = (/1.0d0,2.0d0,3.0d0,4.0d0,5.0d0,6.0d0,7.0d0,8.0d0/)
  call fgsl_permutation_reverse(p2)
  status = fgsl_permute(p_data,da,2_fgsl_size_t,4_fgsl_size_t)
  call unit_assert_equal('fgsl_permute:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_permute',&
       (/7.0d0,2.0d0,5.0d0,4.0d0,3.0d0,6.0d0,1.0d0,8.0d0/),da,eps10)
  da = (/1.0d0,2.0d0,3.0d0,4.0d0,5.0d0,6.0d0,7.0d0,8.0d0/)
  status = fgsl_permute_inverse(p_data,da,2_fgsl_size_t,4_fgsl_size_t)
  call unit_assert_equal('fgsl_permute:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_permute',&
       (/7.0d0,2.0d0,5.0d0,4.0d0,3.0d0,6.0d0,1.0d0,8.0d0/),da,eps10)
  ida = (/1_fgsl_long,2_fgsl_long,3_fgsl_long,4_fgsl_long,&
       5_fgsl_long,6_fgsl_long,7_fgsl_long,8_fgsl_long/)
  status = fgsl_permute(p_data,ida,2_fgsl_size_t,4_fgsl_size_t)
  call unit_assert_equal('fgsl_permute_long:status',fgsl_success,status)
  call unit_assert_equal('fgsl_permute_long',&
       (/7,2,5,4,3,6,1,8/),int(ida))
  ida = (/1_fgsl_long,2_fgsl_long,3_fgsl_long,4_fgsl_long,&
       5_fgsl_long,6_fgsl_long,7_fgsl_long,8_fgsl_long/)
  status = fgsl_permute_inverse(p_data,ida,2_fgsl_size_t,4_fgsl_size_t)
  call unit_assert_equal('fgsl_permute_long_inverse:status',fgsl_success,status)
  call unit_assert_equal('fgsl_permute_long_inverse',&
        (/7,2,5,4,3,6,1,8/),int(ida))
  da = (/1.0d0,2.0d0,3.0d0,4.0d0,5.0d0,6.0d0,7.0d0,8.0d0/)
  vec = fgsl_vector_init(1.0_fgsl_double) 
  status = fgsl_vector_align(da, 4_fgsl_size_t, vec, 4_fgsl_size_t, 0_fgsl_size_t, &
       1_fgsl_size_t)
  status = fgsl_permute_vector(p2,vec)
  call unit_assert_equal_within('fgsl_permute',&
       (/4.0d0,3.0d0,2.0d0,1.0d0/),da(1:4),eps10)  
  da = (/1.0d0,2.0d0,3.0d0,4.0d0,5.0d0,6.0d0,7.0d0,8.0d0/)
  status = fgsl_permute_vector_inverse(p2,vec)
  call unit_assert_equal_within('fgsl_permute_inverse',&
       (/4.0d0,3.0d0,2.0d0,1.0d0/),da(1:4),eps10)  
  call fgsl_vector_free(vec)
! multiply
  status = fgsl_permutation_mul(p3,p1,p2)
  call unit_assert_equal('fgsl_permute_mul:status',fgsl_success,status)
  p_data => fgsl_permutation_data(p3)
  call unit_assert_equal('fgsl_permutation_mul',(/0,1,2,3/),int(p_data))
! I/O
  pfile = fgsl_open('permutation.dat','w')
  call unit_assert_true('fgsl_open',fgsl_well_defined(pfile),.true.)
  status = fgsl_permutation_fwrite(pfile,p1)
  call unit_assert_equal('fgsl_permutation_fwrite:status',fgsl_success,status)
  status = fgsl_close(pfile)
  call unit_assert_equal('fgsl_close:status',fgsl_success,status)
  pfile = fgsl_open('permutation.dat','r')
  call unit_assert_true('fgsl_open',fgsl_well_defined(pfile),.true.)
  status = fgsl_permutation_fread(pfile,p3)
  call unit_assert_equal('fgsl_permutation_fread:status',fgsl_success,status)
  status = fgsl_close(pfile)
  call unit_assert_equal('fgsl_close:status',fgsl_success,status)
  call unit_assert_equal('fgsl_permutation_fread',(/3,2,1,0/),int(p_data))
  pfile = fgsl_open('permutation.dat','w')
  call unit_assert_true('fgsl_open',fgsl_well_defined(pfile),.true.)
  status = fgsl_permutation_fprintf(pfile,p1,'%Zu\n')
  call unit_assert_equal('fgsl_permutation_fprintf:status',fgsl_success,status)
  status = fgsl_close(pfile)
  call unit_assert_equal('fgsl_close:status',fgsl_success,status)
  pfile = fgsl_open('permutation.dat','r')
  call unit_assert_true('fgsl_open',fgsl_well_defined(pfile),.true.)
  p_data(1) = 0
  status = fgsl_permutation_fscanf(pfile,p3)
  status = fgsl_close(pfile)
  call unit_assert_equal('fgsl_close:status',fgsl_success,status)
  call unit_assert_equal('fgsl_permutation_fscanf',(/3,2,1,0/),int(p_data))
!
  p_data = (/1,2,3,0/)
  status = fgsl_permutation_linear_to_canonical(p2, p3)
  call unit_assert_equal('fgsl_permutation_linear_to_canonical:status',&
       fgsl_success,status)
  p_data => fgsl_permutation_data(p2)
  call unit_assert_equal('fgsl_permutation_linear_to_canonical',&
       (/0,1,2,3/),int(p_data))
  p_data => fgsl_permutation_data(p3)
  p_data = (/0,0,0,0/)
  status = fgsl_permutation_canonical_to_linear(p3, p2)
  call unit_assert_equal('fgsl_permutation_canonical_to_linear:status',&
       fgsl_success,status)
  call unit_assert_equal('fgsl_permutation_canonical_to_linear',&
       (/1,2,3,0/),int(p_data))
  index = fgsl_permutation_linear_cycles(p3)
  call unit_assert_equal('fgsl_permutation_linear_cycles',1,int(index))
  index = fgsl_permutation_canonical_cycles(p2)
  call unit_assert_equal('fgsl_permutation_linear_cycles',1,int(index))
!
  call fgsl_permutation_free(p1)
  call fgsl_permutation_free(p2)
  call fgsl_permutation_free(p3)
!
! Combinations
!
  c1 = fgsl_combination_alloc(4_fgsl_size_t,2_fgsl_size_t)
  c2 = fgsl_combination_alloc(4_fgsl_size_t,2_fgsl_size_t)
  call unit_assert_true('fgsl_well_defined',fgsl_well_defined(c1),.true.)
  call unit_assert_true('fgsl_well_defined',fgsl_well_defined(c2),.true.)
  call fgsl_combination_init_first(c1)
  call fgsl_combination_init_last(c2)
  index = fgsl_combination_get(c1,0_fgsl_size_t)
  call unit_assert_equal('fgsl_permutation_init_first:0',0,int(index))
  index = fgsl_combination_get(c1,1_fgsl_size_t)
  call unit_assert_equal('fgsl_permutation_init_first:1',1,int(index))
  index = fgsl_combination_get(c2,0_fgsl_size_t)
  call unit_assert_equal('fgsl_permutation_init_first:2',2,int(index))
  index = fgsl_combination_get(c2,1_fgsl_size_t)
  call unit_assert_equal('fgsl_permutation_init_first:3',3,int(index))
  c1 = fgsl_combination_calloc(4_fgsl_size_t,2_fgsl_size_t)
  p_data => fgsl_combination_data(c1)
  call unit_assert_true('fgsl_well_defined',associated(p_data),.true.)
  call unit_assert_equal('fgsl_combination_data',(/0,1/),int(p_data))
  p_data => fgsl_combination_data(c2)
  p_data(1) = 4
  status = fgsl_combination_valid(c2)
  call unit_assert_equal('fgsl_combination_valid:status',fgsl_failure,status)
  status = fgsl_combination_memcpy(c2,c1)
  call unit_assert_equal('fgsl_combination_memcpy:status',fgsl_success,status)
  call unit_assert_equal('fgsl_combination_memcpy',(/0,1/),int(p_data))
  index = fgsl_combination_n(c1)
  call unit_assert_equal('fgsl_combination_n',4,int(index))
  index = fgsl_combination_k(c1)
  call unit_assert_equal('fgsl_combination_k',2,int(index))
  status = fgsl_combination_next(c2)
  call unit_assert_equal('fgsl_combination_next',(/0,2/),int(p_data))
  status = fgsl_combination_prev(c2)
  call unit_assert_equal('fgsl_combination_prev',(/0,1/),int(p_data))
! I/O
  status = fgsl_combination_next(c1)
  pfile = fgsl_open('combination.dat','w')
  call unit_assert_true('fgsl_open',fgsl_well_defined(pfile),.true.)
  status = fgsl_combination_fwrite(pfile,c1)
  call unit_assert_equal('fgsl_combination_fwrite:status',fgsl_success,status)
  status = fgsl_close(pfile)
  call unit_assert_equal('fgsl_close:status',fgsl_success,status)
  pfile = fgsl_open('combination.dat','r')
  call unit_assert_true('fgsl_open',fgsl_well_defined(pfile),.true.)
  status = fgsl_combination_fread(pfile,c2)
  call unit_assert_equal('fgsl_combination_fread:status',fgsl_success,status)
  status = fgsl_close(pfile)
  call unit_assert_equal('fgsl_close:status',fgsl_success,status)
  call unit_assert_equal('fgsl_combination_fread',(/0,2/),int(p_data))
  pfile = fgsl_open('combination.dat','w')
  call unit_assert_true('fgsl_open',fgsl_well_defined(pfile),.true.)
  status = fgsl_combination_fprintf(pfile,c1,'%Zu\n')
  call unit_assert_equal('fgsl_combination_fprintf:status',fgsl_success,status)
  status = fgsl_close(pfile)
  call unit_assert_equal('fgsl_close:status',fgsl_success,status)
  pfile = fgsl_open('combination.dat','r')
  call unit_assert_true('fgsl_open',fgsl_well_defined(pfile),.true.)
  p_data(1) = 0
  status = fgsl_combination_fscanf(pfile,c2)
  status = fgsl_close(pfile)
  call unit_assert_equal('fgsl_close:status',fgsl_success,status)
  call unit_assert_equal('fgsl_combination_fscanf',(/0,2/),int(p_data))
!
  call fgsl_combination_free(c1)
  call fgsl_combination_free(c2)
!
! Done
!
  call unit_finalize()
end program permutation

program specfunc
  use mod_unit
  use fgsl
  implicit none
  real(fgsl_double), parameter :: eps5 = 1.0E-5_fgsl_double
  real(fgsl_double), parameter :: eps7 = 1.0E-7_fgsl_double
  real(fgsl_double), parameter :: eps10 = 1.0E-10_fgsl_double
  real(fgsl_double), parameter :: eps15 = 1.0E-15_fgsl_double
  integer(fgsl_int) :: status, lmsize
  real(fgsl_double) :: ra, ra_2, ra_3, ra_exp, ra_exp_2, x11, x21, &
       ra_arr(1), ra_arr_der(1), ra_arr_2(1), ra_arr_2_der(1), &
       ra_arr_3(2), ra_arr_3_der(2)
  type(fgsl_sf_result) :: sfres, sfres_der, sfres_2, sfres_2_der
  type(fgsl_sf_result_e10) :: sfres10
! FIXME  here many tests are missing still
!
! Test special functions
!
  call unit_init(800)
!
! Airy functions
!
  ra = fgsl_sf_airy_ai(0.0_fgsl_double, fgsl_prec_double) 
  call unit_assert_equal_within('fgsl_sf_airy_ai',0.35502805d0,ra,eps7)
  status = fgsl_sf_airy_ai_e(0.0_fgsl_double, fgsl_prec_double, sfres)
  call unit_assert_equal('fgsl_sf_airy_ai_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_airy_ai_e',0.3550280538878172d0,&
       sfres%val,sfres%err)
  ra = fgsl_sf_airy_bi(0.0_fgsl_double, fgsl_prec_double) 
  call unit_assert_equal_within('fgsl_sf_airy_bi',0.61492663d0,ra,eps7)
  status = fgsl_sf_airy_bi_e(0.0_fgsl_double, fgsl_prec_double, sfres)
  call unit_assert_equal('fgsl_sf_airy_bi_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_airy_bi_e',0.6149266274460007d0,&
       sfres%val,sfres%err)
  status = fgsl_sf_airy_bi_e(0.0_fgsl_double, fgsl_prec_single, sfres)
  call unit_assert_equal('fgsl_sf_airy_bi_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_airy_bi_e:single',&
       0.6149266274460007d0,sfres%val,sfres%err)
  status = fgsl_sf_airy_bi_e(0.0_fgsl_double, fgsl_prec_approx, sfres)
  call unit_assert_equal('fgsl_sf_airy_bi_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_airy_bi_e:approx',&
       0.6149266274460007d0,sfres%val,sfres%err)
  ra = fgsl_sf_airy_ai_scaled(0.0_fgsl_double, fgsl_prec_double) 
  call unit_assert_equal_within('fgsl_sf_airy_ai_scaled',0.35502805d0,ra,eps7)
  status = fgsl_sf_airy_ai_scaled_e(0.0_fgsl_double, fgsl_prec_double, sfres)
  call unit_assert_equal('fgsl_sf_airy_ai_scaled_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_airy_ai_scaled_e',0.3550280538878172d0,&
       sfres%val,sfres%err)
  ra = fgsl_sf_airy_bi_scaled(0.0_fgsl_double, fgsl_prec_double) 
  call unit_assert_equal_within('fgsl_sf_airy_bi_scaled',0.61492663d0,ra,eps7)
  status = fgsl_sf_airy_bi_scaled_e(0.0_fgsl_double, fgsl_prec_double, sfres)
  call unit_assert_equal('fgsl_sf_airy_bi_scaled_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_airy_bi_scaled_e',0.6149266274460007d0,&
       sfres%val,sfres%err)
  ra = fgsl_sf_airy_ai_deriv(0.0_fgsl_double, fgsl_prec_double) 
  call unit_assert_equal_within('fgsl_sf_airy_ai_deriv',-0.25881940D0,ra,eps7)
  status = fgsl_sf_airy_ai_deriv_e(0.0_fgsl_double, fgsl_prec_double, sfres)
  call unit_assert_equal('fgsl_sf_airy_ai_deriv_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_airy_ai_deriv_e',-0.2588194037928068D0,&
       sfres%val,sfres%err)
  ra = fgsl_sf_airy_bi_deriv(0.0_fgsl_double, fgsl_prec_double) 
  call unit_assert_equal_within('fgsl_sf_airy_bi_deriv',0.44828836d0,ra,eps7)
  status = fgsl_sf_airy_bi_deriv_e(0.0_fgsl_double, fgsl_prec_double, sfres)
  call unit_assert_equal('fgsl_sf_airy_bi_deriv_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_airy_bi_deriv_e',0.4482883573538263d0,&
       sfres%val,sfres%err)
  ra = fgsl_sf_airy_zero_ai(1)
  call unit_assert_equal_within('fgsl_sf_airy_zero_ai',-2.33810741d0,ra,eps7)
  status = fgsl_sf_airy_zero_ai_e(1, sfres)
  call unit_assert_equal('fgsl_sf_airy_zero_ai_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_airy_zero_ai_e',-2.338107410459767d0,&
       sfres%val,sfres%err)
  ra = fgsl_sf_airy_zero_bi(1)
  call unit_assert_equal_within('fgsl_sf_airy_zero_bi',-1.17371322d0,ra,eps7)
  status = fgsl_sf_airy_zero_bi_e(1, sfres)
  call unit_assert_equal('fgsl_sf_airy_zero_bi_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_airy_zero_bi_e',-1.173713222709128d0,&
       sfres%val,sfres%err)
  ra = fgsl_sf_airy_zero_ai_deriv(1)
  call unit_assert_equal_within('fgsl_sf_airy_zero_ai_deriv',&
       -1.01879297d0,ra,eps7)
  status = fgsl_sf_airy_zero_ai_deriv_e(1, sfres)
  call unit_assert_equal('fgsl_sf_airy_zero_ai_deriv_e:status',&
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_airy_zero_ai_deriv_e',&
       -1.018792971647471d0,sfres%val,sfres%err)
  ra = fgsl_sf_airy_zero_bi_deriv(1)
  call unit_assert_equal_within('fgsl_sf_airy_zero_bi_deriv',&
       -2.29443968d0,ra,eps7)
  status = fgsl_sf_airy_zero_bi_deriv_e(1, sfres)
  call unit_assert_equal('fgsl_sf_airy_zero_bi_deriv_e:status',&
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_airy_zero_bi_deriv_e',&
       -2.294439682614123d0,sfres%val,sfres%err)
!
! Bessel functions
!
  ra = fgsl_sf_bessel_jc0(1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_jc0',0.765197686557967d0,ra,eps10)
  status = fgsl_sf_bessel_jc0_e(1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_jc0_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_jc0_e',0.765197686557967d0,&
       sfres%val,sfres%err)
  ra = fgsl_sf_bessel_jc1(1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_jc1',0.4400505857d0,ra,eps10)
  status = fgsl_sf_bessel_jc1_e(1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_jc1_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_jc1_e',0.4400505857449335d0,&
       sfres%val,sfres%err)
  ra = fgsl_sf_bessel_jcn(1,1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_jcn',0.4400505857d0,ra,eps10)
  status = fgsl_sf_bessel_jcn_e(1,1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_jcn_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_jcn_e',0.4400505857449335d0,&
       sfres%val,sfres%err)
  status = fgsl_sf_bessel_jcn_array(1,1,1.0_fgsl_double,ra_arr) 
  call unit_assert_equal('fgsl_sf_bessel_jcn_array:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_jcn_array',0.4400505857449335d0,&
       ra_arr(1),eps10)
  ra = fgsl_sf_bessel_yc0(1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_yc0',0.0882569642d0,ra,eps10)
  status = fgsl_sf_bessel_yc0_e(1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_yc0_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_yc0_e',0.08825696421567691d0,&
       sfres%val,sfres%err)
  ra = fgsl_sf_bessel_yc1(1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_yc1',-0.7812128213d0,ra,eps10)
  status = fgsl_sf_bessel_yc1_e(1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_yc1_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_yc1_e',-0.7812128213002888d0,&
       sfres%val,sfres%err)
  ra = fgsl_sf_bessel_ycn(1,1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_ycn',-0.7812128213d0,ra,eps10)
  status = fgsl_sf_bessel_ycn_e(1,1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_ycn_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_ycn_e',-0.7812128213002888d0,&
       sfres%val,sfres%err)
  status = fgsl_sf_bessel_ycn_array(1,1,1.0_fgsl_double,ra_arr) 
  call unit_assert_equal('fgsl_sf_bessel_ycn_array:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_ycn_array',-0.7812128213002888d0,&
       ra_arr(1),eps10)
  ra = fgsl_sf_bessel_ic0(1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_ic0',1.2660658780d0,ra,eps7)
  status = fgsl_sf_bessel_ic0_e(1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_ic0_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_ic0_e',1.266065877752008d0,&
       sfres%val,sfres%err)
  ra = fgsl_sf_bessel_ic1(1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_ic1',.5651591041d0,ra,eps7)
  status = fgsl_sf_bessel_ic1_e(1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_ic1_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_ic1_e',.5651591039924850d0,&
       sfres%val,sfres%err)
  ra = fgsl_sf_bessel_icn(1,1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_icn',.5651591041d0,ra,eps7)
  status = fgsl_sf_bessel_icn_e(1,1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_icn_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_icn_e',.5651591039924850d0,&
       sfres%val,sfres%err)
  status = fgsl_sf_bessel_icn_array(1,1,1.0_fgsl_double,ra_arr) 
  call unit_assert_equal('fgsl_sf_bessel_icn_array:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_icn_array',.5651591039924850d0,&
       ra_arr(1),eps10)
  ra = fgsl_sf_bessel_ic0_scaled(1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_ic0_scaled',&
       0.4657596077d0,ra,eps7)
  status = fgsl_sf_bessel_ic0_scaled_e(1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_ic0_scaled_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_ic0_scaled_e',&
       0.4657596075936405d0,sfres%val,sfres%err)
  ra = fgsl_sf_bessel_ic1_scaled(1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_ic1_scaled',&
       0.2079104154d0,ra,eps7)
  status = fgsl_sf_bessel_ic1_scaled_e(1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_ic1_scaled_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_ic1_scaled_e',&
       0.2079104153497085d0,sfres%val,sfres%err)
  ra = fgsl_sf_bessel_icn_scaled(1,1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_icn_scaled',&
       0.2079104154d0,ra,eps7)
  status = fgsl_sf_bessel_icn_scaled_e(1,1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_icn_scaled_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_icn_scaled_e',&
       0.2079104153497085d0,sfres%val,sfres%err)
  status = fgsl_sf_bessel_icn_scaled_array(1,1,1.0_fgsl_double,ra_arr) 
  call unit_assert_equal('fgsl_sf_bessel_icn_scaled_array:status',&
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_icn_scaled_array',&
       0.2079104153497085d0,ra_arr(1),eps10)
  ra = fgsl_sf_bessel_kc0(1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_kc0',.42102443823d0,ra,eps7)
  status = fgsl_sf_bessel_kc0_e(1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_kc0_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_kc0_e',.4210244382407084d0,&
       sfres%val,sfres%err)
  ra = fgsl_sf_bessel_kc1(1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_kc1',.6019072302d0,ra,eps7)
  status = fgsl_sf_bessel_kc1_e(1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_kc1_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_kc1_e',.6019072301972346d0,&
       sfres%val,sfres%err)
  ra = fgsl_sf_bessel_kcn(1,1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_kcn',.6019072302d0,ra,eps7)
  status = fgsl_sf_bessel_kcn_e(1,1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_kcn_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_kcn_e',.6019072301972346d0,&
       sfres%val,sfres%err)
  status = fgsl_sf_bessel_kcn_array(1,1,1.0_fgsl_double,ra_arr) 
  call unit_assert_equal('fgsl_sf_bessel_kcn_array:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_kcn_array',.6019072301972346d0,&
       ra_arr(1),eps10)
  ra = fgsl_sf_bessel_kc0_scaled(1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_kc0_scaled',&
       1.144463079806895d0,ra,eps7)
  status = fgsl_sf_bessel_kc0_scaled_e(1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_kc0_scaled_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_kc0_scaled_e',&
       1.144463079806895d0,sfres%val,sfres%err)
  ra = fgsl_sf_bessel_kc1_scaled(1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_kc1_scaled',&
       1.636153486263258d0,ra,eps7)
  status = fgsl_sf_bessel_kc1_scaled_e(1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_kc1_scaled_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_kc1_scaled_e',&
       1.636153486263258d0,sfres%val,sfres%err)
  ra = fgsl_sf_bessel_kcn_scaled(1,1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_kcn_scaled',&
       1.636153486263258d0,ra,eps7)
  status = fgsl_sf_bessel_kcn_scaled_e(1,1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_kcn_scaled_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_kcn_scaled_e',&
       1.636153486263258d0,sfres%val,sfres%err)
  status = fgsl_sf_bessel_kcn_scaled_array(1,1,1.0_fgsl_double,ra_arr) 
  call unit_assert_equal('fgsl_sf_bessel_kcn_scaled_array:status',&
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_kcn_scaled_array',&
       1.636153486263258d0,ra_arr(1),eps10)
  ra = fgsl_sf_bessel_js0(1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_js0',0.84147098d0,ra,eps7)
  status = fgsl_sf_bessel_js0_e(1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_js0_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_js0_e',0.8414709848078965d0,&
       sfres%val,sfres%err)
  ra = fgsl_sf_bessel_js1(1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_js1',0.30116868d0,ra,eps7)
  status = fgsl_sf_bessel_js1_e(1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_js1_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_js1_e',0.3011686789397567d0,&
       sfres%val,sfres%err)
  ra = fgsl_sf_bessel_js2(1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_js2',0.062035052d0,ra,eps7)
  status = fgsl_sf_bessel_js2_e(1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_js2_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_js2_e',6.203505201137386D-02,&
       sfres%val,sfres%err)
  ra = fgsl_sf_bessel_jsl(0,1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_jsl',0.84147098d0,ra,eps7)
  status = fgsl_sf_bessel_jsl_e(0,1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_jsl_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_jsl_e',0.8414709848078965d0,&
       sfres%val,sfres%err)
  status = fgsl_sf_bessel_jsl_array(0,1.0_fgsl_double,ra_arr) 
  call unit_assert_equal('fgsl_sf_bessel_jsl_array:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_jsl_array',0.8414709848078965d0,&
       ra_arr(1),eps10)
  status = fgsl_sf_bessel_jsl_steed_array(0,1.0_fgsl_double,ra_arr) 
  call unit_assert_equal('fgsl_sf_bessel_jsl_steed_array:status',&
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_jsl_steed_array',&
       0.8414709848078965d0,ra_arr(1),eps10)
  ra = fgsl_sf_bessel_ys0(1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_ys0',-0.540302306d0,ra,eps7)
  status = fgsl_sf_bessel_ys0_e(1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_ys0_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_ys0_e',-.5403023058681397d0,&
       sfres%val,sfres%err)
  ra = fgsl_sf_bessel_ys1(1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_ys1',-1.3817733d0,ra,eps7)
  status = fgsl_sf_bessel_ys1_e(1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_ys1_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_ys1_e',-1.381773290676036d0,&
       sfres%val,sfres%err)
  ra = fgsl_sf_bessel_ys2(1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_ys2',-3.6050176d0,ra,eps7)
  status = fgsl_sf_bessel_ys2_e(1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_ys2_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_ys2_e',-3.605017566159969d0,&
       sfres%val,sfres%err)
  ra = fgsl_sf_bessel_ysl(1,1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_ysl',-1.3817733d0,ra,eps7)
  status = fgsl_sf_bessel_ysl_e(1,1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_ysl_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_ysl_e',-1.381773290676036d0,&
       sfres%val,sfres%err)
  status = fgsl_sf_bessel_ysl_array(0,1.0_fgsl_double,ra_arr)
  call unit_assert_equal('fgsl_sf_bessel_ysl_array:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_ysl_array',-.5403023058681397d0,&
       ra_arr(1),eps10)
  ra = fgsl_sf_bessel_is0_scaled(1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_is0',.432332357d0,ra,eps7)
  status = fgsl_sf_bessel_is0_scaled_e(1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_is0_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_is0_e',.4323323583816936d0,&
       sfres%val,sfres%err)
  ra = fgsl_sf_bessel_is1_scaled(1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_is1_scaled',.13533528d0,ra,eps7)
  status = fgsl_sf_bessel_is1_scaled_e(1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_is1_scaled_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_is1_scaled_e',&
       .1353352832366128d0,sfres%val,eps10)
! NOTE: replaced sfres%err by eps10
  ra = fgsl_sf_bessel_is2_scaled(1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_is2_scaled',.026326509d0,ra,eps7)
  status = fgsl_sf_bessel_is2_scaled_e(1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_is2_scaled_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_is2_scaled_e',&
       .02632650867185538d0,sfres%val,eps10)
! NOTE: replaced sfres%err by eps10
  ra = fgsl_sf_bessel_isl_scaled(0,1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_isl_scaled',.432332357d0,ra,eps7)
  status = fgsl_sf_bessel_isl_scaled_e(0,1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_isl_scaled_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_isl_scaled_e',&
       .4323323583816936d0,sfres%val,sfres%err)
  status = fgsl_sf_bessel_isl_scaled_array(0,1.0_fgsl_double,ra_arr) 
  call unit_assert_equal('fgsl_sf_bessel_isl_scaled_array:status',&
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_isl_scaled_array',&
       .4323323583816936d0,ra_arr(1),eps10)
  ra = fgsl_sf_bessel_ks0_scaled(1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_ks0_scaled',1.57079631d0,ra,eps7)
  status = fgsl_sf_bessel_ks0_scaled_e(1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_ks0_scaled_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_ks0_scaled_e',&
       1.570796326794897d0,sfres%val,sfres%err)
  ra = fgsl_sf_bessel_ks1_scaled(1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_ks1_scaled',3.14159265d0,ra,eps7)
  status = fgsl_sf_bessel_ks1_scaled_e(1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_ks1_scaled_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_ks1_scaled_e',&
       3.141592653589793d0,sfres%val,sfres%err)
  ra = fgsl_sf_bessel_ks2_scaled(1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_ks2_scaled',10.99557422d0,ra,eps7)
  status = fgsl_sf_bessel_ks2_scaled_e(1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_ks2_scaled_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_ks2_scaled_e',&
       10.99557428756428d0,sfres%val,sfres%err)
  ra = fgsl_sf_bessel_ksl_scaled(0,1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_ksl_scaled',1.57079631d0,ra,eps7)
  status = fgsl_sf_bessel_ksl_scaled_e(0,1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_bessel_ksl_scaled_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_ksl_scaled_e',&
       1.570796326794897d0,sfres%val,sfres%err)
  status = fgsl_sf_bessel_ksl_scaled_array(0,1.0_fgsl_double,ra_arr) 
  call unit_assert_equal('fgsl_sf_bessel_ksl_scaled_array:status',&
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_ksl_scaled_array',&
       1.570796326794897d0,ra_arr(1),eps10)
  ra = fgsl_sf_bessel_jnu(1.0_fgsl_double,1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_jnu',0.4400505857d0,ra,eps10)
  status = fgsl_sf_bessel_jnu_e(1.0_fgsl_double,1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_bessel_jnu_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_jnu_e',0.4400505857449335d0,&
       sfres%val,sfres%err)
  ra_arr(1) = 1.0d0
  status = fgsl_sf_bessel_sequence_jnu_e(1.0_fgsl_double, fgsl_prec_double, &
       1_fgsl_size_t, ra_arr)
  call unit_assert_equal('fgsl_sf_bessel_sequence_jnu_e:status',&
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_sequence_jnu_e',&
       0.4400505857449335d0,ra_arr(1),eps10)
  ra = fgsl_sf_bessel_ynu(1.0_fgsl_double,1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_ynu',-0.781212821300d0,ra,eps10)
  status = fgsl_sf_bessel_ynu_e(1.0_fgsl_double,1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_bessel_ynu_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_ynu_e',-0.7812128213002888d0,&
       sfres%val,sfres%err)
  ra = fgsl_sf_bessel_inu(1.0_fgsl_double,1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_inu',.5651591039924850d0,ra,eps10)
  status = fgsl_sf_bessel_inu_e(1.0_fgsl_double,1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_bessel_inu_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_inu_e',.5651591039924850d0,&
       sfres%val,sfres%err)
  ra = fgsl_sf_bessel_inu_scaled(1.0_fgsl_double,1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_inu_scaled',&
       0.2079104153497085d0,ra,eps10)
  status = fgsl_sf_bessel_inu_scaled_e(1.0_fgsl_double,1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_bessel_inu_scaled_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_inu_scaled_e',&
       0.2079104153497085d0,sfres%val,sfres%err)
  ra = fgsl_sf_bessel_knu(1.0_fgsl_double,1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_knu',.6019072301972346d0,ra,eps10)
  status = fgsl_sf_bessel_knu_e(1.0_fgsl_double,1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_bessel_knu_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_knu_e',.6019072301972346d0,&
       sfres%val,sfres%err)
  ra = fgsl_sf_bessel_lnknu(1.0_fgsl_double,1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_lnknu',&
       log(.6019072301972346d0),ra,eps10)
  status = fgsl_sf_bessel_lnknu_e(1.0_fgsl_double,1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_bessel_lnknu_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_lnknu_e',&
       log(.6019072301972346d0),sfres%val,sfres%err)
  ra = fgsl_sf_bessel_knu_scaled(1.0_fgsl_double,1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_bessel_knu_scaled',&
       1.636153486263258d0,ra,eps10)
  status = fgsl_sf_bessel_knu_scaled_e(1.0_fgsl_double,1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_bessel_knu_scaled_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_knu_scaled_e',&
       1.636153486263258d0,sfres%val,sfres%err)
  ra = fgsl_sf_bessel_zero_jc0(1) 
  call unit_assert_equal_within('fgsl_sf_bessel_zero_jc0',&
       2.4048255577d0,ra,eps10)
  status = fgsl_sf_bessel_zero_jc0_e(1,sfres)
  call unit_assert_equal('fgsl_sf_bessel_zero_jc0_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_zero_jc0_e',&
       2.404825557695771d0,sfres%val,sfres%err)
  ra = fgsl_sf_bessel_zero_jc1(1) 
  call unit_assert_equal_within('fgsl_sf_bessel_zero_jc1',&
       3.83170597d0,ra,eps7)
  status = fgsl_sf_bessel_zero_jc1_e(1,sfres)
  call unit_assert_equal('fgsl_sf_bessel_zero_jc1_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_zero_jc1_e',&
       3.831705970207503d0,sfres%val,sfres%err)
  ra = fgsl_sf_bessel_zero_jnu(1.0_fgsl_double,1) 
  call unit_assert_equal_within('fgsl_sf_bessel_zero_jnu',&
       3.83170597d0,ra,eps7)
  status = fgsl_sf_bessel_zero_jnu_e(1.0_fgsl_double,1,sfres)
  call unit_assert_equal('fgsl_sf_bessel_zero_jnu_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_bessel_zero_jnu_e',&
       3.831705970207513d0,sfres%val,sfres%err)
! NOTE: error estimates appear to be smaller than variances jnu vs jc1 ...
!
! Clausen function
!
  ra = fgsl_sf_clausen(m_pi/2.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_clausen',&
       0.915966d0,ra,eps5)
  status = fgsl_sf_clausen_e(m_pi/2.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_clausen_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_clausen_e',&
       0.9159655941772190d0,sfres%val,sfres%err)
!
! Coulomb functions
!
  ra = fgsl_sf_hydrogenicr_1(1.0_fgsl_double,1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_hydrogenicr_1',2.0d0/exp(1.0d0),ra,eps7)
  status = fgsl_sf_hydrogenicr_1_e(1.0_fgsl_double, 1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_hydrogenicr_1:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_hydrogenicr_1_e',2.0d0/exp(1.0d0),&
       sfres%val,sfres%err)
  ra = fgsl_sf_hydrogenicr(1,0,1.0_fgsl_double,1.0_fgsl_double) 
  call unit_assert_equal_within('fgsl_sf_hydrogenicr',2.0d0/exp(1.0d0),ra,eps7)
  status = fgsl_sf_hydrogenicr_e(1,0,1.0_fgsl_double, 1.0_fgsl_double, sfres)
  call unit_assert_equal('fgsl_sf_hydrogenicr:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_hydrogenicr_e',2.0d0/exp(1.0d0),&
       sfres%val,sfres%err)
  status = fgsl_sf_coulomb_wave_fg_e(1.0_fgsl_double,1.0_fgsl_double,&
       0.0_fgsl_double,0,sfres,sfres_der,sfres_2,sfres_2_der,&
       ra_exp,ra_exp_2) 
  call unit_assert_equal('fgsl_sf_coulomb_wave_fg_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_coulomb_wave_fg_e:F',&
       0.2275262105105601d0,sfres%val,sfres%err)
  call unit_assert_equal_within('fgsl_sf_coulomb_wave_fg_e:Fder',&
       0.348734422858357d0,sfres_der%val,sfres_der%err)
  call unit_assert_equal_within('fgsl_sf_coulomb_wave_fg_e:G',&
       2.043097162103555d0,sfres_2%val,sfres_2%err)
  call unit_assert_equal_within('fgsl_sf_coulomb_wave_fg_e:Gder',&
       -1.263598113312426d0,sfres_2_der%val,sfres_2_der%err)
  status = fgsl_sf_coulomb_wave_f_array (0.0_fgsl_double,0,1.0_fgsl_double, &
       1.0_fgsl_double,ra_arr,ra_exp)
  call unit_assert_equal('fgsl_sf_coulomb_wave_f_array:status',&
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_coulomb_wave_f_array',&
       0.2275262105105601d0,ra_arr(1),eps10)
  status = fgsl_sf_coulomb_wave_fg_array (0.0_fgsl_double,0,1.0_fgsl_double, &
       1.0_fgsl_double,ra_arr,ra_arr_2,ra_exp,ra_exp_2)
  call unit_assert_equal('fgsl_sf_coulomb_wave_fg_array:status',&
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_coulomb_wave_fg_array:F',&
       0.2275262105105601d0,ra_arr(1),eps10)
  call unit_assert_equal_within('fgsl_sf_coulomb_wave_fg_array:G',&
       2.043097162103555d0,ra_arr_2(1),eps10)
  status = fgsl_sf_coulomb_wave_fgp_array (0.0_fgsl_double,0,1.0_fgsl_double, &
       1.0_fgsl_double,ra_arr,ra_arr_der,ra_arr_2,ra_arr_2_der,ra_exp,ra_exp_2)
  call unit_assert_equal('fgsl_sf_coulomb_wave_fg_array:status',&
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_coulomb_wave_fg_array:F',&
       0.2275262105105601d0,ra_arr(1),eps10)
  call unit_assert_equal_within('fgsl_sf_coulomb_wave_fg_array:Fder',&
       0.348734422858357d0,ra_arr_der(1),eps10)
  call unit_assert_equal_within('fgsl_sf_coulomb_wave_fg_array:G',&
       2.043097162103555d0,ra_arr_2(1),eps10)
  call unit_assert_equal_within('fgsl_sf_coulomb_wave_fg_array:Gder',&
       -1.263598113312426d0,ra_arr_2_der(1),eps10)
  status = fgsl_sf_coulomb_wave_sphf_array (0.0_fgsl_double,0,1.0_fgsl_double, &
       1.0_fgsl_double,ra_arr,ra_exp)
  call unit_assert_equal('fgsl_sf_coulomb_wave_sphf_array:status',&
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_coulomb_wave_sphf_array',&
       0.2275262105105601d0,ra_arr(1),eps10)
  status = fgsl_sf_coulomb_cl_e(0.0_fgsl_double, 0.0_fgsl_double,sfres) 
  call unit_assert_equal('fgsl_sf_coulomb_cl_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_coulomb_cl_e',&
       1.0d0,sfres%val,sfres%err)
  status = fgsl_sf_coulomb_cl_array(0.0_fgsl_double, 0, 0.0_fgsl_double,ra_arr) 
  call unit_assert_equal('fgsl_sf_coulomb_cl_array:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_coulomb_cl_array',&
       1.0d0,ra_arr(1),eps10)
!
! coupling coefficients
!
  ra = fgsl_sf_coupling_3j(2,2,0,0,0,0)
  call unit_assert_equal_within('fgsl_sf_coupling_3j',&
       -1.0d0/sqrt(3.0d0),ra,eps10)
  status = fgsl_sf_coupling_3j_e(2,2,0,0,0,0,sfres)
  call unit_assert_equal('fgsl_sf_coupling_3j_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_coupling_3j_e',&
       -1.0d0/sqrt(3.0d0),sfres%val,sfres%err)
  ra = fgsl_sf_coupling_6j(2,2,0,4,4,4)
  call unit_assert_equal_within('fgsl_sf_coupling_6j',&
       -1.0d0/sqrt(15.0d0),ra,eps10)
  status = fgsl_sf_coupling_6j_e(2,2,0,4,4,4,sfres)
  call unit_assert_equal('fgsl_sf_coupling_6j_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_coupling_6j_e',&
       -1.0d0/sqrt(15.0d0),sfres%val,sfres%err)
  ra = fgsl_sf_coupling_9j(2,2,0,4,4,0,4,4,0)
  call unit_assert_equal_within('fgsl_sf_coupling_9j',&
       1.0d0/(5.0d0*sqrt(3.0d0)),ra,eps10)
  status = fgsl_sf_coupling_9j_e(2,2,0,4,4,0,4,4,0,sfres)
  call unit_assert_equal('fgsl_sf_coupling_9j_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_coupling_9j_e',&
       1.0d0/(5.0d0*sqrt(3.0d0)),sfres%val,sfres%err)
!
! Dawson, Debye and Dilog functions
!
  ra = fgsl_sf_dawson(1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_dawson',&
       0.5380795069d0,ra,eps10)
  status = fgsl_sf_dawson_e(1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_dawson_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_dawson_e',&
       0.5380795069127684d0,sfres%val,sfres%err)  
  ra = fgsl_sf_debye_1(1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_debye_1',&
       0.7775046d0,ra,eps7)
  status = fgsl_sf_debye_1_e(1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_debye_1_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_debye_1_e',&
       0.7775046341122482d0,sfres%val,sfres%err)  
  ra = fgsl_sf_debye_2(1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_debye_2',&
       0.7078785d0,ra,eps7)
  status = fgsl_sf_debye_2_e(1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_debye_2_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_debye_2_e',&
       7.078784756278293511D-01,sfres%val,sfres%err)  
  ra = fgsl_sf_debye_3(1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_debye_3',&
       0.6744156d0,ra,eps7)
  status = fgsl_sf_debye_3_e(1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_debye_3_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_debye_3_e',&
       6.744155640778146665D-01,sfres%val,sfres%err)  
  ra = fgsl_sf_debye_4(1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_debye_4',&
       0.6548741d0,ra,eps7)
  status = fgsl_sf_debye_4_e(1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_debye_4_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_debye_4_e',&
       6.548740688867370485D-01,sfres%val,sfres%err)  
  ra = fgsl_sf_debye_5(1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_debye_5',&
       0.6421003d0,ra,eps7)
  status = fgsl_sf_debye_5_e(1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_debye_5_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_debye_5_e',&
       6.421002580217789468D-01,sfres%val,sfres%err)  
  ra = fgsl_sf_debye_6(1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_debye_6',&
       .6331114d0,ra,eps7)
  status = fgsl_sf_debye_6_e(1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_debye_6_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_debye_6_e',&
       6.331114258349510582D-01,sfres%val,sfres%err)  
  ra = fgsl_sf_dilog(1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_dilog',&
       1.644934067d0,ra,eps7)
  status = fgsl_sf_dilog_e(1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_dilog_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_dilog_e',&
       1.644934066848226d0,sfres%val,sfres%err)  
  status = fgsl_sf_complex_dilog_e(1.0_fgsl_double,0.0_fgsl_double,&
       sfres,sfres_2)
  call unit_assert_equal('fgsl_sf_complex_dilog_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_complex_dilog_e:Re',&
       1.644934066848226d0,sfres%val,sfres%err)  
  call unit_assert_equal_within('fgsl_sf_complex_dilog_e:Im',&
       0.0d0,sfres_2%val,sfres_2%err)  
!
! elliptic functions
!
  ra = fgsl_sf_ellint_kcomp(0.5_fgsl_double, fgsl_prec_double) 
  call unit_assert_equal_within('fgsl_sf_ellint_kcomp',1.685750354812d0,ra,eps10)
  status = fgsl_sf_ellint_kcomp_e(0.5_fgsl_double,fgsl_prec_double,sfres)
  call unit_assert_equal('fgsl_sf_ellint_kcomp_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_ellint_kcomp_e',&
       1.685750354812596d0,sfres%val,sfres%err)  
  ra = fgsl_sf_ellint_ecomp(0.5_fgsl_double, fgsl_prec_double) 
  call unit_assert_equal_within('fgsl_sf_ellint_ecomp',1.46746220933d0,ra,eps10)
  status = fgsl_sf_ellint_ecomp_e(0.5_fgsl_double,fgsl_prec_double,sfres)
  call unit_assert_equal('fgsl_sf_ellint_ecomp_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_ellint_ecomp_e',&
       1.4674622093394274d0,sfres%val,sfres%err)  
  ra = fgsl_sf_ellint_f(m_pi/2,0.5_fgsl_double, fgsl_prec_double) 
  call unit_assert_equal_within('fgsl_sf_ellint_f',1.685750354812d0,ra,eps10)
  status = fgsl_sf_ellint_f_e(m_pi/2,0.5_fgsl_double,&
       fgsl_prec_double,sfres)
  call unit_assert_equal('fgsl_sf_ellint_f_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_ellint_f_e',&
       1.685750354812596d0,sfres%val,sfres%err)  
  ra = fgsl_sf_ellint_e(m_pi/2, 0.5_fgsl_double, fgsl_prec_double) 
  call unit_assert_equal_within('fgsl_sf_ellint_e',1.46746220933d0,ra,eps10)
  status = fgsl_sf_ellint_e_e(m_pi/2,0.5_fgsl_double,&
       fgsl_prec_double,sfres)
  call unit_assert_equal('fgsl_sf_ellint_e_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_ellint_e_e',&
       1.4674622093394274d0,sfres%val,sfres%err)  
  ra = fgsl_sf_ellint_p(m_pi/2, dsqrt(0.75d0), -0.5_fgsl_double, fgsl_prec_double)
  call unit_assert_equal_within('fgsl_sf_ellint_p',3.234773471249d0,ra,eps10)
  status = fgsl_sf_ellint_p_e(m_pi/2,dsqrt(0.75d0),-0.5_fgsl_double,&
       fgsl_prec_double,sfres)
  call unit_assert_equal('fgsl_sf_ellint_p_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_ellint_p_e',&
       3.234773471249465d0,sfres%val,eps10)
! NOTE: replaced sfres%err by eps10  
  ra = fgsl_sf_ellint_d(m_pi/2,.0_fgsl_double,.0_fgsl_double, fgsl_prec_double)
  call unit_assert_equal_within('fgsl_sf_ellint_d',m_pi/4,ra,eps10)
  status = fgsl_sf_ellint_d_e(m_pi/2,.0_fgsl_double,.0_fgsl_double,&
       fgsl_prec_double,sfres)
  call unit_assert_equal('fgsl_sf_ellint_d_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_ellint_d_e',&
       m_pi/4,sfres%val,sfres%err)  
  ra = fgsl_sf_ellint_rc(1.0_fgsl_double,1.0_fgsl_double,fgsl_prec_double)
  call unit_assert_equal_within('fgsl_sf_ellint_rc',1.0d0,ra,eps10)
  status = fgsl_sf_ellint_rc_e(1.0_fgsl_double,1.0_fgsl_double,&
       fgsl_prec_double,sfres)
  call unit_assert_equal('fgsl_sf_ellint_rc_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_ellint_rc_e',&
       1.0d0,sfres%val,sfres%err)  
  ra = fgsl_sf_ellint_rd(1.0_fgsl_double,1.0_fgsl_double,1.0_fgsl_double,&
       fgsl_prec_double)
  call unit_assert_equal_within('fgsl_sf_ellint_rd',1.0d0,ra,eps10)
  status = fgsl_sf_ellint_rd_e(1.0_fgsl_double,1.0_fgsl_double,&
       1.0_fgsl_double,fgsl_prec_double,sfres)
  call unit_assert_equal('fgsl_sf_ellint_rd_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_ellint_rd_e',&
       1.0d0,sfres%val,sfres%err)  
  ra = fgsl_sf_ellint_rf(1.0_fgsl_double,1.0_fgsl_double,1.0_fgsl_double,&
       fgsl_prec_double)
  call unit_assert_equal_within('fgsl_sf_ellint_rf',1.0d0,ra,eps10)
  status = fgsl_sf_ellint_rf_e(1.0_fgsl_double,1.0_fgsl_double,&
       1.0_fgsl_double,fgsl_prec_double,sfres)
  call unit_assert_equal('fgsl_sf_ellint_rf_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_ellint_rf_e',&
       1.0d0,sfres%val,sfres%err)  
  ra = fgsl_sf_ellint_rj(1.0_fgsl_double,1.0_fgsl_double,1.0_fgsl_double,&
       1.0_fgsl_double,fgsl_prec_double)
  call unit_assert_equal_within('fgsl_sf_ellint_rj',1.0d0,ra,eps10)
  status = fgsl_sf_ellint_rj_e(1.0_fgsl_double,1.0_fgsl_double,&
       1.0_fgsl_double,1.0_fgsl_double,fgsl_prec_double,sfres)
  call unit_assert_equal('fgsl_sf_ellint_rj_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_ellint_rj_e',&
       1.0d0,sfres%val,sfres%err)  
  status = fgsl_sf_elljac_e(m_pi/2,0.0_fgsl_double,ra,ra_2,ra_3)
  call unit_assert_equal('fgsl_sf_elljac_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_elljac',1.0d0,ra,eps10)
  call unit_assert_equal_within('fgsl_sf_elljac',0.0d0,ra_2,eps10)
  call unit_assert_equal_within('fgsl_sf_elljac',1.0d0,ra_3,eps10)
!
! Error and Exponential functions
!
  ra = fgsl_sf_erf(1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_erf',0.84270079295d0,ra,eps10)
  status = fgsl_sf_erf_e(1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_erf_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_erf_e',&
       0.8427007929497149d0,sfres%val,sfres%err)  
  ra = fgsl_sf_erfc(1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_erfc',1-0.84270079295d0,ra,eps10)
  status = fgsl_sf_erfc_e(1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_erfc_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_erfc_e',&
       1-0.8427007929497149d0,sfres%val,sfres%err)  
  ra = fgsl_sf_log_erfc(1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_log_erfc',log(1-0.84270079295d0),&
       ra,eps10)
  status = fgsl_sf_log_erfc_e(1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_log_erfc_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_log_erfc_e',&
       log(1-0.8427007929497149d0),sfres%val,sfres%err)  
  ra = fgsl_sf_erf_z(1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_erf_z',1/sqrt(2*m_pi)/exp(0.5d0),ra,eps10)
  status = fgsl_sf_erf_z_e(1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_erf_z_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_erf_z_e',&
       1/sqrt(2*m_pi)/exp(0.5d0),sfres%val,sfres%err)  
  ra = fgsl_sf_erf_q(sqrt(2.0_fgsl_double))
  call unit_assert_equal_within('fgsl_sf_erf_q',(1-0.84270079295d0)/2.0d0,&
       ra,eps10)
  status = fgsl_sf_erf_q_e(sqrt(2.0_fgsl_double),sfres)
  call unit_assert_equal('fgsl_sf_erf_q_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_erf_q_e',&
       (1-0.8427007929497149d0)/2.0d0,sfres%val,sfres%err)  
  ra = fgsl_sf_hazard(sqrt(2.0_fgsl_double))
  call unit_assert_equal_within('fgsl_sf_hazard',&
       sqrt(2/m_pi)/exp(1.0d0)/(1-0.8427007929497149d0),ra,eps10)
  status = fgsl_sf_hazard_e(sqrt(2.0_fgsl_double),sfres)
  call unit_assert_equal('fgsl_sf_hazard_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_hazard_e',&
       sqrt(2/m_pi)/exp(1.0d0)/(1-0.8427007929497149d0),sfres%val,sfres%err)  
  ra = fgsl_sf_exp(1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_exp',exp(1.d0),ra,eps10)
  status = fgsl_sf_exp_e(1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_exp_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_exp_e',&
       exp(1.d0),sfres%val,sfres%err)  
  status = fgsl_sf_exp_e10_e(1.0_fgsl_double,sfres10)
  call unit_assert_equal('fgsl_sf_exp_e10_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_exp_e10_e',&
       exp(1.d0),sfres10%val,sfres10%err)  
  ra = fgsl_sf_exp_mult(1.0_fgsl_double,1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_exp_mult',exp(1.d0),ra,eps10)
  status = fgsl_sf_exp_mult_e(1.0_fgsl_double,1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_exp_mult_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_exp_mult_e',&
       exp(1.d0),sfres%val,sfres%err)  
  status = fgsl_sf_exp_mult_e10_e(1.0_fgsl_double,1.0_fgsl_double,sfres10)
  call unit_assert_equal('fgsl_sf_exp_mult_e10_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_exp_mult_e10_e',&
       exp(1.d0),sfres10%val,sfres10%err)  
  ra = fgsl_sf_expm1(1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_expm1',exp(1.d0)-1,ra,eps10)
  status = fgsl_sf_expm1_e(1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_expm1_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_expm1_e',&
       exp(1.d0)-1,sfres%val,sfres%err)  
  ra = fgsl_sf_exprel(1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_exprel',exp(1.d0)-1,ra,eps10)
  status = fgsl_sf_exprel_e(1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_exprel_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_exprel_e',&
       exp(1.d0)-1,sfres%val,sfres%err)  
  ra = fgsl_sf_exprel_2(1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_exprel_2',2*(exp(1.d0)-2),ra,eps10)
  status = fgsl_sf_exprel_2_e(1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_exprel_2_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_exprel_2_e',&
       2*(exp(1.d0)-2),sfres%val,sfres%err)  
  ra = fgsl_sf_exprel_n(2,1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_exprel_n',2*(exp(1.d0)-2),ra,eps10)
  status = fgsl_sf_exprel_n_e(2,1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_exprel_n_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_exprel_n_e',&
       2*(exp(1.d0)-2),sfres%val,sfres%err)  
  status = fgsl_sf_exp_err_e(1.0_fgsl_double,eps7,sfres)
  call unit_assert_equal('fgsl_sf_exp_err_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_exp_err_e',&
       exp(1.d0),sfres%val,sfres%err)  
  status = fgsl_sf_exp_err_e10_e(1.0_fgsl_double,eps7,sfres10)
  call unit_assert_equal('fgsl_sf_exp_err_e10_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_exp_err_e10_e',&
       exp(1.d0),sfres10%val,sfres10%err)  
  status = fgsl_sf_exp_mult_err_e(1.0_fgsl_double,eps7,1.0_fgsl_double,eps7,sfres)
  call unit_assert_equal('fgsl_sf_exp_mult_err_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_exp_mult_err_e',&
       exp(1.d0),sfres%val,sfres%err)  
  status = fgsl_sf_exp_mult_err_e10_e(1.0_fgsl_double,eps7,&
       1.0_fgsl_double,eps7,sfres10)
  call unit_assert_equal('fgsl_sf_exp_mult_err_e10_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_exp_mult_err_e10_e',&
       exp(1.d0),sfres10%val,sfres10%err)  
!
! Exponential, Hyperbolic and Trigonometric Integrals
!
  ra = fgsl_sf_expint_e1(1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_expint_e1',0.219383934d0,ra,eps7)
  status = fgsl_sf_expint_e1_e(1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_expint_e1_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_expint_e1_e',&
       2.193839343955202859D-01,sfres%val,sfres%err)  
  ra = fgsl_sf_expint_e2(1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_expint_e2',0.1484955d0,ra,eps7)
  status = fgsl_sf_expint_e2_e(1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_expint_e2_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_expint_e2_e',&
       0.1484955067759220d0,sfres%val,sfres%err)  
  ra = fgsl_sf_expint_ei(1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_expint_ei',1.895117816d0,ra,eps7)
  status = fgsl_sf_expint_ei_e(1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_expint_ei_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_expint_ei_e',&
       1.895117816355937d0,sfres%val,sfres%err)  
  ra = fgsl_sf_shi(1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_shi',1.057250875375728372D+00,ra,eps7)
  status = fgsl_sf_shi_e(1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_shi_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_shi_e',&
       1.057250875375728372D+00,sfres%val,sfres%err)  
  ra = fgsl_sf_chi(1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_chi',8.378669409802081969D-01,ra,eps7)
  status = fgsl_sf_chi_e(1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_chi_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_chi_e',&
       8.378669409802081969D-01,sfres%val,sfres%err)  
  ra = fgsl_sf_expint_3(1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_expint_3',8.075111821396715461D-01,ra,eps7)
  status = fgsl_sf_expint_3_e(1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_expint_3_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_expint_3_e',&
       8.075111821396715461D-01,sfres%val,sfres%err)  
  ra = fgsl_sf_si(1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_si',0.9460830704D+00,ra,eps7)
  status = fgsl_sf_si_e(1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_si_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_si_e',&
       9.460830703671829767D-01,sfres%val,sfres%err)  
  ra = fgsl_sf_ci(1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_ci',0.3374039229D+00,ra,eps7)
  status = fgsl_sf_ci_e(1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_ci_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_ci_e',&
       3.374039229009682117D-01,sfres%val,sfres%err)  
  ra = fgsl_sf_atanint(1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_atanint',9.159655941D-01,ra,eps7)
  status = fgsl_sf_atanint_e(1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_atanint_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_atanint_e',&
       9.159655941772190113D-01,sfres%val,sfres%err)  
!
! Fermi-Dirac 
!
  ra = fgsl_sf_fermi_dirac_m1(0.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_fermi_dirac_m1',0.5d0,ra,eps7)
  status = fgsl_sf_fermi_dirac_m1_e(0.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_fermi_dirac_m1_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_fermi_dirac_m1_e',&
       0.5d0,sfres%val,sfres%err)  
  ra = fgsl_sf_fermi_dirac_0(1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_fermi_dirac_0',log(1+exp(1.0d0)),ra,eps7)
  status = fgsl_sf_fermi_dirac_0_e(1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_fermi_dirac_0_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_fermi_dirac_0_e',&
       log(1+exp(1.0d0)),sfres%val,sfres%err)  
  ra = fgsl_sf_fermi_dirac_1(0.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_fermi_dirac_1',8.22467033424D-01,ra,eps7)
  status = fgsl_sf_fermi_dirac_1_e(0.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_fermi_dirac_1_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_fermi_dirac_1_e',&
       8.224670334241132030D-01,sfres%val,sfres%err)  
  ra = fgsl_sf_fermi_dirac_2(0.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_fermi_dirac_2',9.015426774D-01,ra,eps7)
  status = fgsl_sf_fermi_dirac_2_e(0.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_fermi_dirac_2_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_fermi_dirac_2_e',&
       9.015426773696957330D-01,sfres%val,sfres%err)  
  ra = fgsl_sf_fermi_dirac_int(-1,0.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_fermi_dirac_int',0.5d0,ra,eps7)
  status = fgsl_sf_fermi_dirac_int_e(-1,0.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_fermi_dirac_int_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_fermi_dirac_int_e',&
       0.5d0,sfres%val,sfres%err)  
  ra = fgsl_sf_fermi_dirac_mhalf(0.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_fermi_dirac_mhalf',6.0489864342D-01,&
       ra,eps7)
  status = fgsl_sf_fermi_dirac_mhalf_e(0.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_fermi_dirac_mhalf_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_fermi_dirac_mhalf_e',&
       6.048986434216304664D-01,sfres%val,sfres%err)  
  ra = fgsl_sf_fermi_dirac_half(0.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_fermi_dirac_half',7.6514702463D-01,&
       ra,eps7)
  status = fgsl_sf_fermi_dirac_half_e(0.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_fermi_dirac_half_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_fermi_dirac_half_e',&
       7.651470246254079566D-01,sfres%val,sfres%err)  
  ra = fgsl_sf_fermi_dirac_3half(0.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_fermi_dirac_3half',8.67199889012D-01,&
       ra,eps7)
  status = fgsl_sf_fermi_dirac_3half_e(0.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_fermi_dirac_3half_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_fermi_dirac_3half_e',&
       8.671998890121841441D-01,sfres%val,sfres%err)  
  ra = fgsl_sf_fermi_dirac_inc_0(1.0_fgsl_double,0.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_fermi_dirac_inc_0',&
       log(1+exp(1.0d0)),ra,eps7)
  status = fgsl_sf_fermi_dirac_inc_0_e(1.0_fgsl_double,0.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_fermi_dirac_inc_0_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_fermi_dirac_inc_0_e',&
       log(1+exp(1.0d0)),sfres%val,sfres%err)  
!
! Gamma and Beta functions
!
  ra = fgsl_sf_gamma(3.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_gamma',2.d0,ra,eps7)
  status = fgsl_sf_gamma_e(3.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_gamma_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_gamma_e',&
      2.0d0,sfres%val,sfres%err)  
  ra = fgsl_sf_lngamma(3.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_lngamma',log(2.d0),ra,eps7)
  status = fgsl_sf_lngamma_e(3.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_lngamma_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_lngamma_e',&
      log(2.0d0),sfres%val,sfres%err)  
  ra = fgsl_sf_gammastar(3.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_gammastar',&
       2.d0/sqrt(2*m_pi)/3**2.5d0*exp(3.0d0),ra,eps7)
  status = fgsl_sf_gammastar_e(3.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_gammastar_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_gammastar_e',&
      2.0d00/sqrt(2*m_pi)/3**2.5d0*exp(3.0d0),sfres%val,sfres%err)  
  ra = fgsl_sf_gammainv(3.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_gammainv',.5d0,ra,eps7)
  status = fgsl_sf_gammainv_e(3.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_gammainv_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_gammainv_e',&
      .5d0,sfres%val,sfres%err)  
  status = fgsl_sf_lngamma_complex_e(3.0_fgsl_double,0.0_fgsl_double, &
       sfres, sfres_2)
  call unit_assert_equal('fgsl_sf_lngamma_complex_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_lngamma_complex_e',&
      log(2.0d0),sfres%val,eps10)
! NOTE: replaced sfres%err by eps10
  call unit_assert_equal_within('fgsl_sf_lngamma_complex_e',&
      0.0d0,sfres_2%val,eps10)
  ra = fgsl_sf_fact(3)
  call unit_assert_equal_within('fgsl_sf_fact',6.d0,ra,eps7)
  status = fgsl_sf_fact_e(3,sfres)
  call unit_assert_equal('fgsl_sf_fact_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_fact_e',&
      6.0d0,sfres%val,sfres%err)  
  ra = fgsl_sf_doublefact(3)
  call unit_assert_equal_within('fgsl_sf_doublefact',3.d0,ra,eps7)
  status = fgsl_sf_doublefact_e(3,sfres)
  call unit_assert_equal('fgsl_sf_doublefact_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_doublefact_e',&
      3.0d0,sfres%val,sfres%err)  
  ra = fgsl_sf_lnfact(3)
  call unit_assert_equal_within('fgsl_sf_lnfact',log(6.d0),ra,eps7)
  status = fgsl_sf_lnfact_e(3,sfres)
  call unit_assert_equal('fgsl_sf_lnfact_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_lnfact_e',&
      log(6.0d0),sfres%val,sfres%err)  
  ra = fgsl_sf_lndoublefact(3)
  call unit_assert_equal_within('fgsl_sf_lndoublefact',log(3.d0),ra,eps7)
  status = fgsl_sf_lndoublefact_e(3,sfres)
  call unit_assert_equal('fgsl_sf_lndoublefact_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_lndoublefact_e',&
      log(3.0d0),sfres%val,sfres%err)  
  ra = fgsl_sf_choose(3,0)
  call unit_assert_equal_within('fgsl_sf_choose',1.d0,ra,eps7)
  status = fgsl_sf_choose_e(3,0,sfres)
  call unit_assert_equal('fgsl_sf_choose_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_choose_e',&
      1.0d0,sfres%val,sfres%err)  
  ra = fgsl_sf_lnchoose(3,0)
  call unit_assert_equal_within('fgsl_sf_lnchoose',0.d0,ra,eps7)
  status = fgsl_sf_lnchoose_e(3,0,sfres)
  call unit_assert_equal('fgsl_sf_lnchoose_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_lnchoose_e',&
      0.0d0,sfres%val,sfres%err)  
  ra = fgsl_sf_taylorcoeff(3,1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_taylorcoeff',1/6.d0,ra,eps7)
  status = fgsl_sf_taylorcoeff_e(3,1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_taylorcoeff_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_taylorcoeff_e',&
      1/6.0d0,sfres%val,sfres%err)  
  ra = fgsl_sf_poch(1.0d0,2.0d0)
  call unit_assert_equal_within('fgsl_sf_poch',2.d0,ra,eps7)
  status = fgsl_sf_poch_e(1.0d0,2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_poch_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_poch_e',&
      2.d0,sfres%val,sfres%err)  
  ra = fgsl_sf_lnpoch(1.0d0,2.0d0)
  call unit_assert_equal_within('fgsl_sf_lnpoch',log(2.d0),ra,eps7)
  status = fgsl_sf_lnpoch_e(1.0d0,2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_lnpoch_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_lnpoch_e',&
      log(2.d0),sfres%val,sfres%err)  
  status = fgsl_sf_lnpoch_sgn_e(1.0d0,2.0d0,sfres,ra)
  call unit_assert_equal('fgsl_sf_lnpoch_sgn_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_lnpoch_sgn_e',&
      log(2.d0),sfres%val,sfres%err)  
  call unit_assert_equal_within('fgsl_sf_lnpoch_sgn_e:sign',&
      1.d0,ra,eps10)  
  ra = fgsl_sf_pochrel(1.0d0,2.0d0)
  call unit_assert_equal_within('fgsl_sf_pochrel',.5d0,ra,eps7)
  status = fgsl_sf_pochrel_e(1.0d0,2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_pochrel_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_pochrel_e',&
      .5d0,sfres%val,sfres%err)  
  ra = fgsl_sf_gamma_inc(3.0_fgsl_double,0.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_gamma_inc',2.d0,ra,eps7)
  status = fgsl_sf_gamma_inc_e(3.0_fgsl_double,0.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_gamma_inc_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_gamma_inc_e',&
      2.0d0,sfres%val,sfres%err)  
  ra = fgsl_sf_gamma_inc_q(3.0_fgsl_double,0.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_gamma_inc_q',1.d0,ra,eps7)
  status = fgsl_sf_gamma_inc_q_e(3.0_fgsl_double,0.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_gamma_inc_q_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_gamma_inc_q_e',&
      1.0d0,sfres%val,sfres%err)  
  ra = fgsl_sf_gamma_inc_p(3.0_fgsl_double,0.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_gamma_inc_p',0.d0,ra,eps7)
  status = fgsl_sf_gamma_inc_p_e(3.0_fgsl_double,0.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_gamma_inc_p_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_gamma_inc_p_e',&
      0.0d0,sfres%val,sfres%err)  
  ra = fgsl_sf_beta(2.0_fgsl_double,2.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_beta',1/6.d0,ra,eps7)
  status = fgsl_sf_beta_e(2.0_fgsl_double,2.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_beta_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_beta_e',&
      1/6.0d0,sfres%val,sfres%err)  
  ra = fgsl_sf_lnbeta(2.0_fgsl_double,2.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_lnbeta',log(1/6.d0),ra,eps7)
  status = fgsl_sf_lnbeta_e(2.0_fgsl_double,2.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_lnbeta_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_lnbeta_e',&
      log(1/6.0d0),sfres%val,sfres%err)  
  ra = fgsl_sf_beta_inc(2.0_fgsl_double,2.0_fgsl_double,1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_beta_inc',1.d0,ra,eps7)
  status = fgsl_sf_beta_inc_e(2.0_fgsl_double,2.0_fgsl_double,&
       1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_beta_inc_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_beta_inc_e',&
       1.0d0,sfres%val,sfres%err)  
!
! Gegenbauer functions
!
  ra = fgsl_sf_gegenpoly_1(3.0_fgsl_double,2.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_gegenpoly_1',1.2d1,ra,eps7)
  status = fgsl_sf_gegenpoly_1_e(3.0_fgsl_double,2.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_gegenpoly_1_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_gegenpoly_1_e',&
      1.2d1,sfres%val,sfres%err)  
  ra = fgsl_sf_gegenpoly_2(1.0_fgsl_double,1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_gegenpoly_2',3.d0,ra,eps7)
  status = fgsl_sf_gegenpoly_2_e(1.0_fgsl_double,1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_gegenpoly_2_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_gegenpoly_2_e',&
      3.0d0,sfres%val,sfres%err)  
  ra = fgsl_sf_gegenpoly_3(1.0_fgsl_double,1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_gegenpoly_3',4.0d0,ra,eps7)
  status = fgsl_sf_gegenpoly_3_e(1.0_fgsl_double,1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_gegenpoly_3_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_gegenpoly_3_e',&
      4.0d0,sfres%val,sfres%err)  
  ra = fgsl_sf_gegenpoly_n(3,1.0_fgsl_double,1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_gegenpoly_n',4.0d0,ra,eps7)
  status = fgsl_sf_gegenpoly_n_e(3,1.0_fgsl_double,1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_gegenpoly_n_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_gegenpoly_n_e',&
      4.0d0,sfres%val,sfres%err)  
  status = fgsl_sf_gegenpoly_array(1,3.0_fgsl_double,2.0_fgsl_double,ra_arr_3)
  call unit_assert_equal('fgsl_sf_gegenpoly_array:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_gegenpoly_1',1.d0,ra_arr_3(1),eps10)
  call unit_assert_equal_within('fgsl_sf_gegenpoly_1',1.2d1,ra_arr_3(2),eps10)
!
! Hypergeometric functions
!
  ra = fgsl_sf_hyperg_0f1(1.0_fgsl_double,-.25_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_hyperg_0f1',0.765197686557967d0,ra,eps10)
  status = fgsl_sf_hyperg_0f1_e(1.0_fgsl_double,-.25_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_hyperg_0f1_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_hyperg_0f1_e',&
      0.765197686557967d0,sfres%val,sfres%err)  
  ra = fgsl_sf_hyperg_1f1_int(2,2,2.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_hyperg_1f1_int',exp(2.d0),ra,eps10)
  status = fgsl_sf_hyperg_1f1_int_e(2,2,2.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_hyperg_1f1_int_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_hyperg_1f1_int_e',&
      exp(2.d0),sfres%val,sfres%err)  
  ra = fgsl_sf_hyperg_1f1(2.0_fgsl_double,2.0_fgsl_double,2.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_hyperg_1f1',exp(2.d0),ra,eps10)
  status = fgsl_sf_hyperg_1f1_e(2.0_fgsl_double,2.0_fgsl_double,&
       2.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_hyperg_1f1_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_hyperg_1f1_e',&
      exp(2.d0),sfres%val,sfres%err)  
  ra = fgsl_sf_hyperg_u_int(1,1,1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_hyperg_u_int',&
       2.193839343955202859D-01*exp(1.d0),ra,eps10)
  status = fgsl_sf_hyperg_u_int_e(1,1,1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_hyperg_u_int_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_hyperg_u_int_e',&
      2.193839343955202859D-01*exp(1.d0),sfres%val,sfres%err)  
  status = fgsl_sf_hyperg_u_int_e10_e(1,1,1.0_fgsl_double,sfres10)
  call unit_assert_equal('fgsl_sf_hyperg_u_int_e10_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_hyperg_u_int_e10_e',&
      2.193839343955202859D-01*exp(1.d0),sfres10%val,sfres10%err)  
  ra = fgsl_sf_hyperg_u(1.0_fgsl_double,1.0_fgsl_double,1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_hyperg_u',&
       2.193839343955202859D-01*exp(1.d0),ra,eps10)
  status = fgsl_sf_hyperg_u_e(1.0_fgsl_double,1.0_fgsl_double,&
       1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_hyperg_u_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_hyperg_u_e',&
      2.193839343955202859D-01*exp(1.d0),sfres%val,sfres%err)  
  status = fgsl_sf_hyperg_u_e10_e(1.0_fgsl_double,&
       1.0_fgsl_double,1.0_fgsl_double,sfres10)
  call unit_assert_equal('fgsl_sf_hyperg_u_e10_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_hyperg_u_e10_e',&
      2.193839343955202859D-01*exp(1.d0),sfres10%val,sfres10%err)  
  ra = fgsl_sf_hyperg_2f1(1.0_fgsl_double,1.0_fgsl_double,2.0_fgsl_double, &
       0.5_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_hyperg_2f1',-2*log(0.5d0),ra,eps10)
  status = fgsl_sf_hyperg_2f1_e(1.0_fgsl_double,1.0_fgsl_double,&
       2.0_fgsl_double,0.5_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_hyperg_2f1_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_hyperg_2f1_e',&
       -2*log(0.5d0),sfres%val,sfres%err)  
  ra = fgsl_sf_hyperg_2f1_conj(1.0_fgsl_double,0.0_fgsl_double,2.0_fgsl_double, &
       0.5_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_hyperg_2f1_conj',-2*log(0.5d0),ra,eps10)
  status = fgsl_sf_hyperg_2f1_conj_e(1.0_fgsl_double,0.0_fgsl_double,&
       2.0_fgsl_double,0.5_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_hyperg_2f1_conj_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_hyperg_2f1_conj_e',&
       -2*log(0.5d0),sfres%val,sfres%err)  
  ra = fgsl_sf_hyperg_2f1_renorm(1.0_fgsl_double,1.0_fgsl_double,2.0_fgsl_double, &
       0.5_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_hyperg_2f1_renorm',-2*log(0.5d0),ra,eps10)
  status = fgsl_sf_hyperg_2f1_renorm_e(1.0_fgsl_double,1.0_fgsl_double,&
       2.0_fgsl_double,0.5_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_hyperg_2f1_renorm_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_hyperg_2f1_renorm_e',&
       -2*log(0.5d0),sfres%val,sfres%err)  
  ra = fgsl_sf_hyperg_2f1_conj_renorm(1.0_fgsl_double,0.0_fgsl_double,&
       2.0_fgsl_double,0.5_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_hyperg_2f1_conj_renorm',&
       -2*log(0.5d0),ra,eps10)
  status = fgsl_sf_hyperg_2f1_conj_renorm_e(1.0_fgsl_double,0.0_fgsl_double,&
       2.0_fgsl_double,0.5_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_hyperg_2f1_conj_renorm_e:status',&
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_hyperg_2f1_conj_renorm_e',&
       -2*log(0.5d0),sfres%val,sfres%err)  
  ra = fgsl_sf_hyperg_2f0(1.0_fgsl_double,1.0_fgsl_double,-1.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_hyperg_2f0',&
       2.193839343955202859D-01*exp(1.d0),ra,eps10)
  status = fgsl_sf_hyperg_2f0_e(1.0_fgsl_double,1.0_fgsl_double,&
       -1.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_hyperg_2f0_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_hyperg_2f0_e',&
      2.193839343955202859D-01*exp(1.d0),sfres%val,sfres%err)  
!
! Laguerre functions
!
  ra = fgsl_sf_laguerre_1(0.0_fgsl_double,2.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_laguerre_1',&
       -1.0d0,ra,eps10)
  status = fgsl_sf_laguerre_1_e(0.0_fgsl_double,2.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_laguerre_1_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_laguerre_1_e',&
       -1.d0,sfres%val,sfres%err)  
  ra = fgsl_sf_laguerre_2(0.0_fgsl_double,2.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_laguerre_2',&
       -1.0d0,ra,eps10)
  status = fgsl_sf_laguerre_2_e(0.0_fgsl_double,2.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_laguerre_2_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_laguerre_2_e',&
       -1.d0,sfres%val,sfres%err)  
  ra = fgsl_sf_laguerre_3(0.0_fgsl_double,2.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_laguerre_3',&
       -1/3.0d0,ra,eps10)
  status = fgsl_sf_laguerre_3_e(0.0_fgsl_double,2.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_laguerre_3_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_laguerre_3_e',&
       -1/3.d0,sfres%val,sfres%err)  
  ra = fgsl_sf_laguerre_n(3,0.0_fgsl_double,2.0_fgsl_double)
  call unit_assert_equal_within('fgsl_sf_laguerre_n',&
       -1/3.0d0,ra,eps10)
  status = fgsl_sf_laguerre_n_e(3,0.0_fgsl_double,2.0_fgsl_double,sfres)
  call unit_assert_equal('fgsl_sf_laguerre_n_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_laguerre_n_e',&
       -1/3.d0,sfres%val,sfres%err)  
!
! Lambert functions
!
  ra = fgsl_sf_lambert_w0(-1/exp(1.0d0))
  call unit_assert_equal_within('fgsl_sf_lambert_w0',&
       -1.0d0,ra,eps10)
  status = fgsl_sf_lambert_w0_e(-1/exp(1.0d0),sfres)
  call unit_assert_equal('fgsl_sf_lambert_w0_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_lambert_w0_e',&
       -1.d0,sfres%val,sfres%err)  
  ra = fgsl_sf_lambert_wm1(-1/exp(1.0d0))
  call unit_assert_equal_within('fgsl_sf_lambert_wm1',&
       -1.0d0,ra,eps10)
  status = fgsl_sf_lambert_wm1_e(-1/exp(1.0d0),sfres)
  call unit_assert_equal('fgsl_sf_lambert_wm1_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_lambert_wm1_e',&
       -1.d0,sfres%val,sfres%err)  
!
! Legendre and conical functions
!
  ra = fgsl_sf_legendre_p1(2.0d0)
  call unit_assert_equal_within('fgsl_sf_legendre_p1',2.0d0,ra,eps10)
  status = fgsl_sf_legendre_p1_e(2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_legendre_p1_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_legendre_p1_e',&
       2.d0,sfres%val,sfres%err)  
  ra = fgsl_sf_legendre_p2(2.0d0)
  call unit_assert_equal_within('fgsl_sf_legendre_p2',5.5d0,ra,eps10)
  status = fgsl_sf_legendre_p2_e(2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_legendre_p2_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_legendre_p2_e',&
       5.5d0,sfres%val,sfres%err)  
  ra = fgsl_sf_legendre_p3(2.0d0)
  call unit_assert_equal_within('fgsl_sf_legendre_p3',17.d0,ra,eps10)
  status = fgsl_sf_legendre_p3_e(2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_legendre_p3_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_legendre_p3_e',&
       17.d0,sfres%val,sfres%err)  
  ra = fgsl_sf_legendre_pl(2,1.0d0)
  call unit_assert_equal_within('fgsl_sf_legendre_pl',1.0d0,ra,eps10)
  status = fgsl_sf_legendre_pl_e(2,1.0d0,sfres)
  call unit_assert_equal('fgsl_sf_legendre_pl_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_legendre_pl_e',&
       1.0d0,sfres%val,sfres%err)  
  ra = fgsl_sf_legendre_pl_array(1,1.0d0,ra_arr_3)
  call unit_assert_equal_within('fgsl_sf_legendre_pl_array',&
       1.0d0,ra_arr_3(1),eps10)
  call unit_assert_equal_within('fgsl_sf_legendre_pl_array',&
       1.0d0,ra_arr_3(2),eps10)
  ra = fgsl_sf_legendre_pl_deriv_array(1,1.0d0,ra_arr_3,ra_arr_3_der)
  call unit_assert_equal_within('fgsl_sf_legendre_pl_array:0',&
       1.0d0,ra_arr_3(1),eps10)
  call unit_assert_equal_within('fgsl_sf_legendre_pl_array:1',&
       1.0d0,ra_arr_3(2),eps10)
  call unit_assert_equal_within('fgsl_sf_legendre_pl_array:Der0',&
       0.0d0,ra_arr_3_der(1),eps10)
  call unit_assert_equal_within('fgsl_sf_legendre_pl_array:Der1',&
       1.0d0,ra_arr_3_der(2),eps10)
  ra = fgsl_sf_legendre_q0(2.0d0)
  call unit_assert_equal_within('fgsl_sf_legendre_q0',0.5d0*log(3.0d0),ra,eps10)
  status = fgsl_sf_legendre_q0_e(2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_legendre_q0_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_legendre_q0_e',&
       0.5d0*log(3.0d0),sfres%val,sfres%err)  
  ra = fgsl_sf_legendre_q1(2.0d0)
  call unit_assert_equal_within('fgsl_sf_legendre_q1',log(3.0d0)-1,ra,eps10)
  status = fgsl_sf_legendre_q1_e(2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_legendre_q1_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_legendre_q1_e',&
       log(3.0d0)-1,sfres%val,sfres%err)  
  ra = fgsl_sf_legendre_ql(0,2.0d0)
  call unit_assert_equal_within('fgsl_sf_legendre_ql',0.5d0*log(3.0d0),ra,eps10)
  status = fgsl_sf_legendre_ql_e(0,2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_legendre_ql_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_legendre_ql_e',&
       0.5d0*log(3.0d0),sfres%val,sfres%err)  
  ra = fgsl_sf_legendre_plm(2,1,0.5d0)
  call unit_assert_equal_within('fgsl_sf_legendre_plm',-0.75d0*sqrt(3.0d0),ra,eps10)
  status = fgsl_sf_legendre_plm_e(2,1,0.5d0,sfres)
  call unit_assert_equal('fgsl_sf_legendre_plm_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_legendre_plm_e',&
       -0.75d0*sqrt(3.0d0),sfres%val,sfres%err)  
  status = fgsl_sf_legendre_plm_array(2,1,0.5d0,ra_arr_3)
  call unit_assert_equal_within('fgsl_sf_legendre_plm_array:1',&
       -0.5d0*sqrt(3.0d0),ra_arr_3(1),eps10)
  call unit_assert_equal_within('fgsl_sf_legendre_plm_array:2',&
       -0.75d0*sqrt(3.0d0),ra_arr_3(2),eps10)
  status = fgsl_sf_legendre_plm_deriv_array(2,1,0.5d0,ra_arr_3,ra_arr_3_der)
  call unit_assert_equal_within('fgsl_sf_legendre_plm_deriv_array:1',&
       -0.5d0*sqrt(3.0d0),ra_arr_3(1),eps10)
  call unit_assert_equal_within('fgsl_sf_legendre_plm_deriv_array:2',&
       -0.75d0*sqrt(3.0d0),ra_arr_3(2),eps10)
  call unit_assert_equal_within('fgsl_sf_legendre_plm_deriv_array:Der1',&
       1/sqrt(3.0d0),ra_arr_3_der(1),eps10)
  call unit_assert_equal_within('fgsl_sf_legendre_plm_deriv_array:Der2',&
       -1.0d0*sqrt(3.0d0),ra_arr_3_der(2),eps10)
  x21=sqrt(5.0d0/(24.0d0*m_pi))
  x11=sqrt(3.0d0/(8.0d0*m_pi))
  ra = fgsl_sf_legendre_sphplm(2,1,0.5d0)
  call unit_assert_equal_within('fgsl_sf_legendre_sphplm',&
       -x21*0.75d0*sqrt(3.0d0),ra,eps10)
  status = fgsl_sf_legendre_sphplm_e(2,1,0.5d0,sfres)
  call unit_assert_equal('fgsl_sf_legendre_sphplm_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_legendre_sphplm_e',&
       -x21*0.75d0*sqrt(3.0d0),sfres%val,sfres%err)  
  status = fgsl_sf_legendre_sphplm_array(2,1,0.5d0,ra_arr_3)
  call unit_assert_equal('fgsl_sf_legendre_sphplm_array:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_legendre_sphplm_array:1',&
       -x11*0.5d0*sqrt(3.0d0),ra_arr_3(1),eps10)
  call unit_assert_equal_within('fgsl_sf_legendre_sphplm_array:2',&
       -x21*0.75d0*sqrt(3.0d0),ra_arr_3(2),eps10)
  status = fgsl_sf_legendre_sphplm_deriv_array(2,1,0.5d0,ra_arr_3,ra_arr_3_der)
  call unit_assert_equal('fgsl_sf_legendre_sphplm_deriv_array:status',&
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_legendre_sphplm_deriv_array:1',&
       -x11*0.5d0*sqrt(3.0d0),ra_arr_3(1),eps10)
  call unit_assert_equal_within('fgsl_sf_legendre_sphplm_deriv_array:2',&
       -x21*0.75d0*sqrt(3.0d0),ra_arr_3(2),eps10)
  call unit_assert_equal_within('fgsl_sf_legendre_sphplm_deriv_array:Der1',&
       x11/sqrt(3.0d0),ra_arr_3_der(1),eps10)
  call unit_assert_equal_within('fgsl_sf_legendre_sphplm_deriv_array:Der2',&
       -x21*1.0d0*sqrt(3.0d0),ra_arr_3_der(2),eps10)
  lmsize = fgsl_sf_legendre_array_size(4, 2)
  call unit_assert_equal('fgsl_sf_legendre_array_size',3,lmsize)
!
! Conical functions:
! need values
  ra = fgsl_sf_conicalp_half(1.0d0,2.0d0)
  call unit_assert_equal_within('fgsl_sf_conicalp_half',&
       0.1522450487467270d0,ra,eps10)
  status = fgsl_sf_conicalp_half_e(1.0d0,2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_conicalp_half_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_conicalp_half_e',&
       0.1522450487467270d0,sfres%val,sfres%err)  
  ra = fgsl_sf_conicalp_mhalf(1.0d0,2.0d0)
  call unit_assert_equal_within('fgsl_sf_conicalp_mhalf',&
       0.5868339135394002d0,ra,eps10)
  status = fgsl_sf_conicalp_mhalf_e(1.0d0,2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_conicalp_mhalf_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_conicalp_mhalf_e',&
       0.5868339135394002d0,sfres%val,sfres%err)  
  ra = fgsl_sf_conicalp_0(1.0d0,2.0d0)
  call unit_assert_equal_within('fgsl_sf_conicalp_0',&
       0.5564135489350757d0,ra,eps10)
  status = fgsl_sf_conicalp_0_e(1.0d0,2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_conicalp_0_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_conicalp_0_e',&
       0.5564135489350757d0,sfres%val,sfres%err)  
  ra = fgsl_sf_conicalp_1(1.0d0,2.0d0)
  call unit_assert_equal_within('fgsl_sf_conicalp_1',&
       -0.5433190759960184d0,ra,eps10)
  status = fgsl_sf_conicalp_1_e(1.0d0,2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_conicalp_1_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_conicalp_1_e',&
       -0.5433190759960184d0,sfres%val,sfres%err)  
  ra = fgsl_sf_conicalp_sph_reg(1,1.0d0,2.0d0)
  call unit_assert_equal_within('fgsl_sf_conicalp_sph_reg',&
       0.2626861935782107d0,ra,eps10)
  status = fgsl_sf_conicalp_sph_reg_e(1,1.0d0,2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_conicalp_sph_reg_e:status',&
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_conicalp_sph_reg_e',&
       0.2626861935782107d0,sfres%val,sfres%err)  
  ra = fgsl_sf_conicalp_cyl_reg(1,1.0d0,2.0d0)
  call unit_assert_equal_within('fgsl_sf_conicalp_cyl_reg',&
       0.4346552607968133d0,ra,eps10)
  status = fgsl_sf_conicalp_cyl_reg_e(1,1.0d0,2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_conicalp_cyl_reg_e:status',&
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_conicalp_cyl_reg_e',&
       0.4346552607968133d0,sfres%val,sfres%err)  
  ra = fgsl_sf_legendre_h3d_0(1.0d0,2.0d0)
  call unit_assert_equal_within('fgsl_sf_legendre_h3d_0',&
       0.2507120000699062d0,ra,eps10)
  status = fgsl_sf_legendre_h3d_0_e(1.0d0,2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_legendre_h3d_0_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_legendre_h3d_0_e',&
       0.2507120000699062d0,sfres%val,sfres%err)  
  ra = fgsl_sf_legendre_h3d_1(1.0d0,2.0d0)
  call unit_assert_equal_within('fgsl_sf_legendre_h3d_1',&
       0.2650289172078014d0,ra,eps10)
  status = fgsl_sf_legendre_h3d_1_e(1.0d0,2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_legendre_h3d_1_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_legendre_h3d_1_e',&
       0.2650289172078014d0,sfres%val,sfres%err)  
  ra = fgsl_sf_legendre_h3d(1,1.0d0,2.0d0)
  call unit_assert_equal_within('fgsl_sf_legendre_h3d',&
       0.2650289172078014d0,ra,eps10)
  status = fgsl_sf_legendre_h3d_e(1,1.0d0,2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_legendre_h3d_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_legendre_h3d_e',&
       0.2650289172078014d0,sfres%val,sfres%err)  
  status = fgsl_sf_legendre_h3d_array(1,1.0d0,2.0d0,ra_arr_3)
  call unit_assert_equal('fgsl_sf_legendre_h3d_0_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_legendre_h3d_0',&
       0.2507120000699062d0,ra_arr_3(1),eps10)
  call unit_assert_equal_within('fgsl_sf_legendre_h3d_e',&
       0.2650289172078014d0,ra_arr_3(2),eps10)  
!
! Some standard functions
!
  ra = fgsl_sf_log(2.0d0)
  call unit_assert_equal_within('fgsl_sf_log',&
       log(2.0d0),ra,eps10)
  status = fgsl_sf_log_e(2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_log_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_log_e',&
       log(2.0d0),sfres%val,sfres%err)  
  status = fgsl_sf_complex_log_e(2.0d0,0.0d0,sfres,sfres_2)
  call unit_assert_equal('fgsl_sf_complex_log_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_complex_log_e',&
       log(2.0d0),sfres%val,eps10)  
  call unit_assert_equal_within('fgsl_sf_complex_log_e',&
       0.0d0,sfres_2%val,eps10)  
  ra = fgsl_sf_log_abs(2.0d0)
  call unit_assert_equal_within('fgsl_sf_log_abs',&
       abs(log(2.0d0)),ra,eps10)
  status = fgsl_sf_log_abs_e(2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_log_abs_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_log_abs_e',&
       abs(log(2.0d0)),sfres%val,sfres%err)  
  ra = fgsl_sf_log_1plusx(1.0d0)
  call unit_assert_equal_within('fgsl_sf_log_1plusx',&
       log(2.0d0),ra,eps10)
  status = fgsl_sf_log_1plusx_e(1.0d0,sfres)
  call unit_assert_equal('fgsl_sf_log_1plusx_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_log_1plusx_e',&
       log(2.0d0),sfres%val,sfres%err)  
  ra = fgsl_sf_log_1plusx_mx(1.0d0)
  call unit_assert_equal_within('fgsl_sf_log_1plusx_mx',&
       log(2.0d0)-1,ra,eps10)
  status = fgsl_sf_log_1plusx_mx_e(1.0d0,sfres)
  call unit_assert_equal('fgsl_sf_log_1plusx_mx_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_log_1plusx_mx_e',&
       log(2.0d0)-1,sfres%val,sfres%err)  
  ra = fgsl_sf_log(2.0d0)
  call unit_assert_equal_within('fgsl_sf_log',&
       log(2.0d0),ra,eps10)
!
! Digamma, Trigamma, Polygamma
!
  ra = fgsl_sf_psi_int(2)
  call unit_assert_equal_within('fgsl_sf_psi_int',&
       0.4227843350984671d0,ra,eps10)
  status = fgsl_sf_psi_int_e(2,sfres)
  call unit_assert_equal('fgsl_sf_psi_int_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_psi_int_e',&
       0.4227843350984671d0,sfres%val,sfres%err)  
  ra = fgsl_sf_psi(2.0d0)
  call unit_assert_equal_within('fgsl_sf_psi',&
       0.4227843350984671d0,ra,eps10)
  status = fgsl_sf_psi_e(2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_psi_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_psi_e',&
       0.4227843350984671d0,sfres%val,sfres%err)  
  ra = fgsl_sf_psi_1piy(2.0d0)
  call unit_assert_equal_within('fgsl_sf_psi_1piy',&
       0.7145915153739806d0,ra,eps10)
  status = fgsl_sf_psi_1piy_e(2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_psi_1piy_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_psi_1piy_e',&
       0.7145915153739806d0,sfres%val,sfres%err)  
  ra = fgsl_sf_psi_1_int(2)
  call unit_assert_equal_within('fgsl_sf_psi_1_int',&
       0.6449340668482265d0,ra,eps10)
  status = fgsl_sf_psi_1_int_e(2,sfres)
  call unit_assert_equal('fgsl_sf_psi_1_int_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_psi_1_int_e',&
       0.6449340668482265d0,sfres%val,sfres%err)  
  ra = fgsl_sf_psi_1(2.0d0)
  call unit_assert_equal_within('fgsl_sf_psi_1',&
       0.6449340668482265d0,ra,eps10)
  status = fgsl_sf_psi_1_e(2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_psi_1_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_psi_1_e',&
       0.6449340668482265d0,sfres%val,sfres%err)  
  ra = fgsl_sf_psi_n(1,2.0d0)
  call unit_assert_equal_within('fgsl_sf_psi_n',&
       0.6449340668482265d0,ra,eps10)
  status = fgsl_sf_psi_n_e(1,2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_psi_n_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_psi_n_e',&
       0.6449340668482265d0,sfres%val,sfres%err)  
!
! Synchrotron and Transport
!
  ra = fgsl_sf_synchrotron_1(2.0d0)
  call unit_assert_equal_within('fgsl_sf_synchrotron_1',&
       0.3016359028507383d0,ra,eps10)
  status = fgsl_sf_synchrotron_1_e(2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_synchrotron_1_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_synchrotron_1_e',&
       0.3016359028507383d0,sfres%val,sfres%err)  
  ra = fgsl_sf_synchrotron_2(2.0d0)
  call unit_assert_equal_within('fgsl_sf_synchrotron_2',&
       0.2496778549762562d0,ra,eps10)
  status = fgsl_sf_synchrotron_2_e(2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_synchrotron_2_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_synchrotron_2_e',&
       0.2496778549762562d0,sfres%val,sfres%err)  
  ra = fgsl_sf_transport_2(2.0d0)
  call unit_assert_equal_within('fgsl_sf_transport_2',&
       1.8017185674405778d0,ra,eps10)
  status = fgsl_sf_transport_2_e(2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_transport_2_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_transport_2_e',&
       1.8017185674405778d0,sfres%val,sfres%err)  
  ra = fgsl_sf_transport_3(2.0d0)
  call unit_assert_equal_within('fgsl_sf_transport_3',&
       1.7063547219458659d0,ra,eps10)
  status = fgsl_sf_transport_3_e(2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_transport_3_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_transport_3_e',&
       1.7063547219458659d0,sfres%val,sfres%err)  
  ra = fgsl_sf_transport_4(2.0d0)
  call unit_assert_equal_within('fgsl_sf_transport_4',&
       2.2010881024333409d0,ra,eps10)
  status = fgsl_sf_transport_4_e(2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_transport_4_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_transport_4_e',&
       2.2010881024333409d0,sfres%val,sfres%err)  
  ra = fgsl_sf_transport_5(2.0d0)
  call unit_assert_equal_within('fgsl_sf_transport_5',&
       3.2292901663684050d0,ra,eps10)
  status = fgsl_sf_transport_5_e(2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_transport_5_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_transport_5_e',&
       3.2292901663684050d0,sfres%val,sfres%err)  
!
! Trigonometric functions
! not available as Fortran intrinsics
  ra = fgsl_sf_hypot(3.0d0,4.0d0)
  call unit_assert_equal_within('fgsl_sf_hypot',&
       5.0d0,ra,eps10)
  status = fgsl_sf_hypot_e(3.0d0,4.0d0,sfres)
  call unit_assert_equal('fgsl_sf_hypot_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_hypot_e',&
       5.0d0,sfres%val,sfres%err)  
  ra = fgsl_sf_sinc(0.5d0)
  call unit_assert_equal_within('fgsl_sf_sinc',&
       2/m_pi,ra,eps10)
  status = fgsl_sf_sinc_e(0.5d0,sfres)
  call unit_assert_equal('fgsl_sf_sinc_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_sinc_e',&
       2/m_pi,sfres%val,sfres%err)  
  status = fgsl_sf_complex_sin_e(m_pi/2,0.0d0,sfres,sfres_2)
  call unit_assert_equal('fgsl_sf_complex_sin_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_complex_sin_e',&
       1.0d0,sfres%val,eps10)  
  call unit_assert_equal_within('fgsl_sf_complex_sin_e',&
       0.0d0,sfres_2%val,eps10)  
  status = fgsl_sf_complex_cos_e(m_pi,0.0d0,sfres,sfres_2)
  call unit_assert_equal('fgsl_sf_complex_cos_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_complex_cos_e',&
       -1.0d0,sfres%val,eps10)  
  call unit_assert_equal_within('fgsl_sf_complex_cos_e',&
       0.0d0,sfres_2%val,eps10)  
  status = fgsl_sf_complex_logsin_e(m_pi/2,0.0d0,sfres,sfres_2)
  call unit_assert_equal('fgsl_sf_complex_logsin_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_complex_logsin_e',&
       0.0d0,sfres%val,eps10)  
  call unit_assert_equal_within('fgsl_sf_complex_logsin_e',&
       0.0d0,sfres_2%val,eps10)  
  ra = fgsl_sf_lnsinh(0.5d0)
  call unit_assert_equal_within('fgsl_sf_lnsinh',&
       log(sinh(0.5d0)),ra,eps10)
  status = fgsl_sf_lnsinh_e(0.5d0,sfres)
  call unit_assert_equal('fgsl_sf_lnsinh_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_lnsinh_e',&
       log(sinh(0.5d0)),sfres%val,eps15)  
  ra = fgsl_sf_lncosh(0.5d0)
  call unit_assert_equal_within('fgsl_sf_lncosh',&
       log(cosh(0.5d0)),ra,eps10)
  status = fgsl_sf_lncosh_e(0.5d0,sfres)
  call unit_assert_equal('fgsl_sf_lncosh_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_lncosh_e',&
       log(cosh(0.5d0)),sfres%val,eps15)  
  status = fgsl_sf_polar_to_rect(1.0d0,m_pi/2,sfres,sfres_2)
  call unit_assert_equal('fgsl_sf_polar_to_rect_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_polar_to_rect_e',&
       0.0d0,sfres%val,eps10)  
  call unit_assert_equal_within('fgsl_sf_polar_to_rect_e',&
       1.0d0,sfres_2%val,eps10)  
  status = fgsl_sf_rect_to_polar(0.0d0,1.0d0,sfres,sfres_2)
  call unit_assert_equal('fgsl_sf_rect_to_polar_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_rect_to_polar_e',&
       1.0d0,sfres%val,eps10)  
  call unit_assert_equal_within('fgsl_sf_rect_to_polar_e',&
       m_pi/2,sfres_2%val,eps10)  
  ra = fgsl_sf_angle_restrict_symm(-1.5d0*m_pi)
  call unit_assert_equal_within('fgsl_sf_angle_restrict_symm',&
       m_pi/2,ra,eps10)
  ra = -1.5d0*m_pi
  status = fgsl_sf_angle_restrict_symm_e(ra)
  call unit_assert_equal('fgsl_sf_angle_restrict_symm_e:status',&
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_angle_restrict_symm_e',&
       m_pi/2,ra,eps10)  
  ra = fgsl_sf_angle_restrict_pos(-1.5d0*m_pi)
  call unit_assert_equal_within('fgsl_sf_angle_restrict_pos',&
       m_pi/2,ra,eps10)
  ra = -1.5d0*m_pi
  status = fgsl_sf_angle_restrict_pos_e(ra)
  call unit_assert_equal('fgsl_sf_angle_restrict_pos_e:status',&
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_angle_restrict_pos_e',&
       m_pi/2,ra,eps10)  
  status = fgsl_sf_sin_err_e(m_pi/2,eps7,sfres)
  call unit_assert_equal('fgsl_sf_sin_err_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_sin_err_e',&
       1.0d0,sfres%val,sfres%err)  
  status = fgsl_sf_cos_err_e(m_pi,eps7,sfres)
  call unit_assert_equal('fgsl_sf_cos_err_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_cos_err_e',&
       -1.0d0,sfres%val,sfres%err)  
!
! Zeta functions
!
  ra = fgsl_sf_zeta_int(2)
  call unit_assert_equal_within('fgsl_sf_zeta_int',&
       1.644934066848226406d0,ra,eps10)
  status = fgsl_sf_zeta_int_e(2,sfres)
  call unit_assert_equal('fgsl_sf_zeta_int_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_zeta_int_e',&
       1.644934066848226406d0,sfres%val,sfres%err)  
! NOTE: inconsistency between int and dble results (sfres%err too small!)
  ra = fgsl_sf_zeta(2.0d0)
  call unit_assert_equal_within('fgsl_sf_zeta',&
       1.644934066848227516d0,ra,eps10)
  status = fgsl_sf_zeta_e(2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_zeta_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_zeta_e',&
       1.644934066848227516d0,sfres%val,sfres%err)  
  ra = fgsl_sf_zetam1_int(2)
  call unit_assert_equal_within('fgsl_sf_zetam1_int',&
       0.644934066848226406d0,ra,eps10)
  status = fgsl_sf_zetam1_int_e(2,sfres)
  call unit_assert_equal('fgsl_sf_zetam1_int_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_zetam1_int_e',&
       0.644934066848226406d0,sfres%val,sfres%err)  
! NOTE: inconsistency between int and dble results (sfres%err too small!)
  ra = fgsl_sf_zetam1(2.0d0)
  call unit_assert_equal_within('fgsl_sf_zetam1',&
       0.644934066848227516d0,ra,eps10)
  status = fgsl_sf_zetam1_e(2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_zetam1_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_zetam1_e',&
       0.644934066848227516d0,sfres%val,sfres%err)  
  ra = fgsl_sf_hzeta(2.0d0,1.0d0)
  call unit_assert_equal_within('fgsl_sf_hzeta',&
       1.644934066848227516d0,ra,eps10)
  status = fgsl_sf_hzeta_e(2.0d0,1.0d0,sfres)
  call unit_assert_equal('fgsl_sf_hzeta_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_hzeta_e',&
       1.644934066848227516d0,sfres%val,sfres%err)  
  ra = fgsl_sf_eta_int(2)
  call unit_assert_equal_within('fgsl_sf_eta_int',&
       0.5d0*1.644934066848226406d0,ra,eps10)
  status = fgsl_sf_eta_int_e(2,sfres)
  call unit_assert_equal('fgsl_sf_eta_int_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_eta_int_e',&
       0.5d0*1.644934066848226406d0,sfres%val,sfres%err)  
! NOTE: inconsistency between int and dble results (sfres%err too small!)
  ra = fgsl_sf_eta(2.0d0)
  call unit_assert_equal_within('fgsl_sf_eta',&
       0.5d0*1.644934066848227516d0,ra,eps10)
  status = fgsl_sf_eta_e(2.0d0,sfres)
  call unit_assert_equal('fgsl_sf_eta_e:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_sf_eta_e',&
       0.5d0*1.644934066848227516d0,sfres%val,sfres%err)  
!
! Done
!
  call unit_finalize()
end program specfunc

program histogram
  use fgsl
  implicit none
  real(fgsl_double) :: a, b, x
  integer(fgsl_size_t) :: n
  integer(fgsl_int) :: status
  type(fgsl_histogram) :: h
  type(fgsl_file) :: stdout
  namelist / histpar / a, b, n
!
  write(6, *) 'Reading histogram parameters from file histogram.dat ... '
  open(20, file='histogram.dat', form='formatted', status='old')
  read(20, nml=histpar) 
  close(20)
  stdout = fgsl_stdout()
  h = fgsl_histogram_alloc(n)
  status = fgsl_histogram_set_ranges_uniform(h, a, b)
  write(6, *) '... Done. Now please enter histogram data.'
  write(6, *) 'One number per line. CTRL-D concludes input.'
  do
     read(5, end=1, fmt=*) x 
     status = fgsl_histogram_increment (h, x)
  end do
1 continue
  write(6, *) 'Printing histogram:'
  status = fgsl_histogram_fprintf(stdout, h,'%12.5f','%7.0f')
  call fgsl_histogram_free(h)
end program histogram

program ieee
  use fgsl
  implicit none
  type(fgsl_file) :: stdout
  integer(fgsl_int) :: status
  real(fgsl_float) :: f
  real(fgsl_double) :: d, fd
  f = 1.0/3.0
  d = 1.D0/3.D0
  fd = f

  stdout = fgsl_stdout()
  write(6, advance='no', fmt='('' f='')') 
  call fgsl_ieee_printf(f)
  status = fgsl_flush(stdout)
  write(6, '('''')')
  
  write(6, advance='no', fmt='('' fd='')') 
  call fgsl_ieee_printf(fd)
  status = fgsl_flush(stdout)
  write(6, '('''')')

  write(6, advance='no', fmt='('' d='')') 
  call fgsl_ieee_printf(d)
  status = fgsl_flush(stdout)
  write(6, '('''')')

end program ieee

program fitting
  use fgsl
  implicit none
  integer(fgsl_size_t), parameter :: n = 4
  integer(fgsl_int) :: i, status
  real(fgsl_double), dimension(n) :: x = &
       (/ 1970.D0, 1980.D0, 1990.D0, 2000.D0 /) 
  real(fgsl_double), dimension(n) :: y = &
       (/ 12.D0, 11.D0, 14.D0, 13.D0 /)
  real(fgsl_double), dimension(n) :: w = &
       (/ 0.1D0, 0.2D0, 0.3D0, 0.4D0 /)
  real(fgsl_double) :: c0, c1, cov00, cov01, cov11, chisq
  real(fgsl_double) :: xf, yf, yf_err

  status = fgsl_fit_wlinear (x, 1_fgsl_size_t, w, 1_fgsl_size_t, &
       y, 1_fgsl_size_t, n, & 
       c0, c1, cov00, cov01, cov11, chisq)
       
  
  write(6, '(''# best fit: Y = '',F12.5,'' + '',F12.5, &
       & ''*X'')') c0, c1
  write(6, '(''# covariance matrix: '')')
  write(6, '(''# [ '',F12.5,'', '',F12.5, '' ]'')') cov00, cov01 
  write(6, '(''# [ '',F12.5,'', '',F12.5, '' ]'')') cov01, cov11
  write(6, '(''# chisq = '',F12.5)') chisq

  do i=1, n
     write(6, '(''data: '',2(F6.1,1X),F12.5))') x(i), y(i), 1.0D0/sqrt(w(i))
  end do

  do i=-30,129
     xf = x(1) + dble(i)/100.D0 * (x(n) - x(1))
     status = fgsl_fit_linear_est (xf, c0, c1, cov00, cov01, cov11, &
          yf, yf_err)
     write(6, '(''fit, error: '',F6.1,1X,F10.5,'' +/-'',F10.5)') &
          xf, yf, yf_err 
  end do
end program fitting

module mod_minim
  use, intrinsic :: iso_c_binding
  use fgsl
  use mod_unit
  implicit none
contains
  function cosp1(x, params) bind(c)
    real(c_double), value :: x
    type(c_ptr), value :: params
    real(c_double) :: cosp1
!   
    cosp1 = cos(x) + 1.0d0
  end function cosp1
end module mod_minim
program minim
  use mod_minim
  implicit none
  real(fgsl_double), parameter :: eps5 = 1.0d-5
  integer(fgsl_int), parameter :: itmax_root = 50
  real(fgsl_double) :: ra, xlo, xhi
  type(c_ptr) :: ptr
  type(fgsl_function) :: stdfunc
  type(fgsl_min_fminimizer) :: min_fslv
  integer(fgsl_int) :: status, i
  character(kind=fgsl_char,len=fgsl_strmax) :: name
!
! Test one-dimensional minimization
!
  call unit_init(20)
!
  min_fslv = fgsl_min_fminimizer_alloc(fgsl_min_fminimizer_brent)
  call unit_assert_true('fgsl_min_fminimizer_alloc', &
       fgsl_well_defined(min_fslv), .true.)
  stdfunc = fgsl_function_init(cosp1, ptr)
  status = fgsl_min_fminimizer_set(min_fslv, stdfunc, &
       3.0_fgsl_double, 0.0_fgsl_double, 6.0_fgsl_double)
  name = fgsl_min_fminimizer_name(min_fslv)
  call unit_assert_equal('fgsl_min_fminimizer_name','brent',trim(name))
  i = 0
  do
     i = i + 1
     status = fgsl_min_fminimizer_iterate(min_fslv)
     if (status /= fgsl_success .or. i > itmax_root) then
        exit
     end if
     ra = fgsl_min_fminimizer_x_minimum(min_fslv)
     xlo = fgsl_min_fminimizer_x_lower(min_fslv)
     xhi = fgsl_min_fminimizer_x_upper(min_fslv)
     status = fgsl_min_test_interval (xlo, xhi, eps5, 0.0_fgsl_double)
     if (status == fgsl_success) exit
  end do
  call unit_assert_equal('fgsl_min_fminimizer:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_min_fminimizer', &
       m_pi,ra,eps5)
  call fgsl_min_fminimizer_free(min_fslv)
  call fgsl_function_free(stdfunc)
!
! Done
!
  call unit_finalize() 
end program minim

program poly
  use mod_unit
  use fgsl
  implicit none
  real(fgsl_double), parameter :: eps10 = 1.0E-10_fgsl_double
  integer(fgsl_int) :: status
  real(fgsl_double) :: ra, ri, ro, &
       d(2), xa(10), ya(10), da(10), di(10)
  complex(fgsl_double) :: z0, z1, z2, &
       z(10)
  type(fgsl_poly_complex_workspace) :: wk
!
! Test polynomial API
!
  call unit_init(50)
!
  d(1:2) = (/1.0_fgsl_double, 2.0_fgsl_double/)
  ra = fgsl_poly_eval(d, 2, 2.0_fgsl_double)
  call unit_assert_equal_within('fgsl_poly_eval',5.0d0,ra,eps10)
  xa(1:3) =  (/1.0_fgsl_double, 2.0_fgsl_double, 3.0_fgsl_double/)
  ya(1:3) =  (/1.0_fgsl_double, 8.0_fgsl_double, 3.0_fgsl_double/)
  status = fgsl_poly_dd_init(da, xa, ya, 3_fgsl_size_t)
  ra = fgsl_poly_dd_eval(da, xa, 3_fgsl_size_t, 2.0_fgsl_double)
  call unit_assert_equal('fgsl_poly_dd_init',fgsl_success,status)
  call unit_assert_equal_within('fgsl_poly_dd_eval',8.0d0,ra,eps10)
  status = fgsl_poly_dd_taylor(di, 0.0_fgsl_double, da, xa, 3_fgsl_size_t, d) 
  ra = di(1) + 2.0d0 * di(2) + 4.0d0 * di(3)
  call unit_assert_equal('fgsl_poly_dd_taylor:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_poly_dd_taylor',8.0d0,ra,eps10)
  status = fgsl_poly_solve_quadratic(1.0_fgsl_double, -3.0_fgsl_double, &
       2.0_fgsl_double, ra, ri)
  call unit_assert_equal('fgsl_poly_solve_quadratic:status',2,status)
  call unit_assert_equal_within('fgsl_poly_solve_quadratic',1.0d0,ra,eps10)
  call unit_assert_equal_within('fgsl_poly_solve_quadratic',2.0d0,ri,eps10)
  status = fgsl_poly_complex_solve_quadratic(1.0_fgsl_double,0.0_fgsl_double, &
       1.0_fgsl_double, z0, z1)
  call unit_assert_equal('fgsl_poly_complex_solve_quadratic:status',2,status)
  call unit_assert_equal_within('fgsl_poly_complex_solve_quadratic',&
       (0.0d0,-1.0d0),z0,eps10)
  call unit_assert_equal_within('fgsl_poly_complex_solve_quadratic',&
       (0.0d0,1.0d0),z1,eps10)
  status = fgsl_poly_solve_cubic(-6.0_fgsl_double,11.0_fgsl_double, &
       -6.0_fgsl_double, ra, ri, ro)
  call unit_assert_equal('fgsl_poly_solve_cubic:status',3,status)
  call unit_assert_equal_within('fgsl_poly_solve_cubic',1.0d0,ra,eps10)
  call unit_assert_equal_within('fgsl_poly_solve_cubic',2.0d0,ri,eps10)
  call unit_assert_equal_within('fgsl_poly_solve_cubic',3.0d0,ro,eps10)
  status = fgsl_poly_complex_solve_cubic(0.0_fgsl_double,0.0_fgsl_double, &
       -1.0_fgsl_double, z0, z1, z2)
  call unit_assert_equal('fgsl_poly_complex_solve_cubic:status',3,status)
  call unit_assert_equal_within('fgsl_poly_complex_solve_cubic',&
       cos(2.0d0*m_pi/3.0d0) - (0.0d0,1.0d0)*sin(2.0d0*m_pi/3.0d0),z0,eps10)
  call unit_assert_equal_within('fgsl_poly_complex_solve_cubic',&
        cos(2.0d0*m_pi/3.0d0) + (0.0d0,1.0d0)*sin(2.0d0*m_pi/3.0d0),z1,eps10)
  call unit_assert_equal_within('fgsl_poly_complex_solve_cubic',&
        (1.0d0,0.0d0),z2,eps10)
  wk = fgsl_poly_complex_workspace_alloc(4_fgsl_size_t)
  xa(1:4) =  (/-1.0_fgsl_double, 0.0_fgsl_double, 0.0_fgsl_double, 1.0_fgsl_double/)
  call unit_assert_true('fgsl_poly_complex_workspace_alloc',fgsl_well_defined(wk),&
       .true.)
  status = fgsl_poly_complex_solve(xa, 4_fgsl_size_t, wk, z)
  call fgsl_poly_complex_workspace_free(wk)
  call unit_assert_equal_within('fgsl_poly_complex_solve',&
        cos(2.0d0*m_pi/3.0d0)+(0.0d0,1.0d0)*sin(2.0d0*m_pi/3.0d0),z(1),eps10)
  call unit_assert_equal_within('fgsl_poly_complex_solve',&
        cos(2.0d0*m_pi/3.0d0)-(0.0d0,1.0d0)*sin(2.0d0*m_pi/3.0d0),z(2),eps10)
  call unit_assert_equal_within('fgsl_poly_complex_solve',&
        (1.0d0,0.0d0),z(3),eps10)
!
! Done
!
  call unit_finalize()
end program poly

program eigen
  use fgsl
  use mod_unit
  implicit none
  real(fgsl_double), parameter :: eps10 = 1.0d-10
  type(fgsl_matrix) :: a, evec
  type(fgsl_vector) :: eval
  real(fgsl_double) :: af(3, 3), evalf(3), evecf(3, 3)
  type(fgsl_eigen_symm_workspace) :: wks
  type(fgsl_eigen_symmv_workspace) :: wksv
  integer(fgsl_int) :: status
!
! Test eigenvectors / eigenvalues
! remember that matrices are transposed vs. usual Fortran convention
!
  call unit_init(200)
!
  a = fgsl_matrix_init(1.0_fgsl_double)
  evec = fgsl_matrix_init(1.0_fgsl_double)
  eval = fgsl_vector_init(1.0_fgsl_double)
  wks = fgsl_eigen_symm_alloc(3_fgsl_size_t)
  wksv = fgsl_eigen_symmv_alloc(3_fgsl_size_t)
  af = reshape((/ 1.0d0, -1.0d0, 0.0d0, -1.0d0, 2.0d0, 3.0d0, &
       0.0d0, 3.0d0, 1.0d0 /), (/3, 3/))
  status = fgsl_matrix_align(af, 3_fgsl_size_t, 3_fgsl_size_t, &
       3_fgsl_size_t,a)
  status = fgsl_matrix_align(evecf, 3_fgsl_size_t, 3_fgsl_size_t, &
       3_fgsl_size_t,evec)
  status = fgsl_vector_align(evalf, 3_fgsl_size_t, eval, 3_fgsl_size_t, &
       0_fgsl_size_t, 1_fgsl_size_t)
  status = fgsl_eigen_symm(a, eval, wks)
  call unit_assert_equal_within('fgsl_eigen_symm:eval',&
       (/(3.0d0+sqrt(41.0d0))/2.0d0, 1.0d0, (3.0d0-sqrt(41.0d0))/2.0d0 /), &
       evalf,eps10)
  af = reshape((/ 1.0d0, -1.0d0, 0.0d0, -1.0d0, 2.0d0, 3.0d0, &
       0.0d0, 3.0d0, 1.0d0 /), (/3, 3/))
  status = fgsl_eigen_symmv(a, eval, evec, wksv)
  call unit_assert_equal_within('fgsl_eigen_symmv:eval',&
       (/(3.0d0+sqrt(41.0d0))/2.0d0, 1.0d0, (3.0d0-sqrt(41.0d0))/2.0d0 /), &
       evalf,eps10)
! FIXME: remaining routines

! 
  call fgsl_matrix_free(a)
  call fgsl_vector_free(eval)
  call fgsl_matrix_free(evec)
  call fgsl_eigen_symm_free(wks)
  call fgsl_eigen_symmv_free(wksv)
   
! 
! Done
!
  call unit_finalize()
end program eigen

module mod_integration
  use fgsl
  use mod_unit
  use, intrinsic :: iso_c_binding
  implicit none  
  real(fgsl_double), parameter :: eps7 = 1.0d-7
  real(fgsl_double), parameter :: eps10 = 1.0d-10
!  real(fgsl_double), parameter :: eps12 = 1.0d-12
  real(fgsl_double) :: pts(4)
  integer(fgsl_size_t) :: limit = 1000_fgsl_size_t
  integer(fgsl_size_t) :: isub  = 8_fgsl_size_t
contains
  function integrate_fun1(x, params) bind(c)
    real(c_double), value :: x
    type(c_ptr), value :: params
    real(c_double) :: integrate_fun1
!
    real(c_double), pointer :: alpha
    call c_f_pointer(params, alpha)
!    write(6, *) 'Alpha = ',alpha
    integrate_fun1 = log(alpha * x) / sqrt(x)
  end function integrate_fun1
  function integrate_fun2(x, params) bind(c)
    real(c_double), value :: x
    type(c_ptr), value :: params
    real(c_double) :: integrate_fun2
!
    real(c_double), pointer :: alpha
    call c_f_pointer(params, alpha)
!    write(6, *) 'Alpha = ',alpha, ' x = ',x
    integrate_fun2 = 1.0_c_double + alpha * x * x
  end function integrate_fun2
  function integrate_fun3(x, params) bind(c)
    real(c_double), value :: x
    type(c_ptr), value :: params
    real(c_double) :: integrate_fun3
!
    real(c_double), pointer :: alpha
    call c_f_pointer(params, alpha)
!    write(6, *) 'Alpha = ',alpha, ' x = ',x
    integrate_fun3 = 1.0_c_double / (1.0_c_double + alpha * x * x)
  end function integrate_fun3
  function integrate_fun4(x, params) bind(c)
    real(c_double), value :: x
    type(c_ptr), value :: params
    real(c_double) :: integrate_fun4
!
    integrate_fun4 = 1.0_c_double / sqrt(abs(x))
  end function integrate_fun4
  function integrate_fun5(x, params) bind(c)
    real(c_double), value :: x
    type(c_ptr), value :: params
    real(c_double) :: integrate_fun5
!
    integrate_fun5 = exp(-x*x)
  end function integrate_fun5
  function integrate_fun6(x, params) bind(c)
    real(c_double), value :: x
    type(c_ptr), value :: params
    real(c_double) :: integrate_fun6
!
    integrate_fun6 = 2*x
  end function integrate_fun6
  function integrate_fun7(x, params) bind(c)
    real(c_double), value :: x
    type(c_ptr), value :: params
    real(c_double) :: integrate_fun7
!
    real(c_double), pointer :: alpha
    call c_f_pointer(params, alpha)
    integrate_fun7 = exp(-alpha*x)
  end function integrate_fun7
 end module mod_integration
program integration
  use mod_integration
  implicit none
  real(fgsl_double), target :: xx
  real(fgsl_double) :: ra, rda
  integer(fgsl_int) :: status
  integer(fgsl_size_t) :: neval
  type(c_ptr) :: ptr
  type(fgsl_error_handler_t) :: std
  type(fgsl_function) :: stdfunc
  type(fgsl_integration_workspace) :: integ_wk, integ_wc
  type(fgsl_integration_qaws_table) :: qaws_wk
  type(fgsl_integration_qawo_table) :: qawo_wk
!
! Test quadrature routines
!
  call unit_init(200)
  std = fgsl_set_error_handler_off()
  ptr = c_loc(xx)
  integ_wk = fgsl_integration_workspace_alloc(limit)
  call unit_assert_true('fgsl_integration_workspace_alloc',&
       fgsl_well_defined(integ_wk),.true.)
  qaws_wk = fgsl_integration_qaws_table_alloc(1.0d0,2.0d0,0,0)
  call unit_assert_true('fgsl_integration_qaws_table_alloc',&
       fgsl_well_defined(qaws_wk),.true.)
  status = fgsl_integration_qaws_table_set(qaws_wk,0.0d0,1.0d0,0,0)
  call unit_assert_equal('fgsl_integration_qaws_table_set:status',&
       fgsl_success,status)
  qawo_wk = fgsl_integration_qawo_table_alloc(2.0d0,4.0d0,&
       fgsl_integ_cosine,isub)
  call unit_assert_true('fgsl_integration_qawo_table_alloc',&
       fgsl_well_defined(qawo_wk),.true.)
  status = fgsl_integration_qawo_table_set(qawo_wk,2.0d0,4.0d0,&
       fgsl_integ_sine)
  call unit_assert_equal('fgsl_integration_qawo_table_set:status',&
       fgsl_success,status)
  status = fgsl_integration_qawo_table_set_length(qawo_wk,1.0d0)
  call unit_assert_equal('fgsl_integration_qawo_table_set_length:status',&
       fgsl_success,status)
!
  xx = sqrt(2.0D0)
  stdfunc = fgsl_function_init(integrate_fun2, ptr)
  status = fgsl_integration_qng(stdfunc, -1.0_fgsl_double, 1.0_fgsl_double, &
       eps10, eps10, ra, rda, neval)
  call unit_assert_equal('fgsl_integration_qng:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_integration_qng',&
       2.0d0*(3+sqrt(2.0d0))/3.0d0,ra,rda)
  call fgsl_function_free(stdfunc)
!
  stdfunc = fgsl_function_init(integrate_fun2, ptr)
  status = fgsl_integration_qag(stdfunc, -1.0_fgsl_double, 1.0_fgsl_double, &
       eps10, eps10, limit, 2, integ_wk, ra, rda)
  call unit_assert_equal('fgsl_integration_qags:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_integration_qags',&
       2.0d0*(3+sqrt(2.0d0))/3.0d0,ra,rda)
  call fgsl_function_free(stdfunc)
!
  xx = 1.0D0
  stdfunc = fgsl_function_init(integrate_fun1, ptr)
  status = fgsl_integration_qags(stdfunc, 0.0_fgsl_double, 1.0_fgsl_double, &
       eps10, eps10, limit, integ_wk, ra, rda)
  call unit_assert_equal('fgsl_integration_qags:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_integration_qags',-4.0d0,ra,rda)
  call fgsl_function_free(stdfunc)
!
  xx = 1.0D0
  pts(1:3) = (/-1.0d0, 0.0d0, 1.0d0/)
  stdfunc = fgsl_function_init(integrate_fun4, ptr)
  status = fgsl_integration_qagp(stdfunc, pts, 3_fgsl_size_t, &
       eps10, eps10, limit, integ_wk, ra, rda);
  call unit_assert_equal('fgsl_integration_qagp:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_integration_qagp',4.0d0,ra,rda)
  call fgsl_function_free(stdfunc)
!
  stdfunc = fgsl_function_init(integrate_fun5, ptr)
  status = fgsl_integration_qagi(stdfunc, eps10, eps10, limit, integ_wk, ra, rda)
  call unit_assert_equal('fgsl_integration_qagi:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_integration_qagi',sqrt(m_pi),ra,rda)
  call fgsl_function_free(stdfunc)
!
  stdfunc = fgsl_function_init(integrate_fun5, ptr)
  status = fgsl_integration_qagiu(stdfunc, 0.0d0, eps10, eps10, limit, integ_wk, ra, rda)
  call unit_assert_equal('fgsl_integration_qagiu:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_integration_qagiu',sqrt(m_pi)/2.0d0,ra,rda)
  call fgsl_function_free(stdfunc)
!
  stdfunc = fgsl_function_init(integrate_fun5, ptr)
  status = fgsl_integration_qagil(stdfunc, 0.0d0, eps10, eps10, limit, integ_wk, ra, rda)
  call unit_assert_equal('fgsl_integration_qagil:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_integration_qagil',sqrt(m_pi)/2.0d0,ra,rda)
  call fgsl_function_free(stdfunc)
!
  stdfunc = fgsl_function_init(integrate_fun6, ptr)
  status = fgsl_integration_qawc(stdfunc, -1.0_fgsl_double, 1.0_fgsl_double, &
       0.0_fgsl_double, eps10, eps10, limit, integ_wk, ra, rda)
  call unit_assert_equal('fgsl_integration_qawc:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_integration_qawc',&
       4.0d0,ra,eps10)
! NOTE replaced rda with eps10 (fails on 32 bit with NAG)
  call fgsl_function_free(stdfunc)
!
  stdfunc = fgsl_function_init(integrate_fun6, ptr)
  status = fgsl_integration_qaws(stdfunc, 0.0_fgsl_double, 1.0_fgsl_double, &
       qaws_wk, eps10, eps10, limit, integ_wk, ra, rda)
  call unit_assert_equal('fgsl_integration_qaws:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_integration_qaws',&
       1.0d0/3.0d0,ra,rda)
  call fgsl_function_free(stdfunc)
!
  stdfunc = fgsl_function_init(integrate_fun6, ptr)
  status = fgsl_integration_qawo(stdfunc, 0.0_fgsl_double, &
       eps10, eps10, limit, integ_wk, qawo_wk, ra, rda)
  call unit_assert_equal('fgsl_integration_qawo:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_integration_qawo',&
       0.5d0*sin(2.0d0)-cos(2.0d0),ra,rda)
  status = fgsl_integration_qawo_table_set(qawo_wk,2.0d0,1.0d0,&
       fgsl_integ_cosine)
  status = fgsl_integration_qawo(stdfunc, 0.0_fgsl_double, &
       eps10, eps10, limit, integ_wk, qawo_wk, ra, rda)
  call unit_assert_equal('fgsl_integration_qawo:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_integration_qawo',&
       sin(2.0d0)+0.5d0*cos(2.0d0)-0.5d0,ra,rda)
  call fgsl_function_free(stdfunc)
!
  integ_wc = fgsl_integration_workspace_alloc(limit)
  call unit_assert_true('fgsl_integration_workspace_alloc',&
       fgsl_well_defined(integ_wc),.true.)
  xx = 1.0D0
  stdfunc = fgsl_function_init(integrate_fun7, ptr)
  status = fgsl_integration_qawo_table_set(qawo_wk,2.0d0,1.0d0,&
       fgsl_integ_sine)
  status = fgsl_integration_qawf(stdfunc, 0.0_fgsl_double, &
       eps10, limit, integ_wk, integ_wc, qawo_wk, ra, rda)
  call unit_assert_equal('fgsl_integration_qawf:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_integration_qawf',&
       0.4d0,ra,rda)
  call fgsl_integration_workspace_free(integ_wc)
  call fgsl_function_free(stdfunc)
!
  call fgsl_integration_qaws_table_free(qaws_wk)
  call fgsl_integration_qawo_table_free(qawo_wk)
  call fgsl_integration_workspace_free(integ_wk)
!
! Done
!
  call unit_finalize()
end program integration

module mod_monte
  use fgsl
  use, intrinsic :: iso_c_binding
  implicit none
  real(fgsl_double), parameter :: exact = 1.3932039296856768_fgsl_double
  integer(fgsl_size_t), parameter :: calls = 500000
contains
  function g(v, n, params) bind(c)
    integer(c_size_t), value :: n
    real(c_double), dimension(*) :: v
    type(c_ptr), value :: params
    real(c_double) :: g
    g = 1.0_c_double/(m_pi**3)/ &
         (1.0_fgsl_double - cos(v(1))*cos(v(2))*cos(v(3)))
  end function g
  subroutine display_results(title,result,error)
    character(kind=fgsl_char,len=*), intent(in) :: title
    real(fgsl_double), intent(in) :: result, error
    write(6, '(A,'' ================='')') trim(title)
    write(6, '(''result = '',F10.6)') result
    write(6, '(''sigma  = '',F10.6)') error
    write(6, '(''exact  = '',F10.6)') exact
    write(6, '(''error  = '',F10.6,'' = '',F5.1,'' sigma'')') &
         result - exact, abs(result - exact) / error
  end subroutine display_results
end module mod_monte
program monte
! Computation of the integral,
!
!      I = int (dx dy dz)/(2pi)^3  1/(1-cos(x)cos(y)cos(z))
!
!   over (-pi,-pi,-pi) to (+pi, +pi, +pi).  The exact answer
!   is Gamma(1/4)^4/(4 pi^3).  This example is taken from
!   C.Itzykson, J.M.Drouffe, "Statistical Field Theory -
!   Volume 1", Section 1.1, p21, which cites the original
!   paper M.L.Glasser, I.J.Zucker, Proc.Natl.Acad.Sci.USA 74
!   1800 (1977) 

! For simplicity we compute the integral over the region 
!   (0,0,0) -> (pi,pi,pi) and multiply by 8
  use mod_monte
  implicit none
  real(fgsl_double) :: chisq, xl(3), xu(3), res, err, y, yy, yyy
  integer(fgsl_int) :: status, stage, mode, verbose
  integer(fgsl_size_t) :: its
  type(fgsl_file) :: file
  type(fgsl_rng) :: r
  type(fgsl_rng_type) :: t
  type(fgsl_monte_plain_state) :: s
  type(fgsl_monte_miser_state) :: m
  type(fgsl_monte_vegas_state) :: v
  type(fgsl_monte_function) :: gfun
  type(c_ptr) :: ptr
!
  xl = 0.0_fgsl_double ; xu = m_pi
  t = fgsl_rng_env_setup()
  r = fgsl_rng_alloc(t)
  gfun = fgsl_monte_function_init(g, 3_fgsl_size_t, ptr)
  s = fgsl_monte_plain_alloc(3_fgsl_size_t)
  status = fgsl_monte_plain_integrate(gfun, xl, xu, 3_fgsl_size_t, &
       calls, r, s, res, err)
  call fgsl_monte_plain_free(s)
  call display_results('plain',res,err)
!
  m = fgsl_monte_miser_alloc(3_fgsl_size_t)
  status = fgsl_monte_miser_integrate(gfun, xl, xu, 3_fgsl_size_t, &
       calls, r, m, res, err)
  call fgsl_monte_miser_free(m)
  call display_results('miser',res,err)
!
  v = fgsl_monte_vegas_alloc(3_fgsl_size_t)
  status = fgsl_monte_vegas_integrate(gfun, xl, xu, 3_fgsl_size_t, &
       10000_fgsl_size_t, r, v, res, err)
  call display_results('vegas warm-up',res,err)
  write(6, *) 'converging ...'
  do 
     status = fgsl_monte_vegas_integrate(gfun, xl, xu, 3_fgsl_size_t, &
          calls/5_fgsl_size_t, r, v, res, err)
     call fgsl_monte_vegas_getparams(v, y, yy, chisq, yyy, &
       its, stage, mode, verbose, file)
     write(6, '(''result = '',F10.6,'' sigma = '',F10.6, &
          & '' chisq/dof = '',F6.1)') res,err,chisq
     if (abs(chisq - 1.0_fgsl_double) <= 0.5_fgsl_double) exit 
  end do
  call fgsl_monte_vegas_free(v)
  call fgsl_monte_function_free(gfun)
  call fgsl_rng_free(r)
end program monte

module mod_deriv
  use, intrinsic :: iso_c_binding
  use fgsl
  use mod_unit
  implicit none
contains
  function power(x, params) bind(c)
    real(c_double), value :: x
    type(c_ptr), value :: params
    real(c_double) :: power
!
    real(fgsl_double), pointer :: p
    call c_f_pointer(params, p)
    power = x ** p
  end function power
end module mod_deriv
program deriv
  use mod_deriv
  implicit none
  real(fgsl_double), parameter :: eps5 = 1.0d-5
  real(fgsl_double), target :: fpar(3)
  real(fgsl_double) :: abserr, result
  type(c_ptr) :: ptr
  type(fgsl_function) :: stdfunc
  integer(fgsl_int) :: status
!
! Test numerical derivative routines
!
  call unit_init(20)
!
  fpar = (/1.5_fgsl_double, 0.0_fgsl_double, 0.0_fgsl_double/)
  ptr = c_loc(fpar)
  stdfunc = fgsl_function_init(power, ptr)
  status = fgsl_deriv_central(stdfunc, 2.0_fgsl_double, eps5, result, abserr)
  call unit_assert_equal('fgsl_deriv_central:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_deriv_central',1.5d0*sqrt(2.0d0), &
       result,abserr)
  status = fgsl_deriv_forward(stdfunc, 2.0_fgsl_double, eps5, result, abserr)
  call unit_assert_equal('fgsl_deriv_within:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_deriv_within',1.5d0*sqrt(2.0d0), &
       result,abserr)
  status = fgsl_deriv_backward(stdfunc, 2.0_fgsl_double, eps5, result, abserr)
  call unit_assert_equal('fgsl_deriv_backward:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_deriv_within',1.5d0*sqrt(2.0d0), &
       result,abserr)
  call fgsl_function_free(stdfunc)
!
! Done
!
  call unit_finalize() 
end program deriv

module tmod
  use fgsl
  use, intrinsic :: iso_c_binding
! some scaffolding for the testing
  implicit none
  logical, parameter, private :: debug = .false.
  interface
     subroutine pp1(xp) bind(c)
       import :: c_ptr
       type(c_ptr), value :: xp
     end subroutine pp1
  end interface
  type data 
     integer(fgsl_size_t) :: n
     real(fgsl_double), allocatable :: y(:), sigma(:)
  end type data
  character(kind=fgsl_char,len=fgsl_strmax) :: test_message
contains
  subroutine testres_toggle(whichtest,test_ok,ok,nok)
    character(len=*), intent(in) :: whichtest
    logical, intent(inout) :: test_ok
    logical, intent(inout) :: ok(:)
    integer, intent(inout) :: nok
    if (.not. test_ok) then
       write(6, *) 'FAIL: ', whichtest
    elseif (debug) then
       write(6, *) 'OK: ', whichtest
    end if
    ok(nok) = test_ok
    test_ok = .true.
    nok = nok + 1
  end subroutine testres_toggle
!
! error treatment test 
!
  subroutine mine_sr(reason, file, line, errno) bind(c)
    type(c_ptr), value :: reason, file
    integer(c_int), value :: line, errno
!
    test_message = fgsl_strerror(errno)
    write(6, *) 'Processed error in ',trim(fgsl_name(file)), ' at line ',line
    write(6, *) 'Reason was: ',trim(fgsl_name(reason))
  end subroutine mine_sr
!
! simulated annealing
!
  function e1(xp) bind(c)
    type(c_ptr), value :: xp
    real(fgsl_double) :: e1
!
    real(fgsl_double), pointer :: x
    call c_f_pointer(xp, x)
    e1 = exp(-(x-1.0_fgsl_double)**2.0_fgsl_double) * &
         sin(8.0_fgsl_double*x)
  end function e1
  function m1(xp, yp) bind(c)
    type(c_ptr), value :: xp, yp
    real(fgsl_double) :: m1
!
    real(fgsl_double), pointer :: x, y
    call c_f_pointer(xp, x)
    call c_f_pointer(yp, y)
    m1 = abs(x - y)
  end function m1
  subroutine s1(r, xp, step_size) bind(c)
    type(c_ptr), value :: r, xp
    real(fgsl_double), value :: step_size
!
    real(fgsl_double), pointer :: x
    real(fgsl_double) :: u
    type(fgsl_rng) :: gr
    call fgsl_obj_c_ptr(gr, r)
    call c_f_pointer(xp, x)
    u = fgsl_rng_uniform(gr)
    x = x + 2.0_fgsl_double * u * step_size - step_size
  end subroutine s1
!
! numerical quadrature
!
  function integrate_fun1(x, params) bind(c)
    real(c_double), value :: x
    type(c_ptr), value :: params
    real(c_double) :: integrate_fun1
!
    real(c_double), pointer :: alpha
    call c_f_pointer(params, alpha)
!    write(6, *) 'Alpha = ',alpha
    integrate_fun1 = log(alpha * x) / sqrt(x)
  end function integrate_fun1
! functions for ODE testing
  function func_ode(t, y, dydt, params) bind(c)
    real(c_double), value :: t
    real(c_double), dimension(*), intent(in) :: y
    real(c_double), dimension(*) :: dydt
    type(c_ptr), value :: params
    integer(c_int) :: func_ode
! 
    real(c_double), pointer :: mu
!
!    write(6, *) 'Starting func:'
    call c_f_pointer(params, mu)
!    write(6, *) 'y, mu:', y(1:2), mu
    dydt(1) = y(2)
    dydt(2) = -y(1) - mu*y(2)*(y(1)*y(1) - 1)
    func_ode = fgsl_success
  end function func_ode
  function jac(t, y, dfdy, dfdt, params) bind(c)
    real(c_double), value :: t
    real(c_double), dimension(*), intent(in) :: y
    real(c_double), dimension(*) :: dfdy
    real(c_double), dimension(*) :: dfdt
    type(c_ptr), value :: params
    integer(c_int) :: jac
! 
    real(c_double), pointer :: mu
!
!    write(6, *) 'Calling jac'
    call c_f_pointer(params, mu)
    dfdy(1) = 0.0_c_double
    dfdy(2) = 1.0_c_double
    dfdy(3) = -2.0_c_double*mu*y(1)*y(2) - 1.0_c_double
    dfdy(4) = -mu*(y(1)*y(1) - 1.0_c_double)
    dfdt(1:2) = 0.0_c_double
    jac = fgsl_success
  end function jac
! functions for sorting
  function compare_double(x, y) bind(c)
    type(c_ptr), value :: x, y
    integer(c_int) :: compare_double
!
    real(fgsl_double), pointer :: xp, yp
    call c_f_pointer(x, xp)
    call c_f_pointer(y, yp)
!    write(6, *) xp, yp
    if (xp > yp) then
       compare_double = 1_c_int
    else if (xp < yp) then
       compare_double = -1_c_int
    else
       compare_double = 0_c_int
    end if
  end function compare_double
! functions for root finding tests
  function quadratic(x, params) bind(c)
    real(c_double), value :: x
    type(c_ptr), value :: params
    real(c_double) :: quadratic
!
    real(fgsl_double), pointer :: p(:)
    call c_f_pointer(params, p, (/3/))
    quadratic = (p(1)*x + p(2))*x + p(3)
  end function quadratic
  function quadratic_deriv(x, params) bind(c)
    real(c_double), value :: x
    type(c_ptr), value :: params
    real(c_double) :: quadratic_deriv
!
    real(fgsl_double), pointer :: p(:)
    call c_f_pointer(params, p, (/3/))
    quadratic_deriv = 2.0_fgsl_double*p(1)*x + p(2) 
  end function quadratic_deriv
  subroutine quadratic_fdf(x, params, y, dy) bind(c)
    real(c_double), value :: x
    type(c_ptr), value :: params
    real(c_double), intent(out) :: y, dy
!
    real(fgsl_double), pointer :: p(:)
    call c_f_pointer(params, p, (/3/))
    y = (p(1)*x + p(2))*x + p(3)
    dy = 2.0_fgsl_double*p(1)*x + p(2)
  end subroutine quadratic_fdf
  function power(x, params) bind(c)
    real(c_double), value :: x
    type(c_ptr), value :: params
    real(c_double) :: power
!
    real(fgsl_double), pointer :: p
    call c_f_pointer(params, p)
    power = x ** p
  end function power
!
! for minimization test
!
  function cosp1(x, params) bind(c)
    real(c_double), value :: x
    type(c_ptr), value :: params
    real(c_double) :: cosp1
!   
    cosp1 = cos(x) + 1.0d0
  end function cosp1
!
! for multiroot-finding
!
  function rosenbrock_f(x, params, f) bind(c)
    type(c_ptr), value :: x, params, f
    integer(c_int) :: rosenbrock_f
!
    type(fgsl_vector) :: fx, ff
    real(fgsl_double), pointer :: par(:), xv(:), yv(:)
    integer(fgsl_int) :: status
    call fgsl_obj_c_ptr(fx, x)
    call fgsl_obj_c_ptr(ff, f)
    call c_f_pointer(params, par, (/ 2 /))
    status = fgsl_vector_align(xv, fx)
    status = fgsl_vector_align(yv, ff)
    yv(1) = par(1) * (1.0_fgsl_double - xv(1))
    yv(2) = par(2) * (xv(2) - xv(1)*xv(1))
    rosenbrock_f = fgsl_success
  end function rosenbrock_f
  function rosenbrock_df(x, params, df) bind(c)
    type(c_ptr), value :: x, params, df
    integer(c_int) :: rosenbrock_df
!
    type(fgsl_vector) :: fx
    type(fgsl_matrix) :: dff
    real(fgsl_double), pointer :: par(:), xv(:), yv(:,:)
    integer(fgsl_int) :: status
    call fgsl_obj_c_ptr(fx, x)
    call fgsl_obj_c_ptr(dff, df)
    call c_f_pointer(params, par, (/ 2 /))
    status = fgsl_vector_align(xv, fx)
    status = fgsl_matrix_align(yv, dff)
    yv(1:2,1:2) = reshape( source = (/ -par(1), 0.0_fgsl_double , &
         -2.0_fgsl_double*par(2)*xv(1), par(2)  /), &
         shape = (/ 2, 2 /))
    rosenbrock_df = fgsl_success
  end function rosenbrock_df
  function rosenbrock_fdf(x, params, f, df) bind(c)
    type(c_ptr), value :: x, params, f, df
    integer(c_int) :: rosenbrock_fdf
!
    integer(c_int) :: status
    status = rosenbrock_f(x, params, f)
    status = rosenbrock_df(x, params, df)
    rosenbrock_fdf = fgsl_success
  end function rosenbrock_fdf
!
! Multimin
!
  function paraboloid_f(v, p) bind(c)
    type(c_ptr), value :: v, p
    real(c_double) :: paraboloid_f
!
    type(fgsl_vector) :: vec
    real(fgsl_double), pointer :: par(:), pvec(:)
    integer(fgsl_int) :: status
    call fgsl_obj_c_ptr(vec, v)
    call c_f_pointer(p, par, (/ 2 /))
    status = fgsl_vector_align(pvec, vec)
    paraboloid_f = 10.0_fgsl_double * (pvec(1)-par(1))**2 + &
         20.0_fgsl_double * (pvec(2)-par(2))**2 + 30.0_fgsl_double
  end function paraboloid_f
  subroutine paraboloid_df(v, p, df) bind(c)
    type(c_ptr), value :: v, p, df
!
    type(fgsl_vector) :: vec, grad
    real(fgsl_double), pointer :: par(:), pvec(:), pdf(:)
    integer(fgsl_int) :: status
    call fgsl_obj_c_ptr(vec, v)
    call fgsl_obj_c_ptr(grad, df)
    call c_f_pointer(p, par, (/ 2 /))
    status = fgsl_vector_align(pvec, vec)
    status = fgsl_vector_align(pdf, grad)
    pdf(1) = 20.0_fgsl_double * (pvec(1)-par(1))
    pdf(2) = 40.0_fgsl_double * (pvec(2)-par(2))
  end subroutine paraboloid_df
  subroutine paraboloid_fdf(v, p, f, df) bind(c)
    type(c_ptr), value :: v, p, df
    real(c_double) :: f
    f = paraboloid_f(v, p)
    call paraboloid_df(v, p, df)
  end subroutine paraboloid_fdf
! Least squares fitting
  function expb_f(x, cdata, f) bind(c)
    type(c_ptr), value :: x, cdata, f
    integer(c_int) :: expb_f
!
    type(fgsl_vector) :: f_x, f_f
    type(data), pointer :: f_data
    integer(fgsl_size_t) :: i
    integer(fgsl_int) :: status
    real(fgsl_double) :: yy
    real(fgsl_double), pointer :: p_x(:), p_f(:)
!
    call fgsl_obj_c_ptr(f_x, x)
    call fgsl_obj_c_ptr(f_f, f)
    status = fgsl_vector_align(p_x, f_x)
    status = fgsl_vector_align(p_f, f_f)
    call c_f_pointer(cdata, f_data)
    do i=1,f_data%n
       yy = p_x(1) * exp(- p_x(2) * dble(i-1) ) + p_x(3)
       p_f(i) = (yy - f_data%y(i))/f_data%sigma(i)
    end do
    expb_f = fgsl_success
  end function expb_f
  function expb_df(x, cdata, j) bind(c)
    type(c_ptr), value :: x, cdata, j
    integer(c_int) :: expb_df
!
    type(fgsl_vector) :: f_x
    type(fgsl_matrix) :: f_j
    type(data), pointer :: f_data
    integer(fgsl_size_t) :: i
    integer(fgsl_int) :: status
    real(fgsl_double) :: yy
    real(fgsl_double), pointer :: p_x(:), p_j(:,:)
!
    call fgsl_obj_c_ptr(f_x, x)
    call fgsl_obj_c_ptr(f_j, j)
    status = fgsl_vector_align(p_x, f_x)
    status = fgsl_matrix_align(p_j, f_j)
    call c_f_pointer(cdata, f_data)
    do i=1,f_data%n
       yy = exp(- p_x(2) * dble(i-1) )
       p_j(1,i) = yy / f_data%sigma(i)
       p_j(2,i) = - dble(i-1) * p_x(1) * yy / f_data%sigma(i)
       p_j(3,i) = 1 / f_data%sigma(i)
    end do
    expb_df = fgsl_success
  end function expb_df
  function expb_fdf(x, cdata, f, j) bind(c)
    type(c_ptr), value :: x, cdata, f, j
    integer(c_int) :: expb_fdf
!
    integer(c_int) :: status
    status = expb_f(x, cdata, f)
    status = expb_df(x, cdata, j)
    expb_fdf = fgsl_success
  end function expb_fdf
end module tmod

program rng
  use fgsl
  use mod_unit
  implicit none
  real(fgsl_double), parameter :: eps10 = 1.0d-10
  character(kind=fgsl_char, len=fgsl_strmax) :: name
  integer(fgsl_long) :: rn
  real(fgsl_double) :: rd, rd_copy, re, rid, rie, qd(1), qd_copy(1)
  type(fgsl_rng) :: r, copy, clone
  type(fgsl_qrng) :: q, qcopy, qclone
  type(fgsl_rng_type) :: t
  type(fgsl_file) :: rfile
  integer :: status
!
! Test random generators
!
  call unit_init(500)
! rng
  t = fgsl_rng_default
  r = fgsl_rng_alloc(t)
  call unit_assert_true('fgsl_rng_alloc',fgsl_well_defined(r),.true.)
!
  name = fgsl_rng_name(r)
  call fgsl_rng_set(r, 219_fgsl_long)
  call unit_assert_equal('fgsl_rng_name:mt19937','mt19937',trim(name))
  rn = fgsl_rng_get(r)
  call unit_assert_equal('fgsl_rng_get',57953729,int(rn))
  rd = fgsl_rng_uniform(r)
  call unit_assert_equal_within('fgsl_rng_uniform', &
       1.232697358354926109D-01,rd,eps10)
  rd = fgsl_rng_uniform_pos(r)
  call unit_assert_equal_within('fgsl_rng_uniform', &
       2.761673277709633112D-01,rd,eps10)
  rn = fgsl_rng_uniform_int(r,1000_fgsl_long)
  call unit_assert_equal('fgsl_rng_max',425,int(rn))
  rn = fgsl_rng_max(r)
! FIXME for 32 bit platforms
!  rn = rn - 4294967295_fgsl_long
!  write(6, *) rn
  rn = fgsl_rng_min(r)
  call unit_assert_equal('fgsl_rng_min',0,int(rn))
!
  copy = fgsl_rng_alloc(t)
  status = fgsl_rng_memcpy(copy,r)
  call unit_assert_true('fgsl_rng_memcpy:defined',fgsl_well_defined(copy),.true.)
  rfile = fgsl_open('rng.dat','w')
  status = fgsl_rng_fwrite(rfile, copy)
  call unit_assert_equal('fgsl_rng_fwrite:status',fgsl_success,status)
  status = fgsl_close(rfile)
  clone = fgsl_rng_clone(r)
  call unit_assert_true('fgsl_rng_clone:defined',fgsl_well_defined(clone),.true.)
  rd = fgsl_rng_uniform(r)
  rd_copy = fgsl_rng_uniform(copy)
  call unit_assert_equal_within('fgsl_rng_memcpy',rd,rd_copy,eps10)
  rd_copy = fgsl_rng_uniform(clone)
  call unit_assert_equal_within('fgsl_rng_clone',rd,rd_copy,eps10)
  rfile = fgsl_open('rng.dat','r')
  status = fgsl_rng_fread(rfile, copy)
  call unit_assert_equal('fgsl_rng_fread:status',fgsl_success,status)
  status = fgsl_close(rfile)
  rd_copy = fgsl_rng_uniform(copy)
  call unit_assert_equal_within('fgsl_rng_fwrite/read',rd,rd_copy,eps10)
! qrng
  q = fgsl_qrng_alloc(fgsl_qrng_sobol,1)
  name = fgsl_qrng_name(q)
  call unit_assert_equal('fgsl_qrng_name','sobol',trim(name))
  call unit_assert_true('fgsl_qrng_alloc',fgsl_well_defined(q),.true.)
  status = fgsl_qrng_get(q, qd)
  call unit_assert_equal_within('fgsl_qrng_get',(/5.d-1/),qd,eps10)
  call fgsl_qrng_init(q)
  status = fgsl_qrng_get(q, qd)
  call unit_assert_equal_within('fgsl_qrng_get',(/5.d-1/),qd,eps10)
  status = fgsl_qrng_get(q, qd)
  qcopy = fgsl_qrng_alloc(fgsl_qrng_sobol,1)
  status = fgsl_qrng_memcpy(qcopy,q)
  call unit_assert_true('fgsl_qrng_memcpy:defined',fgsl_well_defined(qcopy),.true.)
  qclone = fgsl_qrng_clone(q)
  call unit_assert_true('fgsl_qrng_clone:defined',fgsl_well_defined(qclone),.true.)
  status = fgsl_qrng_get(q, qd)
  status = fgsl_qrng_get(qcopy, qd_copy)
  call unit_assert_equal_within('fgsl_qrng_memcpy',qd,qd_copy,eps10)
  status = fgsl_qrng_get(qclone, qd_copy)
  call unit_assert_equal_within('fgsl_qrng_clone',qd,qd_copy,eps10)
! ran
  call fgsl_rng_free(r)
  r = fgsl_rng_alloc(t)
  rd = fgsl_ran_gaussian(r,1.5d0)
  call unit_assert_equal_within('fgsl_ran_gaussian',&
       0.2008779121780138d0,rd,eps10)
  rd = fgsl_ran_gaussian_pdf(2.0d0,1.5d0)
  call unit_assert_equal_within('fgsl_ran_gaussian_pdf',&
       0.1093400497839958d0,rd,eps10)
  rd = fgsl_ran_gaussian_ziggurat(r,1.5d0)
  call unit_assert_equal_within('fgsl_ran_gaussian_ziggurat',&
       -1.0801457088799626d0,rd,eps10)
  rd = fgsl_ran_gaussian_ratio_method(r,1.5d0)
  call unit_assert_equal_within('fgsl_ran_gaussian_ratio_method',&
       1.3425078569348390d0,rd,eps10)
  rd = fgsl_ran_ugaussian(r)
  call unit_assert_equal_within('fgsl_ran_ugaussian',&
       0.7336411072925795d0,rd,eps10)
  rd = fgsl_ran_ugaussian_pdf(2.0d0)
  call unit_assert_equal_within('fgsl_ran_ugaussian_pdf',&
       0.0539909665131881d0,rd,eps10)
  rd = fgsl_ran_ugaussian_ratio_method(r)
  call unit_assert_equal_within('fgsl_ran_ugaussian_ratio_method',&
       0.7630954425575337d0,rd,eps10)
  rd = fgsl_cdf_gaussian_p(2.0d0,1.0d0)
  call unit_assert_equal_within('fgsl_cdf_gaussian_p',&
       0.9772498680518208d0,rd,eps10)
  re = fgsl_cdf_gaussian_q(2.0d0,1.0d0)
  call unit_assert_equal_within('fgsl_cdf_gaussian_q',&
       0.0227501319481792d0,re,eps10)
  rid = fgsl_cdf_gaussian_pinv(rd,1.0d0)
  call unit_assert_equal_within('fgsl_cdf_gaussian_pinv',&
       2.0d0,rid,eps10)
  rie = fgsl_cdf_gaussian_qinv(re,1.0d0)
  call unit_assert_equal_within('fgsl_cdf_gaussian_qinv',&
       2.0d0,rie,eps10)
  rd = fgsl_cdf_ugaussian_p(2.0d0)
  call unit_assert_equal_within('fgsl_cdf_ugaussian_p',&
       0.9772498680518208d0,rd,eps10)
  re = fgsl_cdf_ugaussian_q(2.0d0)
  call unit_assert_equal_within('fgsl_cdf_ugaussian_q',&
       0.0227501319481792d0,re,eps10)
  rid = fgsl_cdf_ugaussian_pinv(rd)
  call unit_assert_equal_within('fgsl_cdf_ugaussian_pinv',&
       2.0d0,rid,eps10)
  rie = fgsl_cdf_ugaussian_qinv(re)
  call unit_assert_equal_within('fgsl_cdf_ugaussian_qinv',&
       2.0d0,rie,eps10)

! 
  call fgsl_rng_free(r)
  call fgsl_rng_free(copy)
  call fgsl_rng_free(clone)
  call fgsl_qrng_free(q)
  call fgsl_qrng_free(qcopy)
  call fgsl_qrng_free(qclone)
!
! Done
!
  call unit_finalize()
end program rng

module mod_error
  use, intrinsic :: iso_c_binding
  use fgsl
  use mod_unit
  implicit none
  character(kind=fgsl_char,len=fgsl_strmax) :: test_message
contains
  subroutine mine_sr(reason, file, line, errno) bind(c)
    type(c_ptr), value :: reason, file
    integer(c_int), value :: line, errno
!
    test_message = fgsl_strerror(errno)
    write(6, *) 'Processed error in ',trim(fgsl_name(file)), ' at line ',line
    write(6, *) 'Reason was: ',trim(fgsl_name(reason))
  end subroutine mine_sr
end module mod_error
program error
  use mod_error
  implicit none
!
  integer(fgsl_int), parameter :: num_tests=10
  integer(fgsl_size_t), parameter :: nmax=10
  type(fgsl_error_handler_t) :: std, off, mine
  type(fgsl_interp) :: interp
  integer :: i, nok
  integer(fgsl_int) :: status
  integer(fgsl_size_t) :: index
  character(kind=fgsl_char, len=fgsl_strmax) :: message
  real(fgsl_double), dimension(10) :: xa, ya
!------------------------------------------------------------------------------
! Testing the Fortran error interface to GSL
!------------------------------------------------------------------------------
  call unit_init(20)
!  write object sizes
! use an interpolation object to test
  do i=1,nmax
     xa(i) = dble(i-1)
     ya(i) = dble(i-1)**3.0_fgsl_double
  end do
!
  std = fgsl_set_error_handler_off()
!
  interp = fgsl_interp_alloc(fgsl_interp_cspline,1_fgsl_size_t)
  call unit_assert_true('fgsl_interp_alloc', &
       .not. fgsl_well_defined(interp), .true.)
  interp = fgsl_interp_alloc(fgsl_interp_cspline,nmax)
  status = fgsl_interp_init(interp,xa,ya,1_fgsl_size_t)
  call unit_assert_equal('fgsl_interp_init:status',fgsl_einval,status)
  message = fgsl_strerror(status)
  call unit_assert_equal('fgsl_interp_init', &
       'invalid argument supplied by user',trim(message))
  status = fgsl_interp_init(interp,xa,ya,nmax)
  call unit_assert_equal('fgsl_interp_init:status',fgsl_success,status)
!
! own error handler
!
  mine = fgsl_error_handler_init(mine_sr)
  off = fgsl_set_error_handler(mine)
  status = fgsl_interp_init(interp,xa,ya,1_fgsl_size_t)
!  write(6, *) trim(test_message)
  call unit_assert_equal('fgsl_interp_init:own handler', &
       'invalid argument supplied by user',trim(test_message))
!  need to build with preprocessing for next line
  call fgsl_error("my_own_call",__FILE__,__LINE__,2)
!  call fgsl_error("my_own_call","error.f90",80,2)
  write(6, *) trim(test_message)
  call unit_assert_equal('fgsl_interp_init:own handler', &
       'output range error',trim(test_message))
  write(6, *) 'now check GSL-internal abort ...'
!
! Done
!
  call unit_finalize() 
  flush(6)
!
! Copy back standard handler 
!
  call fgsl_interp_free(interp)
  off = fgsl_set_error_handler(std)
  interp = fgsl_interp_alloc(fgsl_interp_cspline,1_fgsl_size_t)
! the following lines should not be reached
  call unit_init(1)
  call unit_assert_equal('fgsl_interp_alloc:nofail',0,1)
  call unit_finalize() 
end program error

program interp
  use mod_unit
  use fgsl
  implicit none
  integer(fgsl_size_t), parameter :: nmax = 10
  real(fgsl_double), parameter :: eps10 = 1.0E-10_fgsl_double
  integer(fgsl_int) :: status
  type(fgsl_interp_accel) :: acc
  type(fgsl_interp) :: a_interp
  type(fgsl_spline) :: spline
  integer :: i, index
  character(kind=fgsl_char,len=fgsl_strmax) :: name
  real(fgsl_double), dimension(nmax) :: xa, ya, d, d2, di, ra_e, rda_e, rd2a_e, ri_e
  real(fgsl_double) :: dmx, ra, rda, rd2a, ri

!
! Test interpolation API
!
  call unit_init(15)
!
  do i=1,nmax
     xa(i) = dble(i-1)
     ya(i) = dble(i-1)**3.0_fgsl_double
     d(i) =  3.0_fgsl_double * dble(i-1)**2.0_fgsl_double
     d2(i) =  6.0_fgsl_double * dble(i-1)
     di(i) =  1/4.0_fgsl_double * dble(i-1)**4.0_fgsl_double
  end do
  acc = fgsl_interp_accel_alloc()
  call unit_assert_true('fgsl_interp_accel_alloc',fgsl_well_defined(acc),.true.)
  a_interp = fgsl_interp_alloc(fgsl_interp_cspline,nmax)
  call unit_assert_true('fgsl_interp_alloc',fgsl_well_defined(a_interp),.true.)
  name = fgsl_interp_name(a_interp)
  call unit_assert_equal('fgsl_interp_alloc','cspline',name)
  status = fgsl_interp_init(a_interp,xa,ya,nmax)
  call unit_assert_equal('fgsl_interp_init',fgsl_success,status)
  dmx = 0.0d0
  do i=2,nmax
     ra = fgsl_interp_eval(a_interp, xa, ya, xa(i), acc)
     status = fgsl_interp_eval_e(a_interp, xa, ya, xa(i), acc, ra_e(i))
     rda = fgsl_interp_eval_deriv(a_interp, xa, ya, xa(i), acc)
     status = fgsl_interp_eval_deriv_e(a_interp, xa, ya, xa(i), acc, rda_e(i))
     rd2a = fgsl_interp_eval_deriv2(a_interp, xa, ya, xa(i), acc)
     status = fgsl_interp_eval_deriv2_e(a_interp, xa, ya, xa(i), acc, rd2a_e(i))
     ri = fgsl_interp_eval_integ(a_interp, xa, ya, 0.0_fgsl_double, xa(i), acc)
     status = fgsl_interp_eval_integ_e(a_interp, xa, ya, 0.0_fgsl_double, xa(i), &
          acc, ri_e(i))
     dmx = max(dmx, abs(ra - ya(i)))
     dmx = max(dmx, abs(rda - rda_e(i)))
     dmx = max(dmx, abs(rd2a - rd2a_e(i)))
     dmx = max(dmx, abs(ri - ri_e(i)))
!     write(6, fmt='(1pd20.13,1x)') ra
!     write(6, fmt='(2(1pd20.13,1x))') xa(i),ya(i)
  end do
  call unit_assert_equal_within('fgsl_interp_eval',0.0d0,dmx,eps10)
  call fgsl_interp_free(a_interp)
!
  spline = fgsl_spline_alloc(fgsl_interp_cspline,nmax)
  call unit_assert_true('fgsl_spline_alloc',fgsl_well_defined(spline),.true.)
  name = fgsl_spline_name(spline)
  call unit_assert_equal('fgsl_spline_alloc','cspline',name)
  status = fgsl_spline_init(spline,xa,ya,nmax)
  call unit_assert_equal('fgsl_interp_init',fgsl_success,status)
  dmx = 0.0d0
  do i=2,nmax
     ra = fgsl_spline_eval(spline, xa(i), acc)
     rda = fgsl_spline_eval_deriv(spline, xa(i), acc)
     rd2a = fgsl_spline_eval_deriv2(spline, xa(i), acc)
     ri = fgsl_spline_eval_integ(spline, 0.0_fgsl_double, xa(i), acc)
     dmx = max(dmx, abs(ra - ya(i)))
     dmx = max(dmx, abs(rda - rda_e(i)))
     dmx = max(dmx, abs(rd2a - rd2a_e(i)))
     dmx = max(dmx, abs(ri - ri_e(i)))
  end do
  call unit_assert_equal_within('fgsl_spline_eval',0.0d0,dmx,eps10)
  index = fgsl_spline_min_size(spline)
  call unit_assert_equal('fgsl_interp_init',3,index)
  
  call fgsl_spline_free(spline)
!
  a_interp = fgsl_interp_alloc(fgsl_interp_polynomial,nmax)
  name = fgsl_interp_name(a_interp)
  call unit_assert_equal('fgsl_interp_alloc','polynomial',name)
  status = fgsl_interp_init(a_interp,xa,ya,nmax)
  call unit_assert_equal('fgsl_interp_init',fgsl_success,status)
  dmx = 0.0d0
  do i=2,nmax
     ra = fgsl_interp_eval(a_interp, xa, ya, xa(i), acc)
     rda = fgsl_interp_eval_deriv(a_interp, xa, ya, xa(i), acc)
     rd2a = fgsl_interp_eval_deriv2(a_interp, xa, ya, xa(i), acc)
     ri = fgsl_interp_eval_integ(a_interp, xa, ya, 0.0_fgsl_double, xa(i), acc)
!     write(6, fmt='(4(1pd20.13,1x))') ra, rda, rd2a, ri
!     write(6, fmt='(4(1pd20.13,1x))') ya(i),d(i),d2(i), di(i)
     dmx = max(dmx, abs(ra - ya(i)))
     dmx = max(dmx, abs(rda - d(i)))
     dmx = max(dmx, abs(rd2a - d2(i)))
     dmx = max(dmx, abs(ri - di(i)))
  end do
  call unit_assert_equal_within('fgsl_interp_eval',0.0d0,dmx,eps10)
  call fgsl_interp_free(a_interp)
!
  index = fgsl_interp_bsearch(xa, 1.5_fgsl_double,1_fgsl_size_t,nmax)
  call unit_assert_equal('fgsl_interp_bsearch',2,index)
  index = fgsl_interp_accel_find(acc, xa, nmax, 1.5_fgsl_double)
  call unit_assert_equal('fgsl_interp_accel_find',2,index)
  call fgsl_interp_accel_free(acc)
!
! Done
!
  call unit_finalize()
end program interp

program test_fgsl
!------------------------------------------------------------------------------
! Testing the Fortran interface to GSL
!------------------------------------------------------------------------------
  use fgsl
  use tmod
  implicit none
! 
  integer(fgsl_size_t), parameter :: nmax = 10, lda = 4, nfmax=19, ntmax=120
  integer, parameter :: num_tests=1000, itmax_root = 50
  real(fgsl_double), parameter :: eps = 1.0d-10
  real(fgsl_double), parameter :: eps2 = 1.0d-5, eps3 = 1.0d-3
  type(fgsl_function) :: stdfunc
  type(fgsl_function_fdf) :: stdfunc_fdf
  type(fgsl_error_handler_t) :: std
  type(fgsl_interp_accel) :: acc
  type(fgsl_interp) :: interp
  type(fgsl_spline) :: spline
  type(fgsl_poly_complex_workspace) :: wk
  type(fgsl_sf_result) :: sfres
  type(fgsl_vector) :: cvec, fvec, xvec, yvec, wvec, step
  type(fgsl_matrix) :: fmat, cov
!
  type(fgsl_permutation) :: p1, p2
  type(fgsl_integration_workspace) :: integ_wk
  type(fgsl_rng) :: rng
  type(fgsl_rng_type) :: rng_type
  type(fgsl_ntuple) :: ntuple
  type(fgsl_histogram) :: hist
  type(fgsl_siman_params_t) :: siman_params
  type(fgsl_odeiv_step) :: ode_step
  type(fgsl_odeiv_control) :: ode_ctrl
  type(fgsl_odeiv_evolve) :: ode_evlv
  type(fgsl_odeiv_system) :: ode_system
  type(fgsl_root_fsolver) :: root_fslv
  type(fgsl_root_fdfsolver) :: root_fdfslv
  type(fgsl_multiroot_fsolver) :: mroot_fslv
  type(fgsl_multiroot_function) :: mroot_f
  type(fgsl_multiroot_fdfsolver) :: mroot_fdfslv
  type(fgsl_multiroot_function_fdf) :: mroot_fdf
  type(fgsl_multimin_fminimizer) :: mmin_fmin
  type(fgsl_multimin_function) :: mmin_f
  type(fgsl_multimin_fdfminimizer) :: mmin_fdfmin
  type(fgsl_multimin_function_fdf) :: mmin_fdf
  type(fgsl_min_fminimizer) :: min_fslv
  type(fgsl_multifit_linear_workspace) :: lfit_ws
  type(fgsl_multifit_function_fdf) :: nlfit_fdf
  type(fgsl_multifit_fdfsolver) :: nlfit_slv
!
  type(fgsl_file) :: tfile
  character(kind=fgsl_char,len=fgsl_strmax) :: ieee_str1, ieee_str2
!
  type(data), target :: fitdata
!
  type(c_ptr) :: ptr, par_ptr
  integer :: i, j, nok
  integer(fgsl_int) :: status
  integer(fgsl_size_t) :: index, ivals(nmax), nsrt, istr, nrt
  integer(fgsl_size_t), pointer :: p_data(:)
  integer(fgsl_long) :: iarr(nmax),iarrdest(nmax)
  character(kind=fgsl_char, len=fgsl_strmax) :: name
  real(fgsl_double), dimension(nmax), target :: xa
  real(fgsl_double), dimension(nmax) :: ya, d, d2, di
  real(fgsl_double), dimension(lda, nmax), target :: a2d
  real(fgsl_double), dimension(3, nfmax), target :: xmf
  real(fgsl_double), dimension(3, ntmax) :: cmfstore
  real(fgsl_double), dimension(nfmax), target :: ymf, wmf
  real(fgsl_double), dimension(3), target :: cmf
  real(fgsl_double), dimension(3,3), target :: covmf
  real(fgsl_double), dimension(lda, nmax) :: b
  real(fgsl_double), pointer :: xptr(:), fptr(:), fmptr(:,:)
  real(c_double) :: y(2), dydt(2)
  real(c_double), target :: fpar(3), sarr(nmax), sarrdest(nmax)
  real(c_double), target :: xx, xv(3), stepv(2)
  real(fgsl_double) :: ra, rda, rd2a, ri, dmx, vmx, t, t1, h, xlo, xhi, &
        result, abserr, c0, c1, cov00, cov01, cov10, cov11, chisq
  complex(fgsl_double) :: z0, z1, z2, z(nmax)
  real(fgsl_float) :: ts
  logical :: test_ok, ok(num_tests)
!
  std = fgsl_set_error_handler_off()
  ok = .true.
  test_ok = .true.
  nok = 1
! NOTE: call of fdf_min routines gives float invalid/underflow
! the following attempts to suppress this
! (export GSL_IEEE_MODE="mask-invalid,mask-underflow,mask-denormalized")
! Need to check how to handle this in a better way
! (NAG aborts, g95 doesn't, bug in GSL????)
  call fgsl_ieee_env_setup()
!
! Polynomials
!
  d(1:2) = (/1.0_fgsl_double, 2.0_fgsl_double/)
  rda = fgsl_poly_eval(d, 2, 2.0_fgsl_double)
!  write(6, *) 'rda = ',rda, '(5?)'
  if (abs(rda - 5.0d0) > eps) test_ok = .false.
  
  call testres_toggle('fgsl_poly_eval',test_ok,ok,nok)
!
  xa(1:3) =  (/1.0_fgsl_double, 2.0_fgsl_double, 3.0_fgsl_double/)
  ya(1:3) =  (/1.0_fgsl_double, 8.0_fgsl_double, 3.0_fgsl_double/)
  status = fgsl_poly_dd_init(d2, xa, ya, 3_fgsl_size_t)
  rda = fgsl_poly_dd_eval(d2, xa, 3_fgsl_size_t, 2.0_fgsl_double)
!  write(6, *) 'rda = ',rda, '(8?)'
  if (abs(rda - 8.0d0) > eps .or. status /= fgsl_success) test_ok = .false.
  call testres_toggle('fgsl_poly_dd_init',test_ok,ok,nok)
!
  status = fgsl_poly_dd_taylor(di, 0.0_fgsl_double, d2, xa, 3_fgsl_size_t, d) 
  rda = di(1) + 2.0d0 * di(2) + 4.0d0 * di(3)
!  write(6, *) 'rda = ',rda, '(8?)'
  if (abs(rda - 8.0d0) > eps .or. status /= fgsl_success) test_ok = .false.
  call testres_toggle('fgsl_poly_dd_taylor',test_ok,ok,nok)
!
  status = fgsl_poly_solve_quadratic(1.0_fgsl_double, -3.0_fgsl_double, &
       2.0_fgsl_double, ra, ri)
!  write(6, *) 'ra = ',ra, '(1?); ri = ',ri, '(2?); status = ', status
  if (abs(ra - 1.0d0) > eps .or. abs(ri - 2.0d0) > eps .or. &
       status /= 2) test_ok = .false.
  call testres_toggle('fgsl_poly_solve_quadratic',test_ok,ok,nok)
!
  status = fgsl_poly_complex_solve_quadratic(1.0_fgsl_double,0.0_fgsl_double, &
       1.0_fgsl_double, z0, z1)
  if ( abs(z0 + (0.0d0,1.0d0)) > eps .or. abs(z1 - (0.0d0,1.0d0)) > eps &
       .or. status /= 2) test_ok = .false.
  call testres_toggle('fgsl_poly_complex_solve_quadratic',test_ok,ok,nok)
!
  status = fgsl_poly_solve_cubic(-6.0_fgsl_double,11.0_fgsl_double, &
       -6.0_fgsl_double, ra, ri, dmx)
 ! write(6, *) 'ra = ',ra, '(1?); ri = ',ri, '(2?); dmx = ',dmx, &
 !      '(3?); status = ', status
  if (abs(ra - 1.0d0) > eps .or. abs(ri - 2.0d0) > eps .or. &
       abs(dmx - 3.0d0) > eps .or. status /= 3) test_ok = .false.
  call testres_toggle('fgsl_poly_solve_cubic',test_ok,ok,nok)
!
  status = fgsl_poly_complex_solve_cubic(0.0_fgsl_double,0.0_fgsl_double, &
       -1.0_fgsl_double, z0, z1, z2)
  if ( abs(z0 - cos(2.0d0*m_pi/3.0d0) + (0.0d0,1.0d0)*sin(2.0d0*m_pi/3.0d0)) > eps &
       .or. abs(z2 - 1.0d0) > eps .or. abs(z1 - cos(2.0d0*m_pi/3.0d0) - &
       (0.0d0,1.0d0)*sin(2.0d0*m_pi/3.0d0)) > eps .or. status /= 3) test_ok = .false.
  call testres_toggle('fgsl_poly_complex_solve_cubic',test_ok,ok,nok)
!
  wk = fgsl_poly_complex_workspace_alloc(4_fgsl_size_t)
  status = -1
  xa(1:4) =  (/-1.0_fgsl_double, 0.0_fgsl_double, 0.0_fgsl_double, 1.0_fgsl_double/)
  if (.not. fgsl_well_defined(wk)) then
     test_ok=.false.
  else
     status = fgsl_poly_complex_solve(xa, 4_fgsl_size_t, wk, z)
  end if
!  write(6, *) 'complex roots z: ',z(1:3)
  if  ( abs(z(2) - cos(2.0d0*m_pi/3.0d0) + (0.0d0,1.0d0)*sin(2.0d0*m_pi/3.0d0)) > eps &
       .or. abs(z(3) - 1.0d0) > eps .or. abs(z(1) - cos(2.0d0*m_pi/3.0d0) - &
       (0.0d0,1.0d0)*sin(2.0d0*m_pi/3.0d0)) > eps .or. status /= fgsl_success) test_ok = .false.
  call fgsl_poly_complex_workspace_free(wk)
  call testres_toggle('fgsl_poly_complex_solve',test_ok,ok,nok)
!
! Special Functions
!
  ra = fgsl_sf_airy_ai(0.0_fgsl_double, fgsl_prec_double) 
  if (abs(ra - 0.35502805d0) > 1.0d-7) test_ok = .false.
  call testres_toggle('fgsl_sf_airy_ai',test_ok,ok,nok)
  status = fgsl_sf_airy_ai_e(0.0_fgsl_double, fgsl_prec_double, sfres)
  if (status /= fgsl_success .or. &
       abs(sfres%val - 0.3550280538878172d0) > sfres%err) test_ok = .false.
!  write(6, *) 'val/err was ',sfres
  call testres_toggle('fgsl_sf_airy_ai_e',test_ok,ok,nok)
  ra = fgsl_sf_airy_bi(0.0_fgsl_double, fgsl_prec_double) 
  if (abs(ra - 0.61492663d0) > 1.0d-7) test_ok = .false.
  call testres_toggle('fgsl_sf_airy_bi',test_ok,ok,nok)
  status = fgsl_sf_airy_bi_e(0.0_fgsl_double, fgsl_prec_double, sfres)
  if (status /= fgsl_success .or. &
       abs(sfres%val - 0.6149266274460007d0) > sfres%err) test_ok = .false.
!  write(6, *) 'val/err was ',sfres
  call testres_toggle('fgsl_sf_airy_bi_e',test_ok,ok,nok)
  status = fgsl_sf_airy_bi_e(0.0_fgsl_double, fgsl_prec_single, sfres)
  if (status /= fgsl_success .or. &
       abs(sfres%val - 0.6149266274460007d0) > sfres%err) test_ok = .false.
!  write(6, *) 'val/err was ',sfres
  call testres_toggle('fgsl_sf_airy_bi_e (single)',test_ok,ok,nok)
  status = fgsl_sf_airy_bi_e(0.0_fgsl_double, fgsl_prec_approx, sfres)
  if (status /= fgsl_success .or. &
       abs(sfres%val - 0.6149266274460007d0) > sfres%err) test_ok = .false.
!  write(6, *) 'val/err was ',sfres
  call testres_toggle('fgsl_sf_airy_bi_e (approx)',test_ok,ok,nok)
! FIXME  here many tests are missing still
  ra = fgsl_sf_bessel_jc0(1.0_fgsl_double) 
  if (abs(ra - 0.765197686557967d0) > eps) test_ok = .false.
  call testres_toggle('fgsl_sf_bessel_jc0',test_ok,ok,nok)
  ra = fgsl_sf_bessel_jc1(1.0_fgsl_double) 
  if (abs(ra - 0.4400505857d0) > eps) test_ok = .false.
  call testres_toggle('fgsl_sf_bessel_jc1',test_ok,ok,nok)
  ra = fgsl_sf_bessel_yc0(1.0_fgsl_double) 
  if (abs(ra - 0.0882569642d0) > eps) test_ok = .false.
  call testres_toggle('fgsl_sf_bessel_yc0',test_ok,ok,nok)
  ra = fgsl_sf_bessel_js0(1.0_fgsl_double) 
  if (abs(ra - 0.84147098d0) > 1.0d-7) test_ok = .false.
  call testres_toggle('fgsl_sf_bessel_js0',test_ok,ok,nok)
  ra = fgsl_sf_bessel_js1(1.0_fgsl_double) 
  if (abs(ra - 0.30116868) > 1.0d-7) test_ok = .false.
  call testres_toggle('fgsl_sf_bessel_js1',test_ok,ok,nok)
  ra = fgsl_sf_bessel_js2(1.0_fgsl_double) 
  if (abs(ra - 0.062035052d0) > 1.0d-7) test_ok = .false.
  call testres_toggle('fgsl_sf_bessel_js2',test_ok,ok,nok)
  ra = fgsl_sf_bessel_ys0(1.0_fgsl_double) 
  if (abs(ra + 0.54030231d0) > 1.0d-7) test_ok = .false.
  call testres_toggle('fgsl_sf_bessel_ys0',test_ok,ok,nok)
! elliptic functions
  ra = fgsl_sf_ellint_kcomp(0.5_fgsl_double, fgsl_prec_double) 
!  write(6, *) 'ra = ', ra
  if (abs(ra - 1.685750354812596d0) > eps) test_ok = .false.
  call testres_toggle('fgsl_sf_ellint_kcomp',test_ok,ok,nok)
  ra = fgsl_sf_ellint_ecomp(0.5_fgsl_double, fgsl_prec_double) 
!  write(6, *) 'ra = ', ra
  if (abs(ra - 1.46746220933d0) > eps) test_ok = .false.
  call testres_toggle('fgsl_sf_ellint_ecomp',test_ok,ok,nok)
  ra = fgsl_sf_ellint_f(m_pi/2,0.5_fgsl_double, fgsl_prec_double) 
!  write(6, *) 'ra = ', ra
  if (abs(ra - 1.685750354812596d0) > eps) test_ok = .false.
  call testres_toggle('fgsl_sf_ellint_f',test_ok,ok,nok)
  ra = fgsl_sf_ellint_e(m_pi/2, 0.5_fgsl_double, fgsl_prec_double) 
!  write(6, *) 'ra = ', ra
  if (abs(ra - 1.46746220933d0) > eps) test_ok = .false.
  call testres_toggle('fgsl_sf_ellint_e',test_ok,ok,nok)
  ra = fgsl_sf_ellint_p(m_pi/2, dsqrt(0.75d0), -0.5_fgsl_double, fgsl_prec_double) 
!  write(6, *) 'ra = ', ra
  if (abs(ra - 3.234773471249465d0) > eps) test_ok = .false.
  call testres_toggle('fgsl_sf_ellint_e',test_ok,ok,nok)
!
! Array processing
!
! vector
  do i=1,nmax
     xa(i) = dble(i)
  end do
  fvec = fgsl_vector_init(1.0_fgsl_double)
  status = fgsl_vector_align(xa,nmax,fvec,3_fgsl_size_t,1_fgsl_size_t,&
       2_fgsl_size_t)
!  write(6, *) 'Status: ',status,fgsl_success
  if (status /= fgsl_success) test_ok = .false.
  ya(1:3) = fvec
!  write(6, *) 'ya: ',ya(1:3)
  if (abs(ya(1)-2.0_fgsl_double) > eps .or. abs(ya(2)-4.0_fgsl_double) > eps .or. &
       abs(ya(3)-6.0_fgsl_double) > eps)  test_ok = .false.
  status = fgsl_vector_align(fptr,fvec)
  if (abs(fptr(1)-2.0_fgsl_double) > eps .or. abs(fptr(2)-4.0_fgsl_double) > eps .or. &
       abs(fptr(3)-6.0_fgsl_double) > eps .or. size(fptr) /= 3)  test_ok = .false.
  call fgsl_vector_free(fvec)
  call testres_toggle('fgsl_vector',test_ok,ok,nok)
! matrix
  do j=1,6
     do i=1,3
        a2d(i, j) = 10*j+i
     end  do
  end do
  fmat = fgsl_matrix_init(1.0_fgsl_double)
  status = fgsl_matrix_align(a2d, lda, 3_fgsl_size_t,6_fgsl_size_t,fmat)
  if (status /= fgsl_success) test_ok = .false.
  b(1:3,1:6) = fmat
  dmx = 0.0_fgsl_double
  do j=1,6
     do i=1,3
!        write(6, *) 'i, j, a, b: ', i, j, a2d(i, j), b(i, j)
        dmx = dmx + abs(b(i, j) - dble(10*j+i))
!        write(6, *) 'dmx : ', dmx
     end  do
  end do
  if (dmx > eps)  test_ok = .false.
  status = fgsl_matrix_align(fmptr,fmat)
  if (size(fmptr,1) /= 3 .or. size(fmptr,2) /= 6) test_ok = .false.
  dmx = 0.0_fgsl_double
  do j=1,6
     do i=1,3
        dmx = dmx + abs(fmptr(i, j) - dble(10*j+i))
     end  do
  end do
  if (dmx > eps)  test_ok = .false.
  call fgsl_matrix_free(fmat)
  call testres_toggle('fgsl_matrix',test_ok,ok,nok)
!
! Interpolation
!   not all interpolation types are checked since interface is invariant
!
  do i=1,nmax
     xa(i) = dble(i-1)
     ya(i) = dble(i-1)**3.0_fgsl_double
     d(i) =  3.0_fgsl_double * dble(i-1)**2.0_fgsl_double
     d2(i) =  6.0_fgsl_double * dble(i-1)
     di(i) =  1/4.0_fgsl_double * dble(i-1)**4.0_fgsl_double
  end do
! this only needed once
  acc = fgsl_interp_accel_alloc()
! cspline
  interp = fgsl_interp_alloc(fgsl_interp_cspline,nmax)
  name = fgsl_interp_name(interp)
!  write(6, *) name
  status = fgsl_interp_init(interp,xa,ya,nmax)
  dmx = 0.0d0
  do i=2,nmax
     ra = fgsl_interp_eval(interp, xa, ya, xa(i), acc)
     rda = fgsl_interp_eval_deriv(interp, xa, ya, xa(i), acc)
     rd2a = fgsl_interp_eval_deriv2(interp, xa, ya, xa(i), acc)
!     write(6, fmt='(3(1pd20.13,1x))') ra, rda, rd2a
!     write(6, fmt='(3(1pd20.13,1x))') ya(i),d(i),d2(i)
     dmx = max(dmx, abs(ra - ya(i)))
  end do
  call fgsl_interp_free(interp)
! write(6, *) 'Name is: ',trim(name)
  if (dmx > eps .or. trim(name) /= 'cspline') test_ok = .false.
  call testres_toggle('fgsl_interp',test_ok,ok,nok)
! cspline high-level interface
  spline = fgsl_spline_alloc(fgsl_interp_cspline,nmax)
  name = fgsl_spline_name(spline)
!  write(6, *) name
  status = fgsl_spline_init(spline,xa,ya,nmax)
  dmx = 0.0d0
  do i=2,nmax
     ra = fgsl_spline_eval(spline, xa(i), acc)
     rda = fgsl_spline_eval_deriv(spline, xa(i), acc)
     rd2a = fgsl_spline_eval_deriv2(spline, xa(i), acc)
     ri = fgsl_spline_eval_integ(spline, 0.0_fgsl_double, xa(i), acc)
!     write(6, fmt='(3(1pd20.13,1x))') ra, rda, rd2a
!     write(6, fmt='(3(1pd20.13,1x))') ya(i),d(i),d2(i)
     dmx = max(dmx, abs(ra - ya(i)))
  end do
  call fgsl_spline_free(spline)
  if (dmx > eps .or. trim(name) /= 'cspline') test_ok = .false.
  call testres_toggle('fgsl_spline',test_ok,ok,nok)
! polynomial
  interp = fgsl_interp_alloc(fgsl_interp_polynomial,4_fgsl_size_t)
  name = fgsl_interp_name(interp)
!  write(6, *) name
  status = fgsl_interp_init(interp,xa,ya,4_fgsl_size_t)
  dmx = 0.0d0
  do i=2,nmax
     ra = fgsl_interp_eval(interp, xa, ya, xa(i), acc)
     rda = fgsl_interp_eval_deriv(interp, xa, ya, xa(i), acc)
     rd2a = fgsl_interp_eval_deriv2(interp, xa, ya, xa(i), acc)
     ri = fgsl_interp_eval_integ(interp, xa, ya, 0.0_fgsl_double, xa(i), acc)
!     write(6, fmt='(4(1pd20.13,1x))') ra, rda, rd2a, ri
!     write(6, fmt='(4(1pd20.13,1x))') ya(i),d(i),d2(i), di(i)
     dmx = max(dmx, abs(ra - ya(i)))
     dmx = max(dmx, abs(rda - d(i)))
     dmx = max(dmx, abs(rd2a - d2(i)))
     dmx = max(dmx, abs(ri - di(i)))
  end do
  call fgsl_interp_free(interp)
  if (dmx > eps .or. trim(name) /= 'polynomial') test_ok = .false.
  call testres_toggle('fgsl_interp-2',test_ok,ok,nok)
! acc routines
  index = fgsl_interp_bsearch(xa, 1.5_fgsl_double,1_fgsl_size_t,nmax)
!  write(6, *) 'bsearch: index is ', index
  if (index /= 2)  test_ok = .false.
  call testres_toggle('fgsl_interp_bsearch',test_ok,ok,nok)
  index = fgsl_interp_accel_find(acc, xa, nmax, 1.5_fgsl_double)
!  write(6, *) 'find: index is ', index
  if (index /= 2)  test_ok = .false.
  call testres_toggle('fgsl_interp_accel_find',test_ok,ok,nok)
! cleanup
  call fgsl_interp_accel_free(acc)
!
! Permutations and combinations
!
  if (fgsl_well_defined(p1)) test_ok = .false.
  p1 = fgsl_permutation_alloc(4_fgsl_size_t)
  p2 = fgsl_permutation_alloc(4_fgsl_size_t)
  if (.not. (fgsl_well_defined(p1) .and. fgsl_well_defined(p2))) test_ok = .false.
  call fgsl_permutation_init(p1)
  call fgsl_permutation_init(p2)
  status = fgsl_permutation_swap(p1, 1_fgsl_size_t, 3_fgsl_size_t)
  index = fgsl_permutation_get(p1,1_fgsl_size_t)
  if (index /= 3) test_ok = .false.
  index = fgsl_permutation_get(p1,3_fgsl_size_t)
  if (index /= 1) test_ok = .false.
  status = fgsl_permutation_valid(p1)
  if (status /= fgsl_success) test_ok = .false.
  index = fgsl_permutation_size(p1)
  if (index /= 4) test_ok = .false.
!  write(6, *) 'Index = ',index
  p_data => fgsl_permutation_data(p1)
!  write(6, *) 'Size p_data is',size(p_data),associated(p_data)
  if (p_data(1) /= 0 .or. p_data(2) /= 3 .or. &
       p_data(3) /= 2 .or. p_data(4) /= 1) test_ok = .false.
  call testres_toggle('fgsl_permutation',test_ok,ok,nok)
!  write(6, *) 'permutations done'
  call fgsl_permutation_free(p1)
  call fgsl_permutation_free(p2)
!
! numerical quadrature
!
  xx = 1.0D0
  ptr = c_loc(xx)
  stdfunc = fgsl_function_init(integrate_fun1, ptr)
  integ_wk = fgsl_integration_workspace_alloc(1000_fgsl_size_t)
  status = fgsl_integration_qags(stdfunc, 0.0_fgsl_double, 1.0_fgsl_double, &
       0.0_fgsl_double, 1.0e-7_fgsl_double, 1000_fgsl_size_t, integ_wk, ra, rda); 
  if (status /= fgsl_success) test_ok = .false.
!  write(6, *) 'Integration result and error: ', ra, rda
  if (abs(ra + 4.0d0) > eps) test_ok = .false.
  call fgsl_function_free(stdfunc)
  call fgsl_integration_workspace_free(integ_wk)
  call testres_toggle('fgsl_integration',test_ok,ok,nok)
!
! histograms
!
  hist = fgsl_histogram_alloc(ntmax)
  if (fgsl_well_defined(hist)) then
     status = fgsl_histogram_set_ranges_uniform(hist, 0.0_fgsl_double, 3.6_fgsl_double)
     if (status /= fgsl_success) test_ok = .false.
     t = 0.1_fgsl_double
     do i=1, ntmax
        ra = sqrt(t)
        status = fgsl_histogram_increment(hist, ra)
        if (status /= fgsl_success) then
           test_ok = .false.
           exit
        end if
        t = t + 0.1_fgsl_double
     end do
  else
     test_ok = .false.
  end if
  tfile = fgsl_open('hist.dat','w+')
  status = fgsl_histogram_fprintf(tfile,hist,'%16.8f ','%16.8f ')
  status = fgsl_close(tfile)
  open(20, file='hist.dat',form='FORMATTED',status='OLD')
  do i=1, 115
     read(20, fmt=*) cmf
!     write(6, '(3(1PD15.8,1X))') cmf
  end do
  if (abs(cmf(1) - 3.42_fgsl_double) > eps .or. &
       abs(cmf(2) - 3.45_fgsl_double) > eps .or. &
       abs(cmf(3) - 3.0_fgsl_double) > eps) test_ok = .false.
!  close(20, status='DELETE')
  call fgsl_histogram_free(hist)
  call testres_toggle('fgsl_histogram',test_ok,ok,nok)
!
! Ntuples
!
  ptr = c_loc(cmf)
  ntuple = fgsl_ntuple_create('test.dat',ptr,24_fgsl_size_t)
  if (.not. fgsl_well_defined(ntuple)) test_ok = .false.
  rng = fgsl_rng_alloc(fgsl_rng_default)
  do i=1, ntmax
     cmf(1) = fgsl_ran_ugaussian(rng)
     cmf(2) = fgsl_ran_ugaussian(rng)
     cmf(3) = fgsl_ran_ugaussian(rng)
     cmfstore(1:3,i) = cmf
!     write(6, *) cmf
     status = fgsl_ntuple_write(ntuple)
     if (status /= fgsl_success) test_ok = .false.
  end do
  status = fgsl_ntuple_close(ntuple)
  if (status /= fgsl_success) test_ok = .false.
  ntuple = fgsl_ntuple_open('test.dat',ptr,24_fgsl_size_t)
  if (fgsl_well_defined(ntuple)) then
     do i=1, ntmax
        status = fgsl_ntuple_read(ntuple)
        dmx = abs(cmf(1)-cmfstore(1,i)) + &
             abs(cmf(2)-cmfstore(2,i)) + &
             abs(cmf(3)-cmfstore(3,i))
        if (dmx > eps) test_ok = .false.
     end do
     status = fgsl_ntuple_close(ntuple)
     if (status /= fgsl_success) test_ok = .false.
  else
     test_ok = .false.
  end if
  open(20,file='test.dat',form='FORMATTED',status='OLD')
  close(20,status='DELETE')
! FIXME test further ntuple stuff 
  call fgsl_rng_free(rng)
  call testres_toggle('fgsl_ntuple',test_ok,ok,nok)
!
! Sorting
!
  nsrt = 5
  istr = 1
  sarr(1:nsrt) = (/2.0_fgsl_double, 2.2_fgsl_double, -2.0_fgsl_double, -4.0_fgsl_double, &
       5.2_fgsl_double/)
  ptr = c_loc(sarr)
! FIXME fgsl_sizeof missing
  call fgsl_heapsort(ptr, nsrt, 8_fgsl_size_t, compare_double)
  if (sarr(1) /= -4.0_fgsl_double .or. sarr(2) /= -2.0_fgsl_double .or. &
       sarr(3) /= 2.0_fgsl_double .or. sarr(4) /= 2.2_fgsl_double .or. &
       sarr(5) /= 5.2_fgsl_double) test_ok = .false.
!  write(6, *) 'sarr = ',sarr(1:nsrt)
  sarr(1:nsrt) = (/2.0_fgsl_double, 2.2_fgsl_double, -2.0_fgsl_double, -4.0_fgsl_double, &
       5.2_fgsl_double/)
  status = fgsl_heapsort_index(ivals, ptr, nsrt, 8_fgsl_size_t, compare_double)
  if (ivals(1) /= 3 .or. ivals(2) /= 2 .or. ivals(3) /= 0 .or. ivals(4) /= 1 .or. &
       ivals(5) /= 4 .or. status /= fgsl_success) test_ok = .false.
  call testres_toggle('fgsl_heapsort',test_ok,ok,nok)
  nsrt = 3
  istr = 2
  sarr(1:6) = (/2.0_fgsl_double, 0.2_fgsl_double, -2.0_fgsl_double, 0.2_fgsl_double, &
       0.2_fgsl_double, 3.3_fgsl_double/)
  call fgsl_sort(sarr, istr, nsrt)
  if (sarr(1) /= -2.0_fgsl_double .or. sarr(2) /= 0.2_fgsl_double .or. &
       sarr(3) /= 0.2_fgsl_double .or. sarr(4) /= 0.2_fgsl_double .or. &
       sarr(5) /= 2.0_fgsl_double .or. sarr(6) /= 3.3_fgsl_double) test_ok = .false.
  nsrt = 5
  istr = 1
  sarr(1:nsrt) = (/2.0_fgsl_double, 2.2_fgsl_double, -2.0_fgsl_double, -4.0_fgsl_double, &
       5.2_fgsl_double/)
  call fgsl_sort_index(ivals,sarr, istr, nsrt)
  if (ivals(1) /= 3 .or. ivals(2) /= 2 .or. ivals(3) /= 0 .or. ivals(4) /= 1 .or. &
       ivals(5) /= 4 .or. status /= fgsl_success) test_ok = .false.
  status = fgsl_sort_smallest(sarrdest, 2_fgsl_size_t, sarr, istr, nsrt)
  if (sarrdest(1) /= -4.0_fgsl_double .or. sarrdest(2) /= -2.0_fgsl_double .or. &
       status /= fgsl_success) test_ok = .false. 
  status = fgsl_sort_smallest_index(ivals, 2_fgsl_size_t, sarr, istr, nsrt)
  if (ivals(1) /= 3 .or. ivals(2) /= 2 .or. status /= fgsl_success) test_ok = .false.
  status = fgsl_sort_largest(sarrdest, 2_fgsl_size_t, sarr, istr, nsrt)
  if (sarrdest(1) /= 5.2_fgsl_double .or. sarrdest(2) /= 2.2_fgsl_double .or. &
       status /= fgsl_success) test_ok = .false. 
  status = fgsl_sort_largest_index(ivals, 2_fgsl_size_t, sarr, istr, nsrt)
  if (ivals(1) /= 4 .or. ivals(2) /= 1 .or. status /= fgsl_success) test_ok = .false.
!
  nsrt = 3
  istr = 2
  iarr(1:6) = (/2_fgsl_long, 0_fgsl_long, -2_fgsl_long, 0_fgsl_long, &
       0_fgsl_long, 3_fgsl_long/)
  call fgsl_sort(iarr, istr, nsrt)
  if (iarr(1) /= -2_fgsl_long .or. iarr(2) /= 0_fgsl_long .or. &
       iarr(3) /= 0_fgsl_long .or. iarr(4) /= 0_fgsl_long .or. &
       iarr(5) /= 2_fgsl_long .or. iarr(6) /= 3_fgsl_long) test_ok = .false.
!  write(6, *) 'iarr is ', iarr(1:6)
  nsrt = 5
  istr = 1
  iarr(1:nsrt) = (/1_fgsl_long, 2_fgsl_long, -2_fgsl_long, -4_fgsl_long, &
       5_fgsl_long/)
  call fgsl_sort_index(ivals,iarr, istr, nsrt)
  if (ivals(1) /= 3 .or. ivals(2) /= 2 .or. ivals(3) /= 0 .or. ivals(4) /= 1 .or. &
       ivals(5) /= 4 .or. status /= fgsl_success) test_ok = .false.
  status = fgsl_sort_smallest(iarrdest, 2_fgsl_size_t, iarr, istr, nsrt)
  if (iarrdest(1) /= -4_fgsl_long .or. iarrdest(2) /= -2_fgsl_long .or. &
       status /= fgsl_success) test_ok = .false. 
  status = fgsl_sort_smallest_index(ivals, 2_fgsl_size_t, iarr, istr, nsrt)
  if (ivals(1) /= 3 .or. ivals(2) /= 2 .or. status /= fgsl_success) test_ok = .false.
  status = fgsl_sort_largest(iarrdest, 2_fgsl_size_t, iarr, istr, nsrt)
  if (iarrdest(1) /= 5_fgsl_long .or. iarrdest(2) /= 2_fgsl_long .or. &
       status /= fgsl_success) test_ok = .false. 
  status = fgsl_sort_largest_index(ivals, 2_fgsl_size_t, iarr, istr, nsrt)
  if (ivals(1) /= 4 .or. ivals(2) /= 1 .or. status /= fgsl_success) test_ok = .false.
  call testres_toggle('fgsl_sort',test_ok,ok,nok)
!
! Simulated Annealing
!
!  rng_type = fgsl_rng_env_setup()
  rng = fgsl_rng_alloc(fgsl_rng_default)
  xx = 15.5_fgsl_double
  ptr = c_loc(xx)
  call fgsl_siman_params_init(siman_params, 200, 10, 10.0_fgsl_double, &
       1.0_fgsl_double, 0.002_fgsl_double, 1.005_fgsl_double, 2.0e-6_fgsl_double) 
!  call fgsl_siman_solve(rng, ptr, e1, s1, m1, pp1, &
  call fgsl_siman_solve(rng, ptr, e1, s1, m1, &
       element_size=8_fgsl_size_t, params=siman_params)
!  write(6, *) xx
  if (abs(xx-1.3633498) > eps2) test_ok = .false.
  call fgsl_siman_params_free(siman_params)
  call fgsl_rng_free(rng)
  call testres_toggle('fgsl_siman',test_ok,ok,nok)
!
! Ordinary Differential Equations 
!
!  ode_step = fgsl_odeiv_step_alloc(fgsl_odeiv_step_rk8pd,2_fgsl_size_t)
! Note: bsimp uses the jacobian and gives consistency indicated below
  ode_step = fgsl_odeiv_step_alloc(fgsl_odeiv_step_bsimp,2_fgsl_size_t)
  name = fgsl_odeiv_step_name(ode_step)
!  write(6, *) 'ode_step_alloc of type ',trim(name),' done'
! FIXME: well_defined checks missing
  ode_ctrl = fgsl_odeiv_control_y_new(1.0e-6_fgsl_double, 0.0_fgsl_double)
  ode_evlv = fgsl_odeiv_evolve_alloc(2_fgsl_size_t)
  xx = 10.0e0_c_double
  ptr = c_loc(xx)
  ode_system = fgsl_odeiv_system_init(func_ode, 2_c_size_t, ptr, jac)
!
  t = 0.0_fgsl_double; t1 = 100.0_fgsl_double
  h = 1.0e-6_fgsl_double; y = (/1.0_c_double, 0.0_c_double /)
  do while (t < t1) 
     status = fgsl_odeiv_evolve_apply(ode_evlv, ode_ctrl, ode_step, ode_system, & 
          t, t1, h, y)
     if (status /= fgsl_success) exit
!     write(6,fmt='(3E15.8,1X)') t, y(1), y(2)
  end do
  call fgsl_odeiv_evolve_free (ode_evlv)
  call fgsl_odeiv_control_free (ode_ctrl)
  call fgsl_odeiv_step_free (ode_step)
  call fgsl_odeiv_system_free(ode_system)
  if (status /= fgsl_success .or. abs(y(1) + 1.758888) > 1.0e-5 .or. &
       abs(y(2) - 0.083643595) > 1.0e-6) test_ok = .false.
  call testres_toggle('fgsl_ode',test_ok,ok,nok)
!
! Numerical differentiation
!
  fpar = (/1.5_fgsl_double, 0.0_fgsl_double, 0.0_fgsl_double/)
  ptr = c_loc(fpar)
  stdfunc = fgsl_function_init(power, ptr)
  status = fgsl_deriv_central(stdfunc, 2.0_fgsl_double, eps2, result, abserr)
  if (status /= fgsl_success .or. abs(result - 1.5d0*sqrt(2.0d0)) > abserr) then
     test_ok = .false.
  end if
  status = fgsl_deriv_forward(stdfunc, 2.0_fgsl_double, eps2, result, abserr)
  if (status /= fgsl_success .or. abs(result - 1.5d0*sqrt(2.0d0)) > abserr) then
     test_ok = .false.
  end if
  status = fgsl_deriv_backward(stdfunc, 2.0_fgsl_double, eps2, result, abserr)
  if (status /= fgsl_success .or. abs(result - 1.5d0*sqrt(2.0d0)) > abserr) then
     test_ok = .false.
  end if
!  write(6, *) result, abserr, 1.5d0*sqrt(2.0d0)
  call fgsl_function_free(stdfunc)
  call testres_toggle('fgsl_deriv',test_ok,ok,nok)
!
! One dimensional root finding
!
  fpar = (/1.0_fgsl_double, 0.0_fgsl_double, -5.0_fgsl_double/)
  ptr = c_loc(fpar)
!
  root_fslv = fgsl_root_fsolver_alloc(fgsl_root_fsolver_brent)
  if (fgsl_well_defined(root_fslv)) then
     stdfunc = fgsl_function_init(quadratic, ptr)
     status = fgsl_root_fsolver_set(root_fslv, stdfunc, 0.0_fgsl_double, &
          5.0_fgsl_double)
     name = fgsl_root_fsolver_name (root_fslv)
     if (trim(name) /= 'brent') test_ok = .false.
     i = 0
     do
        i = i + 1
        status = fgsl_root_fsolver_iterate(root_fslv)
        if (status /= fgsl_success .or. i > itmax_root) then
           test_ok = .false.
           exit
        end if
        ra = fgsl_root_fsolver_root(root_fslv)
        xlo = fgsl_root_fsolver_x_lower(root_fslv)
        xhi = fgsl_root_fsolver_x_upper(root_fslv)
        status = fgsl_root_test_interval (xlo, xhi, 0.0_fgsl_double, eps2)
        if (status == fgsl_success) exit
     end do
  else
     test_ok = .false.
  end if
  if (abs(ra - sqrt(5.0_fgsl_double)) > eps2) test_ok = .false.
  call fgsl_root_fsolver_free(root_fslv)
  call fgsl_function_free(stdfunc)
  call testres_toggle('fgsl_roots',test_ok,ok,nok)
!
  root_fdfslv = fgsl_root_fdfsolver_alloc(fgsl_root_fdfsolver_newton)
  if (fgsl_well_defined(root_fdfslv)) then
     stdfunc_fdf = fgsl_function_fdf_init(quadratic, quadratic_deriv, &
          quadratic_fdf, ptr)
     status = fgsl_root_fdfsolver_set(root_fdfslv, stdfunc_fdf, &
          5.0_fgsl_double)
     name = fgsl_root_fdfsolver_name (root_fdfslv)
     if (trim(name) /= 'newton') test_ok = .false.
     i = 0
     ra = 0
     do
        i = i + 1
        status = fgsl_root_fdfsolver_iterate(root_fdfslv)
        if (status /= fgsl_success .or. i > itmax_root) then
           test_ok = .false.
           exit
        end if
        ri = ra
        ra = fgsl_root_fdfsolver_root(root_fdfslv)
        status = fgsl_root_test_delta (ra, ri, 0.0_fgsl_double, eps2)
        if (status == fgsl_success) exit
     end do
  else
     test_ok = .false.
  end if
  if (abs(ra - sqrt(5.0_fgsl_double)) > eps2) test_ok = .false.
!  write(6, *) ra, sqrt(5.0d0), i
  call fgsl_root_fdfsolver_free(root_fdfslv)
  call fgsl_function_fdf_free(stdfunc_fdf)
  call testres_toggle('fgsl_roots_fdf',test_ok,ok,nok)
!
! One-dimensional minimization
!
  min_fslv = fgsl_min_fminimizer_alloc(fgsl_min_fminimizer_brent)
  if (fgsl_well_defined(min_fslv)) then
     stdfunc = fgsl_function_init(cosp1, ptr)
     status = fgsl_min_fminimizer_set(min_fslv, stdfunc, 3.0_fgsl_double, 0.0_fgsl_double, &
          6.0_fgsl_double)
     name = fgsl_min_fminimizer_name(min_fslv)
     if (trim(name) /= 'brent') test_ok = .false.
     i = 0
     do
        i = i + 1
        status = fgsl_min_fminimizer_iterate(min_fslv)
        if (status /= fgsl_success .or. i > itmax_root) then
           test_ok = .false.
           exit
        end if
        ra = fgsl_min_fminimizer_x_minimum(min_fslv)
        xlo = fgsl_min_fminimizer_x_lower(min_fslv)
        xhi = fgsl_min_fminimizer_x_upper(min_fslv)
        status = fgsl_min_test_interval (xlo, xhi, eps2, 0.0_fgsl_double)
        if (status == fgsl_success) exit
     end do
  else
     test_ok = .false.
  end if
  if (abs(ra - m_pi) > eps2) test_ok = .false.
  call fgsl_min_fminimizer_free(min_fslv)
  call fgsl_function_free(stdfunc)
  call testres_toggle('fgsl_min',test_ok,ok,nok)
!
! Multi-root
!
! fsolver
  nrt = 2
  mroot_fslv = fgsl_multiroot_fsolver_alloc(fgsl_multiroot_fsolver_hybrids,nrt)
  name = fgsl_multiroot_fsolver_name(mroot_fslv)
  if (trim(name) /= "hybrids") test_ok = .false.
! initialize function object
  fpar(1:2) = (/1.0_fgsl_double, 10.0_fgsl_double/)
  ptr = c_loc(fpar)
  mroot_f = fgsl_multiroot_function_init(rosenbrock_f,nrt,ptr)
!
  xv(1:2) = (/-10.0_fgsl_double, -5.0_fgsl_double/)
  xvec = fgsl_vector_init(1.0_fgsl_double)
  status = fgsl_vector_align(xv,nrt,xvec,nrt,0_fgsl_size_t,1_fgsl_size_t)
!  ya(1:2) = xvec
!  write(6, *) 'status = ', status, ' vec: ',ya(1:2)
  if (status /= fgsl_success) test_ok = .false.
  status = fgsl_multiroot_fsolver_set(mroot_fslv, mroot_f, xvec)
  call fgsl_vector_free(xvec)
!  write(6, *) 'status = ', status
  if (status /= fgsl_success) test_ok = .false.
  fvec = fgsl_multiroot_fsolver_f(mroot_fslv)
  status = fgsl_vector_align(fptr, fvec)
  xvec = fgsl_multiroot_fsolver_root(mroot_fslv)
  status = fgsl_vector_align(xptr, xvec)
  if (fgsl_well_defined(mroot_fslv)) then
     i = 0
!     write(6,'('' It.              X                     F(X) '')')
     do
!        write(6, '(1x,i2,1x,2(1f12.5),1x,2(1f12.5))') i, xptr(1:2), fptr(1:2)
        i = i + 1
        status = fgsl_multiroot_fsolver_iterate(mroot_fslv);
        if (status /= fgsl_success .or. i > itmax_root) then
           test_ok = .false.
           exit
        end if
        status = fgsl_multiroot_test_residual(fvec, 1.0E-7_fgsl_double)
        if (status == fgsl_success) then 
!           write(6, '(1x,i2,1x,2(1f12.5),1x,2(1f12.5))') i, xptr(1:2), fptr(1:2)
           exit
        end if
     end do
  end if
  call fgsl_multiroot_fsolver_free(mroot_fslv)
  call fgsl_multiroot_function_free(mroot_f)
  call testres_toggle('fgsl_f_multiroot',test_ok,ok,nok)
! fdfsolver
  nrt = 2
  mroot_fdfslv = fgsl_multiroot_fdfsolver_alloc(fgsl_multiroot_fdfsolver_gnewton,nrt)
  name = fgsl_multiroot_fdfsolver_name(mroot_fdfslv)
  if (trim(name) /= "gnewton") test_ok = .false.
! initialize function object
  fpar(1:2) = (/1.0_fgsl_double, 10.0_fgsl_double/)
  ptr = c_loc(fpar)
  mroot_fdf = fgsl_multiroot_function_fdf_init(rosenbrock_f,rosenbrock_df, &
       rosenbrock_fdf,nrt,ptr)
!
  xv(1:2) = (/-10.0_fgsl_double, -5.0_fgsl_double/)
  xvec = fgsl_vector_init(1.0_fgsl_double)
  status = fgsl_vector_align(xv,nrt,xvec,nrt,0_fgsl_size_t,1_fgsl_size_t)
!  ya(1:2) = xvec
!  write(6, *) 'status = ', status, ' vec: ',ya(1:2)
  if (status /= fgsl_success) test_ok = .false.
  status = fgsl_multiroot_fdfsolver_set(mroot_fdfslv, mroot_fdf, xvec)
  call fgsl_vector_free(xvec)
!  write(6, *) 'status = ', status
  if (status /= fgsl_success) test_ok = .false.
  fvec = fgsl_multiroot_fdfsolver_f(mroot_fdfslv)
  status = fgsl_vector_align(fptr, fvec)
  xvec = fgsl_multiroot_fdfsolver_root(mroot_fdfslv)
  status = fgsl_vector_align(xptr, xvec)
  if (fgsl_well_defined(mroot_fdfslv)) then
     i = 0
!     write(6,'('' It.              X                     F(X) '')')
     do
!        write(6, '(1x,i2,1x,2(1f12.5),1x,2(1f12.5))') i, xptr(1:2), fptr(1:2)
        i = i + 1
        status = fgsl_multiroot_fdfsolver_iterate(mroot_fdfslv);
        if (status /= fgsl_success .or. i > itmax_root) then
           test_ok = .false.
           exit
        end if
        status = fgsl_multiroot_test_residual(fvec, 1.0E-7_fgsl_double)
        if (status == fgsl_success) then 
!           write(6, '(1x,i2,1x,2(1f12.5),1x,2(1f12.5))') i, xptr(1:2), fptr(1:2)
           exit
        end if
     end do
  end if
  call fgsl_multiroot_fdfsolver_free(mroot_fdfslv)
  call fgsl_multiroot_function_fdf_free(mroot_fdf)
  call testres_toggle('fgsl_fdf_multiroot',test_ok,ok,nok)
!
! Multi-minimizer
!
! fminimizer
  nrt = 2
  mmin_fmin = fgsl_multimin_fminimizer_alloc(fgsl_multimin_fminimizer_nmsimplex,nrt)
  name = fgsl_multimin_fminimizer_name(mmin_fmin)
  if (trim(name) /= "nmsimplex") test_ok = .false.
! initialize function object
  fpar(1:2) = (/1.0_fgsl_double, 2.0_fgsl_double/)
  ptr = c_loc(fpar)
  mmin_f = fgsl_multimin_function_init(paraboloid_f,nrt,ptr)
!
  xv(1:2) = (/5.0_fgsl_double, 7.0_fgsl_double/)
  xvec = fgsl_vector_init(1.0_fgsl_double)
  status = fgsl_vector_align(xv,nrt,xvec,nrt,0_fgsl_size_t,1_fgsl_size_t)
  stepv(1:2) = (/1.0_fgsl_double, 1.0_fgsl_double/)
  step = fgsl_vector_init(1.0_fgsl_double)
  status = fgsl_vector_align(stepv,nrt,step,nrt,0_fgsl_size_t,1_fgsl_size_t)
!  ya(1:2) = xvec
!  write(6, *) 'status = ', status, ' vec: ',ya(1:2)
  if (status /= fgsl_success) test_ok = .false.
  status = fgsl_multimin_fminimizer_set(mmin_fmin, mmin_f, xvec, step)
  call fgsl_vector_free(xvec)
  call fgsl_vector_free(step)
! FIXME: vector_free may not be necessary. Check memory leak without call.
!  write(6, *) 'status = ', status
  if (status /= fgsl_success) test_ok = .false.
  xvec = fgsl_multimin_fminimizer_x(mmin_fmin)
  status = fgsl_vector_align(xptr, xvec)
  if (fgsl_well_defined(mmin_fmin)) then
     i = 0
!     write(6,'('' It.              X                     f(X) '')')
     do
!        write(6, '(1x,i2,1x,2(1f12.5),1x,2(1f12.5))') i, xptr(1:2), &
!              fgsl_multimin_fminimizer_minimum(mmin_fmin)
        i = i + 1
        status = fgsl_multimin_fminimizer_iterate(mmin_fmin);
        if (status /= fgsl_success .or. i > itmax_root) then
           test_ok = .false.
           exit
        end if
        dmx = fgsl_multimin_fminimizer_size(mmin_fmin);
        status = fgsl_multimin_test_size(dmx, eps3)
!        write(6, *) 'status, dmx: ', status, dmx
        if (status == fgsl_success) then 
!           write(6, '(1x,i2,1x,2(1f12.5),1x,2(1f12.5))') i, xptr(1:2), &
!                 fgsl_multimin_fminimizer_minimum(mmin_fmin)
           exit
        end if
     end do
  end if
  call fgsl_multimin_fminimizer_free(mmin_fmin)
  call fgsl_multimin_function_free(mmin_f)
  call testres_toggle('fgsl_f_multimin',test_ok,ok,nok)
! fdfminimizer
  nrt = 2
  mmin_fdfmin = fgsl_multimin_fdfminimizer_alloc(fgsl_multimin_fdfminimizer_conjugate_fr,nrt)
  name = fgsl_multimin_fdfminimizer_name(mmin_fdfmin)
  if (trim(name) /= "conjugate_fr") test_ok = .false.
! initialize function object
  fpar(1:2) = (/1.0_fgsl_double, 2.0_fgsl_double/)
  ptr = c_loc(fpar)
  mmin_fdf = fgsl_multimin_function_fdf_init(paraboloid_f,paraboloid_df, paraboloid_fdf,nrt,ptr)
!
  xv(1:2) = (/5.0_fgsl_double, 7.0_fgsl_double/)
  xvec = fgsl_vector_init(1.0_fgsl_double)
  status = fgsl_vector_align(xv,nrt,xvec,nrt,0_fgsl_size_t,1_fgsl_size_t)
!  ya(1:2) = xvec
!  write(6, *) 'status = ', status, ' vec: ',ya(1:2)
  if (status /= fgsl_success) test_ok = .false.
  status = fgsl_multimin_fdfminimizer_set(mmin_fdfmin, mmin_fdf, xvec, 0.01_fgsl_double, eps3)
  call fgsl_vector_free(xvec)
! FIXME: vector_free may not be necessary. Check memory leak without call.
!  write(6, *) 'status = ', status
  if (status /= fgsl_success) test_ok = .false.
  xvec = fgsl_multimin_fdfminimizer_x(mmin_fdfmin)
  status = fgsl_vector_align(xptr, xvec)
  if (fgsl_well_defined(mmin_fdfmin)) then
     i = 0
!     write(6,'('' It.              X                     f(X) '')')
     do
!        write(6, '(1x,i2,1x,2(1f12.5),1x,2(1f12.5))') i, xptr(1:2), &
!              fgsl_multimin_fdfminimizer_minimum(mmin_fdfmin)
        i = i + 1
        status = fgsl_multimin_fdfminimizer_iterate(mmin_fdfmin)
! FIXME: last iteration produces invalid floating point operation. 
! g95 does not check flags, NAG requires -ieee=full to run through.
! try IEEE utilities?
        if (status /= fgsl_success .or. i > itmax_root) then
           test_ok = .false.
           exit
        end if
        fvec = fgsl_multimin_fdfminimizer_gradient(mmin_fdfmin)
        status = fgsl_multimin_test_gradient(fvec, eps3)
        if (status == fgsl_success) then 
!           write(6, '(1x,i2,1x,2(1f12.5),1x,2(1f12.5))') i, xptr(1:2), &
!                 fgsl_multimin_fminimizer_minimum(mmin_fmin)
           exit
        end if
     end do
  else
     test_ok = .false.
  end if
  call fgsl_multimin_fdfminimizer_free(mmin_fdfmin)
  call fgsl_multimin_function_fdf_free(mmin_fdf)
  call testres_toggle('fgsl_fdf_multimin',test_ok,ok,nok)
!
! Fitting
!
  d(1:4) = (/ 1970_fgsl_double, 1980_fgsl_double, 1990_fgsl_double, &
       2000_fgsl_double /)
  ya(1:4) = (/12_fgsl_double, 11_fgsl_double, 14_fgsl_double, &
       13_fgsl_double /)
  xa(1:4) = (/ 0.1_fgsl_double,  0.2_fgsl_double,  0.3_fgsl_double, &
       0.4_fgsl_double /)
  nrt = 4
  istr = 1
  status = fgsl_fit_wlinear (d, istr, xa, istr, ya, istr, nrt, &
       c0, c1, cov00, cov01, cov11, chisq)
  if (status /= fgsl_success) test_ok = .false.
!  write(6, *) 'Fit function: ',c0,' + ',c1,' * X'
!  write(6, *) 'Covariance Matrix (lower triangle): ',cov00,cov01,cov11
!  write(6, *) 'ChiSq: ',chisq
!  write(6, *) 'eps2: ',eps2
  if (abs(chisq-0.8_fgsl_double) > eps2 .or. abs(c0 + 106.6_fgsl_double) > eps2 &
       .or. abs(c1 - 0.06) > eps2 .or. abs(cov00 - 39602._fgsl_double) > eps2 .or. &
       abs(cov01 + 19.9_fgsl_double) > eps2 .or. &
       abs(cov11 - 0.01_fgsl_double) > eps2) test_ok = .false.
  call testres_toggle('fgsl_fit',test_ok,ok,nok)
!
  rng_type = fgsl_rng_env_setup()
  rng = fgsl_rng_alloc(fgsl_rng_default)
  t = 0.1_fgsl_double
  do i=1,nfmax
     xmf(1, i) = 1.0_fgsl_double
     xmf(2, i) = t
     xmf(3, i) = t*t
     ra = exp(t)
     ri = 0.1 * ra
     ymf(i) = ra + fgsl_ran_gaussian(rng, ri)
     wmf(i) = 1.0_fgsl_double/(ri*ri)
!     write(6, fmt='(3(1PD17.8,1X))') t, ymf(i), ri
     t = t + 0.1_fgsl_double
  end do
  lfit_ws = fgsl_multifit_linear_alloc(nfmax, 3_fgsl_size_t)
  if (fgsl_well_defined(lfit_ws)) then
     yvec = fgsl_vector_init(1.0_fgsl_double)
     wvec = fgsl_vector_init(1.0_fgsl_double)
     fmat = fgsl_matrix_init(1.0_fgsl_double)
     cvec = fgsl_vector_init(1.0_fgsl_double)
     cov = fgsl_matrix_init(1.0_fgsl_double)
     status = fgsl_vector_align(ymf,nfmax,yvec,nfmax,0_fgsl_size_t,1_fgsl_size_t)
     status = fgsl_vector_align(wmf,nfmax,wvec,nfmax,0_fgsl_size_t,1_fgsl_size_t)
     status = fgsl_matrix_align(xmf, 3_fgsl_size_t, 3_fgsl_size_t,nfmax,fmat)
     status = fgsl_vector_align(cmf,3_fgsl_size_t,cvec,3_fgsl_size_t,0_fgsl_size_t, &
          1_fgsl_size_t)
     status = fgsl_matrix_align(covmf, 3_fgsl_size_t, 3_fgsl_size_t,3_fgsl_size_t,cov)
     status = fgsl_multifit_wlinear (fmat, wvec, yvec, cvec, cov, chisq, lfit_ws)
     if (status /= fgsl_success) test_ok = .false.
     if (abs(cmf(1) - 1.1824632501803487_fgsl_double) > eps .or. &
          abs(cmf(2) - 0.1845715862795292_fgsl_double) > eps .or. &
          abs(cmf(3) - 1.3031038162033384_fgsl_double) > eps)  test_ok = .false.
     if (abs(covmf(1,1) - 1.25611919D-02) > eps2 .or. &
          abs(covmf(2,1) + 3.64387341D-02) > eps2 .or. &
          abs(covmf(3,1) - 1.94389116D-02) > eps2 .or. &
          abs(covmf(2,2) - 1.42339296D-01) > eps2 .or. &
          abs(covmf(3,2) + 8.48762160D-02) > eps2 .or. &
          abs(covmf(3,3) - 5.60243141D-02) > eps2)  test_ok = .false.
!     write(6, *) 'Fit: ',cmf
!     write(6, *) 'Cov: '
!     write(6,  fmt='(3(1PD17.8,1X))') covmf(1,1:3)
!     write(6,  fmt='(3(1PD17.8,1X))') covmf(2,1:3)
!     write(6,  fmt='(3(1PD17.8,1X))') covmf(3,1:3)
  else
     test_ok = .false.
  end if

  call fgsl_rng_free(rng)
  call fgsl_vector_free(cvec)
  call fgsl_vector_free(yvec)
  call fgsl_vector_free(wvec)
  call fgsl_matrix_free(fmat)
  call fgsl_matrix_free(cov)
  if (fgsl_well_defined(lfit_ws)) then
     call fgsl_multifit_linear_free(lfit_ws)
  end if
  call testres_toggle('fgsl_fit_multi',test_ok,ok,nok)
!
! Nonlinear fitting
!
  rng = fgsl_rng_alloc(fgsl_rng_default)
  fitdata%n = nmax
  allocate(fitdata%y(nmax),fitdata%sigma(nmax))
  do i=1, nmax
     fitdata%y(i) = 1.0_fgsl_double + 5.0_fgsl_double * exp(-0.1_fgsl_double*dble(i-1)) + &
          fgsl_ran_gaussian(rng, 0.1_fgsl_double)
     fitdata%sigma(i) = 0.1_fgsl_double
  end do
  ptr = c_loc(fitdata)
  nrt = 3_fgsl_size_t
  nlfit_fdf = fgsl_multifit_function_fdf_init(expb_f, expb_df, expb_fdf, nmax, nrt, ptr)
  nlfit_slv = fgsl_multifit_fdfsolver_alloc(fgsl_multifit_fdfsolver_lmsder, nmax, nrt)
  xv(1:3) = (/1.0_fgsl_double, 0.0_fgsl_double, 0.0_fgsl_double/)
  xvec = fgsl_vector_init(1.0_fgsl_double)
  status = fgsl_vector_align(xv,nrt,xvec,nrt,0_fgsl_size_t,1_fgsl_size_t)
  if (fgsl_well_defined(nlfit_slv)) then
     status = fgsl_multifit_fdfsolver_set(nlfit_slv, nlfit_fdf, xvec)
     if (status /= fgsl_success) then
        test_ok = .false.
     else
        i = 0
        do
           i = i + 1
           status = fgsl_multifit_fdfsolver_iterate(nlfit_slv)
           if (status /= fgsl_success .or. i > itmax_root) then
              test_ok = .false.
              exit
           end if
           status = fgsl_multifit_test_delta(fgsl_multifit_fdfsolver_dx(nlfit_slv), &
                fgsl_multifit_fdfsolver_position(nlfit_slv), eps2, eps2)
           if (status == fgsl_success) then 
              exit
           end if
        end do
     end if
  else
     test_ok = .false.
  end if
!  deallocate(fitdata%y,fitdata%sigma)
  call fgsl_vector_free(xvec)
  call fgsl_multifit_fdfsolver_free(nlfit_slv)
  call fgsl_multifit_function_fdf_free(nlfit_fdf)
  call fgsl_rng_free(rng)
  call testres_toggle('fgsl_nl_fit',test_ok,ok,nok)
!
! IEEE utils
!
  tfile = fgsl_open(fgsl_char_'ieee.dat',fgsl_char_'w+')
  if (fgsl_well_defined(tfile)) then
     t = 1.0_fgsl_double/3.0_fgsl_double
     call fgsl_ieee_fprintf(tfile, t)
     ts = 1.0_fgsl_float/3.0_fgsl_float
     call fgsl_ieee_fprintf(tfile, ts)
     status = fgsl_close(tfile)
     if (status /= 0) test_ok = .false.
     open(unit=20, file='ieee.dat',form='FORMATTED',status='OLD')
     read(20, fmt=*) ieee_str1, ieee_str2
!     write(6, *) 'ieee_str = ',trim(ieee_str1),' ',trim(ieee_str2)
     if (trim(ieee_str1) /= &
          '1.0101010101010101010101010101010101010101010101010101*2^-2') test_ok = .false. 
     if (trim(ieee_str2) /= &
          '1.01010101010101010101011*2^-2') test_ok = .false. 
     close(20,status='DELETE')
  else
     status = fgsl_close(tfile)
     test_ok = .false.
  end if
  call testres_toggle('fgsl_ieee',test_ok,ok,nok)
!
! Done
!
  if (all(ok)) then
     write(6, *) 'OK: All tests passed'
  else
     write(6, *) 'FAIL: Some or all tests failed'
  end if
end program test_fgsl

program fitting2
  use fgsl
  implicit none
  integer(fgsl_int) :: status
  integer(fgsl_size_t) :: i, n
  real(fgsl_double) :: xi, yi, ei, chisq
  type(fgsl_matrix) :: x, cov
  type(fgsl_vector) :: y, w, c
  real(fgsl_double), allocatable :: x_m(:,:), y_v(:), w_v(:)
  real(fgsl_double) :: cov_m(3,3), c_v(3)
  type(fgsl_multifit_linear_workspace) :: work
!
  x = fgsl_matrix_init(type=1.0D0)
  cov = fgsl_matrix_init(type=1.0D0)
  y = fgsl_vector_init(type=1.0D0)
  w = fgsl_vector_init(type=1.0D0)
  c = fgsl_vector_init(type=1.0D0)
!
  open(20, file='fitting2.dat', form='formatted', status='old', iostat=status)
  if (status > 0) then
     stop 'Could not open fitting2.dat. You may need to run fitting3.exe'
  end if
  read(20, *) n
  allocate(x_m(3, n), y_v(n), w_v(n))
!
  status = fgsl_vector_align(y_v, n, y, n, 0_fgsl_size_t, 1_fgsl_size_t)
  status = fgsl_vector_align(w_v, n, w, n, 0_fgsl_size_t, 1_fgsl_size_t)
  status = fgsl_matrix_align(x_m, 3_fgsl_size_t, 3_fgsl_size_t, n, x)
  status = fgsl_vector_align(c_v, 3_fgsl_size_t, c, &
       3_fgsl_size_t, 0_fgsl_size_t, 1_fgsl_size_t)
  status = fgsl_matrix_align(cov_m, 3_fgsl_size_t, 3_fgsl_size_t, &
       3_fgsl_size_t, cov)
!
  do i=1, n
     read(20, *) xi, yi, ei
     x_m(1, i) = 1.0D0
     x_m(2, i) = xi
     x_m(3, i) = xi * xi
     y_v(i) = yi
     w_v(i) = 1.0D0/(ei * ei)
  end do
  close(20)
  work = fgsl_multifit_linear_alloc(n, 3_fgsl_size_t)
  status = fgsl_multifit_wlinear(x, w, y, c, cov, chisq, work)
  call fgsl_multifit_linear_free(work)
  write(6, '(''# best fit:  Y = '',F12.5,'' + '',F12.5, &
       & ''*X + '',F12.5,''*X^2'')') c_v
  write(6, '(''# covariance matrix: '')') 
  write(6, '(3(F12.5,1X))')  cov_m(1:3,1)
  write(6, '(3(F12.5,1X))')  cov_m(1:3,2)
  write(6, '(3(F12.5,1X))')  cov_m(1:3,3)
  write(6, '(''# chisq = '',F12.5)') chisq

  call fgsl_vector_free(y)
  call fgsl_vector_free(w)
  call fgsl_vector_free(c)
  call fgsl_matrix_free(x)
  call fgsl_matrix_free(cov)
  deallocate(x_m, y_v, w_v)
end program fitting2

module mod_multimin
  use, intrinsic :: iso_c_binding
  use fgsl
  use mod_unit
  implicit none
contains
  function paraboloid_f(v, p) bind(c)
    type(c_ptr), value :: v, p
    real(c_double) :: paraboloid_f
!
    type(fgsl_vector) :: vec
    real(fgsl_double), pointer :: par(:), pvec(:)
    integer(fgsl_int) :: status
    call fgsl_obj_c_ptr(vec, v)
    call c_f_pointer(p, par, (/ 2 /))
    status = fgsl_vector_align(pvec, vec)
    paraboloid_f = 10.0_fgsl_double * (pvec(1)-par(1))**2 + &
         20.0_fgsl_double * (pvec(2)-par(2))**2 + 30.0_fgsl_double
  end function paraboloid_f
  subroutine paraboloid_df(v, p, df) bind(c)
    type(c_ptr), value :: v, p, df
!
    type(fgsl_vector) :: vec, grad
    real(fgsl_double), pointer :: par(:), pvec(:), pdf(:)
    integer(fgsl_int) :: status
    call fgsl_obj_c_ptr(vec, v)
    call fgsl_obj_c_ptr(grad, df)
    call c_f_pointer(p, par, (/ 2 /))
    status = fgsl_vector_align(pvec, vec)
    status = fgsl_vector_align(pdf, grad)
    pdf(1) = 20.0_fgsl_double * (pvec(1)-par(1))
    pdf(2) = 40.0_fgsl_double * (pvec(2)-par(2))
  end subroutine paraboloid_df
  subroutine paraboloid_fdf(v, p, f, df) bind(c)
    type(c_ptr), value :: v, p, df
    real(c_double) :: f
    f = paraboloid_f(v, p)
    call paraboloid_df(v, p, df)
  end subroutine paraboloid_fdf
end module mod_multimin
program multimin
  use mod_multimin
  implicit none
  real(fgsl_double), parameter :: eps5 = 1.0d-5
  integer(fgsl_int), parameter :: itmax_root = 50
  real(fgsl_double), target :: fpar(2), xv(2), stepv(2)
  real(fgsl_double) :: dmx
  type(c_ptr) :: ptr
  type(fgsl_function) :: stdfunc
  type(fgsl_function_fdf) :: stdfunc_fdf
  type(fgsl_vector) :: fvec, xvec, step
  type(fgsl_multimin_fminimizer) :: mmin_fmin
  type(fgsl_multimin_function) :: mmin_f
  type(fgsl_multimin_fdfminimizer) :: mmin_fdfmin
  type(fgsl_multimin_function_fdf) :: mmin_fdf
  integer(fgsl_int) :: status, i
  integer(fgsl_size_t) :: nrt
  character(kind=fgsl_char,len=fgsl_strmax) :: name
  real(fgsl_double), pointer :: xptr(:)

! see below
!  std = fgsl_set_error_handler_off()
!  call fgsl_ieee_env_setup()

!
! Test multiminimization routines
!
  call unit_init(20)
!
  nrt = 2
  mmin_fmin = fgsl_multimin_fminimizer_alloc(fgsl_multimin_fminimizer_nmsimplex,nrt)
  name = fgsl_multimin_fminimizer_name(mmin_fmin)
  call unit_assert_equal('fgsl_multiroot_fsolver_name','nmsimplex',trim(name))
! initialize function object
  fpar(1:2) = (/1.0_fgsl_double, 2.0_fgsl_double/)
  ptr = c_loc(fpar)
  mmin_f = fgsl_multimin_function_init(paraboloid_f,nrt,ptr)
!
  xv(1:2) = (/5.0_fgsl_double, 7.0_fgsl_double/)
  xvec = fgsl_vector_init(1.0_fgsl_double)
  status = fgsl_vector_align(xv,nrt,xvec,nrt,0_fgsl_size_t,1_fgsl_size_t)
  stepv(1:2) = (/1.0_fgsl_double, 1.0_fgsl_double/)
  step = fgsl_vector_init(1.0_fgsl_double)
  status = fgsl_vector_align(stepv,nrt,step,nrt,0_fgsl_size_t,1_fgsl_size_t)
  status = fgsl_multimin_fminimizer_set(mmin_fmin, mmin_f, xvec, step)
  call unit_assert_equal('fgsl_multiroot_fminimizer_set:status', &
       fgsl_success,status)
  call fgsl_vector_free(xvec)
  call fgsl_vector_free(step)
  xvec = fgsl_multimin_fminimizer_x(mmin_fmin)
  status = fgsl_vector_align(xptr, xvec)
  call unit_assert_true('fgsl_multiroot_fminimizer_alloc', &
       fgsl_well_defined(mmin_fmin), .true.)
  i = 0
  do
     i = i + 1
     status = fgsl_multimin_fminimizer_iterate(mmin_fmin);
     if (status /= fgsl_success .or. i > itmax_root) then
        exit
     end if
     dmx = fgsl_multimin_fminimizer_size(mmin_fmin);
     status = fgsl_multimin_test_size(dmx, eps5)
     if (status == fgsl_success) then 
        exit
     end if
  end do
  call unit_assert_equal('fgsl_multimin_fminimizer_iterate:status', &
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_multimin_fminimizer_iterate', &
       (/1.0d0, 2.0d0/), &
       xptr,eps5)
  call unit_assert_equal_within('fgsl_multimin_fminimizer_iterate', &
       3.0d1, fgsl_multimin_fminimizer_minimum(mmin_fmin),eps5)
  call fgsl_multimin_fminimizer_free(mmin_fmin)
  call fgsl_multimin_function_free(mmin_f)

! fdfminimizer
  nrt = 2
  mmin_fdfmin = fgsl_multimin_fdfminimizer_alloc(fgsl_multimin_fdfminimizer_conjugate_fr,nrt)
  name = fgsl_multimin_fdfminimizer_name(mmin_fdfmin)
  call unit_assert_equal('fgsl_multiroot_fsolver_name', &
       'conjugate_fr',trim(name))
! initialize function object
  fpar(1:2) = (/1.0_fgsl_double, 2.0_fgsl_double/)
  ptr = c_loc(fpar)
  mmin_fdf = fgsl_multimin_function_fdf_init( &
       paraboloid_f,paraboloid_df, paraboloid_fdf,nrt,ptr)
  xv(1:2) = (/5.0_fgsl_double, 7.0_fgsl_double/)
  xvec = fgsl_vector_init(1.0_fgsl_double)
  status = fgsl_vector_align(xv,nrt,xvec,nrt,0_fgsl_size_t,1_fgsl_size_t)
  status = fgsl_multimin_fdfminimizer_set(mmin_fdfmin, mmin_fdf, xvec, 0.01_fgsl_double, eps5)
  call unit_assert_equal('fgsl_multiroot_fdfminimizer_set:status', &
       fgsl_success,status)
  call fgsl_vector_free(xvec)
  xvec = fgsl_multimin_fdfminimizer_x(mmin_fdfmin)
  status = fgsl_vector_align(xptr, xvec)
  call unit_assert_true('fgsl_multiroot_fdfminimizer_alloc', &
       fgsl_well_defined(mmin_fdfmin), .true.)
  i = 0
  do
     i = i + 1
     status = fgsl_multimin_fdfminimizer_iterate(mmin_fdfmin)
! FIXME: last iteration produces invalid floating point operation. 
! g95 does not check flags, NAG requires -ieee=full to run through.
! try IEEE utilities?
     if (status /= fgsl_success .or. i > itmax_root) then
        exit
     end if
     fvec = fgsl_multimin_fdfminimizer_gradient(mmin_fdfmin)
     status = fgsl_multimin_test_gradient(fvec, eps5)
     if (status == fgsl_success) then 
        exit
     end if
  end do
  call unit_assert_equal('fgsl_multimin_fdfminimizer_iterate:status', &
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_multimin_fdfminimizer_iterate', &
       (/1.0d0, 2.0d0/), &
       xptr,eps5)
  call unit_assert_equal_within('fgsl_multimin_fdfminimizer_iterate', &
       3.0d1, fgsl_multimin_fminimizer_minimum(mmin_fmin),eps5)
  call fgsl_multimin_fdfminimizer_free(mmin_fdfmin)
  call fgsl_multimin_function_fdf_free(mmin_fdf)
!
! Done
!
  call unit_finalize() 
end program multimin

program ieee_utils
  use fgsl
  use mod_unit
  implicit none
  integer(fgsl_int) :: status
  real(fgsl_double) :: t
  real(fgsl_float) :: ts
  type(fgsl_file) :: tfile
  character(kind=fgsl_char,len=fgsl_strmax) :: ieee_str1, ieee_str2
!
  call unit_init(20)
!
  tfile = fgsl_open(fgsl_char_'ieee.dat',fgsl_char_'w+')
  call unit_assert_true('fgsl_open', fgsl_well_defined(tfile), .true.)
  t = 1.0_fgsl_double/3.0_fgsl_double
  call fgsl_ieee_fprintf(tfile, t)
  ts = 1.0_fgsl_float/3.0_fgsl_float
  call fgsl_ieee_fprintf(tfile, ts)
  status = fgsl_close(tfile)
  call unit_assert_equal('fgsl_close:status',fgsl_success,status)
  open(unit=20, file='ieee.dat',form='FORMATTED',status='OLD')
  read(20, fmt=*) ieee_str1, ieee_str2
  call unit_assert_equal('fgsl_ieee_double',ieee_str1,&
       '1.0101010101010101010101010101010101010101010101010101*2^-2')
  call unit_assert_equal('fgsl_ieee_float',ieee_str2,&
       '1.01010101010101010101011*2^-2')
  close(20,status='DELETE')
! 
! Done
!
  call unit_finalize()
end program ieee_utils

module mod_roots
  use, intrinsic :: iso_c_binding
  use fgsl
  use mod_unit
  implicit none
contains
  function quadratic(x, params) bind(c)
    real(c_double), value :: x
    type(c_ptr), value :: params
    real(c_double) :: quadratic
!
    real(fgsl_double), pointer :: p(:)
    call c_f_pointer(params, p, (/3/))
    quadratic = (p(1)*x + p(2))*x + p(3)
  end function quadratic
  function quadratic_deriv(x, params) bind(c)
    real(c_double), value :: x
    type(c_ptr), value :: params
    real(c_double) :: quadratic_deriv
!
    real(fgsl_double), pointer :: p(:)
    call c_f_pointer(params, p, (/3/))
    quadratic_deriv = 2.0_fgsl_double*p(1)*x + p(2) 
  end function quadratic_deriv
  subroutine quadratic_fdf(x, params, y, dy) bind(c)
    real(c_double), value :: x
    type(c_ptr), value :: params
    real(c_double), intent(out) :: y, dy
!
    real(fgsl_double), pointer :: p(:)
    call c_f_pointer(params, p, (/3/))
    y = (p(1)*x + p(2))*x + p(3)
    dy = 2.0_fgsl_double*p(1)*x + p(2)
  end subroutine quadratic_fdf
end module mod_roots
program roots
  use mod_roots
  implicit none
  real(fgsl_double), parameter :: eps5 = 1.0d-5
  integer(fgsl_int), parameter :: itmax_root = 50
  real(fgsl_double), target :: fpar(3)
  real(fgsl_double) :: ri, ra, xlo, xhi
  type(c_ptr) :: ptr
  type(fgsl_function) :: stdfunc
  type(fgsl_function_fdf) :: stdfunc_fdf
  type(fgsl_root_fsolver) :: root_fslv
  type(fgsl_root_fdfsolver) :: root_fdfslv
  integer(fgsl_int) :: status, i
  character(kind=fgsl_char,len=fgsl_strmax) :: name
!
! Test root finding routines
!
  call unit_init(20)
!
  fpar = (/1.0_fgsl_double, 0.0_fgsl_double, -5.0_fgsl_double/)
  ptr = c_loc(fpar)
  stdfunc = fgsl_function_init(quadratic, ptr)
  root_fslv = fgsl_root_fsolver_alloc(fgsl_root_fsolver_brent)
  call unit_assert_true('fgsl_root_fsolver_alloc', &
       fgsl_well_defined(root_fslv), .true.)
  stdfunc = fgsl_function_init(quadratic, ptr)
  status = fgsl_root_fsolver_set(root_fslv, stdfunc, 0.0_fgsl_double, &
       5.0_fgsl_double)
  name = fgsl_root_fsolver_name(root_fslv)
  call unit_assert_equal('fgsl_root_fsolver_name','brent',trim(name))
  i = 0
  do
     i = i + 1
     status = fgsl_root_fsolver_iterate(root_fslv)
     if (status /= fgsl_success .or. i > itmax_root) then
        exit
     end if
     ra = fgsl_root_fsolver_root(root_fslv)
     xlo = fgsl_root_fsolver_x_lower(root_fslv)
     xhi = fgsl_root_fsolver_x_upper(root_fslv)
     status = fgsl_root_test_interval (xlo, xhi, 0.0_fgsl_double, eps5)
     if (status == fgsl_success) exit
  end do
  call unit_assert_equal('fgsl_root_fsolver:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_root_fsolver',sqrt(5.0_fgsl_double), &
       ra,eps5)
  call fgsl_root_fsolver_free(root_fslv)
  call fgsl_function_free(stdfunc)
!
  root_fdfslv = fgsl_root_fdfsolver_alloc(fgsl_root_fdfsolver_newton)
  call unit_assert_true('fgsl_root_fdfsolver_alloc', &
       fgsl_well_defined(root_fdfslv), .true.)
  stdfunc_fdf = fgsl_function_fdf_init(quadratic, quadratic_deriv, &
       quadratic_fdf, ptr)
  status = fgsl_root_fdfsolver_set(root_fdfslv, stdfunc_fdf, &
          5.0_fgsl_double)
  name = fgsl_root_fdfsolver_name (root_fdfslv)
  call unit_assert_equal('fgsl_root_fdfsolver_name','newton',trim(name))
  i = 0
  ra = 0
  do
     i = i + 1
     status = fgsl_root_fdfsolver_iterate(root_fdfslv)
     if (status /= fgsl_success .or. i > itmax_root) then
        exit
     end if
     ri = ra
     ra = fgsl_root_fdfsolver_root(root_fdfslv)
     status = fgsl_root_test_delta (ra, ri, 0.0_fgsl_double, eps5)
     if (status == fgsl_success) exit
  end do
  call unit_assert_equal('fgsl_fsolver:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_fsolver',sqrt(5.0_fgsl_double), &
       ra,eps5)
  call fgsl_root_fdfsolver_free(root_fdfslv)
  call fgsl_function_fdf_free(stdfunc_fdf)
!
! Done
!
  call unit_finalize() 
end program roots

program bspline
  use mod_unit
  use fgsl
  implicit none
  integer(fgsl_size_t), parameter :: nbreak = 10, ncbf = nbreak + 2
  real(fgsl_double), parameter :: eps7 = 1.0D-7
  integer(fgsl_int) :: status, i
  type(fgsl_bspline_workspace) :: sw
  type(fgsl_vector) :: b, k
  real(fgsl_double), target :: bv(ncbf), kv(nbreak)
  real(fgsl_double), pointer :: bp(:)
!
! Test B-Spline API
!
  call unit_init(10)
!
  sw = fgsl_bspline_alloc(4_fgsl_size_t, nbreak)
  kv = (/ (dble(i-1), i=1,nbreak) /)
  b = fgsl_vector_init(1.0d0) ; k = fgsl_vector_init(1.0d0)
  status = fgsl_vector_align(kv, nbreak, k, nbreak, 0_fgsl_size_t, &
       1_fgsl_size_t)
  status = fgsl_vector_align(bv, ncbf, b, ncbf, 0_fgsl_size_t, &
       1_fgsl_size_t)
  status = fgsl_vector_align(bp, b)
!  write(6, *) 'Size = ',size(bp)
  status = fgsl_bspline_knots(k, sw)
  call unit_assert_equal('fgsl_bspline_knots:status',fgsl_success,status)
  status = fgsl_bspline_eval(3.0_fgsl_double, b, sw)
  call unit_assert_equal('fgsl_bspline_eval:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_bspline_eval',(/0.d0,0.d0,0.d0,&
       0.16666666666d0,0.66666666666d0,0.16666666666d0,0.d0,0.d0,0.d0,&
       0.d0,0.d0,0.d0/),bv,eps7)
  status = fgsl_bspline_knots_uniform(0.0d0, dble(nbreak-1), sw)
  call unit_assert_equal('fgsl_bspline_knots_uniform:status',fgsl_success,status)
  status = fgsl_bspline_eval(3.0_fgsl_double, b, sw)
  call unit_assert_equal('fgsl_bspline_eval:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_bspline_eval',(/0.d0,0.d0,0.d0,&
       0.16666666666d0,0.66666666666d0,0.16666666666d0,0.d0,0.d0,0.d0,&
       0.d0,0.d0,0.d0/),bv,eps7)
  call fgsl_bspline_free(sw); call fgsl_vector_free(k) ; call fgsl_vector_free(b)
!
! Done
!
  call unit_finalize()
end program bspline

program fit
  use fgsl
  use mod_unit
  implicit none
  integer(fgsl_size_t), parameter :: nfmax = 19
  real(fgsl_double), parameter :: eps10 = 1.0d-10
  real(fgsl_double), parameter :: eps5 = 1.0d-5
  real(fgsl_double) :: d(4), ya(4), xa(4), &
       chisq, c0, c1, cov00, cov01, cov11, &
       t, ri, ra
  real(fgsl_double), dimension(3, nfmax), target :: xmf
  real(fgsl_double), dimension(nfmax), target :: ymf, wmf
  real(fgsl_double), dimension(3,3), target :: covmf
  real(fgsl_double), dimension(3), target :: cmf
  integer(fgsl_int) :: status, i
  integer(fgsl_size_t) :: istr, nrt
  type(fgsl_rng_type) :: rng_type
  type(fgsl_rng) :: rng
  type(fgsl_vector) :: cvec, yvec, wvec
  type(fgsl_matrix) :: fmat, cov
  type(fgsl_multifit_linear_workspace) :: lfit_ws
!
! Test simulated annealing routines
!
  call unit_init(20)
!
  d(1:4) = (/ 1970_fgsl_double, 1980_fgsl_double, 1990_fgsl_double, &
       2000_fgsl_double /)
  ya(1:4) = (/12_fgsl_double, 11_fgsl_double, 14_fgsl_double, &
       13_fgsl_double /)
  xa(1:4) = (/ 0.1_fgsl_double,  0.2_fgsl_double,  0.3_fgsl_double, &
       0.4_fgsl_double /)
  nrt = 4
  istr = 1
  status = fgsl_fit_wlinear (d, istr, xa, istr, ya, istr, nrt, &
       c0, c1, cov00, cov01, cov11, chisq)
  call unit_assert_equal('fgsl_fit_wlinear:status',fgsl_success,status)
!  write(6, *) 'Fit function: ',c0,' + ',c1,' * X'
!  write(6, *) 'Covariance Matrix (lower triangle): ',cov00,cov01,cov11
!  write(6, *) 'ChiSq: ',chisq
!  write(6, *) 'eps2: ',eps2
  call unit_assert_equal_within('fgsl_fit_wlinear:c0',-106.6d0, c0, eps10)
  call unit_assert_equal_within('fgsl_fit_wlinear:c1',0.06d0, c1, eps10)
  call unit_assert_equal_within('fgsl_fit_wlinear:chisq',0.8d0, chisq, eps10)
  call unit_assert_equal_within('fgsl_fit_wlinear:cov00',39602d0, cov00, eps10)
  call unit_assert_equal_within('fgsl_fit_wlinear:cov01',-19.9d0, cov01, eps10)
  call unit_assert_equal_within('fgsl_fit_wlinear:cov11',0.01d0, cov11, eps10)
!
  rng_type = fgsl_rng_env_setup()
  rng = fgsl_rng_alloc(fgsl_rng_default)
  t = 0.1_fgsl_double
  do i=1,nfmax
     xmf(1, i) = 1.0_fgsl_double
     xmf(2, i) = t
     xmf(3, i) = t*t
     ra = exp(t)
     ri = 0.1 * ra
     ymf(i) = ra + fgsl_ran_gaussian(rng, ri)
     wmf(i) = 1.0_fgsl_double/(ri*ri)
!     write(6, fmt='(3(1PD17.8,1X))') t, ymf(i), ri
     t = t + 0.1_fgsl_double
  end do
  lfit_ws = fgsl_multifit_linear_alloc(nfmax, 3_fgsl_size_t)
  call unit_assert_true('fgsl_multifit_linear_alloc(', &
       fgsl_well_defined(lfit_ws), .true.)
  yvec = fgsl_vector_init(1.0_fgsl_double)
  wvec = fgsl_vector_init(1.0_fgsl_double)
  fmat = fgsl_matrix_init(1.0_fgsl_double)
  cvec = fgsl_vector_init(1.0_fgsl_double)
  cov = fgsl_matrix_init(1.0_fgsl_double)
  status = fgsl_vector_align(ymf,nfmax,yvec,nfmax,0_fgsl_size_t,1_fgsl_size_t)
  status = fgsl_vector_align(wmf,nfmax,wvec,nfmax,0_fgsl_size_t,1_fgsl_size_t)
  status = fgsl_matrix_align(xmf, 3_fgsl_size_t, 3_fgsl_size_t,nfmax,fmat)
  status = fgsl_vector_align(cmf,3_fgsl_size_t,cvec,3_fgsl_size_t,0_fgsl_size_t, &
       1_fgsl_size_t)
  status = fgsl_matrix_align(covmf, 3_fgsl_size_t, 3_fgsl_size_t,3_fgsl_size_t,cov)
  status = fgsl_multifit_wlinear (fmat, wvec, yvec, cvec, cov, chisq, lfit_ws)
  call unit_assert_equal('fgsl_multifit_wlinear:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_multifit_wlinear:cmf', &
       (/1.1824632501803487d0, 0.1845715862795292d0, &
       1.3031038162033384d0 /),cmf,eps10)
  covmf(1, 2) = 0.0d0
  covmf(1, 3) = 0.0d0
  covmf(2, 3) = 0.0d0
  call unit_assert_equal_within('fgsl_multifit_wlinear:covmf', &
       (/1.25611919d-02,-3.64387341d-02, 1.94389116d-02, &
       0.0d0, 1.42339296d-01, -8.48762160d-02, &
       0.0d0, 0.0d0, 5.60243141d-02 /),reshape(covmf, (/ 9 /)),eps5)
  call fgsl_rng_free(rng)
  call fgsl_vector_free(cvec)
  call fgsl_vector_free(yvec)
  call fgsl_vector_free(wvec)
  call fgsl_matrix_free(fmat)
  call fgsl_matrix_free(cov)
  call fgsl_multifit_linear_free(lfit_ws)
!
! Done
!
  call unit_finalize() 
end program fit

module mod_ntuple
  use fgsl
  use mod_unit
  use, intrinsic :: iso_c_binding
  integer(fgsl_size_t), parameter :: nsize = 50
  real(fgsl_double), parameter :: eps10 = 1.0d-10
  type, bind(c) :: tuple_data
     integer(c_int) :: len
     real(c_double) :: stuff(nsize) 
  end type tuple_data
end module mod_ntuple
program ntuple
  use mod_ntuple
  implicit none
  integer :: i
  integer(fgsl_size_t) :: isz, iisz
  integer(fgsl_int) :: status
  type(tuple_data), target :: obj_data
  type(tuple_data), pointer :: ptr_data
  type(c_ptr) :: obj_ptr
  type(fgsl_ntuple) :: tuple
!
! Test tuple routines
!
  call unit_init(200)
!
  obj_ptr = c_loc(obj_data)
  isz = fgsl_sizeof(1_fgsl_int) + nsize * fgsl_sizeof(1.0_fgsl_double) + 4
! FIXME: I don't know why the +4 above is needed; if it's not there the last
! Element in the structure is read incorrectly.
! This needs to be re-checked!
  tuple = fgsl_ntuple_create ('ntuple.dat', obj_ptr, isz)
  call unit_assert_true('fgsl_ntuple_create',fgsl_well_defined(tuple),.true.)
  obj_data%len = nsize
  obj_data%stuff = (/(dble(i),i=1,nsize)/)
  status = fgsl_ntuple_write(tuple)
  call unit_assert_equal('fgsl_ntuple_write',fgsl_success,status)
  obj_data%len = nsize
  obj_data%stuff = (/(dble(i)*10,i=1,nsize)/)
  status = fgsl_ntuple_bookdata(tuple)
  call unit_assert_equal('fgsl_ntuple_bookdata',fgsl_success,status)
  status = fgsl_ntuple_close(tuple)
  call unit_assert_equal('fgsl_ntuple_close',fgsl_success,status)
!
  tuple = fgsl_ntuple_open('ntuple.dat',obj_ptr,isz)
  call unit_assert_true('fgsl_ntuple_open',fgsl_well_defined(tuple),.true.)
  status = fgsl_ntuple_read(tuple)
  obj_ptr = fgsl_ntuple_data(tuple)
  call c_f_pointer(obj_ptr, ptr_data)
  call unit_assert_equal('fgsl_ntuple_read',int(nsize),ptr_data%len)
  call unit_assert_equal_within('fgsl_ntuple_read',(/(dble(i),i=1,nsize)/), &
       ptr_data%stuff,eps10)
  obj_data%stuff = 0.0d0
  status = fgsl_ntuple_read(tuple)
  obj_ptr = fgsl_ntuple_data(tuple)
  call c_f_pointer(obj_ptr, ptr_data)
  iisz = fgsl_ntuple_size(tuple)
  call unit_assert_equal('fgsl_ntuple_read',int(nsize),ptr_data%len)
  call unit_assert_equal('fgsl_ntuple_read',int(isz),int(iisz))
  call unit_assert_equal_within('fgsl_ntuple_read',(/(dble(i)*10,i=1,nsize)/), &
       ptr_data%stuff,eps10)
!
! FIXME: project call and histogramming is not in the test suite presently
!
!
! Done
!
  call unit_finalize() 
end program ntuple

program fft
  use fgsl
  use mod_unit
  implicit none
  real(fgsl_double), parameter :: eps10 = 1.0d-10
  complex(fgsl_double), parameter :: ai = (0.0d0, 1.0d0), ui=(1.0d0, 0.0d0)
  complex(fgsl_double) :: data(4)
  real(fgsl_double) :: rdata(4)
  type(fgsl_fft_complex_wavetable) :: wavetable
  type(fgsl_fft_complex_workspace) :: work
  integer(fgsl_int) :: status
  type(fgsl_error_handler_t) :: std
!
  std = fgsl_set_error_handler_off()
  call unit_init(60)
!
! Test FFT routines
!
  data(1) = 1.0d0*ui
  data(2) = 1.0d0*ui
  data(3) = 0.0d0*ui
  data(4) = 1.0d0*ui
  status = fgsl_fft_complex_radix2_forward(data, 1_fgsl_size_t, 4_fgsl_size_t)
  call unit_assert_equal('fgsl_fft_complex_radix2_forward:status', &
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_gsl_fft_complex_radix2_forward:data',&
       (/3.0d0*ui, ui, -ui, ui /),data,eps10)
  data(1) = 1.0d0*ui
  data(2) = 1.0d0*ui
  data(3) = 0.0d0*ui
  data(4) = 1.0d0*ui
  status = fgsl_fft_complex_radix2_backward(data, 1_fgsl_size_t, 4_fgsl_size_t)
  call unit_assert_equal('fgsl_fft_complex_radix2_backward:status', &
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_gsl_fft_complex_radix2_backward:data',&
       (/3.0d0*ui, ui, -ui, ui /),data,eps10)
  data(1) = 1.0d0*ui
  data(2) = 1.0d0*ui
  data(3) = 0.0d0*ui
  data(4) = 1.0d0*ui
  status = fgsl_fft_complex_radix2_inverse(data, 1_fgsl_size_t, 4_fgsl_size_t)
  call unit_assert_equal('fgsl_fft_complex_radix2_inverse:status', &
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_gsl_fft_complex_radix2_inverse:data',&
       (/.75d0*ui, .25d0*ui, -.25d0*ui, .25d0*ui /),data,eps10)
  data(1) = 1.0d0*ui
  data(2) = 1.0d0*ui
  data(3) = 0.0d0*ui
  data(4) = 1.0d0*ui
  status = fgsl_fft_complex_radix2_transform(data, 1_fgsl_size_t, &
       4_fgsl_size_t, 1_fgsl_int ) 
  call unit_assert_equal('fgsl_fft_complex_radix2_transform:status', &
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_gsl_fft_complex_radix2_transform:data',&
       (/3.0d0*ui, ui, -ui, ui /),data,eps10)
  wavetable = fgsl_fft_complex_wavetable_alloc(4_fgsl_size_t)
  work = fgsl_fft_complex_workspace_alloc(4_fgsl_size_t)
  data(1) = 1.0d0*ui
  data(2) = 1.0d0*ui
  data(3) = 0.0d0*ui
  data(4) = 1.0d0*ui
  status = fgsl_fft_complex_forward(data, 1_fgsl_size_t, 4_fgsl_size_t, &
       wavetable, work)
  call unit_assert_equal('fgsl_fft_complex_forward:status', &
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_gsl_fft_complex_forward:data',&
       (/3.0d0*ui, ui, -ui, ui /),data,eps10)
  data(1) = 1.0d0*ui
  data(2) = 1.0d0*ui
  data(3) = 0.0d0*ui
  data(4) = 1.0d0*ui
  status = fgsl_fft_complex_backward(data, 1_fgsl_size_t, 4_fgsl_size_t, &
       wavetable, work)
  call unit_assert_equal('fgsl_fft_complex_backward:status', &
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_gsl_fft_complex_backward:data',&
       (/3.0d0*ui, ui, -ui, ui /),data,eps10)
  data(1) = 1.0d0*ui
  data(2) = 1.0d0*ui
  data(3) = 0.0d0*ui
  data(4) = 1.0d0*ui
  status = fgsl_fft_complex_inverse(data, 1_fgsl_size_t, 4_fgsl_size_t, &
       wavetable, work)
  call unit_assert_equal('fgsl_fft_complex_inverse:status', &
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_gsl_fft_complex_inverse:data',&
       (/.75d0*ui, .25d0*ui, -.25d0*ui, .25d0*ui/),data,eps10)
  data(1) = 1.0d0*ui
  data(2) = 1.0d0*ui
  data(3) = 0.0d0*ui
  data(4) = 1.0d0*ui
  status = fgsl_fft_complex_transform(data, 1_fgsl_size_t, 4_fgsl_size_t, &
       wavetable, work, 1_fgsl_int)
  call unit_assert_equal('fgsl_fft_complex_transform:status', &
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_gsl_fft_complex_transform:data',&
       (/3.0d0*ui, ui, -ui, ui /),data,eps10) 
!
  rdata(1) = 1.0d0
  rdata(2) = 1.0d0
  rdata(3) = 0.0d0
  rdata(4) = 1.0d0
  status = fgsl_fft_real_radix2_transform(rdata, 1_fgsl_size_t, &
       4_fgsl_size_t)
  call unit_assert_equal('fgsl_fft_real_radix2_transform:status', &
       fgsl_success,status)
  status = fgsl_fft_real_unpack(rdata, data, 1_fgsl_size_t, &
       4_fgsl_size_t)
  call unit_assert_equal_within('fgsl_gsl_fft_complex_radix2_forward:data',&
       (/3.0d0*ui, ui, -ui, 0.0d0*ui /),data,eps10)

  
!
  call fgsl_fft_complex_workspace_free(work)
  call fgsl_fft_complex_wavetable_free(wavetable) 
! 
! Done
!
  call unit_finalize()
end program fft

program linalg
  use fgsl
  use mod_unit
  implicit none
  real(fgsl_double), parameter :: eps10 = 1.0d-10
  complex(fgsl_double), parameter :: ai = (0.0d0, 1.0d0), ui=(1.0d0, 0.0d0)
  type(fgsl_matrix) :: a, a_orig, inv, q, r
  type(fgsl_matrix_complex) :: ac, ac_orig
  type(fgsl_vector) :: b, x, res, tau
  type(fgsl_vector_complex) :: bc, xc, resc
  real(fgsl_double), target :: af(3, 3), af_orig(3, 3), bf(3), xf(3), resf(3), &
       invf(3, 3), tauf(3), qf(3, 3), rf(3, 3), mf(3, 3)
  complex(fgsl_double) :: acf(3, 3), xcf(3), bcf(3), rescf(3), acf_orig(3, 3)
  real(fgsl_double) :: det, lndet
  type(fgsl_permutation) :: p
  integer(fgsl_int) :: status, signum, ip(3), sgn
  integer(fgsl_size_t) :: i
!
! Test linear algebra
! remember that matrices are transposed vs. usual Fortran convention
!
  call unit_init(200)
!
! LU - real
!
  a = fgsl_matrix_init(1.0_fgsl_double)
  a_orig = fgsl_matrix_init(1.0_fgsl_double)
  inv = fgsl_matrix_init(1.0_fgsl_double)
  af = reshape((/ 1.0d0, 1.0d0, 0.0d0, 1.0d0, 0.0d0, 1.0d0, &
       0.0d0, 2.0d0, 1.0d0 /), (/3, 3/))
  af_orig = af
  status = fgsl_matrix_align(af, 3_fgsl_size_t, 3_fgsl_size_t, &
       3_fgsl_size_t,a)
  status = fgsl_matrix_align(af_orig, 3_fgsl_size_t, 3_fgsl_size_t, &
       3_fgsl_size_t,a_orig)
  status = fgsl_matrix_align(invf, 3_fgsl_size_t, 3_fgsl_size_t, &
       3_fgsl_size_t,inv)
  p = fgsl_permutation_alloc(3_fgsl_size_t)
  call unit_assert_equal('fgsl_matrix_align(in):status',fgsl_success,status)
  status = fgsl_linalg_lu_decomp(a, p, signum) 
  call unit_assert_equal('fgsl_linalg_lu_decomp:status',fgsl_success,status)
!  write(6, *) af
  do i=1,3
     ip(i) = fgsl_permutation_get(p, i-1)
  end do
!  write(6, *) ip, signum
  call unit_assert_equal_within('fgsl_linalg_lu_decomp:a',&
       reshape((/1.d0, 1.d0, 0.d0, 0.d0, 2.d0, 1.d0, 1.d0, -0.5d0, 1.5d0 /), &
       (/3, 3/)),af,eps10)
  call unit_assert_equal('fgsl_linalg_lu_decomp:p',&
       (/0, 2, 1/),ip)
  call unit_assert_equal('fgsl_linalg_lu_decomp:signum',&
       -1,signum)
  bf = (/1.0d0, 2.0d0, 3.0d0/)
  b = fgsl_vector_init(1.0_fgsl_double)
  x = fgsl_vector_init(1.0_fgsl_double)
  res = fgsl_vector_init(1.0_fgsl_double)
  status = fgsl_vector_align(bf, 3_fgsl_size_t, b, 3_fgsl_size_t, &
       0_fgsl_size_t, 1_fgsl_size_t)
  status = fgsl_vector_align(xf, 3_fgsl_size_t, x, 3_fgsl_size_t, &
       0_fgsl_size_t, 1_fgsl_size_t)
  status = fgsl_vector_align(resf, 3_fgsl_size_t, res, 3_fgsl_size_t, &
       0_fgsl_size_t, 1_fgsl_size_t)
  status = fgsl_linalg_lu_solve(a, p, b, x)
  call unit_assert_equal('fgsl_linalg_lu_solve:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_linalg_lu_solve:x',&
       (/1.0d0/3.0d0, 2.0d0/3.0d0, 5.0d0/3.0d0 /),xf,eps10)
!  write(6, *) xf
  xf = bf
  status = fgsl_linalg_lu_svx(a, p, x)
  call unit_assert_equal('fgsl_linalg_lu_svx:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_linalg_lu_svx:x',&
       (/1.0d0/3.0d0, 2.0d0/3.0d0, 5.0d0/3.0d0 /),xf,eps10)
! small deformation of solution for refinement
  xf(1) = xf(1) + 1.0d-5
  xf(3) = xf(3) - 2.0d-5
  status = fgsl_linalg_lu_refine (a_orig, a, p, b, x, res)
  call unit_assert_equal('fgsl_linalg_lu_refine:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_linalg_lu_refine:x',&
       (/1.0d0/3.0d0, 2.0d0/3.0d0, 5.0d0/3.0d0 /),xf,eps10)
  call unit_assert_equal_within('fgsl_linalg_lu_refine:res',&
       (/1.0d-5, 0.0d0, -2.0d-5 /),resf,eps10)
  status = fgsl_linalg_lu_invert(a, p, inv)
  call unit_assert_equal_within('fgsl_linalg_lu_decomp:a',&
       reshape((/2.d0/3.0d0, 1.d0/3.0d0, -1.d0/3.0d0, &
       1.d0/3.0d0, -1.d0/3.0d0, 1.d0/3.0d0, &
       -2.d0/3.0d0, 2.d0/3.0d0, 1.d0/3.0d0/), &
       (/3, 3/)),invf,eps10)
  det = fgsl_linalg_lu_det(a, signum)
  call unit_assert_equal_within('fgsl_linalg_lu_det',&
       -3.0d0,det,eps10)
  lndet = fgsl_linalg_lu_lndet(a)
  call unit_assert_equal_within('fgsl_linalg_lu_lndet',&
       log(3.0d0),lndet,eps10)
  sgn = fgsl_linalg_lu_sgndet(a, signum)
  call unit_assert_equal('fgsl_linalg_lu_sgndet',-1,sgn)
!
! LU complex
!
  ac = fgsl_matrix_init(ai)
  acf = reshape((/ ui, ai, 0.0d0*ui, -ai, 0.0d0*ui, ui, &
       0.0d0*ui, 2.0d0*ui, ai /), (/3, 3/))
  ac_orig = fgsl_matrix_init(ai)
  acf_orig = acf
  status = fgsl_matrix_align(acf, 3_fgsl_size_t, 3_fgsl_size_t, &
       3_fgsl_size_t,ac)
  status = fgsl_matrix_align(acf_orig, 3_fgsl_size_t, 3_fgsl_size_t, &
       3_fgsl_size_t,ac_orig)
  bcf = (/ai, 2.0d0*ui, ui+ai/)
  bc = fgsl_vector_init(ai)
  xc = fgsl_vector_init(ai)
  resc = fgsl_vector_init(ai)
  status = fgsl_vector_align(bcf, 3_fgsl_size_t, bc, 3_fgsl_size_t, &
       0_fgsl_size_t, 1_fgsl_size_t)
  status = fgsl_vector_align(xcf, 3_fgsl_size_t, xc, 3_fgsl_size_t, &
       0_fgsl_size_t, 1_fgsl_size_t)
  status = fgsl_vector_align(rescf, 3_fgsl_size_t, resc, 3_fgsl_size_t, &
       0_fgsl_size_t, 1_fgsl_size_t)
  status = fgsl_linalg_complex_lu_decomp(ac, p, signum) 
  call unit_assert_equal('fgsl_linalg_complex_lu_decomp:status',fgsl_success,status)
!  write(6, *) acf
  do i=1,3
     ip(i) = fgsl_permutation_get(p, i-1)
  end do
!  write(6, *) ip, signum
  call unit_assert_equal_within('fgsl_linalg_complex_lu_decomp:a',&
      reshape((/ui, ai, 0*ui, 0*ui, 2*ui, ai, -ai, -0.5d0*ui, ui+0.5d0*ai  /), &
       (/3, 3/)),acf,eps10)
  call unit_assert_equal('fgsl_linalg_lu_decomp:p',&
       (/0, 2, 1/),ip)
  call unit_assert_equal('fgsl_linalg_lu_decomp:signum',&
       -1,signum)
  status = fgsl_linalg_complex_lu_solve(ac, p, bc, xc)
  call unit_assert_equal('fgsl_linalg_complex_lu_solve:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_linalg_complex_lu_solve:x',&
       (/(-ui+3*ai)/5.0d0, (2*ui-ai)/5.0d0, (7*ui-ai)/5.0d0 /),xcf,eps10)
  xcf = bcf
  status = fgsl_linalg_complex_lu_svx(ac, p, xc)
  call unit_assert_equal('fgsl_linalg_complex_lu_svx:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_linalg_complex_lu_svx:x',&
       (/(-ui+3*ai)/5.0d0, (2*ui-ai)/5.0d0, (7*ui-ai)/5.0d0 /),xcf,eps10)
  xcf(1) = xcf(1) + 1.0d-5 * ui
  xcf(3) = xcf(3) - 2.0d-5 * ui
  status = fgsl_linalg_complex_lu_refine (ac_orig, ac, p, bc, xc, resc)
  call unit_assert_equal('fgsl_linalg_lu_refine:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_linalg_lu_refine:x',&
       (/(-ui+3*ai)/5.0d0, (2*ui-ai)/5.0d0, (7*ui-ai)/5.0d0 /),xcf,eps10)
  call unit_assert_equal_within('fgsl_linalg_lu_refine:res',&
       (/1.0d-5*ui, 0.0d0*ui, -2.0d-5*ui /),rescf,eps10)
! FIXME: remaining complex routines 

!
! QR
!
  q = fgsl_matrix_init(1.0_fgsl_double)
  r = fgsl_matrix_init(1.0_fgsl_double)
  status = fgsl_matrix_align(qf, 3_fgsl_size_t, 3_fgsl_size_t, &
       3_fgsl_size_t,q)
  status = fgsl_matrix_align(rf, 3_fgsl_size_t, 3_fgsl_size_t, &
       3_fgsl_size_t,r)
  tau = fgsl_vector_init(1.0_fgsl_double)
  status = fgsl_vector_align(tauf, 3_fgsl_size_t, tau, 3_fgsl_size_t, &
       0_fgsl_size_t, 1_fgsl_size_t)
  af = af_orig
  status = fgsl_linalg_qr_decomp(a, tau)
  call unit_assert_equal('fgsl_linalg_qr_decomp:status',fgsl_success,status)
  status = fgsl_linalg_qr_solve(a, tau, b, x)
  call unit_assert_equal('fgsl_linalg_qr_solve:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_linalg_qr_solve:x',&
       (/1.0d0/3.0d0, 2.0d0/3.0d0, 5.0d0/3.0d0 /),xf,eps10)
  xf = bf
  status = fgsl_linalg_qr_svx(a, tau, x)
  call unit_assert_equal('fgsl_linalg_qr_svx:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_linalg_qr_svx:x',&
       (/1.0d0/3.0d0, 2.0d0/3.0d0, 5.0d0/3.0d0 /),xf,eps10)
  status = fgsl_linalg_qr_lssolve(a, tau, b, x, res)
  call unit_assert_equal('fgsl_linalg_qr_lssolve:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_linalg_qr_lssolve:x',&
       (/1.0d0/3.0d0, 2.0d0/3.0d0, 5.0d0/3.0d0 /),xf,eps10)
  call unit_assert_equal_within('fgsl_linalg_qr_lssolve:res',&
       (/0.0d0, 0.0d0, 0.0d0 /),resf,eps10)
  status = fgsl_linalg_qr_unpack (a, tau, q, r) 
  call unit_assert_equal('fgsl_linalg_qr_unpack:status',fgsl_success,status)
  resf = (/ 1.0d0, 2.0d0, 3.0d0 /)
  status = fgsl_linalg_qr_qtvec (a, tau, res)
  call unit_assert_equal('fgsl_linalg_qr_qtvec:status',fgsl_success,status)
  xf = matmul(qf,  (/ 1.0d0, 2.0d0, 3.0d0 /))
  call unit_assert_equal_within('fgsl_linalg_qr_qtvec:res',&
       xf,resf,eps10)  
  resf = (/ 1.0d0, 2.0d0, 3.0d0 /)
  status = fgsl_linalg_qr_qvec (a, tau, res)
  call unit_assert_equal('fgsl_linalg_qr_qvec:status',fgsl_success,status)
  xf = matmul(transpose(qf),  (/ 1.0d0, 2.0d0, 3.0d0 /))
  call unit_assert_equal_within('fgsl_linalg_qr_qvec:res',&
       xf,resf,eps10)  
  invf = reshape((/ 1.0d0, 0.0d0, 0.0d0, 0.0d0, 1.0d0, 0.0d0, &
       0.0d0, 0.0d0, 1.0d0 /), (/3, 3/))
  status = fgsl_linalg_qr_qtmat (a, tau, inv)
  call unit_assert_equal('fgsl_linalg_qr_qtvec:status',fgsl_success,status)
  mf = matmul(transpose(qf), &
       reshape((/ 1.0d0, 0.0d0, 0.0d0, 0.0d0, 1.0d0, 0.0d0, &
       0.0d0, 0.0d0, 1.0d0 /), (/3, 3/)) )
  call unit_assert_equal_within('fgsl_linalg_qr_qtvec:res',&
       mf,invf,eps10) 
  status = fgsl_linalg_qr_rsolve(a, b, x)
  call unit_assert_equal('fgsl_linalg_qr_rsolve:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_linalg_qr_rsolve:x',&
       (/-(1.0d0+5.0d0/(3.0d0*sqrt(2.0d0))), &
       (2.0d0*sqrt(2.0d0)-3.0d0)/3.0d0, 3.0d0 /),xf,eps10)
  xf = bf
  status = fgsl_linalg_qr_rsvx(a, x)
  call unit_assert_equal('fgsl_linalg_qr_rsvx:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_linalg_qr_rsvx:x',&
       (/-(1.0d0+5.0d0/(3.0d0*sqrt(2.0d0))), &
       (2.0d0*sqrt(2.0d0)-3.0d0)/3.0d0, 3.0d0 /),xf,eps10)
  status = fgsl_linalg_qr_qrsolve(q, r, b, x)
  call unit_assert_equal('fgsl_linalg_qr_qrsolve:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_linalg_qr_qrsolve:x',&
       (/1.0d0/3.0d0, 2.0d0/3.0d0, 5.0d0/3.0d0 /),xf,eps10)
  status = fgsl_linalg_r_solve(r, b, x)
  call unit_assert_equal('fgsl_linalg_r_solve:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_linalg_r_solve:x',&
       (/-(1.0d0+5.0d0/(3.0d0*sqrt(2.0d0))), &
       (2.0d0*sqrt(2.0d0)-3.0d0)/3.0d0, 3.0d0 /),xf,eps10)
  xf = bf
  status = fgsl_linalg_r_svx(r, x)
  call unit_assert_equal('fgsl_linalg_r_svx:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_linalg_r_svx:x',&
       (/-(1.0d0+5.0d0/(3.0d0*sqrt(2.0d0))), &
       (2.0d0*sqrt(2.0d0)-3.0d0)/3.0d0, 3.0d0 /),xf,eps10)
  xf = (/ -1.0d0, 0.0d0, 0.0d0 /)
  status = fgsl_linalg_qr_update (q, r, x, b)
  call unit_assert_equal('fgsl_linalg_qr_update:status',fgsl_success,status)
  mf = matmul(rf, qf)
  af = af_orig - matmul(reshape((/ 1.0d0, 2.0d0, 3.0d0, &
       0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0 /), (/3, 3/)),qf)
  call unit_assert_equal_within('fgsl_linalg_qr_update:mf',&
       af,mf,eps10)
  af = af_orig
  status = fgsl_linalg_qrpt_decomp(a, tau, p, signum, res)
  call unit_assert_equal('fgsl_linalg_qrpt_decomp:status',fgsl_success,status)
  status = fgsl_linalg_qrpt_solve(a, tau, p, b, x)
  call unit_assert_equal('fgsl_linalg_qrpt_solve:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_linalg_qrpt_solve:x',&
       (/1.0d0/3.0d0, 2.0d0/3.0d0, 5.0d0/3.0d0 /),xf,eps10)
  xf = bf
  status = fgsl_linalg_qrpt_svx(a, tau, p, x)
  call unit_assert_equal('fgsl_linalg_qrpt_svx:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_linalg_qrpt_svx:x',&
       (/1.0d0/3.0d0, 2.0d0/3.0d0, 5.0d0/3.0d0 /),xf,eps10)
  status = fgsl_linalg_qrpt_rsolve(a, p, b, x)
  call unit_assert_equal('fgsl_linalg_qrpt_rsolve:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_linalg_qrpt_rsolve:x',&
       (/-1.0d0-2*sqrt(5.0d0)/3.0d0, &
       -1.0d0-1.0d0/(3*sqrt(5.0d0)), 3.0d0 /),xf,eps10)
  xf = bf
  status = fgsl_linalg_qrpt_rsvx(a, p, x)
  call unit_assert_equal('fgsl_linalg_qrpt_rsvx:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_linalg_qrpt_rsvx:x',&
       (/-1.0d0-2*sqrt(5.0d0)/3.0d0, &
       -1.0d0-1.0d0/(3*sqrt(5.0d0)), 3.0d0 /),xf,eps10)
  af = af_orig
  status = fgsl_linalg_qrpt_decomp2(a, q, r, tau, p, signum, res)
  call unit_assert_equal('fgsl_linalg_qrpt_decomp2:status',fgsl_success,status)
  status = fgsl_linalg_qrpt_qrsolve(q, r, p, b, x)
  call unit_assert_equal('fgsl_linalg_qrpt_qrsolve:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_linalg_qrpt_qrsolve:x',&
       (/1.0d0/3.0d0, 2.0d0/3.0d0, 5.0d0/3.0d0 /),xf,eps10)
  xf = (/ -1.0d0, 0.0d0, 0.0d0 /)
  status = fgsl_linalg_qrpt_update (q, r, p, x, b)
  call unit_assert_equal('fgsl_linalg_qrpt_update:status',fgsl_success,status)
  mf = matmul(rf, qf)
  invf =  - matmul(reshape((/ 1.0d0, 2.0d0, 3.0d0, &
       0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0 /), (/3, 3/)),qf)
! p is (1 0 2)
  af(1, 1:3) = af_orig(2, 1:3) + invf(2, 1:3)
  af(2, 1:3) = af_orig(1, 1:3) + invf(1, 1:3)
  af(3, 1:3) = af_orig(3, 1:3) + invf(3, 1:3)
  call unit_assert_equal_within('fgsl_linalg_qrpt_update:mf',&
       af,mf,eps10)
!
! SVD
!
  af = af_orig
  status = fgsl_linalg_sv_decomp(a, q, tau, res)
  call unit_assert_equal('fgsl_linalg_sv_decomp:status',fgsl_success,status)
  status = fgsl_linalg_sv_solve (a, q, tau, b, x)
  call unit_assert_equal('fgsl_linalg_sv_solve:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_linalg_sv_solve:x',&
       (/1.0d0/3.0d0, 2.0d0/3.0d0, 5.0d0/3.0d0 /),xf,eps10)
  af = af_orig
  status = fgsl_linalg_sv_decomp_mod(a, r, q, tau, res)
  call unit_assert_equal('fgsl_linalg_sv_decomp_mod:status',fgsl_success,status)
  status = fgsl_linalg_sv_solve (a, q, tau, b, x)
  call unit_assert_equal('fgsl_linalg_sv_solve_mod:status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_linalg_sv_solve_mod:x',&
       (/1.0d0/3.0d0, 2.0d0/3.0d0, 5.0d0/3.0d0 /),xf,eps10)
  af = af_orig
  status = fgsl_linalg_sv_decomp_jacobi(a, q, tau)
  call unit_assert_equal('fgsl_linalg_sv_decomp_jacobi:status',&
       fgsl_success,status)
  status = fgsl_linalg_sv_solve (a, q, tau, b, x)
  call unit_assert_equal('fgsl_linalg_sv_solve_jacobi:status',&
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_linalg_sv_solve:x',&
       (/1.0d0/3.0d0, 2.0d0/3.0d0, 5.0d0/3.0d0 /),xf,eps10)
!
! Cholesky
!
  af_orig = reshape((/2.0d0, 0.0d0, 0.0d0, 0.0d0, 2.0d0, 0.0d0, &
       1.0d0, 1.0d0, 2.0d0 /), (/3, 3/))
  af = af_orig
  status = fgsl_linalg_cholesky_decomp(a)
  call unit_assert_equal('fgsl_linalg_cholesky_decomp:status', &
       fgsl_success,status)
  status = fgsl_linalg_cholesky_solve (a, b, x)
  call unit_assert_equal('fgsl_linalg_cholesky_solve:status',&
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_linalg_sv_solve:x',&
       (/-.25d0, .25d0, 1.5d0 /),xf,eps10)
  xf = bf
  status = fgsl_linalg_cholesky_svx (a, x)
  call unit_assert_equal('fgsl_linalg_cholesky_svx:status',&
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_linalg_sv_svx:x',&
       (/-.25d0, .25d0, 1.5d0 /),xf,eps10)
! FIXME complex Cholesky 
  
!
! cleanup
!
  call fgsl_permutation_free(p)
  call fgsl_matrix_free(a)
  call fgsl_matrix_free(ac)
  call fgsl_matrix_free(inv)
  call fgsl_matrix_free(q)
  call fgsl_matrix_free(r)
  call fgsl_matrix_free(a_orig)
  call fgsl_matrix_free(ac_orig)
  call fgsl_vector_free(b)
  call fgsl_vector_free(bc)
  call fgsl_vector_free(x)
  call fgsl_vector_free(xc)
  call fgsl_vector_free(res)
  call fgsl_vector_free(resc)
  call fgsl_vector_free(tau)
! 
! Done
!
  call unit_finalize()
end program linalg

module mod_unit
! utilities for unit testing
  implicit none
  private
  public :: unit_debug, unit_init, unit_finalize, unit_assert_equal, &
       unit_assert_equal_within, unit_assert_true
  integer, parameter :: ik = selected_int_kind(6)
  integer, parameter :: dk = selected_real_kind(15)
  logical, protected :: unit_debug = .false.
  logical, allocatable :: unit_ok(:) 
  integer :: index_ok
  interface unit_assert_equal
     module procedure unit_assert_equal_integer
     module procedure unit_assert_equal_integer_array
     module procedure unit_assert_equal_string
  end interface
  interface unit_assert_equal_within
     module procedure unit_assert_equal_within_double
     module procedure unit_assert_equal_within_double_array
     module procedure unit_assert_equal_within_double_2d_array
     module procedure unit_assert_equal_within_double_complex
     module procedure unit_assert_equal_within_double_complex_array
     module procedure unit_assert_equal_within_double_complex_2d_array
   end interface
contains
  subroutine unit_init(num_tests)
    integer, intent(in) :: num_tests
    if (allocated(unit_ok)) then
       write(6, *) 'unit_init: Please call unit_finalize before reinitializing.'
       stop
    else
       allocate(unit_ok(num_tests))
       index_ok = 1
       unit_ok = .true.
    end if
    inquire(file='unit_debug',exist=unit_debug)
! FIXME debug read-in
  end subroutine unit_init
  subroutine unit_assert_equal_integer(description, ival_target, ival_check)
    character(len=*), intent(in) :: description
    integer(kind=ik), intent(in) :: ival_target, ival_check
    call unit_toggle(description, ival_target == ival_check)
  end subroutine unit_assert_equal_integer
  subroutine unit_assert_equal_integer_array(description, &
       ival_target, ival_check)
    character(len=*), intent(in) :: description
    integer(kind=ik), intent(in) :: ival_target(:), ival_check(:)
    integer(kind=ik) :: i
    logical :: ok
    if (size(ival_target) /= size(ival_check)) then
       call unit_toggle(description, .false.)
    end if
    ok = .true.
    do i=1,size(ival_target)
       if (ival_target(i) /= ival_check(i)) ok= .false.
    end do
    call unit_toggle(description, ok)
  end subroutine unit_assert_equal_integer_array
  subroutine unit_assert_equal_string(description, ival_target, ival_check)
    character(len=*), intent(in) :: description
    character(len=*), intent(in) :: ival_target, ival_check
    call unit_toggle(description, lge(ival_target,ival_check) .and. &
         lle(ival_target,ival_check))
  end subroutine unit_assert_equal_string
  subroutine unit_assert_equal_within_double(description, &
       val_target, val_check, eps)
    character(len=*), intent(in) :: description
    real(kind=dk), intent(in) :: val_target, val_check, eps
    call unit_toggle(description, abs(val_target - val_check) <= eps)
    if (unit_debug) then
       write(6,fmt='(a,4x,2(1PD25.18),1PD8.1)') description,val_target,val_check,eps
    end if
  end subroutine unit_assert_equal_within_double
  subroutine unit_assert_equal_within_double_array(description, &
       val_target, val_check, eps)
    character(len=*), intent(in) :: description
    real(kind=dk), intent(in) :: val_target(:), val_check(:), eps
    integer(kind=ik) :: i
    logical :: ok
    if (size(val_target) /= size(val_check)) then
       call unit_toggle(description, .false.)
    end if
    ok = .true.
    do i=1,size(val_target)
       if (abs(val_target(i) - val_check(i)) > eps) ok= .false.
    end do
    call unit_toggle(description, ok)
  end subroutine unit_assert_equal_within_double_array
  subroutine unit_assert_equal_within_double_2d_array(description, &
       val_target, val_check, eps)
    character(len=*), intent(in) :: description
    real(kind=dk), intent(in) :: val_target(:,:), val_check(:,:), eps
    integer(kind=ik) :: i, j
    logical :: ok
    if (size(val_target,1) /= size(val_check,1) .or. &
         size(val_target,1) /= size(val_check,1)) then
       call unit_toggle(description, .false.)
       return
    end if
    ok = .true.
    do j=1,size(val_target,2)
       do i=1,size(val_target,1)
          if (abs(val_target(i,j) - val_check(i,j)) > eps) ok= .false.
       end do
    end do
    call unit_toggle(description, ok)
  end subroutine unit_assert_equal_within_double_2d_array
  subroutine unit_assert_equal_within_double_complex(description, &
       val_target, val_check, eps)
    character(len=*), intent(in) :: description
    complex(kind=dk), intent(in) :: val_target, val_check
    real(kind=dk), intent(in) :: eps
    call unit_toggle(description, abs(val_target - val_check) <= eps)
    if (unit_debug) then
       write(6,fmt='(a,/,4x,2(1PD25.18),/,4x,2(1PD25.18),1PD8.1)') &
            description,val_target,val_check,eps
    end if
  end subroutine unit_assert_equal_within_double_complex
  subroutine unit_assert_equal_within_double_complex_array(&
       description, val_target, val_check, eps)
    character(len=*), intent(in) :: description
    complex(kind=dk), dimension(:), intent(in) :: val_target, val_check
    real(kind=dk), intent(in) :: eps
    integer :: i
    logical :: ok
    if (size(val_target) /= size(val_check)) then
       call unit_toggle(description, .false.)
    end if
    ok = .true.
    do i=1,size(val_target)
       if (abs(val_target(i) - val_check(i)) > eps) ok= .false.
    end do
    call unit_toggle(description, ok)
  end subroutine unit_assert_equal_within_double_complex_array
  subroutine unit_assert_equal_within_double_complex_2d_array(&
       description, val_target, val_check, eps)
    character(len=*), intent(in) :: description
    complex(kind=dk), dimension(:,:), intent(in) :: val_target, val_check
    real(kind=dk), intent(in) :: eps
    integer :: i, j
    logical :: ok
    if (size(val_target) /= size(val_check)) then
       call unit_toggle(description, .false.)
    end if
    ok = .true.
    do j=1,size(val_target,2)
       do i=1,size(val_target,1)
          if (abs(val_target(i,j) - val_check(i,j)) > eps) ok= .false.
       end do
    end do
    call unit_toggle(description, ok)
  end subroutine unit_assert_equal_within_double_complex_2d_array
  subroutine unit_assert_true(description, check, abort)
    character(len=*), intent(in) :: description
    logical, intent(in) :: check, abort
    call unit_toggle(description, check)
    if (.not. check .and. abort) then
       call unit_finalize()
       write(6, *) description,': aborting Execution'
       stop
    end if
  end subroutine unit_assert_true
  subroutine unit_toggle(description,test_ok)
    character(len=*), intent(in) :: description
    logical, intent(in) :: test_ok
    if (.not. test_ok) then
       write(6, *) 'FAIL: ', description
    elseif (unit_debug) then
       write(6, *) 'OK: ', description
    end if
    if (.not. allocated(unit_ok)) then
       write(6, *) 'Please in insert call to unit_init(). Aborting. '
       stop
    end if
    if (index_ok > size(unit_ok)) then
       write(6, *) 'Please initialize unit tests with num_tests > ', &
            size(unit_ok)
       stop
    end if
    unit_ok(index_ok) = test_ok
    index_ok = index_ok + 1
 end subroutine unit_toggle
  subroutine unit_finalize()
    if (all(unit_ok)) then
       write(6, fmt='(''OK: All '',i0,'' tests passed'')') index_ok-1
    else
       write(6, fmt='(''FAIL: '',i0,'' of '',i0,'' tests failed'')') &
            count(.not. unit_ok),index_ok-1
    end if
    deallocate(unit_ok)
    index_ok = 0
  end subroutine unit_finalize
end module mod_unit

program array
  use fgsl
  use mod_unit
  implicit none
  integer(fgsl_size_t), parameter :: nmax = 20
  real(fgsl_double), parameter :: eps10 = 1.0d-10
  integer :: i, j, status
  real(fgsl_double), dimension(nmax), target :: xa
  real(fgsl_double), dimension(nmax) :: ya
  real(fgsl_double), dimension(nmax,nmax), target :: a2d
  real(fgsl_double), dimension(nmax,nmax) :: b2d
  complex(fgsl_double), dimension(nmax), target :: xca
  complex(fgsl_double), dimension(nmax) :: yca
  complex(fgsl_double), dimension(nmax,nmax), target :: ac2d
  complex(fgsl_double), dimension(nmax,nmax) :: bc2d
  real(fgsl_double), pointer, dimension(:) :: fptr => null()
  complex(fgsl_double), pointer, dimension(:) :: fcptr => null()
  real(fgsl_double), pointer, dimension(:,:) :: fmptr => null()
  complex(fgsl_double), pointer, dimension(:,:) :: fcmptr => null()
  type(fgsl_vector) :: fvec
  type(fgsl_vector_complex) :: fcvec
  type(fgsl_matrix) :: fmat
  type(fgsl_matrix_complex) :: fcmat
!
! Test vector and matrix support routines
!
  call unit_init(50)
!
!
! Array processing
!
  do i=1,nmax
     xa(i) = dble(i)
     xca(i) = cmplx(dble(i), dble(2*i))
  end do
!  write(6, *) xca
  fvec = fgsl_vector_init(1.0_fgsl_double)
  call unit_assert_true('fgsl_vector_init',fgsl_well_defined(fvec),.true.)
  fcvec = fgsl_vector_init((0.0_fgsl_double, 1.0_fgsl_double))
  call unit_assert_true('fgsl_vector_init',fgsl_well_defined(fcvec),.true.)
  status = fgsl_vector_align(xa,nmax,fvec,5_fgsl_size_t,2_fgsl_size_t,&
       3_fgsl_size_t)
  call unit_assert_equal('fgsl_vector_align(in):status',fgsl_success,status)
  status = fgsl_vector_align(xca,nmax,fcvec,5_fgsl_size_t,2_fgsl_size_t,&
       3_fgsl_size_t)
  call unit_assert_equal('fgsl_vector_complex_align(in):status',&
       fgsl_success,status)
  ya(1:5) = fvec
  yca(1:5) = fcvec
  call unit_assert_equal_within('fgsl_vector:assign',&
       (/3.0d0,6.0d0,9.0d0,12.0d0,15.0d0/),ya(1:5),eps10)
!  write(6, *) ya(1:5)
  call unit_assert_equal_within('fgsl_vector:assign',&
       (/(3.0d0,6.0d0),(6.0d0,1.2d1),(9.0d0,1.8d1),(1.20d1,2.4d1),&
       (1.5d1,3.0d1)/),yca(1:5),eps10)
!  write(6, *) yca(1:5)
  status = fgsl_vector_align(fptr,fvec)
  call unit_assert_equal('fgsl_vector_align(out):status',fgsl_success,status)
  status = fgsl_vector_align(fcptr,fcvec)
!  write(6, *) fcptr(1:5)
  call unit_assert_equal('fgsl_vector_complex_align(out):status',&
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_vector:align(out)',&
       (/3.0d0,6.0d0,9.0d0,12.0d0,15.0d0/),fptr,eps10)
  call fgsl_vector_free(fvec)
  call unit_assert_equal_within('fgsl_vector_complex:align(out)',&
       (/(3.0d0,6.0d0),(6.0d0,1.2d1),(9.0d0,1.8d1),(1.20d1,2.4d1),&
       (1.5d1,3.0d1)/),fcptr,eps10)
  call fgsl_vector_free(fcvec)
! FIXME: add tests with wrong dimensioning
! 
  do j=1,6
     do i=1,3
        a2d(i, j) = 10*j+i
        ac2d(i, j) = cmplx(10*j+i, 10*j-i)
     end  do
  end do
  fmat = fgsl_matrix_init(1.0_fgsl_double)
  call unit_assert_true('fgsl_matrix_init',fgsl_well_defined(fmat),.true.)
  status = fgsl_matrix_align(a2d, nmax, 3_fgsl_size_t,6_fgsl_size_t,fmat)
  call unit_assert_equal('fgsl_matrix_align(in):status',fgsl_success,status)
  b2d(1:3,1:6) = fmat
  call unit_assert_equal_within('fgsl_matrix:assign',a2d(1:3,1:6),&
       b2d(1:3,1:6),eps10)
  status = fgsl_matrix_align(fmptr,fmat)
  call unit_assert_equal('fgsl_matrix_align(out):status',fgsl_success,status)
  call unit_assert_equal_within('fgsl_matrix:assign',a2d(1:3,1:6),&
       fmptr,eps10)
  call fgsl_matrix_free(fmat)
  fcmat = fgsl_matrix_init((0.0_fgsl_double, 1.0_fgsl_double))
  call unit_assert_true('fgsl_matrix_complex_init',&
       fgsl_well_defined(fmat),.true.)
  status = fgsl_matrix_align(ac2d, nmax, 3_fgsl_size_t,6_fgsl_size_t,fcmat)
  call unit_assert_equal('fgsl_matrix_complex_align(in):status',&
       fgsl_success,status)
  bc2d(1:3,1:6) = fcmat
  call unit_assert_equal_within('fgsl_matrix_complex:assign',ac2d(1:3,1:6),&
       bc2d(1:3,1:6),eps10)
  status = fgsl_matrix_align(fcmptr,fcmat)
  call unit_assert_equal('fgsl_matrix_complex_align(out):status',&
       fgsl_success,status)
  call unit_assert_equal_within('fgsl_matrix_complex:assign',ac2d(1:3,1:6),&
       fcmptr,eps10)
  call fgsl_matrix_free(fcmat)
!
! Done
!
  call unit_finalize()
end program array

#! /bin/bash
# run complete set of unit tests


./version.exe
for file in *.exe; do
    if [ $file != "version.exe" ] ; then
	echo "Running $file: "
	./$file
    fi
done

echo "Running error test:"
./error.sh > ERROR.dat 2>&1
grep "OK" ERROR.dat 2> /dev/null
grep "FAIL" ERROR.dat 2> /dev/null
exit 0
